
function isInstall(package_name_str){
    if(cc.sys.os == cc.sys.OS_ANDROID){
        return jsb.reflection.callStaticMethod("com/duoduo/child/story/thirdparty/cocos/NativeInteraction", "IsAppInstalled", "(Ljava/lang/String;)Z", package_name_str);
    }else if(cc.sys.os == cc.sys.OS_IOS){
        return false;
    }else{
        return false;
    }
}

function recommandEnable(){
    if(cc.sys.os == cc.sys.OS_ANDROID){
        return jsb.reflection.callStaticMethod("com/duoduo/child/story/thirdparty/cocos/NativeInteraction", "adEnable", "()Z");
    }else if(cc.sys.os == cc.sys.OS_IOS){
        return true;
    }else{
        return true;
    }
}

//function recommandInstall(){
//    if(cc.sys.os == cc.sys.OS_ANDROID){
//        return jsb.reflection.callStaticMethod("com/duoduo/child/story/thirdparty/cocos/NativeInteraction", "adEnable", "()Z");
//    }else if(cc.sys.os == cc.sys.OS_IOS){
//        return true;
//    }else{
//        return true;
//    }
//}

function recommandType(){
    if(cc.sys.os == cc.sys.OS_ANDROID){
        return jsb.reflection.callStaticMethod("com/duoduo/child/story/thirdparty/cocos/NativeInteraction", "installType", "()I");
    }else if(cc.sys.os == cc.sys.OS_IOS){
        return 0;
    }else{
        return 0;
    }
}

function filterAdInstall(arry_ad_src, ad_num){
    var array_install = new Array();
    var array_no_install = new Array();
    for(var n_index = 0; n_index < arry_ad_src.length; ++n_index){
        var ad_item = arry_ad_src[n_index];
        if(!isInstall(ad_item.getArUrl())){
            array_no_install.push(ad_item);
        }else{
            array_install.push(ad_item);
        }
    }

    if(recommandType()){//recommand installed apps
        if(array_install.length >= ad_num){
            return array_install.slice(0, ad_num);
        }else {
            return array_install;
        }
    }else {
        if(array_no_install.length >= ad_num){
            return array_no_install.slice(0, ad_num);
        }else{
            var ad_gap = ad_num - array_no_install.length;
            if(ad_gap <= array_install.length){
                return array_no_install.concat(array_install.slice(0, ad_gap));
            }else{
                return array_no_install.concat(array_install);
            }
        }
    }
}

function lockAdNotInstall(arry_ad_src, ad_num){
    var array_no_install = new Array();
    for(var n_index = 0; n_index < arry_ad_src.length; ++n_index){
        var ad_item = arry_ad_src[n_index];
        if(!isInstall(ad_item.getArUrl())){
            array_no_install.push(ad_item);
        }
    }

    if(array_no_install.length >= ad_num){
        return array_no_install.slice(0, ad_num);
    }else {
        return array_no_install;
    }
}

function parseAdList(arry_ret, ad_list){
    for(var n_index = 0; n_index < ad_list.length; ++n_index){
    	var ad_item = new AdItem();
 		ad_item.setName(ad_list[n_index].name);
    	ad_item.setImage(ad_list[n_index].pic);
    	ad_item.setQuitPic(ad_list[n_index].quitpic);
    	ad_item.setDesc(ad_list[n_index].des);
    	ad_item.setPosition(ad_list[n_index].position);
    	ad_item.setEnable(ad_list[n_index].enable);
    	if(cc.sys.os == cc.sys.OS_ANDROID){
    	    ad_item.setArUrl(ad_list[n_index].pkg);
   			ad_item.setArClassName(ad_list[n_index].cname);
   			ad_item.setFuncName(ad_list[n_index].fname);
    	}else{
    	    ad_item.setIOSUrl(ad_list[n_index].apple);
    		ad_item.setIOSClassName(ad_list[n_index].cname);
    		ad_item.setFuncName(ad_list[n_index].fname);
   		}

    	arry_ret[n_index] = ad_item;
   	}
}

function parseVideoList(arry_ret, video_list){
    for(var n_index = 0; n_index < video_list.length; ++n_index){
        var video_item = new VideoItem();
     	video_item.setVid(video_list[n_index].id);
       	video_item.setVImage(video_list[n_index].pic);

       	arry_ret[n_index] = video_item;
    }
}

var AD_INDEX = 0;
var AD_QUIT_INDEX = 0;

function showStarAd(target, star_ad, position){
    if (AD_ENABLE && ARRY_AD_IN && ARRY_AD_IN.length) {
        AD_INDEX = (AD_INDEX + 1) % ARRY_AD_IN.length;
        star_ad = new StarAdLayer(ARRY_AD_IN[AD_INDEX]);
        star_ad.x = position.x;
        star_ad.y = position.y;
        target.addChild(star_ad, 150);
    }
}

function closeStarAd(star_ad){
    if (star_ad) {
        star_ad.closeAd();
        star_ad.removeFromParent(true);
    }

    star_ad = null;
}

function shouldShowLock(){

    return false;
}

function showLockAd(parent, lock_ad){
    if(lock_ad){
        lock_ad.removeFromParent();
        lock_ad = null;
    }

    lock_ad = new LockAdViewLayer(function(action){
        cc.log("show lock view");
        if (action == "quit") {
            lock_ad.removeFromParent(true);
            lock_ad = null;
        }

    }, ARRY_AD_LOCK[0]);

    lock_ad.x = 0;
    lock_ad.y = 0;
    parent.addChild(lock_ad, 600);
}

function getQuitAd(){
    if(!ARRY_AD_QUIT || 0 == ARRY_AD_QUIT.length || !AD_ENABLE){
        return null;
    }

    var cur_quit_index = cc.sys.localStorage.getItem(AD_QUIT_INDEX);

    if(!cur_quit_index){
        cur_quit_index = 0;
        cc.sys.localStorage.setItem(AD_QUIT_INDEX, cur_quit_index);
    }

    cur_quit_index = cur_quit_index % ARRY_AD_QUIT.length;
    var ad_item = ARRY_AD_QUIT[cur_quit_index];

    cc.sys.localStorage.setItem(AD_QUIT_INDEX, ++cur_quit_index);

    return ad_item;

}

function adResource(res_name){
	return "res/adView/" + res_name + ".png";
}

function noAdRes(res_name){
    return "res/adView/no_ad/" + res_name + ".png";
}

