var ad_gap_v = 20;
var ad_height = 90;

AdViewLayer = cc.Layer.extend({
	layer_back:null,
	background:null,
	head_icon:null,
	arry_ad_sprite:null,
	arry_ad_listener:null,
	ad_items:null,
	size:null,
	ctor:function (ad_items, winSize){
		this._super();
		
		ad_gap_v = 20;
		ad_height = 90;

		this.ad_items = ad_items;
		
		this.size = winSize;
		
		this.createComponents();
		
		this.loadAdImages();
		
		this.showAnimation();
		
		this.addListeners();
	},

	createComponents:function(){
		this.background = new cc.Sprite(adResource("back"));
		this.background._setAnchorX(0.5);
		this.background._setAnchorY(1);
		this.background.scaleX = 1;
		this.background.scaleY = 0;
		this.background.x = this.size.width / 2;
		this.background.y = this.size.height - 100;
		this.addChild(this.background, 1)
		
		this.head_icon = new cc.Sprite(adResource("more"));
		this.head_icon.x = -100;
		this.head_icon._setAnchorX(0);
		this.head_icon._setAnchorY(0.5);
		this.head_icon.y = this.size.height - 55;
		
		this.addChild(this.head_icon);
		
		var self = this;
		var ad_listener = cc.EventListener.create({
			event: cc.EventListener.TOUCH_ONE_BY_ONE,
			swallowTouches: true,
			onTouchBegan: function (touch, event) {
				// cc.log("touch begin");
                //
				// var target = event.getCurrentTarget();
				// var locationInNode = target.convertToNodeSpace(touch.getLocation());
                //
				// var s = target.getContentSize();
				// var rect = cc.rect(0, 0, s.width, s.height);
                //
				// if (cc.rectContainsPoint(rect, locationInNode)) {
				var target = event.getCurrentTarget();
				var cameraPos = cc.Camera.getDefaultCamera().getPosition();
				var cameraDeltaPos = cp.v(cameraPos.x - cc.winSize.width/2,cameraPos.y-cc.winSize.height/2);
				var locationInNode = target.convertToNodeSpace(cp.v(cameraDeltaPos.x + touch.getLocation().x ,cameraDeltaPos.y + touch.getLocation().y));
				var s = target.getContentSize();
				var rect = cc.rect(0, 0, s.width, s.height);
				if (cc.rectContainsPoint(rect, locationInNode)) {
					
					self.checkSelectIndex(target);
					
					return false;
				}
				return false;

				return false;
			},
			onTouchMoved: function (touch, event) {

			},
			onTouchEnded: function (touch, event) {
			}
		});
		
		if (this.ad_items) {
			this.arry_ad_listener = [];
			this.arry_ad_sprite = [];
			
			var ad_length = this.ad_items.length> 4 ? 4 : this.ad_items.length;
			
			for (var ad_index = 0; ad_index < ad_length; ad_index++) {
				this.arry_ad_sprite[ad_index] = new cc.Sprite(adResource("ad_back"));
				this.arry_ad_sprite[ad_index].x = this.background.width / 2;
				this.arry_ad_sprite[ad_index].y = this.background.height - 24 - ad_gap_v / 2 - (ad_gap_v + ad_height) * (1 / 2 + ad_index);
				this.arry_ad_sprite[ad_index]._setAnchorX(0.5);
				this.arry_ad_sprite[ad_index]._setAnchorY(0.5);
				this.arry_ad_sprite[ad_index].scale = 0.5;
				this.arry_ad_sprite[ad_index].opacity = 0;
				cc.log(this.ad_items[ad_index].getImage());
			
				this.background.addChild(this.arry_ad_sprite[ad_index], 10 + ad_index);
				this.background.setGlobalZOrder(99);
				this.arry_ad_sprite[ad_index].setGlobalZOrder(99);

				this.arry_ad_listener[ad_index] = ad_listener.clone();
				this.arry_ad_listener[ad_index].retain();
			}
		}
	},
	addListeners:function(){
		if(this.arry_ad_sprite){
			for (var n_ad_index = 0; n_ad_index < this.arry_ad_sprite.length; n_ad_index++) {
				cc.eventManager.addListener(this.arry_ad_listener[n_ad_index], this.arry_ad_sprite[n_ad_index]);
			}
		}
	},
	showAnimation:function(){
		this.head_icon.runAction(cc.moveBy(0.2, cc.p(100, 0)));
		this.background.runAction(cc.sequence(cc.delayTime(0.3), cc.scaleTo(0.3, 1, 1)));
		for (var ad_index = 0; ad_index < this.arry_ad_sprite.length; ad_index++) {
			this.arry_ad_sprite[ad_index].runAction(cc.sequence(
				cc.delayTime(0.6),
				cc.fadeTo(0.2, 255)
			));
		}

	},
	checkSelectIndex:function(target){
		console.log("select index is " + target);
		for (var n_ad = 0; n_ad < this.arry_ad_sprite.length; n_ad++) {
			if (target == this.arry_ad_sprite[n_ad]) {
				cc.log("ad is clicked : " + this.ad_items[n_ad].getName());
				umengEvent("AD_HOME", this.ad_items[n_ad].getName());
				openMarket(this.ad_items[n_ad]);
				break;
			}
		}
	},
	loadAdImages:function(){
		for (var n_ad = 0; n_ad < this.ad_items.length; n_ad++) {
			setWebImage(this.ad_items[n_ad].getImage(), this.arry_ad_sprite[n_ad]);
		}
	}
});







var AdViewLayerIOS = function(ad_items, winSize, parent){
	var retView = {};

	retView.init = function(){
		cc.log("retView.init");
		ad_gap_v = 20;
		ad_height = 90;
		retView.layer_back = null;
		retView.background = null;
		retView.head_icon = null;
		retView.arry_ad_sprite = null;
		retView.arry_ad_listener = null;
		retView.ad_items = ad_items;
		retView.size = winSize;

		retView.rootNode = new cc.Node();
		retView.rootNode.setPosition(0,0);
		parent.addChild(retView.rootNode);
	}();

	retView.createComponents=function(){
		cc.log("retView.createComponent");
		retView.background = new cc.Sprite(adResource("back"));
		retView.background._setAnchorX(0.5);
		retView.background._setAnchorY(1);
		retView.background.scaleX = 1;
		retView.background.scaleY = 0;
		retView.background.x = retView.size.width / 2;
		retView.background.y = retView.size.height - 100;
		retView.rootNode.addChild(retView.background, 1)

		retView.head_icon = new cc.Sprite(adResource("more"));
		retView.head_icon.x = -100;
		retView.head_icon._setAnchorX(0);
		retView.head_icon._setAnchorY(0.5);
		retView.head_icon.y = retView.size.height - 55;
		retView.rootNode.addChild(retView.head_icon);


		var ad_listener = cc.EventListener.create({
			event: cc.EventListener.TOUCH_ONE_BY_ONE,
			swallowTouches: true,
			onTouchBegan: function (touch, event) {
				var target = event.getCurrentTarget();
				var cameraPos = cc.Camera.getDefaultCamera().getPosition();
				var cameraDeltaPos = cp.v(cameraPos.x - cc.winSize.width/2,cameraPos.y-cc.winSize.height/2);
				var locationInNode = target.convertToNodeSpace(cp.v(cameraDeltaPos.x + touch.getLocation().x ,cameraDeltaPos.y + touch.getLocation().y));
				var s = target.getContentSize();
				var rect = cc.rect(0, 0, s.width, s.height);
				if (cc.rectContainsPoint(rect, locationInNode)) {
					retView.checkSelectIndex(target);
					return false;
				}
				return false;
			},
			onTouchMoved: function (touch, event) {
			},
			onTouchEnded: function (touch, event) {
			}
		});

		if (retView.ad_items) {
			retView.arry_ad_listener = [];
			retView.arry_ad_sprite = [];

			var ad_length = retView.ad_items.length> 4 ? 4 : retView.ad_items.length;

			for (var ad_index = 0; ad_index < ad_length; ad_index++) {
				retView.arry_ad_sprite[ad_index] = new cc.Sprite(adResource("ad_back"));
				retView.arry_ad_sprite[ad_index].x = retView.background.width / 2;
				retView.arry_ad_sprite[ad_index].y = retView.background.height - 24 - ad_gap_v / 2 - (ad_gap_v + ad_height) * (1 / 2 + ad_index);
				retView.arry_ad_sprite[ad_index]._setAnchorX(0.5);
				retView.arry_ad_sprite[ad_index]._setAnchorY(0.5);
				retView.arry_ad_sprite[ad_index].scale = 0.5;
				retView.arry_ad_sprite[ad_index].opacity = 0;


				retView.background.addChild(retView.arry_ad_sprite[ad_index], 10 + ad_index);
				retView.background.setGlobalZOrder(99);
				retView.arry_ad_sprite[ad_index].setGlobalZOrder(99);

				retView.arry_ad_listener[ad_index] = ad_listener.clone();
				retView.arry_ad_listener[ad_index].retain();
			}
		}
	}();
	retView.loadAdImages=function(){
		cc.log("retView.loadAdImages");
		for (var n_ad = 0; n_ad < retView.ad_items.length; n_ad++) {
			setWebImage(retView.ad_items[n_ad].getImage(), retView.arry_ad_sprite[n_ad]);
		}
	};
	retView.loadAdImages();
	retView.showAnimation=function(){
		cc.log("retView.showAnimation");
		retView.head_icon.runAction(cc.moveBy(0.2, cc.p(100, 0)));
		retView.background.runAction(cc.sequence(cc.delayTime(0.3), cc.scaleTo(0.3, 1, 1)));
		for (var ad_index = 0; ad_index < retView.arry_ad_sprite.length; ad_index++) {
			retView.arry_ad_sprite[ad_index].runAction(cc.sequence(
				cc.delayTime(0.6),
				cc.fadeTo(0.2, 255)
			));
		}

	}();
	retView.addListeners=function(){
		if(retView.arry_ad_sprite){
			for (var n_ad_index = 0; n_ad_index < retView.arry_ad_sprite.length; n_ad_index++) {
				cc.eventManager.addListener(retView.arry_ad_listener[n_ad_index], retView.arry_ad_sprite[n_ad_index]);
			}
		}
	}();

	retView.checkSelectIndex=function(target){
		console.log("select index is " + target);
		for (var n_ad = 0; n_ad < retView.arry_ad_sprite.length; n_ad++) {
			if (target == retView.arry_ad_sprite[n_ad]) {
				cc.log("ad is clicked : " + retView.ad_items[n_ad].getName());
				umengEvent("AD_HOME", retView.ad_items[n_ad].getName());
				openMarket(retView.ad_items[n_ad]);
				break;
			}
		}
	};

	return retView.rootNode;
};
/*
 this.getAdList(function(){
 	if(AD_ENABLE && ARRY_AD_HOME.length != 0){
 		this.ad_view = AdViewLayerNew(ARRY_AD_HOME, cc.size(140, cc.winSize.height),this);
 		this.ad_view.setGlobalZOrder(100);
 		this.cameraController.pushFollowCameraSprites([this.ad_view]);
 	}
 }.bind(this));
 */