
QuitAdViewLayer = cc.Layer.extend({
	isRoot:null,
	_cb:null,
	_adItem:null,
	
	background:null,
	layer_back:null,
	menu_quit:null,
	menu_continue:null,
	menu_close:null,
	menu:null,
	
	app_sprite:null,

	back_listener:null,
	app_listener:null,
	
	ctor:function (cb, ad_item){
		this._super();
		this._cb = cb;
		this._adItem = ad_item;
		this.createComponents();
		setWebImage(ad_item.getQuitPic(), this.app_sprite);
		this.showAnimation();
	},

	createComponents:function(){
		var size = cc.winSize;
		this.layer_back = new cc.LayerColor(cc.color("#000000"), size.width, size.height);
		this.layer_back.opacity = 150;
		this.layer_back.x = 0;
		this.layer_back.y = 0;
		this.addChild(this.layer_back, 0);
		
		this.background = new cc.Sprite(adResource("quit_back"));
		this.background._setAnchorX(0.5);
		this.background._setAnchorY(0.5);
		this.background.scale = 1;
		this.background.x = size.width / 2;
		this.background.y = size.height / 2;
		this.addChild(this.background, 1);

		var self = this;

		var array_menu_item = [];
        this.menu_quit = new cc.MenuItemImage(
            adResource("quit_quit"),
        	adResource("quit_quit"),
        	function(){
        	    self.cleanRes();
        		console.log("quit click!!!");
        		if (self._cb) {
        		    self._cb("quit");
        		}
        },this);

        this.menu_quit.setPosition(-30, -145);
        this.menu_quit.scale = 1;
        this.menu_quit._setAnchorX(1);
        this.menu_quit._setAnchorY(1);
        array_menu_item[0] = this.menu_quit;


        this.menu_continue = new cc.MenuItemImage(
        	adResource("quit_continue"),
        	adResource("quit_continue_high"),
        	function(){
        	    self.cleanRes();
        	    console.log("continue click!!!");
        		if (self._cb) {
        		    self._cb("continue");
        		}
        },this);

        this.menu_continue.setPosition(30, -145);
        this.menu_continue.scale = 1;
        this.menu_continue._setAnchorX(0);
        this.menu_continue._setAnchorY(1);
        array_menu_item[1] = this.menu_continue;

        this.menu_close = new cc.MenuItemImage(
            adResource("quit_close"),
            adResource("quit_close"),
            function(){
                self.cleanRes();
        	    console.log("close click!!!");
        		if (self._cb) {
        		    self._cb("continue");
        		}
        },this);

        this.menu_close.setPosition(245, 200);
        this.menu_close.scale = 1;
        this.menu_close._setAnchorX(0);
        this.menu_close._setAnchorY(1);
        array_menu_item[2] = this.menu_close;

        this.menu = new cc.Menu(array_menu_item);
        this.addChild(this.menu, 10);

		this.app_sprite = new cc.Sprite(adResource("quit_default"));
		this.app_sprite.x = size.width / 2;
		this.app_sprite.y = size.height / 2 + 5;
		this.addChild(this.app_sprite, 2);

		var layer_listener = cc.EventListener.create({
			event: cc.EventListener.TOUCH_ONE_BY_ONE,
			swallowTouches: true,
			onTouchBegan: function (touch, event) {
				cc.log("touch begin");

                var locationInNode = self.app_sprite.convertToNodeSpace(touch.getLocation());
                var s = self.app_sprite.getContentSize();
                var rect = cc.rect(0, 0, s.width, s.height);
                if(cc.rectContainsPoint(rect, locationInNode)){
                    console.log("app item clicked!!!!");
                    openMarket(self._adItem);
                    return true;
                }

				return true;
			},
			onTouchMoved: function (touch, event) {

			},
			onTouchEnded: function (touch, event) {
			}
		});


		this.back_listener = layer_listener.clone();
		this.back_listener.retain();

		cc.eventManager.addListener(this.back_listener, this.background);
	},
	showAnimation:function(){
//		this.menu_continue.runAction(cc.sequence(cc.scaleTo(0.2, 1.1, 1.1), cc.scaleTo(0.1, 1, 1)));
//		this.menu_quit.runAction(cc.sequence(cc.scaleTo(0.2, 1.1, 1.1), cc.scaleTo(0.1, 1, 1)));
	},
	cleanRes:function(){
	    releaseObj(this.back_listener);
	}
});












QuitAdViewLayerLoop = cc.Layer.extend({
	isRoot:null,
	_cb:null,
	_adItem:null,

	background:null,
	layer_back:null,
	menu_quit:null,
	menu_continue:null,
	menu_close:null,
	menu:null,

	app_sprite:null,

	back_listener:null,
	app_listener:null,

	ctor:function (cb, ad_item){
		this._super();
		this._cb = cb;
		this._showAndEnable = false;
		this._adItem = ad_item;
		this.createComponents();
		setWebImage(ad_item.getQuitPic(), this.app_sprite);
		this.showAnimation();
	},
	showAndEnable:function(isShow){
		this._showAndEnable = isShow;
		if(isShow){
			this.layer_back.setVisible(true);
			this.background.setVisible(true);
			this.menu_quit.setVisible(true);
			this.menu_continue.setVisible(true);
			this.app_sprite.setVisible(true);
			this.menu_quit.couldTouch = true;
			this.menu_continue.couldTouch = true;
			this.app_sprite.couldTouch = true;
		}else{
			this.layer_back.setVisible(false);
			this.background.setVisible(false);
			this.menu_quit.setVisible(false);
			this.app_sprite.setVisible(false);
			this.menu_continue.setVisible(false);
			this.menu_quit.couldTouch = false;
			this.menu_continue.couldTouch = false;
			this.app_sprite.couldTouch = false;
		}
	},
	createComponents:function(){
		var size = cc.winSize;
		this.layer_back = new cc.LayerColor(cc.color("#000000"), size.width, size.height);
		this.layer_back.setGlobalZOrder(100);
		this.layer_back.opacity = 150;
		this.layer_back.x = 0;
		this.layer_back.y = 0;
		this.addChild(this.layer_back, 0);

		this.background = new cc.Sprite(adResource("quit_back"));
		this.background.setGlobalZOrder(100);
		this.background._setAnchorX(0.5);
		this.background._setAnchorY(0.5);
		this.background.scale = 1;
		this.background.x = size.width / 2;
		this.background.y = size.height / 2;
		this.addChild(this.background, 1);

		var self = this;


		this.menu_quit = new cc.Sprite(adResource("quit_quit"));
		this.menu_quit.setGlobalZOrder(100);
		this.menu_quit._setAnchorX(0.5);
		this.menu_quit._setAnchorY(0.5);
		this.menu_quit.scale = 1;
		this.menu_quit.x = size.width / 2 - 130;
		this.menu_quit.y = size.height / 2 - 175;
		this.addChild(this.menu_quit, 1);

		this.menu_continue = new cc.Sprite(adResource("quit_continue"));
		this.menu_continue.setGlobalZOrder(100);
		this.menu_continue._setAnchorX(0.5);
		this.menu_continue._setAnchorY(0.5);
		this.menu_continue.scale = 1;
		this.menu_continue.x = size.width / 2 + 130;
		this.menu_continue.y = size.height / 2 - 175;
		this.addChild(this.menu_continue, 1);

		var self = this;

		this.menu_quit.couldTouch = true;
		this.menu_quit.onTouchBegan=function (touch, event) {
			var target = event.getCurrentTarget();
			var cameraPos = cc.Camera.getDefaultCamera().getPosition();
			var cameraDeltaPos = cp.v(cameraPos.x - cc.winSize.width/2,cameraPos.y-cc.winSize.height/2);
			var locationInNode = target.convertToNodeSpace(cp.v(cameraDeltaPos.x + touch.getLocation().x ,cameraDeltaPos.y + touch.getLocation().y));
			var s = target.getContentSize();
			var rect = cc.rect(0, 0, s.width, s.height);
			if (cc.rectContainsPoint(rect, locationInNode) && target.couldTouch) {
				target.couldTouch = false;
				if (self._cb) {
					self._cb("quit");
				}
				return true;
			}
			return false;
		}
		this.menu_quit.onTouchMoved=function (touch, event) {
		}
		this.menu_quit.onTouchEnded=function (touch, event) {
		}

		this.menu_continue.couldTouch = true;
		this.menu_continue.onTouchBegan=function (touch, event) {
			var target = event.getCurrentTarget();
			var cameraPos = cc.Camera.getDefaultCamera().getPosition();
			var cameraDeltaPos = cp.v(cameraPos.x - cc.winSize.width/2,cameraPos.y-cc.winSize.height/2);
			var locationInNode = target.convertToNodeSpace(cp.v(cameraDeltaPos.x + touch.getLocation().x ,cameraDeltaPos.y + touch.getLocation().y));
			var s = target.getContentSize();
			var rect = cc.rect(0, 0, s.width, s.height);
			if (cc.rectContainsPoint(rect, locationInNode) && target.couldTouch) {
				target.couldTouch = false;
				if (self._cb) {
					self._cb("continue");
				}
				return true;
			}
			return false;
		}
		this.menu_continue.onTouchMoved=function (touch, event) {
		}
		this.menu_continue.onTouchEnded=function (touch, event) {
		}

		registerTouchEventOneByOne(this.menu_quit,true);
		registerTouchEventOneByOne(this.menu_continue,true);



		this.app_sprite = new cc.Sprite(adResource("quit_default"));
		this.app_sprite.x = size.width / 2;
		this.app_sprite.y = size.height / 2 + 5;
		this.addChild(this.app_sprite, 2);
		this.app_sprite.setGlobalZOrder(101);


		this.app_sprite.couldTouch = true;
		this.app_sprite.onTouchBegan=function (touch, event) {
			var target = event.getCurrentTarget();
			var cameraPos = cc.Camera.getDefaultCamera().getPosition();
			var cameraDeltaPos = cp.v(cameraPos.x - cc.winSize.width/2,cameraPos.y-cc.winSize.height/2);
			var locationInNode = target.convertToNodeSpace(cp.v(cameraDeltaPos.x + touch.getLocation().x ,cameraDeltaPos.y + touch.getLocation().y));
			var s = target.getContentSize();
			var rect = cc.rect(0, 0, s.width, s.height);
			if (cc.rectContainsPoint(rect, locationInNode) && target.couldTouch) {
				openMarket(self._adItem);
				return true;
			}
			return false;
		}
		this.app_sprite.onTouchMoved=function (touch, event) {
		}
		this.app_sprite.onTouchEnded=function (touch, event) {
		}
		registerTouchEventOneByOne(this.app_sprite,true);
	},
	showAnimation:function(){
//		this.menu_continue.runAction(cc.sequence(cc.scaleTo(0.2, 1.1, 1.1), cc.scaleTo(0.1, 1, 1)));
//		this.menu_quit.runAction(cc.sequence(cc.scaleTo(0.2, 1.1, 1.1), cc.scaleTo(0.1, 1, 1)));
	},
	cleanRes:function(){
		releaseObj(this.back_listener);
	}
});

