
QuitViewLayer = cc.Layer.extend({
	isRoot:null,
	_cb:null,
	
	background:null,
	layer_back:null,
	menu_quit:null,
	menu_continue:null,
	menu:null,
	
	back_listener:null,
	
	ctor:function (cb){
		this._super();
		this._cb = cb;
		this.createComponents();
		this.showAnimation();
	},

	createComponents:function(){
		var size = cc.winSize;
		this.layer_back = new cc.LayerColor(cc.color("#000000"), size.width, size.height);
		this.layer_back.opacity = 150;
		this.layer_back.x = 0;
		this.layer_back.y = 0;
		this.addChild(this.layer_back, 0);
		
		this.background = new cc.Sprite(noAdRes("quit_back"));
		this.background._setAnchorX(0.5);
		this.background._setAnchorY(0.5);
		this.background.scale = 0;
		this.background.x = size.width / 2;
		this.background.y = size.height / 2;
		this.addChild(this.background, 1);
		
		var self = this;
		
		var array_menu_item = [];
		this.menu_quit = new cc.MenuItemImage(
				noAdRes("quit"),
				noAdRes("quit_high"),
				function(){
					if (self.back_listener) {
						self.back_listener.release();
						self.back_listener = null;
					}
					if (self._cb) {
						self._cb("quit");
					}
				},this);

		this.menu_quit.setPosition(-35, -20);
		this.menu_quit.scale = 0;
		this.menu_quit._setAnchorX(1);
		this.menu_quit._setAnchorY(1);
		array_menu_item[0] = this.menu_quit;
		
		
		this.menu_continue = new cc.MenuItemImage(
				noAdRes("continue"),
				noAdRes("continue_high"),
				function(){
					if (self._cb) {
						self._cb("continue");
					}
				},this);

		this.menu_continue.setPosition(35, -20);
		this.menu_continue.scale = 0;
		this.menu_continue._setAnchorX(0);
		this.menu_continue._setAnchorY(1);
		array_menu_item[1] = this.menu_continue;
		
		this.menu = new cc.Menu(array_menu_item);
//		this.menu._setAnchorX(0.5);
//		this.menu._setAnchorY(0.5);
		this.addChild(this.menu, 10);
		
		var self = this;
		var layer_listener = cc.EventListener.create({
			event: cc.EventListener.TOUCH_ONE_BY_ONE,
			swallowTouches: true,
			onTouchBegan: function (touch, event) {
				cc.log("touch begin");

				return true;
			},
			onTouchMoved: function (touch, event) {

			},
			onTouchEnded: function (touch, event) {
			}
		});
		this.back_listener = layer_listener.clone();
		this.back_listener.retain();
		
		cc.eventManager.addListener(this.back_listener, this.layer_back);
	},
	showAnimation:function(){
		this.background.runAction(cc.sequence(cc.scaleTo(0.2, 1.1, 1.1), cc.scaleTo(0.1, 1, 1)));
		
		this.menu_quit.runAction(cc.sequence(cc.scaleTo(0.2, 1.1, 1.1), cc.scaleTo(0.1, 1, 1)));
		this.menu_continue.runAction(cc.sequence(
				cc.scaleTo(0.2, 1.1, 1.1), 
				cc.scaleTo(0.1, 1, 1)));
	}
});







QuitViewLayerLoop = cc.Layer.extend({
	isRoot:null,
	_cb:null,

	background:null,
	layer_back:null,
	menu_quit:null,
	menu_continue:null,
	menu:null,

	back_listener:null,

	ctor:function (cb){
		this._super();
		this._cb = cb;
		this._showAndEnable = false;
		this.createComponents();
		this.showAnimation();
	},
	showAndEnable:function(isShow){
		this._showAndEnable = isShow;
		if(isShow){
			this.layer_back.setVisible(true);
			this.background.setVisible(true);
			this.menu_quit.setVisible(true);
			this.menu_continue.setVisible(true);
			this.menu_quit.couldTouch = true;
			this.menu_continue.couldTouch = true;
		}else{
			this.layer_back.setVisible(false);
			this.background.setVisible(false);
			this.menu_quit.setVisible(false);
			this.menu_continue.setVisible(false);
			this.menu_quit.couldTouch = false;
			this.menu_continue.couldTouch = false;
		}
	},
	createComponents:function(){
		var size = cc.winSize;
		this.layer_back = new cc.LayerColor(cc.color("#000000"), size.width, size.height);
		this.layer_back.setGlobalZOrder(100);
		this.layer_back.opacity = 150;
		this.layer_back.x = 0;
		this.layer_back.y = 0;
		this.addChild(this.layer_back, 0);

		this.background = new cc.Sprite(noAdRes("quit_back"));
		this.background.setGlobalZOrder(100);
		this.background._setAnchorX(0.5);
		this.background._setAnchorY(0.5);
		this.background.scale = 0;
		this.background.x = size.width / 2;
		this.background.y = size.height / 2;
		this.addChild(this.background, 1);


		this.menu_quit = new cc.Sprite(noAdRes("quit"));
		this.menu_quit.setGlobalZOrder(100);
		this.menu_quit._setAnchorX(0.5);
		this.menu_quit._setAnchorY(0.5);
		this.menu_quit.scale = 0;
		this.menu_quit.x = size.width / 2 - 110;
		this.menu_quit.y = size.height / 2 - 60;
		this.addChild(this.menu_quit, 1);

		this.menu_continue = new cc.Sprite(noAdRes("continue"));
		this.menu_continue.setGlobalZOrder(100);
		this.menu_continue._setAnchorX(0.5);
		this.menu_continue._setAnchorY(0.5);
		this.menu_continue.scale = 0;
		this.menu_continue.x = size.width / 2 + 110;
		this.menu_continue.y = size.height / 2 - 60;
		this.addChild(this.menu_continue, 1);

		var self = this;

		this.menu_quit.couldTouch = true;
		this.menu_quit.onTouchBegan=function (touch, event) {
			var target = event.getCurrentTarget();
			var cameraPos = cc.Camera.getDefaultCamera().getPosition();
			var cameraDeltaPos = cp.v(cameraPos.x - cc.winSize.width/2,cameraPos.y-cc.winSize.height/2);
			var locationInNode = target.convertToNodeSpace(cp.v(cameraDeltaPos.x + touch.getLocation().x ,cameraDeltaPos.y + touch.getLocation().y));
			var s = target.getContentSize();
			var rect = cc.rect(0, 0, s.width, s.height);
			if (cc.rectContainsPoint(rect, locationInNode) && target.couldTouch) {
				target.couldTouch = false;
				if (self._cb) {
					self._cb("quit");
				}
				return true;
			}
			return false;
		}
		this.menu_quit.onTouchMoved=function (touch, event) {
		}
		this.menu_quit.onTouchEnded=function (touch, event) {
		}

		this.menu_continue.couldTouch = true;
		this.menu_continue.onTouchBegan=function (touch, event) {
			var target = event.getCurrentTarget();
			var cameraPos = cc.Camera.getDefaultCamera().getPosition();
			var cameraDeltaPos = cp.v(cameraPos.x - cc.winSize.width/2,cameraPos.y-cc.winSize.height/2);
			var locationInNode = target.convertToNodeSpace(cp.v(cameraDeltaPos.x + touch.getLocation().x ,cameraDeltaPos.y + touch.getLocation().y));
			var s = target.getContentSize();
			var rect = cc.rect(0, 0, s.width, s.height);
			if (cc.rectContainsPoint(rect, locationInNode) && target.couldTouch) {
				target.couldTouch = false;
				if (self._cb) {
					self._cb("continue");
				}
				return true;
			}
			return false;
		}
		this.menu_continue.onTouchMoved=function (touch, event) {
		}
		this.menu_continue.onTouchEnded=function (touch, event) {
		}

		registerTouchEventOneByOne(this.menu_quit,true);
		registerTouchEventOneByOne(this.menu_continue,true);
	},
	showAnimation:function(){
		this.background.runAction(cc.sequence(cc.scaleTo(0.2, 1.1, 1.1), cc.scaleTo(0.1, 1, 1)));

		this.menu_quit.runAction(cc.sequence(cc.scaleTo(0.2, 1.1, 1.1), cc.scaleTo(0.1, 1, 1)));
		this.menu_continue.runAction(cc.sequence(
			cc.scaleTo(0.2, 1.1, 1.1),
			cc.scaleTo(0.1, 1, 1)));
	}
});
