var ad_gap_v = 30;
var ad_height = 76;

StarAdLayer = cc.Layer.extend({
	ad_sprite:null,
	star_cover:null,
	ad_listener:null,
	ad_item:null,
	ctor:function (ad_item){
		this._super();

		this.ad_item = ad_item;
		
		this.createComponents();
		
		this.showAnimation();
		
		this.addListeners();
	},

	createComponents:function(){
		var size = cc.size(146, 120);
		
		this.ad_sprite = new cc.Sprite(adResource("ad_back"));
		this.ad_sprite.x = size.width / 3 + 10;
		this.ad_sprite.y = size.height - 80;
		this.ad_sprite._setAnchorX(1);
		this.ad_sprite._setAnchorY(0);
		this.ad_sprite.scale = 0.0;
		this.addChild(this.ad_sprite, 2);	

		this.star_cover = new cc.Sprite(adResource("star"));
		this.star_cover._setAnchorX(1);
		this.star_cover._setAnchorY(0);
		this.star_cover.scale = 0;
		this.star_cover.x = size.width / 2;
		this.star_cover.y = size.height - 97;
		this.addChild(this.star_cover, 3);
		
		setWebImage(this.ad_item.getImage(), this.ad_sprite);
		
		var self = this;
		var ad_listener = cc.EventListener.create({
			event: cc.EventListener.TOUCH_ONE_BY_ONE,
			swallowTouches: true,
			onTouchBegan: function (touch, event) {
				cc.log("touch begin");

				var target = event.getCurrentTarget();
				var locationInNode = target.convertToNodeSpace(touch.getLocation());

				var s = target.getContentSize();
				var rect = cc.rect(0, 0, s.width, s.height);

				if (cc.rectContainsPoint(rect, locationInNode)) {
					
					self.adClick();
					
					return false;
				}
				return false;

				return false;
			},
			onTouchMoved: function (touch, event) {

			},
			onTouchEnded: function (touch, event) {
			}
		});
		
		this.ad_listener = ad_listener.clone();
		this.ad_listener.retain();
	},
	addListeners:function(){
		cc.eventManager.addListener(this.ad_listener, this.star_cover);
	},
	closeAd:function(){
		if (this.ad_listener) {
			this.ad_listener.release();
			this.ad_listener = null;
		}
	},
	showAnimation:function(){
		this.ad_sprite.runAction(cc.scaleTo(0.3, 0.53, 0.53));
		this.star_cover.runAction(cc.scaleTo(0.3, 1, 1));
	},
	adClick:function(){
		cc.log("ad is clicked : " + this.ad_item.getName());
		umengEvent("AD_IN", this.ad_item.getName());
		openMarket(this.ad_item);

	}
});
