var CameraControllerB3 = Controller.extend({
    _cameraFollowSprite:null,
    _followCameraSpriteList:null,
    _couldMoveCamera:null,
    _camera:null,
    ctor:function(parent){
        this._super(parent);
        this._par = parent;
        this.initController();
        mylog("Camera controller ctor");
    },
    //override
    init:function(){
        mylog("Camera controller init");
        if(isPad()) {
            this.metaData = {
                currentFollowPos: cp.v(cc.winSize.width / 2, cc.winSize.height / 2 - 115 - 7),
            };
        }else{
            this.metaData = {
                currentFollowPos: cp.v(cc.winSize.width / 2, cc.winSize.height / 2 - 115 - 7),
            };
        }
    },
    initController:function(){
        this._followCameraSpriteList = [];
        this._couldMoveCamera = true;
        this._camera = cc.Camera.getDefaultCamera();
        this._cameraBeginPosition = cp.v(cc.winSize.width/2,cc.winSize.height/2);
        this._autoMoveCamera = false;
        this._autoMoveCameraPerFrameSpeed = cp.v(0,0);
        this._cameraCurrentPosition = this._cameraBeginPosition;
        this._openCameraLookY = true;
    },
    getFollowCameraSpriteList:function(){
        return this._followCameraSpriteList;
    },
    getTheCamera:function(){
        return this._camera;
    },
    setCouldeMoveCamera:function(couldeMove){
        this._couldMoveCamera = couldeMove;
    },
    pushFollowCameraSprites:function(sprites){
        for(var i = 0;i < sprites.length;i ++) {
            this._followCameraSpriteList.push(sprites[i]);
        }
    },
    changeCameaState:function(state){
        this._autoMoveCamera = state;
    },
    changeStateToAutoMoveCamera:function(perFrameSpeed){
        this.changeCameaState(true);
        this._autoMoveCameraPerFrameSpeed = perFrameSpeed;
    },
    fromAutoMoveStateToNormal:function(){
        this._autoMoveCameraPerFrameSpeed = cp.v(0,0);
        this.changeCameaState(false);
    },
    setCameraFollowSprite:function(sprite){//camera follow the car
        this._cameraFollowSprite = sprite;
    },
    updateFollowCamerSprites:function(deltaX,deltaY){
        for(var i = 0;i < this._followCameraSpriteList.length;i ++){
            this._followCameraSpriteList[i].setPosition(this._followCameraSpriteList[i].getPosition().x + deltaX,this._followCameraSpriteList[i].getPosition().y + deltaY);
        }
    },
    updateCameraPos:function(){//called in update
        // mylog("cc.Camera.getDefaultCamera().getPosition().y = " + cc.Camera.getDefaultCamera().getPosition().y);
        if(!this._autoMoveCamera) {
            if(this._cameraFollowSprite && this._couldMoveCamera){
                if (this._cameraFollowSprite.getPosition().x < cc.winSize.width / 2 || this._cameraFollowSprite.getPosition().x > 19740 - cc.winSize.width/2) {//这句代码数值需要调整
                    return;
                }

                var deltaX = this._cameraFollowSprite.getPosition().x - this.metaData.currentFollowPos.x;
                var deltaY = 0;
                if (this._openCameraLookY) {
                    deltaY = this._cameraFollowSprite.getPosition().y - this.metaData.currentFollowPos.y;
                }

                var sourceX = cc.Camera.getDefaultCamera().getPosition().x;
                var sourceY = cc.Camera.getDefaultCamera().getPosition().y;
                this._camera.setPosition(sourceX + deltaX, sourceY + deltaY);

                this.updateFollowCamerSprites(deltaX, deltaY);

                this.metaData.currentFollowPos = this._cameraFollowSprite.getPosition();
            }
        }else{
            var sourceX = cc.Camera.getDefaultCamera().getPosition().x;
            var sourceY = cc.Camera.getDefaultCamera().getPosition().y;
            this._camera.setPosition(sourceX + this._autoMoveCameraPerFrameSpeed.x, sourceY + this._autoMoveCameraPerFrameSpeed.y);

            var deltaX = this._cameraFollowSprite.getPosition().x - this.metaData.currentFollowPos.x;
            var deltaY = 0;
            if(this._openCameraLookY){
                deltaY = this._cameraFollowSprite.getPosition().y - this.metaData.currentFollowPos.y;
            }
            this.updateFollowCamerSprites(deltaX + this._autoMoveCameraPerFrameSpeed.x,deltaY + this._autoMoveCameraPerFrameSpeed.y);
        }
    },
});
