function makeA3CarProps(){
	var adjustArgument = 0;
	if(isPad()){
		adjustArgument = 106;
	}else{
		adjustArgument = 0;
	}
	var deltaXY = cp.v(100 - 900,200-96+adjustArgument);//original
    // var deltaXY = cp.v(1300,200+adjustArgument);//0
	// var deltaXY = cp.v(2000,200+adjustArgument);//1
	// var deltaXY = cp.v(4500,400+adjustArgument);//2
	// var deltaXY = cp.v(5100,100+adjustArgument);//3
	// var deltaXY = cp.v(8400,270+adjustArgument);//4
	// var deltaXY = cp.v(10100,270+adjustArgument);//5
	// var deltaXY = cp.v(11100,270+adjustArgument);//6
	// var deltaXY = cp.v(12700,330+adjustArgument);//7
	// var deltaXY = cp.v(14800,400+adjustArgument);//9
	// var deltaXY = cp.v(16800,400+adjustArgument);//over
	var prop = {
		name:"A3",
		deltaXY:deltaXY,
		wheelSpeed:0,
		leftWheelProp:{
			radius:35,
			mass:10,
			pos:cp.v(445+deltaXY.x - 100,235+deltaXY.y-200),
			group:constCar.car.leftWheel.group,
			collisionType:constCar.car.leftWheel.collisionType,
			elastic:0.1,
			friction:0.9,

			grooveJoint:{
				anchor1:cp.v(-60, 0),
				anchor2:cp.v(-60, -40-25)
			},
			dampedSpring:{
				anchor1:cp.v(-60,-25),
				anchor2:cp.v(0,0),
				restLength:35,
				stiffness:500,
				damping:82
			}
		},
		rightWheelProp:{
			radius:35,
			mass:10,
			pos:cp.v(555+deltaXY.x - 100,235+deltaXY.y-200),
			group:constCar.car.rightWheel.group,
			collisionType:constCar.car.rightWheel.collisionType,
			elastic:0.1,
			friction:0.9,

			grooveJoint:{
				anchor1:cp.v(60, 0),
				anchor2:cp.v(60, -40-25)
			},
			dampedSpring:{
				anchor1:cp.v(60,-25),
				anchor2:cp.v(0,0),
				restLength:35,
				stiffness:800,
				damping:82
			}
		},
		chassisProp:{
			verts:[-20	,	10,
				-10	,	20,
				20	,	20,
				40	,	10,
				40	,  -10,
				-20	,  -10,
				-20	,	10],
			mass:5,
			widthHeight:cp.v(80,30),
			pos:cp.v(500+deltaXY.x - 100,300+deltaXY.y-200),
			elastic:0.5,
			friction:1,
			group:constCar.car.chassis.group,
			collisionType:constCar.car.chassis.collisionType,
			scale:2.5,
			offset:cp.v(-10,0),
			massCenterDelta:cp.v(0,0)
		},
		machineArmProp:{
			pos:cp.v(245,34)
		},
		monkey:{
			pos:cp.v(159,52.1),
			scale:0.85
		}
	};
	return prop;
}


function makeLeftWheelA3Car(space,prop){
	mylog("makeLeftWheelACar");
	var leftWheel = {};
	var radius = prop.radius;
	var mass = prop.mass;
	var pos = prop.pos;
	var group = prop.group;
	var collisionType = prop.collisionType;
	var elastic = prop.elastic;
	var friction = prop.friction;

	var body = space.addBody(new cp.Body(mass, cp.momentForCircle(mass, 0.0, radius, cp.vzero)));
	body.setPos(prop.pos);

	leftWheel.body = body;

	var shape = space.addShape(new cp.CircleShape(body, radius, cp.vzero));
	leftWheel.shape = shape;
	shape.setElasticity(elastic);
	shape.setFriction(friction);
	shape.group = group;

	shape.setCollisionType(collisionType);

	return leftWheel;
}
function makeRightWheelA3Car(space,prop){
	var rightWheel = {};

	var radius = prop.radius;
	var mass = prop.mass;
	var pos = prop.pos;
	var group = prop.group;
	var elastic = prop.elastic;
	var friction = prop.friction;
	var collisionType = prop.collisionType;

	var body = space.addBody(new cp.Body(mass, cp.momentForCircle(mass, 0.0, radius, cp.vzero)));
	body.setPos(prop.pos);

	rightWheel.body = body;

	var shape = space.addShape(new cp.CircleShape(body, radius, cp.vzero));
	rightWheel.shape = shape;
	shape.setElasticity(elastic);
	shape.setFriction(friction);
	shape.group = group;

	shape.setCollisionType(collisionType);

	return rightWheel;
}
function makeChassisA3Car(space,prop){
	var chassis = {};

	var verts = prop.verts;
	var mass = prop.mass;
	var pos = prop.pos;
	var elastic = prop.elastic;
	var friction = prop.friction;
	var group = prop.group;
	var collisionType = prop.collisionType;
	var scale = prop.scale;
	var offset = prop.offset;
	var widthHeight = prop.widthHeight;
	var massCenterDelta = prop.massCenterDelta;

	for(var i = 0;i < verts.length;i ++){
		if(0 == i % 2){
			verts[i] += offset.x;
		}else{
			verts[i] += offset.y;
		}
		verts[i] *= scale;
	}

	var body = space.addBody(new cp.Body(mass, cp.momentForPoly(mass, verts, cp.v(0,0))));

	body.setPos(cp.v.add(pos,massCenterDelta));

	chassis.body = body;

	var shape = space.addShape(new cp.PolyShape(body, verts, cp.vzero));
	chassis.shape = shape;

	shape.setElasticity(elastic);
	shape.setFriction(friction);
	shape.group = group;
	shape.setCollisionType(collisionType);

	return chassis;
}

function makeWheelsJointsA3Car(space,chassis,leftWheel,rightWheel,leftWheelProp,rightWheelProp,carprop){
	//grooveJoint
	leftWheel.grooveJoint = makeGrooveJoint(space,chassis.body, leftWheel.body, leftWheelProp.grooveJoint.anchor1, leftWheelProp.grooveJoint.anchor2);
	rightWheel.grooveJoint = makeGrooveJoint(space,chassis.body, rightWheel.body, rightWheelProp.grooveJoint.anchor1, rightWheelProp.grooveJoint.anchor2);
	//dampedSpring
	leftWheel.dampedSpring = makeDampedSpring(space,chassis.body,leftWheel.body,leftWheelProp.dampedSpring.anchor1,leftWheelProp.dampedSpring.anchor2,
		leftWheelProp.dampedSpring.restLength,leftWheelProp.dampedSpring.stiffness,leftWheelProp.dampedSpring.damping);
	rightWheel.dampedSpring = makeDampedSpring(space,chassis.body,rightWheel.body,rightWheelProp.dampedSpring.anchor1,rightWheelProp.dampedSpring.anchor2,
		rightWheelProp.dampedSpring.restLength,rightWheelProp.dampedSpring.stiffness,rightWheelProp.dampedSpring.damping);
	//motorJoint
	leftWheel.motorJoint = makeMotorJoint(space,leftWheel.body,chassis.body,carprop.wheelSpeed);
	rightWheel.motorJoint = makeMotorJoint(space,chassis.body,rightWheel.body,carprop.wheelSpeed*(-1));
}

function makeMachineArmA3Car(parent,pos){
	var machinearm = {};
	machinearm.animName = ["cycle","land-3","land-5","land-1-4","land-2-qiqiu","stone-1","stone-2","sea-zhangyu","sea-xiong","sea-jinyu","sea-haima"];
	machinearm = createSkeletonSprite("res/car_a/common/che/anim/skeleton.json", "res/car_a/common/che/anim/skeleton.atlas", 1, parent, pos, -1);

	machinearm.setCompleteListener(function(trackEntry){
		var animationName = trackEntry.animation ? trackEntry.animation.name : "nullname";
		if(animationName != "cycle") {
			mylog(animationName + " is over");
		}
		if("nullname" != animationName && "cycle" != animationName){
			machinearm.setRotation(0);
			machinearm.setAnimation(1,"cycle",true);
			machinearm.stopAllActions();
			machinearm.runAction(cc.repeatForever(cc.sequence(cc.rotateTo(2,2),cc.rotateTo(2,-4),cc.rotateTo(2,2))));
		}
	});

	machinearm.runCycle = function(){
		machinearm.runAction(cc.repeatForever(cc.sequence(cc.rotateTo(2,2),cc.rotateTo(2,-4),cc.rotateTo(2,2))));
		machinearm.setAnimation(1,"cycle",true);
	}

	machinearm.runCycle();
	return machinearm;
}
function makeMonkeyA3Car(parent,pos,scale){
	var skel = {};

	skel.animName = ["biaoqing1","biaoqing2","biaoqing3","biaoqing4","biaoqing5"];
	skel.skelSprite = createSkeletonSprite("res/skel/monkey/skeleton.json", "res/skel/monkey/skeleton.atlas", scale, parent, pos, -1);
	skel.skelSprite.setGlobalZOrder(constCar.globalZOrder.level_pos10);

	recvCustomEvent("labelAddOne",function(){
		var name = ["biaoqing1","biaoqing3","biaoqing4","biaoqing5"];
		var idx = getRand0ToN(3);
		skel.skelSprite.setAnimation(1,name[idx],false);
	});

	skel.skelSprite.setCompleteListener(function(trackEntry){
		var animationName = trackEntry.animation ? trackEntry.animation.name : "nullname";
		if(animationName != skel.animName[1]) {
			skel.skelSprite.setAnimation(1,skel.animName[1],true);
		}else{

		}
	});

	skel.runCycle = function(){
		// skel.skelSprite.runAction(cc.repeatForever(cc.sequence(cc.rotateTo(1,2),cc.rotateTo(1,-4),cc.rotateTo(1,2))));
		skel.skelSprite.setAnimation(1,skel.animName[1],true);
	}

	skel.runCycle();
	return skel;
}
function makeA3Car(space,carProp,parent){
	mylog("make A car");
	var car = {};
	car.balance_sin = 0.0;
	car.last_v = 0.0;

	car.prop = carProp;
	car.leftWheel = makeLeftWheelA3Car(space,car.prop.leftWheelProp);
	car.rightWheel = makeRightWheelA3Car(space,car.prop.rightWheelProp);
	car.chassis = makeChassisA3Car(space,car.prop.chassisProp);

	car.chassisSpr = makeSkin(car.chassis,"res/car_a/common/che/chesheng",cc.p(0.54,0.18),parent,0,0,cc.p(400+car.prop.deltaXY.x,100+car.prop.deltaXY.y),1);
	car.leftWheelSpr = makeSkin(car.leftWheel,"res/car_a/common/che/chelun1",cc.p(0.5,0.5),parent,0,0,cc.p(345+car.prop.deltaXY.x,35+car.prop.deltaXY.y),1);
	car.rightWheelSpr = makeSkin(car.rightWheel,"res/car_a/common/che/chelun1",cc.p(0.5,0.5),parent,0,0,cc.p(455+car.prop.deltaXY.x,35+car.prop.deltaXY.y),1);

	car.leftSpr = new cc.Sprite("res/car_a/common/che/chelun1");
	car.leftSpr.setGlobalZOrder(constCar.globalZOrder.level_pos10);
	car.chassisSpr.addChild(car.leftSpr);
	car.leftSpr.setPosition(cp.v(76.5,-20));

	car.rightSpr = new cc.Sprite("res/car_a/common/che/chelun1");
	car.rightSpr.setGlobalZOrder(constCar.globalZOrder.level_pos10);
	car.chassisSpr.addChild(car.rightSpr);
	car.rightSpr.setPosition(cp.v(76.5+120.5,-20));

	car.isVisibleLeftRightSpr = function(isVisible){
		mylog("isVisibleLeftRightSpr false");

		car.leftSpr.setVisible(isVisible);
		car.rightSpr.setVisible(isVisible);

		car.leftWheelSpr.setVisible(!isVisible);
		car.rightWheelSpr.setVisible(!isVisible);
	};

	car.machinearm = makeMachineArmA3Car(car.chassisSpr,car.prop.machineArmProp.pos);
	car.machinearm.setGlobalZOrder(constCar.globalZOrder.level_pos10);

	car.monkeySkel = makeMonkeyA3Car(car.chassisSpr,car.prop.monkey.pos,car.prop.monkey.scale);

	makeWheelsJointsA3Car(space,car.chassis,car.leftWheel,car.rightWheel,car.prop.leftWheelProp,car.prop.rightWheelProp,car.prop);

	car.addLeftCollisionLine = function(space,body,prop){
		var group = prop.group;
		var width = prop.width;
		var layers = prop.layers;

		var shape = space.addShape(new cp.SegmentShape(body,cp.v(-120,-70),cp.v(-120,70),width));
		shape.group = group;
		car.leftcollisionshape = shape;
		// shape.layers = ~cp.ALL_LAYERS;//because of default layers is cp.ALL_LAYERS
		// shape.layers = ~constCar.collisionlines.layers;
		// shape.layers = 0xfffe;
		shape.layers = layers;

		return shape;
	};
	car.addLeftCollisionLine(space,car.chassis.body,{
		group:parent.metaData.road.group,
		width:5,
		// layers:~constCar.collisionlines.layers
		layers:3
	});

	car.addRightCollisionLine = function(space,body,prop){
		var group = prop.group;
		var width = prop.width;
		var layers = prop.layers;

		var shape = space.addShape(new cp.SegmentShape(body,cp.v(120,-70),cp.v(120,70),width));
		shape.group = group;
		car.rightcollisionshape = shape;
		// shape.layers = ~cp.ALL_LAYERS;//because of default layers is cp.ALL_LAYERS
		// shape.layers = ~constCar.collisionlines.layers;
		// shape.layers = 0xfffe;
		shape.layers = layers;

		return shape;
	};
	car.addRightCollisionLine(space,car.chassis.body,{
		group:parent.metaData.road.group,
		width:5,
		// layers:~constCar.collisionlines.layers
		layers:3
	});

	car.addPuff = function(par){
		car.puff = {};

		car.puff.particleSystem = new cc.ParticleSystem("res/common/huoyan/puff.plist");
		car.puff.particleSystem.setGlobalZOrder(par.getGlobalZOrder());
		// car.puff.particleSystem.duration = cc.ParticleSystem.DURATION_INFINITY;
		// car.puff.particleSystem.setAutoRemoveOnFinish(true);
		car.puff.particleSystem.setPosition(cp.v(36,120));
		// car.puff.particleSystem.setPositionType(cc.ParticleSystem.TYPE_GROUPED);
		par.addChild(car.puff.particleSystem, -10);


		return car.puff;
	}(car.chassisSpr);
	// car.leftWheelSpr.setOpacity(100);
	// car.rightWheelSpr.setOpacity(100);
	// car.chassisSpr.setOpacity(100);
	// car.machinearm.setOpacity(150);

	car.audioManager = function(){
		var audioManager = {};
		audioManager.carAudioRunningCtl = audioController("res/common/audio/car/xingzou.mp3",true,constCar.volume.maxVolume,constCar.volume.minVolume,function(){

		});

		audioManager.carAudioRunningCtl.start();
		audioManager.carAudioRunningCtl.setVolume(0);

		return audioManager;
	}();

	//first : this.car.leftWheel.motorJoint.rate = -10;//change speed
	//second: set the gravity to 0,then by the physicssprite run action to change the speed or the run line
	car.changeSpeed = function(speed){
		car.prop.wheelSpeed = speed;
		car.leftWheel.motorJoint.rate = car.prop.wheelSpeed * (-1);
		car.rightWheel.motorJoint.rate = car.prop.wheelSpeed * 1;
	};

	// car.stopToTargetX = function(dt,target_x,callback,idx,updatecontroller) {
	// 	if(typeof callback == "undefined"){
	// 		return;
	// 	}
	// 	if(callback.controlValue){
	// 		var balance_body = car.chassis.body;
	// 		var wheel_body   = car.leftWheel.body;
    //
	// 		mylog("\n\n");
	// 		/*cpFloat*/ var max_v = 150.0;
	// 		mylog("max_v = " + max_v);
	// 		/*cpFloat*/ var target_v = fclamp(biascoef(0.5, dt/1.2)*(target_x - balance_body.p.x)/dt, -max_v, max_v);
	// 		mylog("target_v = " + target_v);
	// 		/*cpFloat*/ var error_v = (target_v - balance_body.v.x);
	// 		mylog("error_v = " + error_v);
	// 		/*cpFloat*/ var target_sin = 3.0e-3*biascoef(0.1, dt)*error_v/dt;
	// 		mylog("target_sin = " + target_sin);
    //
	// 		/*cpFloat*/ var max_sin = Math.sin(0.5);
	// 		mylog("max_sin = " + max_sin);
	// 		car.balance_sin = fclamp(car.balance_sin - 6.0e-4*biascoef(0.2, dt)*error_v/dt, -max_sin, max_sin);
	// 		mylog("car.balance_sin = " + car.balance_sin);
	// 		/*cpFloat*/ var target_a = Math.asin(fclamp(-target_sin + car.balance_sin, -max_sin, max_sin));
	// 		mylog("target_a = " + target_a);
	// 		/*cpFloat*/ var angular_diff = Math.asin(cp.v.cross(balance_body.rot, cp.v.forangle(target_a)));
	// 		mylog("angular_diff = " + angular_diff);
	// 		/*cpFloat*/ var target_w = biascoef(0.1, dt/0.4)*(angular_diff)/dt;
	// 		mylog("target_w = " + target_w);
    //
	// 		/*cpFloat*/ var max_rate = 35.0;
	// 		mylog("max_rate = " + max_rate);
	// 		/*cpFloat*/ var rate = fclamp(wheel_body.w + balance_body.w - 3 * target_w, -max_rate, max_rate);
	// 		mylog("rate = " + rate);
    //
	// 		var tmpRate = fclamp(rate, -max_rate, max_rate);
	// 		car.changeSpeed(tmpRate);
	// 		mylog("tmpRate = " + tmpRate);
	// 		car.leftWheel.motorJoint.maxForce = (7.0e4);
	// 		car.rightWheel.motorJoint.maxForce = (7.0e4);
    //
    //
	// 		car.audioManager.carAudioRunningCtl.setVolume(0.4);
    //
	// 		// if(Math.abs(car.chassisSpr.getPositionX() - target_x) < 3 || Math.abs(tmpRate) < 0.01){
	// 		if(Math.abs(car.chassisSpr.getPositionX() - target_x) < 1 && Math.abs(tmpRate) < 0.04){
	// 			callback.controlValue = false;
	// 			car.leftWheel.motorJoint.maxForce = (Infinity);
	// 			car.rightWheel.motorJoint.maxForce = (Infinity);
	// 			callback();
	// 		}
	// 	}
	// }
	car.stopToTargetX = function(dt,target_x,callback,idx,updatecontroller) {
		if(typeof callback == "undefined"){
			return;
		}
		if(callback.controlValue){
			var balance_body = car.chassis.body;
			var wheel_body   = car.leftWheel.body;

			mylog("\n\n");
			/*cpFloat*/ var max_v = 150.0;
			mylog("max_v = " + max_v);
			/*cpFloat*/ var target_v = fclamp(biascoef(0.5, dt/1.2)*(target_x - balance_body.p.x)/dt, -max_v, max_v);
			mylog("target_v = " + target_v);
			/*cpFloat*/ var error_v = (target_v - balance_body.v.x);
			mylog("error_v = " + error_v);
			/*cpFloat*/ var target_sin = 3.0e-3*biascoef(0.1, dt)*error_v/dt;
			mylog("target_sin = " + target_sin);

			/*cpFloat*/ var max_sin = Math.sin(0.5);
			mylog("max_sin = " + max_sin);
			car.balance_sin = fclamp(car.balance_sin - 6.0e-4*biascoef(0.2, dt)*error_v/dt, -max_sin, max_sin);
			mylog("car.balance_sin = " + car.balance_sin);
			/*cpFloat*/ var target_a = Math.asin(fclamp(-target_sin + car.balance_sin, -max_sin, max_sin));
			mylog("target_a = " + target_a);
			/*cpFloat*/ var angular_diff = Math.asin(cp.v.cross(balance_body.rot, cp.v.forangle(target_a)));
			mylog("angular_diff = " + angular_diff);
			/*cpFloat*/ var target_w = biascoef(0.1, dt/0.4)*(angular_diff)/dt;
			mylog("target_w = " + target_w);

			// /*cpFloat*/ var max_rate = 25.0;
			var max_rate = Math.abs(car.chassisSpr.getPositionX() - target_x);
			mylog("max_rate = " + max_rate);
			/*cpFloat*/ var rate = fclamp(wheel_body.w + balance_body.w - 3 * target_w, -max_rate, max_rate);
			mylog("rate = " + rate);

			var tmpRate = fclamp(rate, -max_rate, max_rate);
			car.changeSpeed(tmpRate);
			mylog("tmpRate = " + tmpRate);
			car.leftWheel.motorJoint.maxForce = (10.0e4);//10.0e4
			car.rightWheel.motorJoint.maxForce = (10.0e4);//10.0e4


			car.audioManager.carAudioRunningCtl.setVolume(0.4);

			// if(Math.abs(car.chassisSpr.getPositionX() - target_x) < 3 || Math.abs(tmpRate) < 0.01){
			if((Math.abs(tmpRate) > constCar.tmpRateDelta.car1) && (Math.abs(car.chassisSpr.getPositionX() - target_x) < 6)){
				callback.controlValue = false;
				car.leftWheel.motorJoint.maxForce = (Infinity);
				car.rightWheel.motorJoint.maxForce = (Infinity);
				callback();
			}
		}
	};

	car.resetAllForces = function(){

	};

	car.isHideAll = function(isHide){
		var opacity = isHide ? 1 : 255;
		car.leftWheelSpr.setOpacity(opacity);
		car.rightWheelSpr.setOpacity(opacity);
		car.chassisSpr.setOpacity(opacity);
		car.machinearm.setOpacity(opacity);
		car.monkeySkel.skelSprite.setOpacity(opacity);
		car.addPuff.particleSystem.setOpacity(opacity);
		car.addPuff.particleSystem.setVisible(!isHide);
	};

	car.removeAllJointsShapeBody = function(){
		space.removeConstraint(car.leftWheel.grooveJoint);
		space.removeConstraint(car.rightWheel.grooveJoint);

		space.removeConstraint(car.leftWheel.dampedSpring);
		space.removeConstraint(car.rightWheel.dampedSpring);

		space.removeConstraint(car.leftWheel.motorJoint);
		space.removeConstraint(car.rightWheel.motorJoint);

		space.removeShape(car.leftWheel.shape);
		space.removeShape(car.rightWheel.shape);
		space.removeShape(car.chassis.shape);

		space.removeShape(car.leftcollisionshape);
		space.removeShape(car.rightcollisionshape);

		space.removeBody(car.leftWheel.body);
		space.removeBody(car.rightWheel.body);
		space.removeBody(car.chassis.body);

		car.resetAllForces();
	};

	car.readdAllJointsShapeBody = function(deltaxy){
		car.moveDeltaXY = deltaxy;
		//我一直不明白的是chassisbody和wheelbody的处理方式不同
		var leftwheelbody = car.leftWheel.body;
		leftwheelbody.setPos(cp.v.add(leftwheelbody.getPos(),cp.v.add(deltaxy,cp.v(0,0))));
		space.addBody(leftwheelbody);

		var rightwheelbody = car.rightWheel.body;
		rightwheelbody.setPos(cp.v.add(rightwheelbody.getPos(),cp.v.add(deltaxy,cp.v(0,0))));
		space.addBody(rightwheelbody);


		var chassisbody = car.chassis.body;
		chassisbody.setPos(cp.v.add(chassisbody.getPos(),cp.v.add(cp.v(0,0),cp.v(0,0))));
		space.addBody(chassisbody);

		space.addShape(car.leftWheel.shape);
		space.addShape(car.rightWheel.shape);
		space.addShape(car.chassis.shape);

		space.addShape(car.leftcollisionshape);
		space.addShape(car.rightcollisionshape);

		space.addConstraint(car.leftWheel.grooveJoint);
		space.addConstraint(car.rightWheel.grooveJoint);

		space.addConstraint(car.leftWheel.dampedSpring);
		space.addConstraint(car.rightWheel.dampedSpring);

		space.addConstraint(car.leftWheel.motorJoint);
		space.addConstraint(car.rightWheel.motorJoint);

		car.resetAllForces();
	};

	car.readdAllJointsShapeBodyNormal = function(){
		var leftwheelbody = car.leftWheel.body;
		leftwheelbody.setPos(cp.v.add(leftwheelbody.getPos(),cp.v(0,0)));
		space.addBody(leftwheelbody);

		var rightwheelbody = car.rightWheel.body;
		rightwheelbody.setPos(cp.v.add(rightwheelbody.getPos(),cp.v(0,0)));
		space.addBody(rightwheelbody);


		var chassisbody = car.chassis.body;
		chassisbody.setPos(cp.v.add(chassisbody.getPos(),cp.v(0,0)));
		space.addBody(chassisbody);

		space.addShape(car.leftWheel.shape);
		space.addShape(car.rightWheel.shape);
		space.addShape(car.chassis.shape);

		space.addShape(car.leftcollisionshape);
		space.addShape(car.rightcollisionshape);

		space.addConstraint(car.leftWheel.grooveJoint);
		space.addConstraint(car.rightWheel.grooveJoint);

		space.addConstraint(car.leftWheel.dampedSpring);
		space.addConstraint(car.rightWheel.dampedSpring);

		space.addConstraint(car.leftWheel.motorJoint);
		space.addConstraint(car.rightWheel.motorJoint);

		car.resetAllForces();
	};

	car.isVisibleLeftRightSpr(false);
	return car;
}
