function makeB2CarProps(){
	// var deltaXY = cp.v(0,0);//
	var adjustArgument = 0;
	if(isPad()){
		adjustArgument = 106;
	}else{
		adjustArgument = 0;
	}
	var deltaXY = cp.v(0 - 600,-100+10+adjustArgument);//original
	// var deltaXY = cp.v(300,0+adjustArgument);//1
	// var deltaXY = cp.v(951,-380+adjustArgument);//2
	// var deltaXY = cp.v(1300,-400+adjustArgument);//3
	// var deltaXY = cp.v(3000,-300+adjustArgument);//4
	// var deltaXY = cp.v(3400,-300+adjustArgument);//5
	// var deltaXY = cp.v(4800,-200+adjustArgument);//6
	// var deltaXY = cp.v(8800,-200+adjustArgument);//7
	// var deltaXY = cp.v(10000,100+adjustArgument);//over
	var prop = {
			name:"B2",
			deltaXY:deltaXY,
			wheelSpeed:0,
			leftWheelProp:{
				radius:26,
				mass:18,
				pos:cp.v(360-18.5-5+deltaXY.x-100,400+deltaXY.y-200),
				group:constCar.car.chassis.group,
				collisionType:constCar.car.chassis.collisionType,
				elastic:0,
				friction:1.2,

				grooveJoint:{
					anchor1:cp.v(-60+5, 0),
					anchor2:cp.v(-60+5, -50-10+10)
				},
				dampedSpring:{
					anchor1:cp.v(-90,0),
					anchor2:cp.v(0,0),
					restLength:35+30,
					stiffness:800,
					damping:82
				}
			},
			leftCenterWheelProp:{
				radius:26,
				mass:14,
				pos:cp.v(420-18.5-4-5+deltaXY.x-100,400+deltaXY.y-200),
				group:constCar.car.chassis.group,
				collisionType:constCar.car.chassis.collisionType,
				elastic:0,
				friction:1.2,

				grooveJoint:{
					anchor1:cp.v(-10+5, 0),
					anchor2:cp.v(-10+5, -50-10+10 + 2)
				},
				dampedSpring:{
					anchor1:cp.v(-30,0),
					anchor2:cp.v(0,0),
					restLength:35+30,
					stiffness:500,
					damping:82 * 2
				}
			},
			centerRightWheelProp:{
				radius:26,
				mass:16,
				pos:cp.v(480-18.5-8-5+deltaXY.x-100,400+deltaXY.y-200),
				group:constCar.car.chassis.group,
				collisionType:constCar.car.chassis.collisionType,
				elastic:0,
				friction:1.2,

				grooveJoint:{
					anchor1:cp.v(40+5, 0),
					anchor2:cp.v(40+5, -50-10+10 + 2)
				},
				dampedSpring:{
					anchor1:cp.v(30,0),
					anchor2:cp.v(0,0),
					restLength:35+30,
					stiffness:500,
					damping:82 * 2
				}
			},
			rightWheelProp:{
				radius:26,
				mass:22,
				pos:cp.v(540-18.5-12-5+deltaXY.x-100,400+deltaXY.y-200),
				group:constCar.car.chassis.group,
				collisionType:constCar.car.chassis.collisionType,
				elastic:0,
				friction:1.2,

				grooveJoint:{
					anchor1:cp.v(90+5, 0),
					anchor2:cp.v(90+5, -50-10+10)
				},
				dampedSpring:{
					anchor1:cp.v(90,0),
					anchor2:cp.v(0,0),
					restLength:35+30,
					stiffness:800,
					damping:82
				}
			},
			chassisProp:{
				verts:[-20	,	10,
				       -10	,	20,
				       20	,	20,
				       40	,	10,
				       40	,  -10,
				       -20	,  -10,
				       -20	,	10],
				       mass:5,
				       widthHeight:cp.v(80,30),
				       pos:cp.v(500-110+deltaXY.x-100,300+150+deltaXY.y-200),
				       elastic:0,
				       friction:1,
				       group:constCar.car.chassis.group,
				       collisionType:constCar.car.chassis.collisionType,
				       scale:3,
				       offset:cp.v(0,0),
				       massCenterDelta:cp.v(0,0)
			},
			machineArmProp:{
				pos:cp.v(245,34)
			},
			monkey:{
				pos:cp.v(149,68.1),
				scale:0.85
			}
	};
	return prop;
}

function makeLeftWheelB2Car(space,prop){
	var leftWheel = {};
	var radius = prop.radius;
	var mass = prop.mass;
	var pos = prop.pos;
	var group = prop.group;

	var collisionType = prop.collisionType;
	var elastic = prop.elastic;
	var friction = prop.friction;

	var body = space.addBody(new cp.Body(mass, cp.momentForCircle(mass, 0.0, radius, cp.vzero)));
	body.setPos(prop.pos);

	leftWheel.body = body;

	var shape = space.addShape(new cp.CircleShape(body, radius, cp.vzero));
	leftWheel.shape = shape;
	shape.setElasticity(elastic);
	shape.setFriction(friction);
	shape.group = group;

	shape.setCollisionType(collisionType);

	return leftWheel;
}
function makeLeftCenterWheelB2Car(space,prop){
	var leftCenterWheel = {};
	var radius = prop.radius;
	var mass = prop.mass;
	var pos = prop.pos;
	var group = prop.group;
	var collisionType = prop.collisionType;
	var elastic = prop.elastic;
	var friction = prop.friction;

	var body = space.addBody(new cp.Body(mass, cp.momentForCircle(mass, 0.0, radius, cp.vzero)));
	body.setPos(prop.pos);

	leftCenterWheel.body = body;

	var shape = space.addShape(new cp.CircleShape(body, radius, cp.vzero));
	leftCenterWheel.shape = shape;
	shape.setElasticity(elastic);
	shape.setFriction(friction);
	shape.group = group;

	shape.setCollisionType(collisionType);

	return leftCenterWheel;
}
function makeRightWheelB2Car(space,prop){
	var rightWheel = {};

	var radius = prop.radius;
	var mass = prop.mass;
	var pos = prop.pos;
	var group = prop.group;
	var elastic = prop.elastic;
	var friction = prop.friction;
	var collisionType = prop.collisionType;

	var body = space.addBody(new cp.Body(mass, cp.momentForCircle(mass, 0.0, radius, cp.vzero)));
	body.setPos(prop.pos);

	rightWheel.body = body;

	var shape = space.addShape(new cp.CircleShape(body, radius, cp.vzero));
	rightWheel.shape = shape;
	shape.setElasticity(elastic);
	shape.setFriction(friction);
	shape.group = group;

	shape.setCollisionType(collisionType);

	return rightWheel;
}
function makeCenterRightWheelB2Car(space,prop){
	var centerRightWheel = {};
	var radius = prop.radius;
	var mass = prop.mass;
	var pos = prop.pos;
	var group = prop.group;
	var collisionType = prop.collisionType;
	var elastic = prop.elastic;
	var friction = prop.friction;

	var body = space.addBody(new cp.Body(mass, cp.momentForCircle(mass, 0.0, radius, cp.vzero)));
	body.setPos(prop.pos);

	centerRightWheel.body = body;

	var shape = space.addShape(new cp.CircleShape(body, radius, cp.vzero));
	centerRightWheel.shape = shape;
	shape.setElasticity(elastic);
	shape.setFriction(friction);
	shape.group = group;

	shape.setCollisionType(collisionType);

	return centerRightWheel;
}
function makeChassisB2Car(space,prop){
	var chassis = {};

	var verts = prop.verts;
	var mass = prop.mass;
	var pos = prop.pos;
	var elastic = prop.elastic;
	var friction = prop.friction;
	var group = prop.group;
	var collisionType = prop.collisionType;
	var scale = prop.scale;
	var offset = prop.offset;
	var widthHeight = prop.widthHeight;
	var massCenterDelta = prop.massCenterDelta;

	for(var i = 0;i < verts.length;i ++){
		if(0 == i % 2){
			verts[i] += offset.x;
		}else{
			verts[i] += offset.y;
		}
		verts[i] *= scale;
	}

	var body = space.addBody(new cp.Body(mass, cp.momentForPoly(mass, verts, cp.v(0,0))));

	body.setPos(cp.v.add(pos,massCenterDelta));

	chassis.body = body;

	var shape = space.addShape(new cp.PolyShape(body, verts, cp.vzero));
	chassis.shape = shape;

	shape.setElasticity(elastic);
	shape.setFriction(friction);
	shape.group = group;
	shape.setCollisionType(collisionType);

	return chassis;
}

function makeWheelsJointsB2Car(space,chassis,leftWheel,rightWheel,leftWheelProp,rightWheelProp,carprop){
	//grooveJoint
	leftWheel.grooveJoint = makeGrooveJoint(space,chassis.body, leftWheel.body, leftWheelProp.grooveJoint.anchor1, leftWheelProp.grooveJoint.anchor2);
	rightWheel.grooveJoint = makeGrooveJoint(space,chassis.body, rightWheel.body, rightWheelProp.grooveJoint.anchor1, rightWheelProp.grooveJoint.anchor2);
	//dampedSpring
	leftWheel.dampedSpring = makeDampedSpring(space,chassis.body,leftWheel.body,leftWheelProp.dampedSpring.anchor1,leftWheelProp.dampedSpring.anchor2,
		leftWheelProp.dampedSpring.restLength,leftWheelProp.dampedSpring.stiffness,leftWheelProp.dampedSpring.damping);
	rightWheel.dampedSpring = makeDampedSpring(space,chassis.body,rightWheel.body,rightWheelProp.dampedSpring.anchor1,rightWheelProp.dampedSpring.anchor2,
		rightWheelProp.dampedSpring.restLength,rightWheelProp.dampedSpring.stiffness,rightWheelProp.dampedSpring.damping);
	//motorJoint
	leftWheel.motorJoint = makeMotorJoint(space,leftWheel.body,chassis.body,carprop.wheelSpeed);
	rightWheel.motorJoint = makeMotorJoint(space,chassis.body,rightWheel.body,carprop.wheelSpeed*(-1));
}
function makeCenterWheelsJointsB2Car(space,chassis,leftCenterWheel,centerRightWheel,leftCenterWheelProp,centerRightWheelProp,carprop){
	//grooveJoint
	leftCenterWheel.grooveJoint = makeGrooveJoint(space,chassis.body, leftCenterWheel.body, leftCenterWheelProp.grooveJoint.anchor1, leftCenterWheelProp.grooveJoint.anchor2);
	centerRightWheel.grooveJoint = makeGrooveJoint(space,chassis.body, centerRightWheel.body, centerRightWheelProp.grooveJoint.anchor1, centerRightWheelProp.grooveJoint.anchor2);
	//dampedSpring
	leftCenterWheel.dampedSpring = makeDampedSpring(space,chassis.body,leftCenterWheel.body,leftCenterWheelProp.dampedSpring.anchor1,leftCenterWheelProp.dampedSpring.anchor2,
		leftCenterWheelProp.dampedSpring.restLength,leftCenterWheelProp.dampedSpring.stiffness,leftCenterWheelProp.dampedSpring.damping);
	centerRightWheel.dampedSpring = makeDampedSpring(space,chassis.body,centerRightWheel.body,centerRightWheelProp.dampedSpring.anchor1,centerRightWheelProp.dampedSpring.anchor2,
		centerRightWheelProp.dampedSpring.restLength,centerRightWheelProp.dampedSpring.stiffness,centerRightWheelProp.dampedSpring.damping);
	//motorJoint
	leftCenterWheel.motorJoint = makeMotorJoint(space,leftCenterWheel.body,chassis.body,carprop.wheelSpeed);
	centerRightWheel.motorJoint = makeMotorJoint(space,chassis.body,centerRightWheel.body,carprop.wheelSpeed*(-1));
}


function makeLeftRing(){

}
function makeRightRing(){

}

function getTrack2Data(){//up right down left
	var data = [{position:cp.v(488,350),rotation:0},
	            {position:cp.v(498,350),rotation:0},
	            {position:cp.v(508,350),rotation:0},
	            {position:cp.v(518,350),rotation:0},
	            {position:cp.v(528,350),rotation:0},
	            {position:cp.v(538,350),rotation:0},
	            {position:cp.v(548,350),rotation:0},
	            {position:cp.v(558,350),rotation:0},
	            {position:cp.v(568,350),rotation:0},
	            {position:cp.v(578,350),rotation:0},
	            {position:cp.v(588,350),rotation:0},
	            {position:cp.v(598,350),rotation:0},
	            {position:cp.v(608,350),rotation:0},
	            {position:cp.v(618,350),rotation:0},
	            {position:cp.v(628,350),rotation:0},
	            {position:cp.v(638,350),rotation:0},
	            {position:cp.v(648,350),rotation:0},

	            {position:cp.v(657,347),rotation:22},
	            {position:cp.v(664,343),rotation:37},
	            {position:cp.v(671,335),rotation:56},
	            {position:cp.v(675,325),rotation:78},
	            {position:cp.v(675,315),rotation:95},
	            {position:cp.v(672,305),rotation:118},
	            {position:cp.v(666,298),rotation:144},
	            {position:cp.v(657,293),rotation:160},

	            {position:cp.v(648,290),rotation:180},
	            {position:cp.v(638,290),rotation:180},
	            {position:cp.v(628,290),rotation:180},
	            {position:cp.v(618,290),rotation:180},
	            {position:cp.v(608,290),rotation:180},
	            {position:cp.v(598,290),rotation:180},
	            {position:cp.v(588,290),rotation:180},
	            {position:cp.v(578,290),rotation:180},
	            {position:cp.v(568,290),rotation:180},
	            {position:cp.v(558,290),rotation:180},
	            {position:cp.v(548,290),rotation:180},
	            {position:cp.v(538,290),rotation:180},
	            {position:cp.v(528,290),rotation:180},
	            {position:cp.v(518,290),rotation:180},
	            {position:cp.v(508,290),rotation:180},
	            {position:cp.v(498,290),rotation:180},
	            {position:cp.v(488,290),rotation:180},

	            {position:cp.v(479,292),rotation:-160},
	            {position:cp.v(471,296),rotation:-130},
	            {position:cp.v(465,304),rotation:-120},
	            {position:cp.v(461,313),rotation:-90},
	            {position:cp.v(461,323),rotation:-80},
	            {position:cp.v(464,333),rotation:-60},
	            {position:cp.v(469,341),rotation:-40},
	            {position:cp.v(477,347),rotation:-26}]
	var deltaX = -462;
	var deltaY = -293;
	for(var i = 0;i < data.length;i ++){
		data[i].position.x += deltaX;
		data[i].position.y += deltaY;
	}
	return data;
}

function createTrack2(parent){
	var track = new cc.Sprite("res/car_b/common/che/lvdaida");
	track.setGlobalZOrder(constCar.globalZOrder.level_pos10);
	parent.addChild(track,-1);
	track.setPosition(146,-12-13);
	
	track.littleTracks = [];
	
	var trackdata = getTrack2Data();

	for(var i = 0,j = 0;i < trackdata.length;i += 2,j ++){
		if(trackdata[i]){
			track.littleTracks[j] = new cc.Sprite("res/car_b/common/che/lvdai");
			track.littleTracks[j].setPosition(trackdata[i].position.x,trackdata[i].position.y);   
			track.littleTracks[j].setRotation(trackdata[i].rotation);
			track.addChild(track.littleTracks[j]);
			track.littleTracks[j].setGlobalZOrder(constCar.globalZOrder.level_pos10);
		}
	}


	track.cstSpeed = 1;
	track.setCstSpeed = function(cstSpeed){
		track.cstSpeed = cstSpeed;
	};


	track.scheduleTime = 0;
	track.speed = 0;
	track.isClock = true;
	track.maxSpeed = 10;
	track.clockwiseRun = function(speed){
		speed *= track.cstSpeed;
		if(speed > 0){
			track.isClock = true;
		}else{
			track.isClock = false;
		}
		if(Math.abs(speed) <= 0.05){
			track.speed = 0;
		}
		track.speed += Math.abs(speed);
		if(track.maxSpeed <= track.speed){
			track.speed = 0;
			if(track.isClock){
				for(var i = 0,j = 0;i < track.littleTracks.length;i ++,j += 1){
					track.littleTracks[i].setPosition(trackdata[(track.scheduleTime + i + j)%trackdata.length].position);
					track.littleTracks[i].setRotation(trackdata[(track.scheduleTime + i + j)%trackdata.length].rotation);
				}
				track.scheduleTime ++;
			}else{
				for(var i = 0,j = 0;i < track.littleTracks.length;i ++,j += 2){
					track.scheduleTime %= (trackdata.length);
					track.littleTracks[i].setPosition(trackdata[(trackdata.length - track.scheduleTime + j) % trackdata.length].position);
					track.littleTracks[i].setRotation(trackdata[(trackdata.length - track.scheduleTime + j) % trackdata.length].rotation);
				}
				track.scheduleTime ++;
			}
		}
	};
	return track;
}

function makeMachineArmB2Car(parent,pos){
	var machinearm = {};
	machinearm.animName = ["cycle","land-1 stone-2-5 sea-2-3-4-5","land-2 stone-4","stone-1-3 sea-1-5-6","take back"];
	machinearm = createSkeletonSprite("res/car_b/common/che/anim/skeleton.json", "res/car_b/common/che/anim/skeleton.atlas", 1, parent, pos, -1);

	machinearm.setCompleteListener(function(trackEntry){
		var animationName = trackEntry.animation ? trackEntry.animation.name : "nullname";
		if(animationName != "cycle") {
			mylog(animationName + " is over");
		}
		if("nullname" != animationName && "cycle" != animationName){
			machinearm.setRotation(0);
			machinearm.setAnimation(1,"cycle",true);
			machinearm.stopAllActions();
			machinearm.runAction(cc.repeatForever(cc.sequence(cc.rotateTo(2,2),cc.rotateTo(2,-4),cc.rotateTo(2,2))));
		}
	});

	machinearm.runCycle = function(){
		machinearm.runAction(cc.repeatForever(cc.sequence(cc.rotateTo(2,2),cc.rotateTo(2,-4),cc.rotateTo(2,2))));
		machinearm.setAnimation(1,"cycle",true);
	}

	machinearm.runCycle();
	return machinearm;
}

function makeMonkeyB2Car(parent,pos,scale){
	var skel = {};

	skel.animName = ["biaoqing1","biaoqing2","biaoqing3","biaoqing4","biaoqing5"];
	skel.skelSprite = createSkeletonSprite("res/skel/monkey/skeleton.json", "res/skel/monkey/skeleton.atlas", scale, parent, pos, -1);
	skel.skelSprite.setGlobalZOrder(constCar.globalZOrder.level_pos10);

	recvCustomEvent("labelAddOne",function(){
		var name = ["biaoqing1","biaoqing3","biaoqing4","biaoqing5"];
		var idx = getRand0ToN(3);
		skel.skelSprite.setAnimation(1,name[idx],false);
	});

	skel.skelSprite.setCompleteListener(function(trackEntry){
		var animationName = trackEntry.animation ? trackEntry.animation.name : "nullname";
		if(animationName != skel.animName[1]) {
			skel.skelSprite.setAnimation(1,skel.animName[1],true);
		}else{

		}
	});

	skel.runCycle = function(){
		// skel.skelSprite.runAction(cc.repeatForever(cc.sequence(cc.rotateTo(1,2),cc.rotateTo(1,-4),cc.rotateTo(1,2))));
		skel.skelSprite.setAnimation(1,skel.animName[1],true);
	}

	skel.runCycle();
	return skel;
}

function makeB2Car(space,carProp,parent){
	mylog("make B car");
	var car = {};
	car.balance_sin = 0.0;
	car.last_v = 0.0;
	car.premissionUpdateController = false;
	
	car.prop = carProp;
	car.leftWheel = makeLeftWheelB2Car(space,car.prop.leftWheelProp);
	car.leftCenterWheel = makeLeftCenterWheelB2Car(space,car.prop.leftCenterWheelProp);
	car.centerRightWheel = makeLeftCenterWheelB2Car(space,car.prop.centerRightWheelProp);
	car.rightWheel = makeRightWheelB2Car(space,car.prop.rightWheelProp);

	car.chassis = makeChassisB2Car(space,car.prop.chassisProp);


	car.leftWheelSpr = makeSkin(car.leftWheel,"res/car_b/common/che/chelun1",cc.p(0.5,0.5),parent,0,0,cc.p(240+car.prop.deltaXY.x,200+car.prop.deltaXY.y),1);
	car.leftCenterWheelSpr = makeSkin(car.leftCenterWheel,"res/car_b/common/che/chelun1",cc.p(0.5,0.5),parent,0,0,cc.p(240+car.prop.deltaXY.x,200+car.prop.deltaXY.y),1);
	car.rightWheelSpr = makeSkin(car.rightWheel,"res/car_b/common/che/chelun1",cc.p(0.5,0.5),parent,0,0,cc.p(360+car.prop.deltaXY.x,200+car.prop.deltaXY.y),1);
	car.chassisSpr = makeSkin(car.chassis,"res/car_b/common/che/chesheng",cc.p(0.54,0.1),parent,0,0,cc.p(300+car.prop.deltaXY.x,250+car.prop.deltaXY.y),1);

	car.track = createTrack2(car.chassisSpr);
	car.machinearm = makeMachineArmB2Car(car.chassisSpr,car.prop.machineArmProp.pos);

	car.machinearm.setGlobalZOrder(constCar.globalZOrder.level_pos5);

	car.addPuff = function(par){
		car.puff = {};

		car.puff.particleSystem = new cc.ParticleSystem("res/common/huoyan/puff.plist");
		car.puff.particleSystem.setGlobalZOrder(par.getGlobalZOrder());
		// car.puff.particleSystem.duration = cc.ParticleSystem.DURATION_INFINITY;
		// car.puff.particleSystem.setAutoRemoveOnFinish(true);
		car.puff.particleSystem.setPosition(cp.v(36,120));
		// car.puff.particleSystem.setPositionType(cc.ParticleSystem.TYPE_GROUPED);
		par.addChild(car.puff.particleSystem, -10);

		return car.puff;
	}(car.chassisSpr);

	// car.track.setOpacity(100);
	// car.leftWheelSpr.setOpacity(100);
	// car.leftCenterWheelSpr.setOpacity(100);
	// car.rightWheelSpr.setOpacity(100);
	// car.chassisSpr.setOpacity(100);
	// car.machinearm.setOpacity(150);

	car.audioManager = function(){
		var audioManager = {};
		audioManager.carAudioRunningCtl = audioController("res/common/audio/car/xingzou.mp3",true,constCar.volume.maxVolume,constCar.volume.minVolume,function(){

		});

		audioManager.carAudioRunningCtl.start();
		audioManager.carAudioRunningCtl.setVolume(0);

		return audioManager;
	}();

	car.monkeySkel = makeMonkeyB2Car(car.chassisSpr,car.prop.monkey.pos,car.prop.monkey.scale);
	makeWheelsJointsB2Car(space,car.chassis,car.leftWheel,car.rightWheel,car.prop.leftWheelProp,car.prop.rightWheelProp,car.prop);
	makeCenterWheelsJointsB2Car(space,car.chassis,car.leftCenterWheel,car.centerRightWheel,car.prop.leftCenterWheelProp,car.prop.centerRightWheelProp,car.prop);



	car.addLeftCollisionLine = function(space,body,prop){
		var group = prop.group;
		var width = prop.width;
		var layers = prop.layers;

		var shape = space.addShape(new cp.SegmentShape(body,cp.v(-150,-70),cp.v(-150,70),width));
		shape.group = group;
		car.leftcollisionshape = shape;
		// shape.layers = ~cp.ALL_LAYERS;//because of default layers is cp.ALL_LAYERS
		// shape.layers = ~constCar.collisionlines.layers;
		// shape.layers = 0xfffe;
		shape.layers = layers;

		return shape;
	};
	car.addLeftCollisionLine(space,car.chassis.body,{
		group:parent.metaData.road.group,
		width:5,
		// layers:~constCar.collisionlines.layers
		layers:3
	});

	car.addRightCollisionLine = function(space,body,prop){
		var group = prop.group;
		var width = prop.width;
		var layers = prop.layers;

		var shape = space.addShape(new cp.SegmentShape(body,cp.v(150,-70),cp.v(150,70),width));
		shape.group = group;
		car.rightcollisionshape = shape;
		// shape.layers = ~cp.ALL_LAYERS;//because of default layers is cp.ALL_LAYERS
		// shape.layers = ~constCar.collisionlines.layers;
		// shape.layers = 0xfffe;
		shape.layers = layers;

		return shape;
	};
	car.addRightCollisionLine(space,car.chassis.body,{
		group:parent.metaData.road.group,
		width:5,
		// layers:~constCar.collisionlines.layers
		layers:3
	});

	// this.car.leftWheel.motorJoint.rate = -10;//改变速度功能
	car.changeSpeed = function(speed){
		car.prop.wheelSpeed = speed;
		car.leftWheel.motorJoint.rate = car.prop.wheelSpeed * (-1);
		car.leftCenterWheel.motorJoint.rate = car.prop.wheelSpeed * (-1);
		car.centerRightWheel.motorJoint.rate = car.prop.wheelSpeed * (1);
		car.rightWheel.motorJoint.rate = car.prop.wheelSpeed * 1;
	}

	car.stopToTargetX = function(dt,target_x,callback,idx,updatecontroller) {
		if(typeof callback == "undefined"){
			return;
		}
		if(callback.controlValue){
			var balance_body = car.chassis.body;
			var wheel_body   = car.leftWheel.body;

			/*cpFloat*/ var max_v = 150.0;
			/*cpFloat*/ var target_v = fclamp(biascoef(0.5, dt/1.2)*(target_x - balance_body.p.x)/dt, -max_v, max_v);
			/*cpFloat*/ var error_v = (target_v - balance_body.v.x);
			/*cpFloat*/ var target_sin = 3.0e-3*biascoef(0.1, dt)*error_v/dt;

			/*cpFloat*/ var max_sin = Math.sin(0.5);
			car.balance_sin = fclamp(car.balance_sin - 6.0e-5*biascoef(0.2, dt)*error_v/dt, -max_sin, max_sin);
			/*cpFloat*/ var target_a = Math.asin(fclamp(-target_sin + car.balance_sin, -max_sin, max_sin));
			/*cpFloat*/ var angular_diff = Math.asin(cp.v.cross(balance_body.rot, cp.v.forangle(target_a)));
			/*cpFloat*/ var target_w = biascoef(0.1, dt/0.4)*(angular_diff)/dt;

			// /*cpFloat*/ var max_rate = 35.0;
			var max_rate = Math.abs(car.chassisSpr.getPositionX() - target_x);
			/*cpFloat*/ var rate = fclamp(wheel_body.w + balance_body.w - 3 * target_w, -max_rate, max_rate);

			var tmpRate = fclamp(rate, -max_rate, max_rate);
			car.changeSpeed(tmpRate);
			mylog("rate = " + tmpRate);
			car.leftWheel.motorJoint.maxForce = (9.0e4);
			car.rightWheel.motorJoint.maxForce = (9.0e4);

			car.centerRightWheel.motorJoint.maxForce = (8.0e4);
			car.leftCenterWheel.motorJoint.maxForce = (8.0e4);
			car.track.clockwiseRun(mapval(Math.abs(tmpRate),0,2,1,3));
			// car.audioManager.carAudioRunningCtl.setVolume(mapval(Math.abs(tmpRate),0,8,constCar.volume.minVolume,constCar.volume.maxVolume));
			car.audioManager.carAudioRunningCtl.setVolume(0.4);

			if((Math.abs(tmpRate) > constCar.tmpRateDelta.car2)  && (Math.abs(car.chassisSpr.getPositionX() - target_x) < 9)){
				callback.controlValue = false;
				// updatecontroller.updateArrayBool[idx] = false;
				car.leftWheel.motorJoint.maxForce = (Infinity);
				car.rightWheel.motorJoint.maxForce = (Infinity);
				car.centerRightWheel.motorJoint.maxForce = (Infinity);
				car.leftCenterWheel.motorJoint.maxForce = (Infinity);

				car.track.clockwiseRun(0.5);
				callback();
			}
		}
	};

	car.resetAllForces = function(){

	};

	car.removeAllJointsShapeBody = function(){
		car.track.setCstSpeed(0);
		space.removeConstraint(car.leftWheel.grooveJoint);
		space.removeConstraint(car.rightWheel.grooveJoint);
		space.removeConstraint(car.leftCenterWheel.grooveJoint);
		space.removeConstraint(car.centerRightWheel.grooveJoint);

		space.removeConstraint(car.leftWheel.dampedSpring);
		space.removeConstraint(car.rightWheel.dampedSpring);
		space.removeConstraint(car.leftCenterWheel.dampedSpring);
		space.removeConstraint(car.centerRightWheel.dampedSpring);

		space.removeConstraint(car.leftWheel.motorJoint);
		space.removeConstraint(car.rightWheel.motorJoint);
		space.removeConstraint(car.leftCenterWheel.motorJoint);
		space.removeConstraint(car.centerRightWheel.motorJoint);

		space.removeShape(car.leftWheel.shape);
		space.removeShape(car.rightWheel.shape);
		space.removeShape(car.centerRightWheel.shape);
		space.removeShape(car.leftCenterWheel.shape);
		space.removeShape(car.chassis.shape);

		space.removeShape(car.leftcollisionshape);
		space.removeShape(car.rightcollisionshape);

		space.removeBody(car.leftWheel.body);
		space.removeBody(car.rightWheel.body);
		space.removeBody(car.leftCenterWheel.body);
		space.removeBody(car.centerRightWheel.body);
		space.removeBody(car.chassis.body);

		car.resetAllForces();
	};

	car.readdAllJointsShapeBody = function(deltaxy){
		car.track.setCstSpeed(1);
		car.moveDeltaXY = deltaxy;
		//我一直不明白的是chassisbody和wheelbody的处理方式不同
		var leftwheelbody = car.leftWheel.body;
		leftwheelbody.setPos(cp.v.add(leftwheelbody.getPos(),cp.v.add(deltaxy,cp.v(0,0))));
		space.addBody(leftwheelbody);

		var rightwheelbody = car.rightWheel.body;
		rightwheelbody.setPos(cp.v.add(rightwheelbody.getPos(),cp.v.add(deltaxy,cp.v(0,0))));
		space.addBody(rightwheelbody);

		var leftCenterwheelbody = car.leftCenterWheel.body;
		leftCenterwheelbody.setPos(cp.v.add(leftCenterwheelbody.getPos(),cp.v.add(deltaxy,cp.v(0,0))));
		space.addBody(leftCenterwheelbody);

		var centerRightwheelbody = car.centerRightWheel.body;
		centerRightwheelbody.setPos(cp.v.add(centerRightwheelbody.getPos(),cp.v.add(deltaxy,cp.v(0,0))));
		space.addBody(centerRightwheelbody);


		var chassisbody = car.chassis.body;
		chassisbody.setPos(cp.v.add(chassisbody.getPos(),cp.v.add(cp.v(0,0),cp.v(0,0))));
		space.addBody(chassisbody);

		space.addShape(car.leftWheel.shape);
		space.addShape(car.rightWheel.shape);
		space.addShape(car.leftCenterWheel.shape);
		space.addShape(car.centerRightWheel.shape);
		space.addShape(car.chassis.shape);

		space.addShape(car.leftcollisionshape);
		space.addShape(car.rightcollisionshape);

		space.addConstraint(car.leftWheel.grooveJoint);
		space.addConstraint(car.rightWheel.grooveJoint);
		space.addConstraint(car.leftCenterWheel.grooveJoint);
		space.addConstraint(car.centerRightWheel.grooveJoint);

		space.addConstraint(car.leftWheel.dampedSpring);
		space.addConstraint(car.rightWheel.dampedSpring);
		space.addConstraint(car.centerRightWheel.dampedSpring);
		space.addConstraint(car.leftCenterWheel.dampedSpring);

		space.addConstraint(car.leftWheel.motorJoint);
		space.addConstraint(car.rightWheel.motorJoint);
		space.addConstraint(car.leftCenterWheel.motorJoint);
		space.addConstraint(car.centerRightWheel.motorJoint);

		car.resetAllForces();
	};

	car.readdAllJointsShapeBodyNormal = function(){
		car.track.setCstSpeed(1);
		var leftwheelbody = car.leftWheel.body;
		leftwheelbody.setPos(cp.v.add(leftwheelbody.getPos(),cp.v(0,0)));
		space.addBody(leftwheelbody);

		var rightwheelbody = car.rightWheel.body;
		rightwheelbody.setPos(cp.v.add(rightwheelbody.getPos(),cp.v(0,0)));
		space.addBody(rightwheelbody);

		var leftCenterwheelbody = car.leftCenterWheel.body;
		leftCenterwheelbody.setPos(cp.v.add(leftCenterwheelbody.getPos(),cp.v(0,0)));
		space.addBody(leftCenterwheelbody);

		var centerRightwheelbody = car.centerRightWheel.body;
		centerRightwheelbody.setPos(cp.v.add(centerRightwheelbody.getPos(),cp.v(0,0)));
		space.addBody(centerRightwheelbody);


		var chassisbody = car.chassis.body;
		chassisbody.setPos(cp.v.add(chassisbody.getPos(),cp.v(0,0)));
		space.addBody(chassisbody);

		space.addShape(car.leftWheel.shape);
		space.addShape(car.rightWheel.shape);
		space.addShape(car.leftCenterWheel.shape);
		space.addShape(car.centerRightWheel.shape);
		space.addShape(car.chassis.shape);

		space.addShape(car.leftcollisionshape);
		space.addShape(car.rightcollisionshape);

		space.addConstraint(car.leftWheel.grooveJoint);
		space.addConstraint(car.rightWheel.grooveJoint);
		space.addConstraint(car.leftCenterWheel.grooveJoint);
		space.addConstraint(car.centerRightWheel.grooveJoint);

		space.addConstraint(car.leftWheel.dampedSpring);
		space.addConstraint(car.rightWheel.dampedSpring);
		space.addConstraint(car.centerRightWheel.dampedSpring);
		space.addConstraint(car.leftCenterWheel.dampedSpring);

		space.addConstraint(car.leftWheel.motorJoint);
		space.addConstraint(car.rightWheel.motorJoint);
		space.addConstraint(car.leftCenterWheel.motorJoint);
		space.addConstraint(car.centerRightWheel.motorJoint);

		car.resetAllForces();
	};

	return car;
}
