function makeC3CarProps(){
    var adjustArgument = 0;
    if(isPad()){
        adjustArgument = 106;
    }else{
        adjustArgument = 0;
    }
    var deltaXYOrigin=cp.v(100,100+adjustArgument);//oringinal
    var deltaXY = cp.v.add(deltaXYOrigin,cp.v(-800,-120));//original
    // var deltaXY = cp.v.add(deltaXYOrigin,cp.v(800,0));//1
    // var deltaXY = cp.v.add(deltaXYOrigin,cp.v(2850,460));//2
    // var deltaXY = cp.v.add(deltaXYOrigin,cp.v(4000,280));//3
    // var deltaXY = cp.v.add(deltaXYOrigin,cp.v(4700,280));//4
    // var deltaXY = cp.v.add(deltaXYOrigin,cp.v(5700,280));//5
    // var deltaXY = cp.v.add(deltaXYOrigin,cp.v(8600,200));//6
    // var deltaXY = cp.v.add(deltaXYOrigin,cp.v(9600,0));//7
    // var deltaXY = cp.v.add(deltaXYOrigin,cp.v(12900,200));//8
    // var deltaXY = cp.v.add(deltaXYOrigin,cp.v(13700,200));//9
    // var deltaXY = cp.v.add(deltaXYOrigin,cp.v(16600,405));//c
    // var deltaXY = cp.v.add(deltaXYOrigin,cp.v(19000,665));//over

    var prop = {
        name:"C3",
        deltaXY:deltaXY,
        wheelSpeed:0,
        leftWheelProp:{
            radius:35,
            mass:25,
            pos:cp.v(420-84-8+deltaXY.x-100,300-30+20+deltaXY.y-120),
            group:2,
            collisionType:constCar.car.chassis.collisionType,
            elastic:0.01,
            friction:0.9,

            grooveJoint:{
                anchor1:cp.v(-70, 0),
                anchor2:cp.v(-70, -40+7)
            },
            dampedSpring:{
                anchor1:cp.v(-70,0),
                anchor2:cp.v(0,0),
                restLength:40-7 + 10,
                stiffness:1000-200,
                damping:120-60
            }
        },
        centerWheelProp:{
            radius:30,
            mass:10,
            pos:cp.v(496-84-12+deltaXY.x-100,300-30+20+deltaXY.y-120),
            group:2,
            collisionType:constCar.car.leftWheel.collisionType,
            elastic:0.01,
            friction:0.9,

            grooveJoint:{
                anchor1:cp.v(0, 0),
                anchor2:cp.v(1, -42+7)
            },
            dampedSpring:{
                anchor1:cp.v(0,0),
                anchor2:cp.v(0,0),
                restLength:42-7,
                stiffness:800-200,
                damping:110-60
            }
        },
        rightWheelProp:{
            radius:25,
            mass:25,
            pos:cp.v(560-84-16+deltaXY.x-100,300-30+20+deltaXY.y-120),
            group:2,
            collisionType:constCar.car.rightWheel.collisionType,
            elastic:0.01,
            friction:0.9,

            grooveJoint:{
                anchor1:cp.v(60, 0),
                anchor2:cp.v(61, -45+7)
            },
            dampedSpring:{
                anchor1:cp.v(60,0),
                anchor2:cp.v(0,0),
                restLength:45-7 + 10,
                stiffness:1000-200,
                damping:120-60
            }
        },
        chassisProp:{
            verts:[-30	,	10,
                -10	,	15,
                20	,	15,
                45	,	5,
                38	,  -3,
                -30 ,    0,
                -30	,	10],
            mass:5,
            widthHeight:cp.v(80,30),
            pos:cp.v(400+deltaXY.x-100,320+deltaXY.y-120),
            elastic:0.5,
            friction:0.9,
            group:2,
            collisionType:constCar.car.chassis.collisionType,
            scale:3,
            offset:cp.v(-10,0),
            massCenterDelta:cp.v(0,0)
        },
        machineArmProp:{
            pos:cp.v(245,34)
        },
        monkey:{
            pos:cp.v(124,72.1),
            scale:0.85
        }
    };
    return prop;
}

function makeCenterWheelC3Car(space,prop,deltaxy){
    var centerWheel = {};
    var radius = prop.radius;
    var mass = prop.mass;
    var pos = prop.pos;
    var group = prop.group;
    var collisionType = prop.collisionType;
    var elastic = prop.elastic;
    var friction = prop.friction;

    var body = space.addBody(new cp.Body(mass, cp.momentForCircle(mass, 0.0, radius, cp.vzero)));
    body.setPos(cp.v.add(prop.pos,deltaxy));

    centerWheel.body = body;

    var shape = space.addShape(new cp.CircleShape(body, radius, cp.vzero));
    centerWheel.shape = shape;
    shape.setElasticity(elastic);
    shape.setFriction(friction);
    shape.group = group;

    shape.setCollisionType(collisionType);

    return centerWheel;
}
function makeLeftWheelC3Car(space,prop,deltaxy){
    var leftWheel = {};
    var radius = prop.radius;
    var mass = prop.mass;
    var pos = prop.pos;
    var group = prop.group;
    var collisionType = prop.collisionType;
    var elastic = prop.elastic;
    var friction = prop.friction;

    var body = space.addBody(new cp.Body(mass, cp.momentForCircle(mass, 0.0, radius, cp.vzero)));
    body.setPos(cp.v.add(prop.pos,deltaxy));

    leftWheel.body = body;

    var shape = space.addShape(new cp.CircleShape(body, radius, cp.vzero));
    leftWheel.shape = shape;
    shape.setElasticity(elastic);
    shape.setFriction(friction);
    shape.group = group;

    shape.setCollisionType(collisionType);

    return leftWheel;
}
function makeRightWheelC3Car(space,prop,deltaxy){
    var rightWheel = {};

    var radius = prop.radius;
    var mass = prop.mass;
    var pos = prop.pos;
    var group = prop.group;
    var elastic = prop.elastic;
    var friction = prop.friction;
    var collisionType = prop.collisionType;

    var body = space.addBody(new cp.Body(mass, cp.momentForCircle(mass, 0.0, radius, cp.vzero)));
    body.setPos(cp.v.add(prop.pos,deltaxy));

    rightWheel.body = body;

    var shape = space.addShape(new cp.CircleShape(body, radius, cp.vzero));
    rightWheel.shape = shape;
    shape.setElasticity(elastic);
    shape.setFriction(friction);
    shape.group = group;

    shape.setCollisionType(collisionType);

    return rightWheel;
}
function makeChassisC3Car(space,prop,deltaxy){
    var chassis = {};

    var verts = prop.verts;
    var mass = prop.mass;
    var pos = prop.pos;
    var elastic = prop.elastic;
    var friction = prop.friction;
    var group = prop.group;
    var collisionType = prop.collisionType;
    var scale = prop.scale;
    var offset = prop.offset;
    var widthHeight = prop.widthHeight;
    var massCenterDelta = prop.massCenterDelta;

    for(var i = 0;i < verts.length;i ++){
        if(0 == i % 2){
            verts[i] += offset.x;
        }else{
            verts[i] += offset.y;
        }
        verts[i] *= scale;
    }

    var body = space.addBody(new cp.Body(mass, cp.momentForPoly(mass, verts, cp.v(0,0))));

    body.setPos(cp.v.add(cp.v.add(pos,deltaxy),massCenterDelta));

    chassis.body = body;

    var shape = space.addShape(new cp.PolyShape(body, verts, cp.vzero));
    chassis.shape = shape;

    shape.setElasticity(elastic);
    shape.setFriction(friction);
    shape.group = group;
    shape.setCollisionType(collisionType);

    return chassis;
}

function makeWheelsJointsC3Car(space,chassis,leftWheel,rightWheel,leftWheelProp,rightWheelProp,carprop){
    //grooveJoint
    leftWheel.grooveJoint = makeGrooveJoint(space,chassis.body, leftWheel.body, leftWheelProp.grooveJoint.anchor1, leftWheelProp.grooveJoint.anchor2);
    rightWheel.grooveJoint = makeGrooveJoint(space,chassis.body, rightWheel.body, rightWheelProp.grooveJoint.anchor1, rightWheelProp.grooveJoint.anchor2);
    //dampedSpring
    leftWheel.dampedSpring = makeDampedSpring(space,chassis.body,leftWheel.body,leftWheelProp.dampedSpring.anchor1,leftWheelProp.dampedSpring.anchor2,
        leftWheelProp.dampedSpring.restLength,leftWheelProp.dampedSpring.stiffness,leftWheelProp.dampedSpring.damping);
    rightWheel.dampedSpring = makeDampedSpring(space,chassis.body,rightWheel.body,rightWheelProp.dampedSpring.anchor1,rightWheelProp.dampedSpring.anchor2,
        rightWheelProp.dampedSpring.restLength,rightWheelProp.dampedSpring.stiffness,rightWheelProp.dampedSpring.damping);
    //motorJoint
    leftWheel.motorJoint = makeMotorJoint(space,leftWheel.body,chassis.body,carprop.wheelSpeed);
    rightWheel.motorJoint = makeMotorJoint(space,chassis.body,rightWheel.body,carprop.wheelSpeed*(-1));
}

function makeCenterWheelsJointsC3Car(space,chassis,centerWheel,centerWheelProp,carprop){
    //grooveJoint
    centerWheel.grooveJoint = makeGrooveJoint(space,chassis.body, centerWheel.body, centerWheelProp.grooveJoint.anchor1, centerWheelProp.grooveJoint.anchor2);
    //dampedSpring
    centerWheel.dampedSpring = makeDampedSpring(space,chassis.body,centerWheel.body,centerWheelProp.dampedSpring.anchor1,centerWheelProp.dampedSpring.anchor2,
        centerWheelProp.dampedSpring.restLength,centerWheelProp.dampedSpring.stiffness,centerWheelProp.dampedSpring.damping);
    //motorJoint
    centerWheel.motorJoint = makeMotorJoint(space,chassis.body,centerWheel.body,carprop.wheelSpeed*(-1));
}

function makeMachineArmC3Car(parent,pos){
    var machinearm = {};
    machinearm.animName = ["cycle","land-3","land-5","land-1-4","land-2-qiqiu","stone-1","stone-2","sea-zhangyu","sea-xiong","sea-jinyu","sea-haima"];
    machinearm = createSkeletonSprite("res/car_c/common/che/anim/skeleton.json", "res/car_c/common/che/anim/skeleton.atlas", 1, parent, pos, -1);
    machinearm.setGlobalZOrder(constCar.globalZOrder.level_pos10);

    machinearm.setCompleteListener(function(trackEntry){
        // var animationName = trackEntry.animation ? trackEntry.animation.name : "nullname";
        // if(animationName != "cycle") {
        //     mylog(animationName + " is over");
        // }
        // if("nullname" != animationName && "cycle" != animationName){
        //     machinearm.setRotation(0);
        //     machinearm.setAnimation(1,"cycle",true);
        //     machinearm.runAction(cc.repeatForever(cc.sequence(cc.rotateTo(1,2),cc.rotateTo(1,-4),cc.rotateTo(1,2))));
        // }
    });

    machinearm.runCycle = function(){
        machinearm.runAction(cc.repeatForever(cc.sequence(cc.rotateTo(2,2),cc.rotateTo(2,-4),cc.rotateTo(1,2))));
        machinearm.setAnimation(1,"cycle",true);
    }

    machinearm.runCycle();
    return machinearm;
}


function createC3CarTrack(parent) {
    var track = new cc.Sprite("res/car_c/common/che/lvdai");
    track.setGlobalZOrder(constCar.globalZOrder.level_pos10);
    // track.setRotation(-6);
    parent.addChild(track);
    track.setPosition(152, -14-2);

    track.deltaX = 56;

    track.wheel1 = new cc.Sprite("res/car_c/common/che/chelun1");
    track.addChild(track.wheel1,1);
    track.wheel1.setScale(1.3);
    track.wheel1.setGlobalZOrder(constCar.globalZOrder.level_pos10);
    track.wheel1.setPosition(cp.v(39 + track.deltaX * 0 - 5,30));

    track.wheel2 = new cc.Sprite("res/car_c/common/che/chelun1");
    track.addChild(track.wheel2,1);
    track.wheel2.setScale(1.1);
    track.wheel2.setGlobalZOrder(constCar.globalZOrder.level_pos10);
    track.wheel2.setPosition(cp.v(39 + track.deltaX * 1+3,30-3));


    track.wheel3 = new cc.Sprite("res/car_c/common/che/chelun1");
    track.addChild(track.wheel3,1);
    track.wheel3.setScale(0.82);
    track.wheel3.setGlobalZOrder(constCar.globalZOrder.level_pos10);
    track.wheel3.setPosition(cp.v(39 + track.deltaX * 2 + 5,30-5));

    track.rotate = function(){
        track.wheel1.setRotation(track.rotateAngel);
        track.wheel2.setRotation(track.rotateAngel);
        track.wheel3.setRotation(track.rotateAngel);
    };

    track.addAngel = function(angel){
        track.rotateAngel += angel;
        track.rotateAngel %= 360;
    };

    track.run = function(addAngle){
        track.addAngel(addAngle);
        track.rotate();
    };
    track.rotateSelf = function(angel){
        track.rotateAngel = angel;
        track.rotate();
    };
    track.rotateAngel = 0;

    return track;
}

function makeMonkeyC3Car(parent,pos,scale){
    var skel = {};

    skel.animName = ["biaoqing1","biaoqing2","biaoqing3","biaoqing4","biaoqing5"];
    skel.skelSprite = createSkeletonSprite("res/skel/monkey/skeleton.json", "res/skel/monkey/skeleton.atlas", scale, parent, pos, -1);
    skel.skelSprite.setGlobalZOrder(constCar.globalZOrder.level_pos10);

    recvCustomEvent("labelAddOne",function(){
        var name = ["biaoqing1","biaoqing3","biaoqing4","biaoqing5"];
        var idx = getRand0ToN(3);
        skel.skelSprite.setAnimation(1,name[idx],false);
    });

    skel.skelSprite.setCompleteListener(function(trackEntry){
        var animationName = trackEntry.animation ? trackEntry.animation.name : "nullname";
        if(animationName != skel.animName[1]) {
            skel.skelSprite.setAnimation(1,skel.animName[1],true);
        }else{

        }
    });

    skel.runCycle = function(){
        // skel.skelSprite.runAction(cc.repeatForever(cc.sequence(cc.rotateTo(1,2),cc.rotateTo(1,-4),cc.rotateTo(1,2))));
        skel.skelSprite.setAnimation(1,skel.animName[1],true);
    }

    skel.runCycle();
    return skel;
}
function makeC3Car(space,carProp,parent){
    var car = {};
    car.balance_sin = 0.0;
    car.last_v = 0.0;
    car.moveDeltaXY = cp.v(0,0);
    car.wheelRotateAngel = 0;

    car.prop = carProp;
    car.leftWheel = makeLeftWheelC3Car(space,car.prop.leftWheelProp,car.moveDeltaXY);
    car.centerWheel = makeCenterWheelC3Car(space,car.prop.centerWheelProp,car.moveDeltaXY);
    car.rightWheel = makeRightWheelC3Car(space,car.prop.rightWheelProp,car.moveDeltaXY);
    car.chassis = makeChassisC3Car(space,car.prop.chassisProp,car.moveDeltaXY);

    car.leftRing = makeLeftRing();
    car.rightRing = makeRightRing();

    //anchorpoint x+ ---> pix left;y+ ----> pix down;
    car.leftWheelSpr = makeSkin(car.leftWheel,"res/car_c/common/che/chelun2",cc.p(0.5,0.5),parent,0,0,cc.p(240+car.prop.deltaXY.x,200+car.prop.deltaXY.y/2),1);
    car.centerWheelSpr = makeSkin(car.centerWheel,"res/car_c/common/che/chelun2",cc.p(0.5,0.5),parent,0,0,cc.p(240+car.prop.deltaXY.x,200+car.prop.deltaXY.y/2),1);
    car.rightWheelSpr = makeSkin(car.rightWheel,"res/car_c/common/che/chelun2",cc.p(0.5,0.5),parent,0,0,cc.p(360+car.prop.deltaXY.x,200+car.prop.deltaXY.y/2),1);
    car.chassisSpr = makeSkin(car.chassis,"res/car_c/common/che/chesheng",cc.p(0.64,0.1),parent,0,0,cc.p(300+car.prop.deltaXY.x,200+car.prop.deltaXY.y),1);

    car.chassisSpr.setGlobalZOrder(constCar.globalZOrder.level_pos10);
    car.leftWheelSpr.setGlobalZOrder(constCar.globalZOrder.level_pos10);
    car.centerWheelSpr.setGlobalZOrder(constCar.globalZOrder.level_pos10);
    car.rightWheelSpr.setGlobalZOrder(constCar.globalZOrder.level_pos10);

    car.machinearm = makeMachineArmC3Car(car.chassisSpr,car.prop.machineArmProp.pos);
    car.monkeySkel = makeMonkeyC3Car(car.chassisSpr,car.prop.monkey.pos,car.prop.monkey.scale);


    car.track = createC3CarTrack(car.chassisSpr);
    car.track.clockwiseRun = function(){};

    car.addPuff = function(par){
        car.puff = {};

        car.puff.particleSystem = new cc.ParticleSystem("res/common/huoyan/puff.plist");
        car.puff.particleSystem.setGlobalZOrder(par.getGlobalZOrder());
        // car.puff.particleSystem.duration = cc.ParticleSystem.DURATION_INFINITY;
        // car.puff.particleSystem.setAutoRemoveOnFinish(true);
        car.puff.particleSystem.setPosition(cp.v(18,65));
        // car.puff.particleSystem.setPositionType(cc.ParticleSystem.TYPE_GROUPED);
        par.addChild(car.puff.particleSystem, -10);


        return car.puff;
    }(car.chassisSpr);

    // car.chassisSpr.setOpacity(15);
    // car.leftWheelSpr.setOpacity(15);
    // car.centerWheelSpr.setOpacity(15);
    // car.rightWheelSpr.setOpacity(15);
    // car.machinearm.setOpacity(15);
    // car.track.setOpacity(15);
    // car.track.wheel1.setOpacity(15);
    // car.track.wheel2.setOpacity(15);
    // car.track.wheel3.setOpacity(15);
    // car.monkeySkel.skelSprite.setOpacity(15);

    car.audioManager = function(){
        var audioManager = {};
        audioManager.carAudioRunningCtl = audioController("res/common/audio/car/xingzou.mp3",true,constCar.volume.maxVolume,constCar.volume.minVolume,function(){

        });

        audioManager.carAudioRunningCtl.start();
        audioManager.carAudioRunningCtl.setVolume(0);

        return audioManager;
    }();

    makeWheelsJointsC3Car(space,car.chassis,car.leftWheel,car.rightWheel,car.prop.leftWheelProp,car.prop.rightWheelProp,car.prop);
    makeCenterWheelsJointsC3Car(space,car.chassis,car.centerWheel,car.prop.centerWheelProp,car.prop);


    mylog("kag car.leftWheel.motorJoint.maxForce = " + car.leftWheel.motorJoint.maxForce);
    car.addLeftCollisionLine = function(space,body,prop){
        var group = prop.group;
        var width = prop.width;
        var layers = prop.layers;

        var shape = space.addShape(new cp.SegmentShape(body,cp.v(-150,-60),cp.v(-150,60),width));
        shape.group = group;
        car.leftcollisionshape = shape;
        // shape.layers = ~cp.ALL_LAYERS;//because of default layers is cp.ALL_LAYERS
        // shape.layers = ~constCar.collisionlines.layers;
        // shape.layers = 0xfffe;
        shape.layers = layers;

        return shape;
    };
    car.addLeftCollisionLine(space,car.chassis.body,{
        group:parent.metaData.road.group,
        width:5,
        // layers:~constCar.collisionlines.layers
        layers:3
    });

    car.addRightCollisionLine = function(space,body,prop){
        var group = prop.group;
        var width = prop.width;
        var layers = prop.layers;

        var shape = space.addShape(new cp.SegmentShape(body,cp.v(150,-60),cp.v(150,60),width));
        shape.group = group;
        car.rightcollisionshape = shape;
        // shape.layers = ~cp.ALL_LAYERS;//because of default layers is cp.ALL_LAYERS
        // shape.layers = ~constCar.collisionlines.layers;
        // shape.layers = 0xfffe;
        shape.layers = layers;

        return shape;
    };
    car.addRightCollisionLine(space,car.chassis.body,{
        group:parent.metaData.road.group,
        width:5,
        // layers:~constCar.collisionlines.layers
        layers:3
    });

    // this.car.leftWheel.motorJoint.rate = -10;//改变速度功能
    car.changeSpeed = function(speed){
        // mylog("changespeed..." + speed);
        car.prop.wheelSpeed = speed;
        if("undefined" != typeof car.leftWheel.motorJoint && "undefined" != typeof car.leftWheel.motorJoint.rate)
            car.leftWheel.motorJoint.rate = car.prop.wheelSpeed * (-1);
        if("undefined" != typeof car.centerWheel.motorJoint && "undefined" != typeof car.centerWheel.motorJoint.rate)
            car.centerWheel.motorJoint.rate = car.prop.wheelSpeed * (1);
        if("undefined" != typeof car.rightWheel.motorJoint && "undefined" != typeof car.rightWheel.motorJoint.rate)
            car.rightWheel.motorJoint.rate = car.prop.wheelSpeed * 1;
    }

    car.stopToTargetX = function(dt,target_x,callback,idx,updatecontroller){
        if(typeof callback == "undefined"){
            return;
        }
        if(callback.controlValue){
            var balance_body = car.chassis.body;
            var wheel_body   = car.leftWheel.body;

            /*cpFloat*/ var max_v = 150.0;
            /*cpFloat*/ var target_v = fclamp(biascoef(0.5, dt/1.2)*(target_x - balance_body.p.x)/dt, -max_v, max_v);
            /*cpFloat*/ var error_v = (target_v - balance_body.v.x);
            /*cpFloat*/ var target_sin = 3.0e-3*biascoef(0.1, dt)*error_v/dt;

            /*cpFloat*/ var max_sin = Math.sin(0.5);
            car.balance_sin = fclamp(car.balance_sin - 6.0e-5*biascoef(0.2, dt)*error_v/dt, -max_sin, max_sin);
            /*cpFloat*/ var target_a = Math.asin(fclamp(-target_sin + car.balance_sin, -max_sin, max_sin));
            /*cpFloat*/ var angular_diff = Math.asin(cp.v.cross(balance_body.rot, cp.v.forangle(target_a)));
            /*cpFloat*/ var target_w = biascoef(0.1, dt/0.4)*(angular_diff)/dt;

            // /*cpFloat*/ var max_rate = 25.0;
            var max_rate = Math.abs(car.chassisSpr.getPositionX() - target_x);
            /*cpFloat*/ var rate = fclamp(wheel_body.w + balance_body.w - 3 * target_w, -max_rate, max_rate);

            var tmpRate = fclamp(rate, -max_rate, max_rate);
            car.changeSpeed(tmpRate);
            mylog("rate = " + tmpRate);
            car.leftWheel.motorJoint.maxForce = (14.0e4);
            car.rightWheel.motorJoint.maxForce = (14.0e4);
            car.centerWheel.motorJoint.maxForce = (14.0e4);

            car.audioManager.carAudioRunningCtl.setVolume(0.4);
            car.track.rotateSelf(-1*(car.rightWheel.body.getAngle() * 180 / 3.1415)%360);

            if((Math.abs(tmpRate) > constCar.tmpRateDelta.car3)&&(Math.abs(car.chassisSpr.getPositionX() - target_x) < 8)){
                callback.controlValue = false;
                // updatecontroller.updateArrayBool[idx] = false;
                car.leftWheel.motorJoint.maxForce = (Infinity);
                car.rightWheel.motorJoint.maxForce = (Infinity);
                car.centerWheel.motorJoint.maxForce = (Infinity);
                callback();
            }
        }
    };

    car.resetAllForces = function(){
        // car.leftWheel.body.resetForces();
        // car.rightWheel.body.resetForces();
        // car.centerWheel.body.resetForces();
        // car.chassis.body.resetForces();

        //not effect
        //
        // car.leftWheel.body.activate();
        // car.leftWheel.body.f = cp.v(0,0);
        // car.leftWheel.body.t = 0;
        //
        // car.rightWheel.body.activate();
        // car.rightWheel.body.f = cp.v(0,0);
        // car.rightWheel.body.t = 0;
        //
        // car.centerWheel.body.activate();
        // car.centerWheel.body.f = cp.v(0,0);
        // car.centerWheel.body.t = 0;
        //
        // car.chassis.body.activate();
        // car.chassis.body.f = cp.v(0,0);
        // car.chassis.body.t = 0;

    };

    car.removeAllJointsShapeBody = function(){
        space.removeConstraint(car.leftWheel.grooveJoint);
        space.removeConstraint(car.rightWheel.grooveJoint);
        space.removeConstraint(car.centerWheel.grooveJoint);

        space.removeConstraint(car.leftWheel.dampedSpring);
        space.removeConstraint(car.rightWheel.dampedSpring);
        space.removeConstraint(car.centerWheel.dampedSpring);

        space.removeConstraint(car.leftWheel.motorJoint);
        space.removeConstraint(car.rightWheel.motorJoint);
        space.removeConstraint(car.centerWheel.motorJoint);


        space.removeShape(car.leftWheel.shape);
        space.removeShape(car.rightWheel.shape);
        space.removeShape(car.centerWheel.shape);
        space.removeShape(car.chassis.shape);

        space.removeShape(car.leftcollisionshape);
        space.removeShape(car.rightcollisionshape);

        space.removeBody(car.leftWheel.body);
        space.removeBody(car.rightWheel.body);
        space.removeBody(car.centerWheel.body);
        space.removeBody(car.chassis.body);

        car.resetAllForces();
    };

    car.readdAllJointsShapeBody = function(deltaxy){
        car.moveDeltaXY = deltaxy;
        //我一直不明白的是chassisbody和wheelbody的处理方式不同
        var leftwheelbody = car.leftWheel.body;
        leftwheelbody.setPos(cp.v.add(leftwheelbody.getPos(),cp.v.add(deltaxy,cp.v(0,0))));
        space.addBody(leftwheelbody);

        var rightwheelbody = car.rightWheel.body;
        rightwheelbody.setPos(cp.v.add(rightwheelbody.getPos(),cp.v.add(deltaxy,cp.v(0,0))));
        space.addBody(rightwheelbody);

        var centerwheelbody = car.centerWheel.body;
        centerwheelbody.setPos(cp.v.add(centerwheelbody.getPos(),cp.v.add(deltaxy,cp.v(0,0))));
        space.addBody(centerwheelbody);

        var chassisbody = car.chassis.body;
        chassisbody.setPos(cp.v.add(chassisbody.getPos(),cp.v(0,0)));
        space.addBody(chassisbody);

        space.addShape(car.leftWheel.shape);
        space.addShape(car.rightWheel.shape);
        space.addShape(car.centerWheel.shape);
        space.addShape(car.chassis.shape);

        space.addShape(car.leftcollisionshape);
        space.addShape(car.rightcollisionshape);

        space.addConstraint(car.leftWheel.grooveJoint);
        space.addConstraint(car.rightWheel.grooveJoint);
        space.addConstraint(car.centerWheel.grooveJoint);

        space.addConstraint(car.leftWheel.dampedSpring);
        space.addConstraint(car.rightWheel.dampedSpring);
        space.addConstraint(car.centerWheel.dampedSpring);

        space.addConstraint(car.leftWheel.motorJoint);
        space.addConstraint(car.rightWheel.motorJoint);
        space.addConstraint(car.centerWheel.motorJoint);

        car.resetAllForces();
    };

    car.readdAllJointsShapeBodyNormal = function(){
        var leftwheelbody = car.leftWheel.body;
        leftwheelbody.setPos(cp.v.add(leftwheelbody.getPos(),cp.v(0,0)));
        space.addBody(leftwheelbody);

        var rightwheelbody = car.rightWheel.body;
        rightwheelbody.setPos(cp.v.add(rightwheelbody.getPos(),cp.v(0,0)));
        space.addBody(rightwheelbody);

        var centerwheelbody = car.centerWheel.body;
        centerwheelbody.setPos(cp.v.add(centerwheelbody.getPos(),cp.v(0,0)));
        space.addBody(centerwheelbody);

        var chassisbody = car.chassis.body;
        chassisbody.setPos(cp.v.add(chassisbody.getPos(),cp.v(0,0)));
        space.addBody(chassisbody);

        space.addShape(car.leftWheel.shape);
        space.addShape(car.rightWheel.shape);
        space.addShape(car.centerWheel.shape);
        space.addShape(car.chassis.shape);

        space.addShape(car.leftcollisionshape);
        space.addShape(car.rightcollisionshape);

        space.addConstraint(car.leftWheel.grooveJoint);
        space.addConstraint(car.rightWheel.grooveJoint);
        space.addConstraint(car.centerWheel.grooveJoint);

        space.addConstraint(car.leftWheel.dampedSpring);
        space.addConstraint(car.rightWheel.dampedSpring);
        space.addConstraint(car.centerWheel.dampedSpring);

        space.addConstraint(car.leftWheel.motorJoint);
        space.addConstraint(car.rightWheel.motorJoint);
        space.addConstraint(car.centerWheel.motorJoint);

        car.resetAllForces();
    };

    return car;
}
