function makeGrooveJoint(space,body1,body2,anchor1,anchor2){//滑槽
	var grooveJoint = new cp.GrooveJoint(body1, body2, anchor1, anchor2, cp.vzero)
	space.addConstraint(grooveJoint);
	return grooveJoint;
}
function makeDampedSpring(space,body1,body2,anchor1,anchor2, restLength, stiffness, damping){//阻尼弹簧
	var dampingSpring = new cp.DampedSpring(body1, body2, anchor1, anchor2, restLength, stiffness, damping);
	space.addConstraint(dampingSpring);
	return dampingSpring;
}
function makePinJoint(space,body1,body2,anchor1,anchor2){//销关节
	var pinJoint = new cp.PinJoint(body1, body2, anchor1, anchor2);
	space.addConstraint(pinJoint);
	return pinJoint;
}
function makeGearJoint(space,body1,body2,phase,ratio){//齿轮关节
	var gearJoint = new cp.GearJoint(body1, body2, phase, ratio);
	space.addConstraint(gearJoint);
	return gearJoint;
}
function makeMotorJoint(space,body1,body2,speed){//马达关节
	var motorJoint = new cp.SimpleMotor(body1, body2, speed);
	space.addConstraint(motorJoint);
	return motorJoint;
}
function makeRatchetJoint(space,body1,body2,phase,ratchet){//棘轮关节
	var ratchJoint = new cp.RatchetJoint(body1, body2, phase,ratchet);
	space.addConstraint(ratchJoint);
	return ratchJoint;
}

function makePivotJoint(space,body1,body2,anchor){//枢纽关节
	var pivotJoint = new cp.PivotJoint(body1,body2,anchor);
	space.addConstraint(pivotJoint);
	return pivotJoint;
}

function makeSkin(object,path,pic_anchorpoint,parent,body_angle,both_rotation,both_pos,pic_scale){
	var sprite = new cc.PhysicsSprite(path);
	sprite.setAnchorPoint(pic_anchorpoint);//图片 
	sprite.setOpacity(255);
	sprite.setBody(object.body);
	parent.addChild(sprite);
	object.body.setAngle(body_angle);
	sprite.setRotation(both_rotation);//body和图片
	sprite.setPosition(both_pos);//图片和body
	sprite.setScale(pic_scale);//图片
	sprite.setGlobalZOrder(constCar.globalZOrder.level_pos10);
	return sprite;
}
function makeSkin_simple(body,path,pic_anchorpoint,parent,body_angle,both_rotation,both_pos,pic_scale){
	var sprite = new cc.PhysicsSprite(path);
	sprite.setAnchorPoint(pic_anchorpoint);//图片 
	sprite.setOpacity(255);
	sprite.setBody(body);
	sprite.setGlobalZOrder(constCar.globalZOrder.level_pos10);
	body.setAngle(body_angle);
	sprite.setRotation(both_rotation);//body和图片
	sprite.setPosition(both_pos);//图片和body
	sprite.setScale(pic_scale);//图片 

	parent.addChild(sprite);
//	cc.Sprite.prototype.setRotation.call(sprite, 190);//没有用，那该如何旋转图片呐
	return sprite;
}



function makeSkin_simple_2_prop(path,pic_anchorpoint,body_angle,both_rotation,both_pos,pic_scale){
	var prop = {};

	prop.path = path;
	prop.pic_anchorpoint = pic_anchorpoint;
	prop.body_angle = body_angle;
	prop.both_rotation = both_rotation;
	prop.both_pos = both_pos;
	prop.pic_scale = pic_scale;

	return prop;
}
function makeSkin_simple_2_prop_no_physics(path,pic_anchorpoint,both_rotation,both_pos,pic_scale){
	var prop = {};

	prop.path = path;
	prop.pic_anchorpoint = pic_anchorpoint;
	prop.both_rotation = both_rotation;
	prop.both_pos = both_pos;
	prop.pic_scale = pic_scale;

	return prop;
}
function makeSkin_simple_2(body,parent,prop){
	var path = prop.path;
	var pic_anchorpoint = prop.pic_anchorpoint;
	var body_angle = prop.body_angle;
	var both_rotation = prop.both_rotation;
	var both_pos = prop.both_pos;
	var pic_scale = prop.pic_scale;

	var sprite = new cc.PhysicsSprite(path);
	sprite.setAnchorPoint(pic_anchorpoint);//图片 
	sprite.setBody(body);
	sprite.setGlobalZOrder(constCar.globalZOrder.level_pos1);
	body.setAngle(body_angle);
	sprite.setRotation(both_rotation);//body和图片
	sprite.setPosition(both_pos);//图片和body
	sprite.setScale(pic_scale);//图片 

	parent.addChild(sprite);
	return sprite;
}
function makeSkin_simple_2_no_physics(parent,prop){
	var path = prop.path;
	var pic_anchorpoint = prop.pic_anchorpoint;
	var both_rotation = prop.both_rotation;
	var both_pos = prop.both_pos;
	var pic_scale = prop.pic_scale;

	var sprite = new cc.Sprite(path);
	sprite.setAnchorPoint(pic_anchorpoint);//图片
	// sprite.setBody(body);
	sprite.setGlobalZOrder(constCar.globalZOrder.level_pos1);
	// body.setAngle(body_angle);
	sprite.setRotation(both_rotation);//body和图片
	sprite.setPosition(both_pos);//图片和body
	sprite.setScale(pic_scale);//图片

	parent.addChild(sprite);
	return sprite;
}
function makeSkin_simple_2_new(body,parent,prop,globalzorder){
	var path = prop.path;
	var pic_anchorpoint = prop.pic_anchorpoint;
	var body_angle = prop.body_angle;
	var both_rotation = prop.both_rotation;
	var both_pos = prop.both_pos;
	var pic_scale = prop.pic_scale;

	var sprite = new cc.PhysicsSprite(path);
	sprite.setAnchorPoint(pic_anchorpoint);//图片
	sprite.setBody(body);
	sprite.setGlobalZOrder(globalzorder);
	body.setAngle(body_angle);
	sprite.setRotation(both_rotation);//body和图片
	sprite.setPosition(both_pos);//图片和body
	sprite.setScale(pic_scale);//图片

	parent.addChild(sprite);
	return sprite;
}

function makeRectProp(){
	var prop = {};

	prop.widthHeight = cp.v(10,10);
	prop.mass = 1;
	prop.pos = cp.v(300,300);
	prop.group = 1;
	prop.elastic = 1.0;
	prop.friction = 1.0;

	return prop;
}
function makeRectPropCustom(widthHeight,mass,pos,group){
	var prop = {};

	prop.widthHeight = widthHeight;
	prop.mass = mass;
	prop.pos = pos;
	prop.group = group;
	prop.elastic = 0.0;
	prop.friction = 1.0;

	return prop;
}
function makeRectangleBody(space,prop){
	var body = {};

	var widthHeight = prop.widthHeight;
	var mass = prop.mass;
	var pos = prop.pos;
	var group = prop.group;
	var elastic = prop.elastic;
	var friction = prop.friction;

	var body = space.addBody(new cp.Body(mass, cp.momentForBox(mass, widthHeight.x, widthHeight.y)));
	body.setPos(pos);

	var shape = space.addShape(new cp.BoxShape(body, widthHeight.x, widthHeight.y));
	shape.setElasticity(elastic);
	shape.setFriction(friction);
	shape.group = group;

	return body;
}
function makeRectangleBody2(space,prop){
	var body = {};

	var widthHeight = prop.widthHeight;
	var mass = prop.mass;
	var pos = prop.pos;
	var group = prop.group;
	var elastic = prop.elastic;
	var friction = prop.friction;
	var layers = prop.layers;

	var body = space.addBody(new cp.Body(mass, cp.momentForBox(mass, widthHeight.x, widthHeight.y)));
	body.setPos(pos);

	var shape = space.addShape(new cp.BoxShape(body, widthHeight.x, widthHeight.y));
	shape.setElasticity(elastic);
	shape.setFriction(friction);
	shape.group = group;
	// shape.setLayers(layers);

	return [body,shape];
}


function stopToTargetX(dt,target_x,car,callback,idx,updatecontroller){
	mylog("real func stopToTargetX.................." + callback.controlValue);
	if(typeof callback == "undefined"){
		mylog("callback is undefined,check it ");
		return;
	}
	if(callback.controlValue){
		var balance_body = car.chassis.body;
		var wheel_body   = car.leftWheel.body;

		/*cpFloat*/ var max_v = 50.0;
		/*cpFloat*/ var target_v = fclamp(biascoef(0.5, dt/1.2)*(target_x - balance_body.p.x)/dt, -max_v, max_v);
		/*cpFloat*/ var error_v = (target_v - balance_body.v.x);
		/*cpFloat*/ var target_sin = 3.0e-3*biascoef(0.1, dt)*error_v/dt;

		/*cpFloat*/ var max_sin = Math.sin(0.5);
		car.balance_sin = fclamp(car.balance_sin - 6.0e-5*biascoef(0.2, dt)*error_v/dt, -max_sin, max_sin);
		/*cpFloat*/ var target_a = Math.asin(fclamp(-target_sin + car.balance_sin, -max_sin, max_sin));
		/*cpFloat*/ var angular_diff = Math.asin(cp.v.cross(balance_body.rot, cp.v.forangle(target_a)));
		/*cpFloat*/ var target_w = biascoef(0.1, dt/0.4)*(angular_diff)/dt;

		/*cpFloat*/ var max_rate = 25.0;
		/*cpFloat*/ var rate = fclamp(wheel_body.w + balance_body.w - 3 * target_w, -max_rate, max_rate);

		var tmpRate = fclamp(rate, -max_rate, max_rate);
		car.changeSpeed(tmpRate);
		mylog("rate = " + tmpRate);
		car.leftWheel.motorJoint.maxForce = (7.0e4);
		car.rightWheel.motorJoint.maxForce = (7.0e4);
		if("undefined" != typeof car.centerWheel){
			car.centerWheel.motorJoint.maxForce = (8.0e4);
		}
		if("undefined" != typeof car.centerRightWheel){
			car.centerRightWheel.motorJoint.maxForce = (8.0e4);
		}
		if("undefined" != typeof car.leftCenterWheel){
			car.leftCenterWheel.motorJoint.maxForce = (8.0e4);
		}
		if(("undefined" != typeof car.track) && ("undefined" != typeof car.track.clockwiseRun)){
			car.track.clockwiseRun(Math.abs(tmpRate));
		}
		// car.audioManager.carAudioRunningCtl.setVolume(mapval(Math.abs(tmpRate),0,8,constCar.volume.minVolume,constCar.volume.maxVolume));
		car.audioManager.carAudioRunningCtl.setVolume(0.4);

		if(Math.abs(car.chassisSpr.getPositionX() - target_x) < 3 || Math.abs(tmpRate) < 0.01){
			callback.controlValue = false;
			// updatecontroller.updateArrayBool[idx] = false;
			car.leftWheel.motorJoint.maxForce = (Infinity);
			car.rightWheel.motorJoint.maxForce = (Infinity);
			if("undefined" != typeof car.centerWheel){
				car.centerWheel.motorJoint.maxForce = (Infinity);
			}
			if("undefined" != typeof car.centerRightWheel){
				car.centerRightWheel.motorJoint.maxForce = (Infinity);
			}
			if("undefined" != typeof car.leftCenterWheel){
				car.leftCenterWheel.motorJoint.maxForce = (Infinity);
			}
			if("undefined" != typeof car.track){
				car.track.clockwiseRun(0.5);
			}
			callback();
		}
	}
}
