function getNewCollType(){
	constCar.collTypeBegin ++;
	return constCar.collTypeBegin;
}


function collisionline_new(space,a,b,collBegCalback,collisionType,friction) {
	mylog("collisionline_new called!!!");
	var center = cp.v.mult(cp.v.add(a, b), 1.0/2.0);

	var body = cp.StaticBody(1,1);
	body.setPos(center);

	var shape = space.addShape(new cp.SegmentShape(body, cp.v.sub(a, center), cp.v.sub(b, center), 2.0));

	shape.setCollisionType(collisionType);
	shape.setFriction(friction);
	shape.group = constCar.collisionlines.group;
	shape.name = "collisionline";
	shape.notCollected = true;
	shape.layers = constCar.collisionlines.layers;
	shape.setSensor(true);

	var collisionBeginCallback = function(arbiter,space){
		var shapeA = arbiter.getShapes()[0];
		var shapeB = arbiter.getShapes()[1];

		space.addPostStepCallback(function(){
			mylog("collisionline poststepcallback new");
			if("collisionline" == shapeA.name && shapeA.notCollected){
				shapeA.notCollected = false;
				if(collBegCalback){
					collBegCalback(shapeA);
				}
			}else if("collisionline" == shapeB.name && shapeB.notCollected){
				shapeB.notCollected = false;
				if(collBegCalback){
					collBegCalback(shapeB);
				}
			}
		});

		return false;
	}

	space.addCollisionHandler(
		constCar.car.chassis.collisionType,
		collisionType,
		collisionBeginCallback,
		function(arbiter,space){},
		function(arbiter,space){},
		function(arbiter,space){}
	);

	return body;
}

function collisionline_new_isSensor(space,a,b,collBegCalback,collisionType,friction,isSensor) {
	mylog("collisionline_new called!!!");
	var center = cp.v.mult(cp.v.add(a, b), 1.0/2.0);

	var body = cp.StaticBody(1,1);
	body.setPos(center);

	var shape = space.addShape(new cp.SegmentShape(body, cp.v.sub(a, center), cp.v.sub(b, center), 2.0));

	shape.setCollisionType(collisionType);
	shape.setFriction(friction);
	shape.group = constCar.collisionlines.group;
	shape.name = "collisionline";
	shape.notCollected = true;
	shape.layers = constCar.collisionlines.layers;
	shape.setSensor(isSensor);

	var collisionBeginCallback = function(arbiter,space){
		var shapeA = arbiter.getShapes()[0];
		var shapeB = arbiter.getShapes()[1];

		space.addPostStepCallback(function(){
			mylog("collisionline poststepcallback new");
			if("collisionline" == shapeA.name && shapeA.notCollected){
				shapeA.notCollected = false;
				if(collBegCalback){
					collBegCalback(shapeA);
				}
			}else if("collisionline" == shapeB.name && shapeB.notCollected){
				shapeB.notCollected = false;
				if(collBegCalback){
					collBegCalback(shapeB);
				}
			}
		});

		return false;
	}

	space.addCollisionHandler(
		constCar.car.chassis.collisionType,
		collisionType,
		collisionBeginCallback,
		function(arbiter,space){},
		function(arbiter,space){},
		function(arbiter,space){}
	);

	return body;
}

function collisionline_new2(parent,space,a,b,collBegCalback,collisionType,friction) {
	parent.physicsController.addALineNew(a,b);
}


function collisionline_new3(parent,point1,point2){
	var shape = parent._space.addShape(new cp.SegmentShape(parent._space.staticBody,point1,point2,0));
	shape.group = parent.metaData.road.group;
	shape.setFriction(parent.metaData.road.friction);
	shape.setElasticity(parent.metaData.road.elastic);
	return shape;
};

var f_offset = (winWidth() - 1136) / 2;

function initConfig_Jigsaw(){                          
	var car1TotalScale = 0.8;
	var car2TotalScale = 0.8;
	var car3TotalScale = 0.8;
	Config_Jigsaw = {
			deltaPos:40,
			currentSceneIdx:0,
			currentSceneList:["car1","car2","car3"],
			currentSceneColor:{
				"car1":cc.color(214,75,53,255),
				"car2":cc.color(85,184,232,255),
				"car3":cc.color(242,148,222,255)
			},
			animDuration:0.08,            
			animTime:1,
			debug:{
				before:true
			},
			car1:{
				totalPic:6,  
				totalAnimPic:13,
				back:{
					scale:car1TotalScale,
					position:cp.v(f_offset + 568,320)
				},
				pic1:{
					get:false,
					before:{
						position:cp.v(f_offset + 880,468),
						scale:0.7,
						rotation:0
					},
					after:{
						position:cp.v(f_offset + 293,400),
						scale:car1TotalScale,
						rotation:0
					}
				},
				pic2:{
					get:false,
					before:{
						position:cp.v(f_offset + 893, 182),
						scale:0.7,
						rotation:0
					},
					after:{
						position:cp.v(f_offset + 630, 256),
						scale:car1TotalScale,
						rotation:0
					}
				},
				pic3:{
					get:false,
					before:{
						position:cp.v(f_offset + 423, 502),
						scale:0.7,
						rotation:0
					},
					after:{
						position:cp.v(f_offset + 721, 380),
						scale:car1TotalScale,
						rotation:0
					}
				},
				pic4:{
					get:false,
					before:{
						position:cp.v(f_offset + 203, 166),
						scale:0.7,
						rotation:0
					},
					after:{
						position:cp.v(f_offset + 436, 385),
						scale:car1TotalScale,
						rotation:0
					}
				},
				pic5:{
					get:false,
					before:{
						position:cp.v(f_offset + 444, 140),
						scale:0.7,
						rotation:0
					},
					after:{
						position:cp.v(f_offset + 486, 319),
						scale:car1TotalScale,
						rotation:0
					}
				},
				pic6:{
					get:false,
					before:{
						position:cp.v(f_offset + 332, 223),
						scale:0.7,
						rotation:0
					},
					after:{
						position:cp.v(f_offset + 565, 346),
						scale:car1TotalScale,
						rotation:0
					}
				}
			},
			car2:{
				totalPic:6,
				totalAnimPic:13,
				back:{
					scale:car2TotalScale,
					position:cp.v(f_offset + 568,320)
				},
				pic1:{
					get:false,
					before:{
						position:cp.v(f_offset + 871, 458),
						scale:0.7,
						rotation:0
					},
					after:{
						position:cp.v(f_offset + 312, 361),
						scale:car2TotalScale,
						rotation:0
					}
				},
				pic2:{
					get:false,
					before:{
						position:cp.v(f_offset + 511, 509),
						scale:0.7,
						rotation:0
					},
					after:{
						position:cp.v(f_offset + 629, 328),
						scale:car2TotalScale,
						rotation:0
					}
				},
				pic3:{
					get:false,
					before:{
						position:cp.v(f_offset + 199, 466),
						scale:0.7,
						rotation:0
					},
					after:{
						position:cp.v(f_offset + 516, 215),
						scale:car2TotalScale,
						rotation:0
					}
				},
				pic4:{
					get:false,
					before:{
						position:cp.v(f_offset + 234, 148),
						scale:0.7,
						rotation:0
					},
					after:{
						position:cp.v(f_offset + 612, 244),
						scale:car2TotalScale,
						rotation:0
					}
				},
				pic5:{
					get:false,
					before:{
						position:cp.v(f_offset + 923, 155),
						scale:0.7,
						rotation:0  
					},
					after:{
						position:cp.v(f_offset + 704, 199),
						scale:car2TotalScale,
						rotation:0
					}
				},
				pic6:{
					get:false,
					before:{
						position:cp.v(f_offset + 582, 103),
						scale:0.7,
						rotation:0
					},
					after:{
						position:cp.v(f_offset + 858, 247),
						scale:car2TotalScale,
						rotation:0
					}
				}
			},
			car3:{
				totalPic:6,
				totalAnimPic:13,
				back:{
					scale:car3TotalScale,
					position:cp.v(f_offset + 568,320)
				},
				pic1:{
					get:false,
					before:{
						position:cp.v(f_offset + 308, 141),
						scale:0.7,
						rotation:0
					},
					after:{
						position:cp.v(f_offset + 309, 526),
						scale:car3TotalScale,
						rotation:0
					}
				},
				pic2:{
					get:false,
					before:{
						position:cp.v(f_offset + 217, 368),
						scale:0.7,
						rotation:0
					},
					after:{
						position:cp.v(f_offset + 439, 395),
						scale:car3TotalScale,
						rotation:0
					}
				},
				pic3:{
					get:false,
					before:{
						position:cp.v(f_offset + 736, 495),
						scale:0.7,
						rotation:0
					},
					after:{
						position:cp.v(f_offset + 677, 218),
						scale:car3TotalScale,
						rotation:0
					}
				},
				pic4:{
					get:false,
					before:{
						position:cp.v(f_offset + 917, 137),
						scale:0.7,
						rotation:0
					},
					after:{
						position:cp.v(f_offset + 567, 117),
						scale:car3TotalScale,
						rotation:0
					}
				},
				pic5:{
					get:false,
					before:{
						position:cp.v(f_offset + 911, 383),
						scale:0.7,
						rotation:0
					},
					after:{
						position:cp.v(f_offset + 610, 160),
						scale:car3TotalScale,
						rotation:0
					}
				},
				pic6:{
					get:false,
					before:{
						position:cp.v(f_offset + 709, 355),
						scale:0.7,
						rotation:0
					},
					after:{
						position:cp.v(f_offset + 716, 131),
						scale:car3TotalScale,
						rotation:0
					}
				}
			}
	};
}
