var audioController = function(path,loop,maxVolume,minVolume,finishCallback){
    var controller = {};

    controller.init = function(path,loop,maxVolume,minVolume,finishCallback){
        controller._path = path;
        controller._audioID = jsb.AudioEngine.INVALID_AUDIO_ID;
        controller._isLoop = loop || false;
        controller._finishCallback = finishCallback;
        controller._isStarted = false;
        controller._maxVolume = maxVolume || 1.0;
        controller._minVolume = minVolume || 0.0;
        controller._currentVolume = constCar.volume.constVolume;
    };
    controller.start = function(){
        controller._audioID = jsb.AudioEngine.play2d(controller._path,controller._isLoop,controller._currentVolume);
        controller._audioID.controller = controller;
        controller.setCallback(controller._finishCallback);
    };
    controller.pause = function(){
        if(controller._audioID != jsb.AudioEngine.INVALID_AUDIO_ID){
            jsb.AudioEngine.pause(controller._audioID);
        }
    };
    controller.resume = function(){
        if(controller._audioID != jsb.AudioEngine.INVALID_AUDIO_ID){
            jsb.AudioEngine.resume(controller._audioID);
        }
    };
    controller.stop = function(){
        if(controller._audioID != jsb.AudioEngine.INVALID_AUDIO_ID){
            jsb.AudioEngine.stop(controller._audioID);
        }
    };
    controller.setLoop = function(isLoop){
        if(controller._audioID != jsb.AudioEngine.INVALID_AUDIO_ID){
            jsb.AudioEngine.setLoop(controller._audioID,isLoop);
        }
    };
    controller.setVolume = function(volume){
        // mylog("set volume .................." + volume);
        if(controller._audioID != jsb.AudioEngine.INVALID_AUDIO_ID){
            if(volume <= controller._minVolume) {
                controller._currentVolume = controller._minVolume;
            }else if(volume >= controller._maxVolume) {
                controller._currentVolume = controller._maxVolume;
            }

            controller._currentVolume = volume;
            jsb.AudioEngine.setVolume(controller._audioID, controller._currentVolume);
        }
    };
    controller.setCallback = function(callback){
        if(controller._audioID != jsb.AudioEngine.INVALID_AUDIO_ID) {
            jsb.AudioEngine.setFinishCallback(controller._audioID,callback);
        }
    };

    controller.init(path,loop,maxVolume,minVolume,finishCallback);
    return controller;
};


var playTreasureEffect = function(){
    return jsb.AudioEngine.play2d("res/common/audio/shiqubaoshi.mp3",false,1);
};

var playLifterEffect = function(){
    return  jsb.AudioEngine.play2d("res/common/audio/shengjiangti.mp3",false,1);
};

var playBalloonEffect = function(){
    return jsb.AudioEngine.play2d("res/common/audio/qiqiubaozha.mp3",false,1);
};

var playFountainEffect = function(){
    return jsb.AudioEngine.play2d("res/common/audio/penquan.mp3",true,1);
};

var playShitousui1Effect = function(){
    return jsb.AudioEngine.play2d("res/common/audio/shitousui1.mp3",false,1);
};

var playShitousui2Effect = function(){
    return jsb.AudioEngine.play2d("res/common/audio/shitousui2.mp3",false,1);
};

var playShikuaidiaoluoEffect = function(){
    return jsb.AudioEngine.play2d("res/common/audio/shikuaidiaoluo.mp3",false,1);
};

var playQiqiubaozhaEffect = function(){
    return jsb.AudioEngine.play2d("res/common/audio/qiqiubaozha.mp3",false,1);
};

var playKaibaoxiangEffect = function(){
    return jsb.AudioEngine.play2d("res/common/audio/kaibaoxiang.mp3",false,1);
};

var playJiaobanjiEffect = function(){
    return jsb.AudioEngine.play2d("res/common/audio/jiaobanji.mp3",false,1);
};

var playUFOEffect = function(volume){
    var _volume = (typeof volume != "undefined") ? volume : 1;
    return jsb.AudioEngine.play2d("res/common/audio/feixingqi.mp3",false,_volume);
};

var playCarEffect = function(name){
    return jsb.AudioEngine.play2d("res/common/audio/car/"+name+".mp3",false,1);
};



var stopTheAudio = function(audioID){
    jsb.AudioEngine.stop(audioID);
};
