var SpriteController = Controller.extend({
	_carController:null,
	_shieldController:null,
	_car:null,
	ctor:function(parent,carprop){
		this._super(parent);
		this.addCarController(carprop);
		mylog("Sprite controller ctor");
	},
	//override
	init:function(){
		mylog("Sprite controller init");
		this.metaData = {

		};
	},    
	getCar:function(){
		return this._car;
	},
	setConstMaxSpeed:function(speed){
		this._carController.setConstMaxSpeed(speed);
	},
	shieldTheLayer:function(isShield){
		// if(!isShield){
			this.changeState(constState.stateNoNe);
		// }
		this._shieldController.shieldTheLayer(isShield);
	},
	changeState:function(state){
		this._carController.changeState(state);
	},
	getTouchState:function(){
		return this._carController.touchState;
	},
	changeStateToAutoDrive:function(){
		this._carController.changeState(constState.stateAutoDrive);
	},
	regainStateFromAutoDrive:function(){
		this._carController.changeState(constState.stateNoNe);
	},
	addACar:function(carprop){
		switch (carprop.name){
			case "A1":
				this._car = makeA1Car(this.par.physicsController.getSpace(),carprop,this.par);
				break;
			case "A2":
				this._car = makeA2Car(this.par.physicsController.getSpace(),carprop,this.par);
				break;
			case "A3":
				this._car = makeA3Car(this.par.physicsController.getSpace(),carprop,this.par);
				break;
			case "B1":
				this._car = makeB1Car(this.par.physicsController.getSpace(),carprop,this.par);
				break;
			case "B2":
				this._car = makeB2Car(this.par.physicsController.getSpace(),carprop,this.par);
				break;
			case "B3":
				this._car = makeB3Car(this.par.physicsController.getSpace(),carprop,this.par);
				break;
			case "C1":
				this._car = makeC1Car(this.par.physicsController.getSpace(),carprop,this.par);
				break;
			case "C2":
				this._car = makeC2Car(this.par.physicsController.getSpace(),carprop,this.par);
				break;
			case "C3":
				this._car = makeC3Car(this.par.physicsController.getSpace(),carprop,this.par);
				break;
			case "Loop":
				this._car = makeLoopCar(this.par.physicsController.getSpace(),carprop,this.par);
				break;
			default :
				break;
		}
	},
	autoDrive:function(distX,cb,speed){
		this._carController.autoDrive(distX,cb,speed);
	},
	getCurrentSpeed:function(){
		return this._carController.currentSpeed;
	},
	getMaxSpeed:function(){
		return this._carController.maxSpeed;
	},
	getFrameAccelerate:function(){
		return this._carController.frameAccelerate;
	},
	setMaxSpeed:function(maxSpeed){
		this._carController.setMaxSpeed(maxSpeed);
	},
	setFrameAccelerate:function(frameAccelerate){
		this._carController.setFrameAccelerate(frameAccelerate);
	},
	setShouldUpdate:function(shouldUpdate){
		this._carController.setShouldUpdate(shouldUpdate);
	},
	addCarController:function(carprop){
		this.addACar(carprop);
		// if(carprop.name == "A1" || carprop.name == "A2" || carprop.name == "A3") {
		// 	this._carController = new CarAControlLayer(cc.color(255, 0, 0, 0), cc.winSize.width, cc.winSize.height, this.par);
		// }else if(carprop.name == "B1" || carprop.name == "B2" || carprop.name == "B3"){
		// 	this._carController = new CarBControlLayer(cc.color(255, 0, 0, 0), cc.winSize.width, cc.winSize.height, this.par);
		// }else if(carprop.name == "C1" || carprop.name == "C2" || carprop.name == "C3"){
		// 	this._carController = new CarCControlLayer(cc.color(255, 0, 0, 0), cc.winSize.width, cc.winSize.height, this.par);
		// }
		switch(carprop.name){
			case "A1" :
				this._carController = new CarAControlLayer_a1(cc.color(255, 0, 0, 0), cc.winSize.width, cc.winSize.height, this.par);
				break;
			case "A2" :
				this._carController = new CarAControlLayer_a2(cc.color(255, 0, 0, 0), cc.winSize.width, cc.winSize.height, this.par);
				break;
			case "A3" :
				this._carController = new CarAControlLayer_a3(cc.color(255, 0, 0, 0), cc.winSize.width, cc.winSize.height, this.par);
				break;

			case "B1" :
				this._carController = new CarBControlLayer_b1(cc.color(255, 0, 0, 0), cc.winSize.width, cc.winSize.height, this.par);
				break;
			case "B2" :
				this._carController = new CarBControlLayer_b2(cc.color(255, 0, 0, 0), cc.winSize.width, cc.winSize.height, this.par);
				break;
			case "B3" :
				this._carController = new CarBControlLayer_b3(cc.color(255, 0, 0, 0), cc.winSize.width, cc.winSize.height, this.par);
				break;

			case "C1" :
				this._carController = new CarCControlLayer_c1(cc.color(255, 0, 0, 0), cc.winSize.width, cc.winSize.height, this.par);
				break;
			case "C2" :
				this._carController = new CarCControlLayer_c2(cc.color(255, 0, 0, 0), cc.winSize.width, cc.winSize.height, this.par);
				break;
			case "C3" :
				this._carController = new CarCControlLayer_c3(cc.color(255, 0, 0, 0), cc.winSize.width, cc.winSize.height, this.par);
				break;
			case "Loop" :
				this._carController = new CarAControlLayer_loop(cc.color(255, 0, 0, 0), cc.winSize.width, cc.winSize.height, this.par);
				break;
		};
		this.par.cameraController.getFollowCameraSpriteList().push(this._carController);
		this.par.addChild(this._carController,1000);

		this._shieldController = new ShieldControlLayer(this.par);
		this.par.cameraController.getFollowCameraSpriteList().push(this._shieldController);
		this._shieldController.setGlobalZOrder(constCar.globalZOrder.level_pos100 + 1);
		this.par.addChild(this._shieldController,1001);
	},
});
SpriteController._instance = null;
SpriteController.getInstance = function(){
	if(!SpriteController._instance) {
		var layer = getLayerByName(GlobalCurrentLayerName);
		var prop = null;
		switch (GlobalCurrentLayerName) {
			case "A1":
				prop = makeA1CarProps();
				break;
			case "A2":
				prop = makeA2CarProps();
				break;
			case "A3":
				prop = makeA3CarProps();
				break;
			case "B1":
				prop = makeB1CarProps();
				break;
			case "B2":
				prop = makeB2CarProps();
				break;
			case "B3":
				prop = makeB3CarProps();
				break;
			case "C1":
				prop = makeC1CarProps();
				break;
			case "C2":
				prop = makeC2CarProps();
				break;
			case "C3":
				prop = makeC3CarProps();
				break;
			case "Loop":
				prop = makeLoopCarProps();
				break;
			default:
				break;
		}
		SpriteController._instance = new SpriteController(layer, prop);
	}
	return SpriteController._instance;
}
