function lifter(path,parent,riseHeight,position,space){
    var lifter = {};

    var spr = cc.Sprite(path);
    lifter.width = spr._getWidth();
    lifter.height = spr._getHeight();

    lifter.pos = position;
    lifter.riseHeight = riseHeight;
    lifter.runTime = 3;
    lifter.carMoveDist = lifter.width/2;
    lifter.leftColDelPos1 = cp.v(lifter.width/2+100,-100);
    lifter.leftColDelPos2 = cp.v(lifter.width/2+100,100);
    lifter.groundLineDelPos1 = cp.v(-lifter.width/2,10);
    lifter.groundLineDelPos2 = cp.v(lifter.width/2,10);

    lifter.leftCollisionPos1 = cp.v.sub(lifter.pos,lifter.leftColDelPos1);
    lifter.leftCollisionPos2 = cp.v.sub(lifter.pos,lifter.leftColDelPos2);
    lifter.groundLinePos1 = cp.v.sub(lifter.pos,lifter.groundLineDelPos1);
    lifter.groundLinePos2 = cp.v.sub(lifter.pos,lifter.groundLineDelPos2);
    lifter.riseGroundLinePos1 = cp.v.add(lifter.groundLinePos1,cp.v(0,lifter.riseHeight));
    lifter.riseGroundLinePos2 = cp.v.add(lifter.groundLinePos2,cp.v(0,lifter.riseHeight));
    lifter.riseGroundLineLeftPos1 = cp.v.add(lifter.riseGroundLinePos2,cp.v(-10,0));
    lifter.riseGroundLineLeftPos2 = cp.v.add(lifter.riseGroundLinePos2,cp.v(-10,lifter.riseHeight));

    lifter.groundLine = collisionline_new(parent._space, lifter.groundLinePos1,lifter.groundLinePos2, function(backshape){}, getNewCollType(), 0.4);
    lifter._backFunc = function(backshape){
        mylog("lifter._backFunc is called");
        var tempnode = new cc.Node();
        parent.addChild(tempnode);
        tempnode.runAction(
            cc.sequence(
                cc.callFunc(function(){
                    if(typeof(parent.spriteController) != "undefined") {
                        parent.spriteController._shieldController.shieldTheLayer(true);
                    }
                }),
                cc.delayTime(0.4),
                cc.callFunc(function(){
                    if(typeof backshape != "undefined")
                        space.removeShape(backshape);

                    var func = function(){

                        parent.physicsController.changeGravity(cp.v(0,0));
                        if(typeof(parent.spriteController) != "undefined") {
                            mylog(parent.spriteController.getCar().chassisSpr.getPosition().x+","+parent.spriteController.getCar().chassisSpr.getPosition().y);
                            parent.spriteController.getCar().chassisSpr.runAction(cc.moveBy(lifter.runTime, 0, lifter.riseHeight));
                        }
                        lifter.physicsSprite.runAction(
                            cc.sequence(
                                cc.callFunc(function(){
                                    lifter.audioID = playLifterEffect();
                                }),
                                cc.moveBy(lifter.runTime,0,lifter.riseHeight),
                                cc.callFunc(function(){
                                    stopTheAudio(lifter.audioID);
                                    lifter.createRiseGround();
                                    parent.physicsController.regainGravity();
                                    parent.spriteController._shieldController.shieldTheLayer(false);
                                })));
                    };
                    if(typeof(parent.spriteController) != "undefined") {
                        func.controlValue = true;
                        var carPosX = parent.spriteController.getCar().chassisSpr.getPosition().x;
                        parent.updateController.pushOneDataToArray(carPosX + lifter.carMoveDist, func);
                    }
                })));
    };
    lifter.leftCollisionLine = collisionline_new(parent._space, lifter.leftCollisionPos1,lifter.leftCollisionPos2, function(backshape){
        lifter._backFunc(backshape);
    } , getNewCollType(), 0.4);


    var bodyProp = makeRectPropCustom(cp.v(lifter.width,lifter.height),1,cp.v(0,0),1);
    lifter.phyBodyShape = makeRectangleBody2(space, bodyProp);
    var prop = makeSkin_simple_2_prop(path, cp.v(0.5,0.5), 0, 0, cp.v(0,0), 1);
    lifter.physicsSprite = makeSkin_simple_2(lifter.phyBodyShape[0], parent, prop);
    lifter.physicsSprite.setPosition(lifter.pos);

    lifter.createRiseGround = function(){
        lifter.riseGroundLine = collisionline_new(
            parent._space,
            lifter.riseGroundLinePos1,
            lifter.riseGroundLinePos2,
            function(backshape){} , getNewCollType(), 0.4);
        lifter.riseGroundLineLeft = collisionline_new(
            parent._space, lifter.riseGroundLineLeftPos1,lifter.riseGroundLineLeftPos2, function(backshape){ }, getNewCollType(), 0.4);
    };

    lifter.test = function(){
        lifter._backFunc();
    };

    return lifter;
}







function lifter2_c2(path,parent,riseHeight,position){
    var lifter = {};

    lifter.spr = cc.Sprite(path);
    parent.addChild(lifter.spr);
    lifter.width = lifter.spr._getWidth();
    lifter.height = lifter.spr._getHeight();
    lifter.spr.setPosition(cp.v.sub(position,cp.v(0,lifter.height/2)));


    lifter.pos = position;
    lifter.riseHeight = riseHeight;
    lifter.runTime = 3;
    lifter.carMoveDist = lifter.width/2;
    lifter.leftColDelPos1 = cp.v(-lifter.width/2 + 120,-20);
    lifter.leftColDelPos2 = cp.v(-lifter.width/2 + 120,20);
    lifter.groundLineDelPos1 = cp.v(-lifter.width/2,0);
    lifter.groundLineDelPos2 = cp.v(lifter.width/2,0);

    lifter.leftCollisionPos1 = cp.v.sub(lifter.pos,lifter.leftColDelPos1);
    lifter.leftCollisionPos2 = cp.v.sub(lifter.pos,lifter.leftColDelPos2);
    lifter.groundLinePos1 = cp.v.sub(lifter.pos,lifter.groundLineDelPos1);
    lifter.groundLinePos2 = cp.v.sub(lifter.pos,lifter.groundLineDelPos2);
    lifter.riseGroundLinePos1 = cp.v.add(lifter.groundLinePos1,cp.v(0,lifter.riseHeight));
    lifter.riseGroundLinePos2 = cp.v.add(lifter.groundLinePos2,cp.v(0,lifter.riseHeight));
    lifter.riseGroundLineLeftPos1 = cp.v.add(lifter.riseGroundLinePos2,cp.v(-10,0));
    lifter.riseGroundLineLeftPos2 = cp.v.add(lifter.riseGroundLinePos2,cp.v(-10,lifter.riseHeight));

    lifter._backFuncToUp = function(backshape){
        parent._space.removeShape(backshape);
        mylog(parent.spriteController.getCar().leftWheel.body.toSource());
        var tempnode = new cc.Node();
        parent.addChild(tempnode);
        parent.spriteController.getCar().removeAllJointsShapeBody();
        tempnode.runAction(
            cc.sequence(
                cc.callFunc(function(){
                    if(typeof(parent.spriteController) != "undefined") {
                        parent.spriteController._shieldController.shieldTheLayer(true);
                    }
                }),
                cc.delayTime(0.4),
                cc.callFunc(function(){
                    parent.spriteController.getCar().chassisSpr.runAction(cc.sequence(cc.moveBy(lifter.runTime, 0, lifter.riseHeight),cc.delayTime(1),cc.callFunc(function(){
                        parent.physicsController._canUpdatePhysics = true;

                        lifter.createLeftCollisionLineUp();
                        var node = new cc.Node();
                        parent.addChild(node);
                        node.runAction(cc.sequence(
                            cc.callFunc(function(){
                                //lifter.groundLineUpTmp = parent.physicsController.addALineNew(lifter.prop2.point1,lifter.prop2.point2,lifter.prop2);
                                lifter.groundLineDownTmp = parent.physicsController.addALineNew(lifter.prop1.point1,lifter.prop1.point2,lifter.prop1);
                                parent.spriteController.getCar().readdAllJointsShapeBody(cp.v(0,0),450);
                            }),
                            cc.delayTime(1),
                            cc.callFunc(function(){
                                parent._space.removeShape(lifter.groundLineDownTmp);
                            })
                        ));
                        // var prop = {
                        //     group:0x0001,
                        //     width:10,
                        //     layers:3
                        // };
                        // parent.physicsController.addALineNew(cp.v.add(cp.v(-180,-200),position),cp.v.add(position,cp.v(-180,600)),prop);

                    })));
                    lifter.spr.runAction(
                        cc.sequence(
                            cc.callFunc(function(){
                                lifter.audioID = playLifterEffect();
                            }),
                            cc.moveBy(lifter.runTime,0,lifter.riseHeight),
                            cc.callFunc(function(){
                                stopTheAudio(lifter.audioID);
                                // lifter.createRiseGround();
                                parent.physicsController._canUpdatePhysics = true;
                                parent.spriteController._shieldController.shieldTheLayer(false);
                            })));
                })));
    };

    lifter._backFuncToDown = function(backshape){
        parent._space.removeShape(backshape);
        mylog(parent.spriteController.getCar().leftWheel.body.toSource());
        var tempnode = new cc.Node();
        parent.addChild(tempnode);
        parent.spriteController.getCar().removeAllJointsShapeBody();
        tempnode.runAction(
            cc.sequence(
                cc.callFunc(function(){
                    if(typeof(parent.spriteController) != "undefined") {
                        parent.spriteController._shieldController.shieldTheLayer(true);
                    }
                }),
                cc.delayTime(0.4),
                cc.callFunc(function(){
                    parent.spriteController.getCar().chassisSpr.runAction(cc.sequence(cc.moveBy(lifter.runTime, 0, -lifter.riseHeight),cc.delayTime(1),cc.callFunc(function(){
                        parent.physicsController._canUpdatePhysics = true;

                        lifter.createLeftCollisionLineDown();
                        var node = new cc.Node();
                        parent.addChild(node);
                        node.runAction(cc.sequence(
                            cc.callFunc(function(){
                                //lifter.groundLineUpTmp = parent.physicsController.addALineNew(lifter.prop2.point1,lifter.prop2.point2,lifter.prop2);
                                lifter.groundLineUpTmp = parent.physicsController.addALineNew(lifter.prop2.point1,lifter.prop2.point2,lifter.prop2);
                                parent.spriteController.getCar().readdAllJointsShapeBody(cp.v(0,0),-450);
                            }),
                            cc.delayTime(1),
                            cc.callFunc(function(){
                                parent._space.removeShape(lifter.groundLineUpTmp);
                            })
                        ));
                        // var prop = {
                        //     group:0x0001,
                        //     width:10,
                        //     layers:3
                        // };
                        // parent.physicsController.addALineNew(cp.v.add(cp.v(-180,-200),position),cp.v.add(position,cp.v(-180,600)),prop);

                    })));
                    lifter.spr.runAction(
                        cc.sequence(
                            cc.callFunc(function(){
                                lifter.audioID = playLifterEffect();
                            }),
                            cc.moveBy(lifter.runTime,0,-lifter.riseHeight),
                            cc.callFunc(function(){
                                stopTheAudio(lifter.audioID);
                                // lifter.createRiseGround();
                                parent.physicsController._canUpdatePhysics = true;
                                parent.spriteController._shieldController.shieldTheLayer(false);
                            })));
                })));
    };


    lifter.prop1 = {
        group:0x0001,
        width:10,
        layers:3,
        point1:cp.v.add(lifter.leftCollisionPos2,cp.v(0+88,0+riseHeight)),
        point2:cp.v.add(lifter.leftCollisionPos2,cp.v(0+88,160+riseHeight))
    };


    lifter.prop2 = {
        group:0x0001,
        width:10,
        layers:3,
        point1:cp.v.add(lifter.leftCollisionPos1,cp.v(0-328,0)),
        point2:cp.v.add(lifter.leftCollisionPos1,cp.v(0-328,160))
    };



    lifter.createDownGround = function(){
        lifter.groundLineDown = collisionline_new3(
            parent,
            lifter.groundLinePos1,
            lifter.groundLinePos2
        );
    }();
    lifter.createRiseGround = function(){
        lifter.groundLineUp = collisionline_new3(
            parent,
            cp.v.add(lifter.groundLinePos1,cp.v(0,riseHeight)),
            cp.v.add(lifter.groundLinePos2,cp.v(0,riseHeight))
        );
    }();
    lifter.createLeftCollisionLineDown = function(){
        lifter.leftCollisionLineDown = collisionline_new(
            parent._space,
            lifter.leftCollisionPos1,
            lifter.leftCollisionPos2,
            function(backshape){
                lifter._backFuncToUp(backshape);
            },
            getNewCollType(),
            0.4);
    };

    lifter.createLeftCollisionLineUp = function(){
        lifter.leftCollisionLineUp = collisionline_new(
            parent._space,
            cp.v.add(lifter.leftCollisionPos1,cp.v(-260,lifter.riseHeight)),
            cp.v.add(lifter.leftCollisionPos2,cp.v(-260,lifter.riseHeight)),
            function(backshape){
                lifter._backFuncToDown(backshape);
            },
            getNewCollType(),
            0.4);
    };

    lifter.createLeftCollisionLineDown();
    lifter.leftLeftCollisionLine = collisionline_new(
        parent._space,
        cp.v.add(lifter.leftCollisionPos1,cp.v(-100,0)),
        cp.v.add(lifter.leftCollisionPos2,cp.v(-100,0)),
        function(backshape){
            parent._space.removeShape(backshape);
            parent.spriteController.autoDrive(100,function(){mylog("rollercoasterccar is over");},4.5);
        },
        getNewCollType(),
        0.4);

    return lifter;
}


function lifter2_a(path,parent,riseHeight,position){
    var lifter = {};

    lifter.spr = cc.Sprite(path);
    parent.addChild(lifter.spr);
    lifter.width = lifter.spr._getWidth();
    lifter.height = lifter.spr._getHeight();
    lifter.spr.setPosition(cp.v.sub(position,cp.v(0,lifter.height/2)));


    lifter.pos = position;
    lifter.riseHeight = riseHeight + 8;
    lifter.runTime = 3;
    lifter.carMoveDist = lifter.width/2;
    lifter.leftColDelPos1 = cp.v(-lifter.width/2 + 120,-20);
    lifter.leftColDelPos2 = cp.v(-lifter.width/2 + 120,20);
    lifter.groundLineDelPos1 = cp.v(-lifter.width/2,0);
    lifter.groundLineDelPos2 = cp.v(lifter.width/2,0);

    lifter.leftCollisionPos1 = cp.v.sub(lifter.pos,lifter.leftColDelPos1);
    lifter.leftCollisionPos2 = cp.v.sub(lifter.pos,lifter.leftColDelPos2);
    lifter.groundLinePos1 = cp.v.sub(lifter.pos,lifter.groundLineDelPos1);
    lifter.groundLinePos2 = cp.v.sub(lifter.pos,lifter.groundLineDelPos2);
    lifter.riseGroundLinePos1 = cp.v.add(lifter.groundLinePos1,cp.v(0,lifter.riseHeight));
    lifter.riseGroundLinePos2 = cp.v.add(lifter.groundLinePos2,cp.v(0,lifter.riseHeight));
    lifter.riseGroundLineLeftPos1 = cp.v.add(lifter.riseGroundLinePos2,cp.v(-10,0));
    lifter.riseGroundLineLeftPos2 = cp.v.add(lifter.riseGroundLinePos2,cp.v(-10,lifter.riseHeight));

    lifter._backFuncToDown = function(backshape){
        parent._space.removeShape(backshape);
        var tempnode = new cc.Node();
        parent.addChild(tempnode);
        parent.spriteController.getCar().removeAllJointsShapeBody();
        tempnode.runAction(
            cc.sequence(
                cc.callFunc(function(){
                    if(typeof(parent.spriteController) != "undefined") {
                        parent.spriteController._shieldController.shieldTheLayer(true);
                    }
                }),
                cc.delayTime(0.4),
                cc.callFunc(function(){
                    parent.spriteController.getCar().chassisSpr.runAction(cc.sequence(cc.callFunc(function(){ parent.spriteController.getCar().isVisibleLeftRightSpr(true);}),cc.moveBy(lifter.runTime, 0, -lifter.riseHeight),cc.delayTime(1),cc.callFunc(function(){
                        parent.spriteController._canUpdatePhysics = true;
                        parent.spriteController.getCar().isVisibleLeftRightSpr(false);


                        var node = new cc.Node();
                        parent.addChild(node);
                        node.runAction(cc.sequence(
                            cc.callFunc(function(){
                                //lifter.groundLineUpTmp = parent.physicsController.addALineNew(lifter.prop2.point1,lifter.prop2.point2,lifter.prop2);
                                lifter.groundLineUpTmp = parent.physicsController.addALineNew(lifter.prop2.point1,lifter.prop2.point2,lifter.prop2);
                                parent.spriteController.getCar().readdAllJointsShapeBody(cp.v(0,-lifter.riseHeight));
                            }),
                            cc.delayTime(0.5),
                            cc.callFunc(function(){
                                parent._space.removeShape(lifter.groundLineUpTmp);
                            })
                        ));
                    })));
                    lifter.spr.runAction(
                        cc.sequence(
                            cc.callFunc(function(){
                                lifter.audioID = playLifterEffect();
                            }),
                            cc.moveBy(lifter.runTime,0,-lifter.riseHeight),
                            cc.callFunc(function(){
                                stopTheAudio(lifter.audioID);

                                lifter.createRiseGround();
                                parent.physicsController._canUpdatePhysics = true;
                                parent.spriteController._shieldController.shieldTheLayer(false);

                                var prop = {
                                    group:0x0001,
                                    width:10,
                                    layers:3
                                };
                                parent.physicsController.addALineNew(cp.v.add(cp.v(-220,200),lifter.pos),cp.v.add(lifter.pos,cp.v(-220,600)),prop);

                                lifter.leftCollisionLineUp = collisionline_new(
                                    parent._space,
                                    cp.v.add(lifter.leftCollisionPos1,cp.v(-220,lifter.riseHeight)),
                                    cp.v.add(lifter.leftCollisionPos2,cp.v(-220,lifter.riseHeight)),
                                    function(backshape){
                                        lifter._backFuncToDown(backshape);
                                    }, getNewCollType(), 0.4);
                            })));
                })));
    };

    lifter._backFuncToUp = function(backshape){
        parent._space.removeShape(backshape);
        mylog("lifter._backFunc is called"+parent.spriteController._canUpdatePhysics);
        var tempnode = new cc.Node();
        parent.addChild(tempnode);
        parent.spriteController.getCar().removeAllJointsShapeBody();
        tempnode.runAction(
            cc.sequence(
                cc.callFunc(function(){
                    if(typeof(parent.spriteController) != "undefined") {
                        parent.spriteController._shieldController.shieldTheLayer(true);
                    }
                }),
                cc.delayTime(0.4),
                cc.callFunc(function(){
                    parent.spriteController.getCar().chassisSpr.runAction(cc.sequence(cc.callFunc(function(){ parent.spriteController.getCar().isVisibleLeftRightSpr(true);}),cc.moveBy(lifter.runTime, 0, lifter.riseHeight),cc.delayTime(1),cc.callFunc(function(){
                        parent.spriteController._canUpdatePhysics = true;
                        parent.spriteController.getCar().isVisibleLeftRightSpr(false);


                        var node = new cc.Node();
                        parent.addChild(node);
                        node.runAction(cc.sequence(
                            cc.callFunc(function(){
                                lifter.groundLineDownTmp = parent.physicsController.addALineNew(lifter.prop1.point1,lifter.prop1.point2,lifter.prop1);
                                parent.spriteController.getCar().readdAllJointsShapeBody(cp.v(0,lifter.riseHeight));
                            }),
                            cc.delayTime(0.5),
                            cc.callFunc(function(){
                                parent._space.removeShape(lifter.groundLineDownTmp);
                            })
                        ));
                    })));
                    lifter.spr.runAction(
                        cc.sequence(
                            cc.callFunc(function(){
                                lifter.audioID = playLifterEffect();
                            }),
                            cc.moveBy(lifter.runTime,0,lifter.riseHeight),
                            cc.callFunc(function(){
                                stopTheAudio(lifter.audioID);

                                lifter.createRiseGround();
                                parent.physicsController._canUpdatePhysics = true;
                                parent.spriteController._shieldController.shieldTheLayer(false);

                                var prop = {
                                    group:0x0001,
                                    width:10,
                                    layers:3
                                };
                                parent.physicsController.addALineNew(cp.v.add(cp.v(-220,200),lifter.pos),cp.v.add(lifter.pos,cp.v(-220,600)),prop);

                                lifter.leftCollisionLineDown = collisionline_new(
                                    parent._space,
                                    lifter.leftCollisionPos1,
                                    lifter.leftCollisionPos2,
                                    function(backshape){
                                        lifter._backFuncToUp(backshape);
                                    }, getNewCollType(), 0.4);
                            })));
                })));
    };


    lifter.prop1 = {
        group:0x0001,
        width:10,
        layers:3,
        point1:cp.v.add(lifter.leftCollisionPos2,cp.v(0+46,0+riseHeight)),
        point2:cp.v.add(lifter.leftCollisionPos2,cp.v(0+46,160+riseHeight))
    };


    lifter.prop2 = {
        group:0x0001,
        width:10,
        layers:3,
        point1:cp.v.add(lifter.leftCollisionPos1,cp.v(0-220,0)),
        point2:cp.v.add(lifter.leftCollisionPos1,cp.v(0-220,160))
    };


    lifter.groundLineDown = collisionline_new3(
        parent,
        cp.v.add(lifter.groundLinePos1,cp.v(0,-4)),
        cp.v.add(lifter.groundLinePos2,cp.v(0,-4))
    );
    lifter.createRiseGround = function(){
        lifter.groundLineUp = collisionline_new3(
            parent,
            cp.v.add(cp.v.add(lifter.groundLinePos1,cp.v(25,0)),cp.v(0,8+riseHeight - 4)),
            cp.v.add(lifter.groundLinePos2,cp.v(0,8+riseHeight - 4))
        );
    };
    lifter.leftCollisionLineDown = collisionline_new(
        parent._space,
        lifter.leftCollisionPos1,
        lifter.leftCollisionPos2,
        function(backshape){
            lifter._backFuncToUp(backshape);
        }, getNewCollType(), 0.4);

    lifter.leftCollisionLineUp = collisionline_new(
        parent._space,
        cp.v.add(lifter.leftCollisionPos1,cp.v(-220,lifter.riseHeight)),
        cp.v.add(lifter.leftCollisionPos2,cp.v(-220,lifter.riseHeight)),
        function(backshape){
            lifter._backFuncToDown(backshape);
        }, getNewCollType(), 0.4);

    lifter.leftLeftCollisionLine = collisionline_new(
        parent._space,
        cp.v.add(lifter.leftCollisionPos1,cp.v(-220,0)),
        cp.v.add(lifter.leftCollisionPos2,cp.v(-220,0)),
        function(backshape){
            parent._space.removeShape(backshape);
            parent.spriteController.autoDrive(220,function(){
                parent.spriteController.getCar().rightWheel.shape.setFriction(0.85);
                parent.spriteController.getCar().leftWheel.shape.setFriction(0.85);
            },3);
        }, getNewCollType(), 5);


    return lifter;
}


function lifter2_b(path,parent,riseHeight,position){
    var lifter = {};
    var deltaRiseHeight = 11;

    lifter.spr = cc.Sprite(path);
    parent.addChild(lifter.spr);
    lifter.width = lifter.spr._getWidth();
    lifter.height = lifter.spr._getHeight();
    lifter.spr.setPosition(cp.v.sub(position,cp.v(0,lifter.height/2)));


    lifter.pos = position;
    lifter.riseHeight = riseHeight += deltaRiseHeight;
    lifter.runTime = 3;
    lifter.carMoveDist = lifter.width/2;
    lifter.leftColDelPos1 = cp.v(-lifter.width/2 + 60,-20);//+120
    lifter.leftColDelPos2 = cp.v(-lifter.width/2 + 60,20);
    lifter.groundLineDelPos1 = cp.v(-lifter.width/2,0);
    lifter.groundLineDelPos2 = cp.v(lifter.width/2,0);

    lifter.leftCollisionPos1 = cp.v.sub(lifter.pos,lifter.leftColDelPos1);
    lifter.leftCollisionPos2 = cp.v.sub(lifter.pos,lifter.leftColDelPos2);
    lifter.groundLinePos1 = cp.v.sub(lifter.pos,lifter.groundLineDelPos1);
    lifter.groundLinePos2 = cp.v.sub(lifter.pos,lifter.groundLineDelPos2);
    lifter.riseGroundLinePos1 = cp.v.add(lifter.groundLinePos1,cp.v(0,lifter.riseHeight));
    lifter.riseGroundLinePos2 = cp.v.add(lifter.groundLinePos2,cp.v(0,lifter.riseHeight));
    lifter.riseGroundLineLeftPos1 = cp.v.add(lifter.riseGroundLinePos2,cp.v(-10,0));
    lifter.riseGroundLineLeftPos2 = cp.v.add(lifter.riseGroundLinePos2,cp.v(-10,lifter.riseHeight));


    lifter._backFuncToDown = function(backshape){
        parent._space.removeShape(backshape);
        var tempnode = new cc.Node();
        parent.addChild(tempnode);
        parent.spriteController.getCar().removeAllJointsShapeBody();
        tempnode.runAction(
            cc.sequence(
                cc.callFunc(function(){
                    if(typeof(parent.spriteController) != "undefined") {
                        parent.spriteController._shieldController.shieldTheLayer(true);
                    }
                }),
                cc.delayTime(0.4),
                cc.callFunc(function(){
                    parent.spriteController.getCar().chassisSpr.runAction(cc.sequence(cc.moveBy(lifter.runTime, 0, -lifter.riseHeight),cc.delayTime(1),cc.callFunc(function(){
                        parent.spriteController._canUpdatePhysics = true;
                        parent.spriteController.getCar().readdAllJointsShapeBody(cp.v(0,-lifter.riseHeight));
                    })));
                    lifter.spr.runAction(
                        cc.sequence(
                            cc.callFunc(function(){
                                lifter.audioID = playLifterEffect();
                            }),
                            cc.moveBy(lifter.runTime,0,-lifter.riseHeight),
                            cc.callFunc(function(){
                                stopTheAudio(lifter.audioID);
                                lifter.createRiseGround();
                                parent.physicsController._canUpdatePhysics = true;
                                parent.spriteController._shieldController.shieldTheLayer(false);

                                lifter.createLeftCollisionLineDown();

                                var node = new cc.Node();
                                parent.addChild(node);
                                node.runAction(cc.sequence(
                                    cc.callFunc(function(){
                                        lifter.createTmpDownLine();
                                    }),
                                    cc.delayTime(1.5),
                                    cc.callFunc(function(){
                                        parent._space.removeShape(lifter.tmpDownLine);
                                    })
                                ));
                                // var prop = {
                                //     group:0x0001,
                                //     width:10,
                                //     layers:3
                                // };
                                // parent.physicsController.addALineNew(cp.v.add(cp.v(-200,200),lifter.pos),cp.v.add(lifter.pos,cp.v(-200,400)),prop);
                            })));
                })));
    };
    lifter._backFuncToUp = function(backshape){
        parent._space.removeShape(backshape);
        var tempnode = new cc.Node();
        parent.addChild(tempnode);
        parent.spriteController.getCar().removeAllJointsShapeBody();
        tempnode.runAction(
            cc.sequence(
                cc.callFunc(function(){
                    if(typeof(parent.spriteController) != "undefined") {
                        parent.spriteController._shieldController.shieldTheLayer(true);
                    }
                }),
                cc.delayTime(0.4),
                cc.callFunc(function(){
                    parent.spriteController.getCar().chassisSpr.runAction(cc.sequence(cc.moveBy(lifter.runTime, 0, lifter.riseHeight),cc.delayTime(1),cc.callFunc(function(){
                        parent.spriteController._canUpdatePhysics = true;
                        parent.spriteController.getCar().readdAllJointsShapeBody(cp.v(0,lifter.riseHeight));
                    })));
                    lifter.spr.runAction(
                        cc.sequence(
                            cc.callFunc(function(){
                                lifter.audioID = playLifterEffect();
                            }),
                            cc.moveBy(lifter.runTime,0,lifter.riseHeight),
                            cc.callFunc(function(){
                                stopTheAudio(lifter.audioID);
                                lifter.createRiseGround();
                                parent.physicsController._canUpdatePhysics = true;
                                parent.spriteController._shieldController.shieldTheLayer(false);


                                lifter.createLeftCollisionLineUp();

                                var node = new cc.Node();
                                parent.addChild(node);
                                node.runAction(cc.sequence(
                                    cc.callFunc(function(){
                                        lifter.createTmpUpLine();
                                    }),
                                    cc.delayTime(1.5),
                                    cc.callFunc(function(){
                                        parent._space.removeShape(lifter.tmpUpLine);
                                    })
                                ));

                                // var prop = {
                                //     group:0x0001,
                                //     width:10,
                                //     layers:3
                                // };
                                // parent.physicsController.addALineNew(cp.v.add(cp.v(-200,200),lifter.pos),cp.v.add(lifter.pos,cp.v(-200,400)),prop);
                            })));
                })));
    };

    lifter.createLineDown = function(){
        if("undefined" == typeof(lifter.groundLineDown)) {
            lifter.groundLineDown = collisionline_new3(
                parent,
                cp.v.add(lifter.groundLinePos1, cp.v(60, 0)),
                cp.v.add(lifter.groundLinePos2, cp.v(-60, 0))
            );
        }
    };

    lifter.createRiseGround = function(){
        if("undefined" == typeof(lifter.groundLineUp)) {
            lifter.groundLineUp = collisionline_new3(
                parent,
                cp.v.add(cp.v.add(lifter.groundLinePos1, cp.v(60, 0)), cp.v(0, lifter.riseHeight)),
                cp.v.add(cp.v.add(lifter.groundLinePos2, cp.v(-60, 0)), cp.v(0, lifter.riseHeight))
            );
        }
    };

    lifter.createTmpUpLine = function(){
        var prop = {
            group:0x0001,
            width:5,
            layers:3
        };
        lifter.tmpUpLine =  parent.physicsController.addALineNew(cp.v.add(cp.v(140,200),lifter.pos),cp.v.add(lifter.pos,cp.v(140,400)),prop);
    };

    lifter.createTmpDownLine = function(){
        var prop = {
            group:0x0001,
            width:5,
            layers:3
        };
        lifter.tmpDownLine = parent.physicsController.addALineNew(cp.v.add(cp.v(-180,0),lifter.pos),cp.v.add(lifter.pos,cp.v(-180,200)),prop);
    };

    lifter.createLineDown();
    lifter.createRiseGround();

    lifter.createLeftCollisionLineDown = function(){
        lifter.leftCollisionLineDown = collisionline_new(
            parent._space,
            lifter.leftCollisionPos1,
            lifter.leftCollisionPos2,
            function (backshape) {
                lifter._backFuncToUp(backshape);
            }, getNewCollType(), 0.4);
    };
    lifter.createLeftCollisionLineDown();

    lifter.createLeftCollisionLineUp = function(){
        lifter.leftCollisionLineUp = collisionline_new(
            parent._space,
            cp.v.add(lifter.leftCollisionPos1, cp.v(-210, riseHeight)),
            cp.v.add(lifter.leftCollisionPos2, cp.v(-210, riseHeight)),
            function (backshape) {
                lifter._backFuncToDown(backshape);
            }, getNewCollType(), 0.4);
    };

    return lifter;
}

function lifter2_c3(path,parent,riseHeight,position){
    var lifter = {};

    lifter.spr = cc.Sprite(path);
    parent.addChild(lifter.spr);
    lifter.width = lifter.spr._getWidth();
    lifter.height = lifter.spr._getHeight();
    lifter.spr.setPosition(cp.v.sub(position,cp.v(0,lifter.height/2)));


    lifter.pos = position;
    lifter.riseHeight = riseHeight;
    lifter.runTime = 3;
    lifter.carMoveDist = lifter.width/2;
    lifter.leftColDelPos1 = cp.v(-lifter.width/2 + 120,-20);
    lifter.leftColDelPos2 = cp.v(-lifter.width/2 + 120,20);
    lifter.groundLineDelPos1 = cp.v(-lifter.width/2,14);
    lifter.groundLineDelPos2 = cp.v(lifter.width/2,14);

    lifter.leftCollisionPos1 = cp.v.sub(lifter.pos,lifter.leftColDelPos1);
    lifter.leftCollisionPos2 = cp.v.sub(lifter.pos,lifter.leftColDelPos2);
    lifter.groundLinePos1 = cp.v.sub(lifter.pos,lifter.groundLineDelPos1);
    lifter.groundLinePos2 = cp.v.sub(lifter.pos,lifter.groundLineDelPos2);
    lifter.riseGroundLinePos1 = cp.v.add(lifter.groundLinePos1,cp.v(0,lifter.riseHeight));
    lifter.riseGroundLinePos2 = cp.v.add(lifter.groundLinePos2,cp.v(0,lifter.riseHeight));
    lifter.riseGroundLineLeftPos1 = cp.v.add(lifter.riseGroundLinePos2,cp.v(-10,0));
    lifter.riseGroundLineLeftPos2 = cp.v.add(lifter.riseGroundLinePos2,cp.v(-10,lifter.riseHeight));

    lifter._backFuncUp = function(backshape){
        mylog("lifter._backFunc is called"+parent.spriteController._canUpdatePhysics);
        var tempnode = new cc.Node();
        parent.addChild(tempnode);
        parent.spriteController.getCar().removeAllJointsShapeBody();
        tempnode.runAction(
            cc.sequence(
                cc.callFunc(function(){
                    if(typeof(parent.spriteController) != "undefined") {
                        parent.spriteController._shieldController.shieldTheLayer(true);
                    }
                }),
                cc.delayTime(0.4),
                cc.callFunc(function(){
                    parent.spriteController.getCar().chassisSpr.runAction(cc.sequence(cc.moveBy(lifter.runTime, 0, -lifter.riseHeight),cc.delayTime(1),cc.callFunc(function(){
                        parent.spriteController.getCar().readdAllJointsShapeBody(cp.v(0,-lifter.riseHeight));

                        lifter.createLeftCollisionLineDown();

                        var node = new cc.Node();
                        parent.addChild(node);
                        node.runAction(cc.sequence(
                            cc.callFunc(function(){
                                mylog("createTmpLineUp");
                                lifter.createTmpUpLine();
                            }),
                            cc.delayTime(1.2),
                            cc.callFunc(function(){
                                parent._space.removeShape(lifter.tmpUpLine);
                            })
                        ));
                        // parent.physicsController._canUpdatePhysics = false;

                        // var prop = {
                        //     group:0x0001,
                        //     width:10,
                        //     layers:3
                        // };
                        // parent.physicsController.addALineNew(cp.v.add(cp.v(-180,-200),position),cp.v.add(position,cp.v(-180,600)),prop);

                    })));
                    lifter.spr.runAction(
                        cc.sequence(
                            cc.callFunc(function(){
                                lifter.audioID = playLifterEffect();
                            }),
                            cc.moveBy(lifter.runTime,0,-lifter.riseHeight),
                            cc.callFunc(function(){
                                stopTheAudio(lifter.audioID);
                                // lifter.createRiseGround();
                                // parent.physicsController._canUpdatePhysics = true;
                                parent.spriteController._shieldController.shieldTheLayer(false);
                            })));
                })));
    };

    lifter._backFuncDown = function(backshape){
        mylog("lifter._backFunc is called"+parent.spriteController._canUpdatePhysics);
        var tempnode = new cc.Node();
        parent.addChild(tempnode);
        parent.spriteController.getCar().removeAllJointsShapeBody();
        tempnode.runAction(
            cc.sequence(
                cc.callFunc(function(){
                    if(typeof(parent.spriteController) != "undefined") {
                        parent.spriteController._shieldController.shieldTheLayer(true);
                    }
                }),
                cc.delayTime(0.4),
                cc.callFunc(function(){
                    parent.spriteController.getCar().chassisSpr.runAction(cc.sequence(cc.moveBy(lifter.runTime, 0, lifter.riseHeight),cc.delayTime(1),cc.callFunc(function(){
                        parent.spriteController.getCar().readdAllJointsShapeBody(cp.v(0,lifter.riseHeight));


                        lifter.createLeftCollisionLineUp();

                        var node = new cc.Node();
                        parent.addChild(node);
                        node.runAction(cc.sequence(
                            cc.callFunc(function(){
                                mylog("createTmpLineDown");
                                lifter.createTmpDownLine();
                            }),
                            cc.delayTime(1.2),
                            cc.callFunc(function(){
                                parent._space.removeShape(lifter.tmpDownLine);
                            })
                        ));
                        // parent.physicsController._canUpdatePhysics = false;

                        // var prop = {
                        //     group:0x0001,
                        //     width:10,
                        //     layers:3
                        // };
                        // parent.physicsController.addALineNew(cp.v.add(cp.v(-180,-200),position),cp.v.add(position,cp.v(-180,600)),prop);

                    })));
                    lifter.spr.runAction(
                        cc.sequence(
                            cc.callFunc(function(){
                                lifter.audioID = playLifterEffect();
                            }),
                            cc.moveBy(lifter.runTime,0,lifter.riseHeight),
                            cc.callFunc(function(){
                                stopTheAudio(lifter.audioID);
                                // lifter.createRiseGround();
                                // parent.physicsController._canUpdatePhysics = true;
                                parent.spriteController._shieldController.shieldTheLayer(false);
                            })));
                })));
    };

    lifter.createTmpUpLine = function(){
        var prop = {
            group:0x0001,
            width:5,
            layers:3
        };
        lifter.tmpUpLine =  parent.physicsController.addALineNew(cp.v.add(lifter.leftCollisionPos1,cp.v(-320,-100)), cp.v.add(lifter.leftCollisionPos2,cp.v(-320,200)),prop);
    };

    lifter.createTmpDownLine = function(){
        var prop = {
            group:0x0001,
            width:5,
            layers:3
        };
        lifter.tmpDownLine = parent.physicsController.addALineNew( cp.v.add(lifter.leftCollisionPos1,cp.v(-20,riseHeight-100)), cp.v.add(lifter.leftCollisionPos2,cp.v(-20,riseHeight+200)),prop);
    };

    lifter.createDownGround = function(){
        lifter.groundLineDown = collisionline_new3(
            parent,
            lifter.groundLinePos1,
            lifter.groundLinePos2
        );
    }();
    lifter.createRiseGround = function(){
        lifter.groundLineUp = collisionline_new3(
            parent,
            cp.v.add(lifter.groundLinePos1,cp.v(0,riseHeight)),
            cp.v.add(lifter.groundLinePos2,cp.v(0,riseHeight))
        );
    }();
    lifter.createLeftCollisionLineDown = function() {
        lifter.leftCollisionLineDown = collisionline_new(
            parent._space,
            cp.v.add(lifter.leftCollisionPos1, cp.v(-100, 0)),
            cp.v.add(lifter.leftCollisionPos2, cp.v(-100, 0)),
            function (backshape) {
                parent._space.removeShape(backshape);
                lifter._backFuncDown(backshape);
            },
            getNewCollType(),
            0.4);
    };

    lifter.createLeftCollisionLineDown();

    lifter.createLeftCollisionLineUp = function(){
        lifter.leftCollisionLineUp = collisionline_new(
            parent._space,
            cp.v.add(lifter.leftCollisionPos1,cp.v(-100 - 200,riseHeight)),
            cp.v.add(lifter.leftCollisionPos2,cp.v(-100 - 200,riseHeight)),
            function(backshape){
                parent._space.removeShape(backshape);
                lifter._backFuncUp(backshape);
            },
            getNewCollType(),
            0.4);
    };


    lifter.leftCollisionLine2 = collisionline_new(
        parent._space,
        cp.v.add(lifter.leftCollisionPos1,cp.v(-270-100,0)),
        cp.v.add(lifter.leftCollisionPos2,cp.v(-270-100,0)),
        function(backshape){
            parent._space.removeShape(backshape);
            parent.spriteController.autoDrive(270,function(){},4.5);
        },
        getNewCollType(),
        0.4);

    lifter.test = function(){
        lifter._backFunc();
    };

    return lifter;
}
