var addBar = function(space,pos,boxOffset,widthHeight,group) {
    var width = widthHeight.x;
    var height = widthHeight.y;
    var mass = 20.0;
    var a = cp.v(width,  0);
    var b = cp.v(-width, 0);

    var body = space.addBody(new cp.Body(mass, cp.momentForSegment(mass, a, b)));
    body.setPos(cp.v.add(pos, boxOffset));

    // var shape = space.addShape(new cp.SegmentShape(body, a, b, height));
    var shape = space.addShape(new cp.BoxShape(body,width*2,height*2));
    shape.setElasticity(0.0);
    shape.setFriction(0.7);
    shape.group = group;
    // shape.group = (12);

    return body;
}
var addBar2 = function(space,pos,boxOffset,widthHeight,group) {
    var width = widthHeight.x;
    var height = widthHeight.y;
    var mass = 2.0;
    var a = cp.v(width,  0);
    var b = cp.v(-width, 0);

    var body = new cp.StaticBody(mass,cp.momentForSegment(mass, a, b));
    body.setPos(cp.v.add(pos, boxOffset));

    // var shape = space.addShape(new cp.SegmentShape(body, a, b, height));
    var shape = space.addShape(new cp.BoxShape(body,width*2,height*2));
    shape.setElasticity(0.0);
    shape.setFriction(0.7);
    shape.group = group;
    // shape.group = (12);

    return body;
}
var addBall = function(space, pos,boxOffset,inradius) {
    var radius = inradius;
    var mass = 1.0;
    var body = space.addBody(new cp.Body(mass, cp.momentForCircle(mass, 0.0, radius, cp.vzero)));
    body.setPos(cp.v.add(pos, boxOffset));
    var shape = space.addShape(new cp.CircleShape(body, radius, cp.vzero));
    shape.setElasticity(0.0);
    shape.setFriction(0.7);

    return body;
}

function seesaw(parent,position){
    var seesaw = {};
    var deltaPos = cp.v.add(cp.v(-120,-120),position);
    var scale = 1;

    var spr = cc.Sprite("res/car_c/scene3/jixieguanka9");
    seesaw.width = spr._getWidth();
    seesaw.height = spr._getHeight();

    seesaw.seesawMainSpr = new cc.Sprite("res/car_c/scene3/jixieguanka2");
    seesaw.seesawMainSpr.setPosition(cp.v.add(cp.v(453,290),deltaPos));
    parent.addChild(seesaw.seesawMainSpr);


    createStaticNode_new("res/car_c/scene3/jixieguanka3", seesaw.seesawMainSpr, cp.v(-255+80,-108+80), 23,1);
    var node1 = createStaticNode_new("res/car_c/scene3/jixieguanka4", seesaw.seesawMainSpr, cp.v(135+80,30+80), 15,1);
    var node2 = createStaticNode_new("res/car_c/scene3/jixieguanka8", seesaw.seesawMainSpr, cp.v(86+80,226+80), 10,1);

    node1.setGlobalZOrder(constCar.globalZOrder.level_pos100);
    node2.setGlobalZOrder(constCar.globalZOrder.level_pos100-1);

    var posA = cp.v( 147+80+35, 160+80-5);
    var boxOffset = cp.v.add(cp.v(255, 205),deltaPos);
    seesaw.body = addBar(parent._space, posA, boxOffset,cp.v(seesaw.width/2 - 15,seesaw.height/2),0x1111);
    seesaw.body.applyImpulse(cp.v(10,-10),cp.v(0.5,0));
    parent._space.addConstraint(new cp.PivotJoint(seesaw.body, parent._space.staticBody, cp.v.add(boxOffset,posA)));
    var prop = makeSkin_simple_2_prop("res/car_c/scene3/jixieguanka9", cp.v(0.5,0.5), 0, 0, cp.v.add(cp.v(517,444),deltaPos), 1.13);
    var physicsSprite = makeSkin_simple_2_new(seesaw.body, parent, prop,0);


    var ground1 = addBar2(parent._space, cp.v.add(posA,cp.v(0,-300)), boxOffset,cp.v(seesaw.width/2 - 15,seesaw.height/2),0x1112);
    var ground2 = addBar2(parent._space, cp.v.add(posA,cp.v(500,-140)), boxOffset,cp.v(seesaw.width/2 - 15,seesaw.height/2),0x1112);
    seesaw.seesawMainSpr.setScale(scale);
    return seesaw;
}
