function makeUFOProp(){
    var width = 270;
    var height = 120;
    var delta = 4;

    //change these
    // var posX = 120 + 480 + 6458;
    // var posY = 164 + (0);
    var posX = 1020;
    var posY = 173;

    var prop = {
        widthHeight:cp.v(width,height),
        mass:30,
        pos:cp.v(posX,posY),
        group:constCar.ufo.group,
        elastic:0,
        friction:1,
        point1:cp.v(posX - width/2 - delta,posY - height/2),
        point2:cp.v(posX + width/2 + delta,posY - height/2),
        baffle_left:{
            pointUp:cp.v(posX - width/2 - delta,posY + 10),
            pointDown:cp.v(posX - width/2 - delta,posY - height/2)
        },
        baffle_right:{
            pointUp:cp.v(posX + width/2 + delta,posY + 10),
            pointDown:cp.v(posX + width/2 + delta,posY - height/2)
        },
        collection_wheel:{
            pointLeft:cp.v(width/4,height/2 + 0),
            pointRight:cp.v(width/4 * 2,height/2 + 0),
            collectionType:10,
            isRemovedFromSpace:false
        },
        twoBaffle:{
            baffle1:{
                point1:cp.v(- width/2,0),
                point2:cp.v(- width/2,height * 2)
            },
            baffle2:{
                point1:cp.v(width/2,0),
                point2:cp.v(width/2,height * 2)
            }
        }
    };
    return prop;
}

var b2_guanqia_ufo_5 = function(parent,position){
    var diaozhua = {};
    diaozhua.horizontalDist = 880;

    diaozhua.deltaPos = cp.v.add(cp.v(-225,-400),position);

    diaozhua.diaozhuaUp = new cc.Sprite("res/car_b/scene2/diaozhua/1");
    diaozhua.diaozhuaUp.setGlobalZOrder(constCar.globalZOrder.level_pos5);
    parent.addChild(diaozhua.diaozhuaUp,3);
    diaozhua.diaozhuaUp.setPosition(cp.v.add(diaozhua.deltaPos,cp.v(300,530)));

    diaozhua.diaozhuaLine = new cc.Sprite("res/car_b/scene2/diaozhua/5");
    diaozhua.diaozhuaLine.setGlobalZOrder(constCar.globalZOrder.level_pos5);
    diaozhua.diaozhuaUp.addChild(diaozhua.diaozhuaLine,-1);
    diaozhua.diaozhuaLine.setAnchorPoint(cp.v(0,1));
    diaozhua.diaozhuaLine.setPosition(cp.v(20,5));

    diaozhua.diaozhuaDown = new cc.Sprite("res/car_b/scene2/diaozhua/2");
    diaozhua.diaozhuaDown.setGlobalZOrder(constCar.globalZOrder.level_pos5);
    diaozhua.diaozhuaUp.addChild(diaozhua.diaozhuaDown,3);
    diaozhua.diaozhuaDown.setPosition(cp.v(38.3,-40));

    diaozhua.right = new cc.Sprite("res/car_b/scene2/diaozhua/3");
    diaozhua.right.setGlobalZOrder(constCar.globalZOrder.level_pos5);
    diaozhua.right.setAnchorPoint(0.4,0.9);
    diaozhua.diaozhuaDown.addChild(diaozhua.right,-3);
    diaozhua.right.setPosition(cp.v.add(cp.v(0,0),cp.v(114,8)));

    diaozhua.left = new cc.Sprite("res/car_b/scene2/diaozhua/4");
    diaozhua.left.setGlobalZOrder(constCar.globalZOrder.level_pos5);
    diaozhua.left.setAnchorPoint(0.6,0.9);
    diaozhua.diaozhuaDown.addChild(diaozhua.left,-3);
    diaozhua.left.setPosition(cp.v.add(cp.v(0,0),cp.v(15,8)));

    diaozhua.leftCicle = new cc.Sprite("res/car_b/scene2/diaozhua/6");
    diaozhua.leftCicle.setGlobalZOrder(constCar.globalZOrder.level_pos5+1);
    parent.addChild(diaozhua.leftCicle,1);
    diaozhua.leftCicle.setPosition(cp.v.add(cp.v(220,530),diaozhua.deltaPos));

    diaozhua.rightCicle = new cc.Sprite("res/car_b/scene2/diaozhua/6");
    diaozhua.rightCicle.setGlobalZOrder(constCar.globalZOrder.level_pos5+1);
    parent.addChild(diaozhua.rightCicle,1);
    diaozhua.rightCicle.setPosition(cp.v.add(cp.v(225+1055,530),diaozhua.deltaPos));

    diaozhua.lineUp = new cc.Sprite("res/car_b/scene2/line");
    diaozhua.lineUp.setGlobalZOrder(constCar.globalZOrder.level_pos5-1);
    parent.addChild(diaozhua.lineUp,-1);
    diaozhua.lineUp.setPosition(cp.v.add(cp.v(747,555),diaozhua.deltaPos));

    diaozhua.lineDown = new cc.Sprite("res/car_b/scene2/line");
    diaozhua.lineDown.setGlobalZOrder(constCar.globalZOrder.level_pos5-1);
    parent.addChild(diaozhua.lineDown,-1);
    diaozhua.lineDown.setPosition(cp.v.add(cp.v(747,508),diaozhua.deltaPos));


    diaozhua.up1 = function(){
        diaozhua.diaozhuaLine.runAction(cc.scaleBy(3, 1, 0.5));
        diaozhua.diaozhuaDown.runAction(cc.sequence(
            cc.spawn(cc.moveBy(3, 0,70),cc.callFunc(function(){parent.spriteController.getCar().chassisSpr.runAction(cc.moveBy(3, 0,70));})),
            cc.delayTime(0.5),
            cc.callFunc(function(){
                diaozhua.diaozhuaUp.runAction(
                    cc.sequence(
                        cc.spawn(
                            cc.spawn(
                                cc.sequence(
                                    cc.callFunc(function(){
                                        // diaozhua.audioID = playUFOEffect();
                                    }),
                                    cc.moveBy(3,diaozhua.horizontalDist,0),
                                    cc.callFunc(function(){
                                        // stopTheAudio(diaozhua.audioID);
                                    })
                                ),
                                cc.callFunc(function(){parent.spriteController.getCar().chassisSpr.runAction(cc.moveBy(3,diaozhua.horizontalDist,0));})),
                            cc.callFunc(function(){
                                diaozhua.leftCicle.runAction(cc.repeatForever(cc.rotateBy(2,360,360)));
                                diaozhua.rightCicle.runAction(cc.repeatForever(cc.rotateBy(2,360,360)));
                            })),
                        cc.callFunc(function(){
                            diaozhua.drop2();
                    })));
            })
        ));
    };


    diaozhua.drop2 = function(){
        diaozhua.diaozhuaLine.runAction(cc.scaleBy(3, 1, 1.4));
        diaozhua.diaozhuaDown.runAction(cc.sequence(
            cc.spawn(cc.moveBy(3,0,-70+30),cc.callFunc(function(){parent.spriteController.getCar().chassisSpr.runAction(cc.moveBy(3,0,-70+30));})),
            cc.delayTime(0.5),
            cc.callFunc(function(){
                parent.spriteController.getCar().readdAllJointsShapeBody(cp.v(diaozhua.horizontalDist,30));
                parent.spriteController._shieldController.shieldTheLayer(false);

                var prop = {
                    group:0x0001,
                    width:10,
                    layers:3
                };
                parent.physicsController.addALineNew(cp.v.add(cp.v(-180 + 900,-500),position),cp.v.add(position,cp.v(-180 + 900,-50)),prop);
            }),
            cc.callFunc(function(){
                diaozhua.left.runAction(cc.rotateBy(1,30,30));
                diaozhua.right.runAction(cc.sequence(cc.rotateBy(1,-30,-30),cc.callFunc(function(){
                    diaozhua.up2();
                })));
            })
        ));
    };

    diaozhua.up2 = function(){
        diaozhua.diaozhuaLine.runAction(cc.scaleBy(2, 1, 0.1));
        diaozhua.diaozhuaDown.runAction(cc.sequence(
            cc.moveBy(3, 0,90),
            cc.delayTime(0.02),
            cc.callFunc(function(){
                mylog("over");
                stopTheAudio(diaozhua.audioID);
                diaozhua.leftCicle.stopAllActions();
                diaozhua.rightCicle.stopAllActions();
            })
        ));
    };

    diaozhua.run = function(){
        diaozhua.diaozhuaUp.runAction(cc.sequence(
            cc.callFunc(function(){
                parent.spriteController.getCar().removeAllJointsShapeBody();
                parent.spriteController._shieldController.shieldTheLayer(true);
            }),
            cc.delayTime(0.1),
            cc.callFunc(function(){
                diaozhua.audioID = playUFOEffect();
                diaozhua.diaozhuaLine.runAction(cc.scaleBy(3, 1, 8));
                diaozhua.diaozhuaDown.runAction(cc.sequence(
                    cc.moveBy(3, 0,-90),
                    cc.delayTime(0.5),
                    cc.callFunc(function(){
                        diaozhua.left.runAction(cc.rotateBy(1,-30,-30));
                        diaozhua.right.runAction(cc.sequence(cc.rotateBy(1,30,30),cc.callFunc(function(){
                            diaozhua.up1();
                        })));
                    })
                ));
            })
        ));
    };

    diaozhua._backFunc = function(){
        diaozhua.run();
    };
    diaozhua.groundLine =  collisionline_new(
        parent._space,
        cp.v.add(cp.v(3839,550),parent.backDelta),
        cp.v.add(cp.v(3939,570),parent.backDelta),
        function(backshape){

        },
        getNewCollType(),
        0.4);

    diaozhua.leftCollisionLine = collisionline_new(
        parent._space,
        cp.v.add(cp.v(3839 + 35,550),parent.backDelta),
        cp.v.add(cp.v(3839 + 35,550 + 30),parent.backDelta),
        function(backshape){
        diaozhua._backFunc(backshape);
        },
        getNewCollType(),
        0.4);


    return diaozhua;
}





var c1_guanqia_ufo_3 = function(parent,position){
    var retufo = {};

    retufo.deltaPos = cp.v.add(position,cp.v(-300,-350));
    retufo.fireDuration = 15;

    var ufo = new cc.Sprite("res/car_c/scene1/feixingqi");
    retufo.ufo = ufo;
    parent.addChild(ufo);
    ufo.setPosition(cp.v.add(cp.v(300,400),retufo.deltaPos));

    retufo.startFire = function(){
        var bothAnim = animationCreate2(1,5,"res/common/huoyan/huoyan-huang","",0.05,100,false);
        bothAnim.retain();

        var huoyan1 = new cc.Sprite("res/common/huoyan/huoyan-huang1");
        huoyan1.setPosition(cp.v(15,-47+29+34-33));
        huoyan1.setGlobalZOrder(constCar.globalZOrder.level_pos5);
        ufo.addChild(huoyan1, 10);

        var huoyan2 = new cc.Sprite("res/common/huoyan/huoyan-huang1");
        huoyan2.setPosition(cp.v(224,-30+44-33));
        huoyan2.setGlobalZOrder(constCar.globalZOrder.level_pos5);
        ufo.addChild(huoyan2, 10);

        var huoyan3 = new cc.Sprite("res/common/huoyan/huoyan-huang1");
        huoyan3.setPosition(cp.v(122,-30+27-33));
        huoyan3.setGlobalZOrder(constCar.globalZOrder.level_pos5);
        ufo.addChild(huoyan3, 10);

        huoyan1.runAction(bothAnim.clone());
        huoyan2.runAction(bothAnim.clone());
        huoyan3.runAction(bothAnim.clone());
    };
    // ufo.bothAnimation = cc.bezierBy(3,[cp.v(130,-300),cp.v(130,-300),cp.v(222,-1130)]);
    ufo.ufomoveXY = cp.v(0,-1130);
    ufo.ufomoveTime = 3;
    ufo.bothAnimation = cc.sequence(
        cc.callFunc(function(){
            ufo.audioID = playUFOEffect();
        }),
        cc.moveBy(ufo.ufomoveTime,ufo.ufomoveXY.x,ufo.ufomoveXY.y),
        cc.callFunc(function(){
            stopTheAudio(ufo.audioID);
        })
    );
    ufo.bothAnimation.retain();


    var prop = {
        group:0x0001,
        width:10,
        layers:3
    };
    parent.physicsController.addALineNew(cp.v.add(cp.v(-220,-100),cp.v.add(position,ufo.ufomoveXY)),cp.v.add(cp.v.add(position,ufo.ufomoveXY),cp.v(-220,400)),prop);

    lifter.groundLineUp = collisionline_new3(
        parent,
        cp.v.add(position,cp.v(-100,90)),
        cp.v.add(position,cp.v(100,90))
    );
    // retufo.groundLineUp = parent.physicsController.addALine(cp.v.add(position,cp.v(-100,90)),cp.v.add(position,cp.v(100,90)));
    retufo.groundLineUpCollision = collisionline_new(
        parent._space,
        cp.v.add(cp.v(100-20,90),position),
        cp.v.add(cp.v(100-20,90+10),position),
        function(backshape){
            retufo.startFire();
            // parent.spriteController.autoDrive(1100,function(){mylog("aaa");},15);
            parent.spriteController._shieldController.shieldTheLayer(true);
            parent.spriteController.getCar().removeAllJointsShapeBody();
            parent._space.removeShape(backshape);

            var tempnode = new cc.Node();
            parent.addChild(tempnode);
            tempnode.runAction(
                cc.sequence(
                    cc.callFunc(function(){
                        parent.cameraController.changeStateToAutoMoveCamera(cp.v(0,-2));
                    }),
                    cc.delayTime(1),
                    cc.callFunc(function(){
                        parent.cameraController.fromAutoMoveStateToNormal();
                    }),
                    cc.delayTime(0.5),
                    cc.callFunc(function() {
                        parent.spriteController.getCar().chassisSpr.runAction(
                            cc.sequence(
                                cc.spawn(
                                    cc.sequence(ufo.bothAnimation,
                                        cc.callFunc(function(){
                                            retufo.ufo.runAction(
                                                cc.sequence(
                                                    cc.delayTime(2),
                                                    cc.callFunc(function(){
                                                        parent.spriteController._shieldController.shieldTheLayer(true);
                                                        parent.cameraController.changeStateToAutoMoveCamera(cp.v(0,2));
                                                    }),
                                                    cc.delayTime(1),
                                                    cc.callFunc(function(){
                                                        parent.cameraController.fromAutoMoveStateToNormal();
                                                    }),
                                                    cc.delayTime(0.2),
                                                    cc.callFunc(function(){
                                                        parent.spriteController.getCar().readdAllJointsShapeBody(ufo.ufomoveXY);
                                                        parent.spriteController._shieldController.shieldTheLayer(false);
                                                    }),
                                                    cc.callFunc(function(){
                                                        ufo.audioID = playUFOEffect();
                                                    }),
                                                    cc.moveBy(1,0,750),
                                                    cc.delayTime(0.2),
                                                    cc.callFunc(function(){
                                                        stopTheAudio(ufo.audioID);
                                                    }),
                                                    cc.removeSelf(true)
                                                )
                                            );
                                        })
                                    ),
                                    cc.callFunc(function(){
                                        ufo.runAction(ufo.bothAnimation.clone());
                                    })
                                )
                            )
                        );
                    })
                ));
        },
        getNewCollType(),
        0.4);

    return retufo;
};


var a1_guanqia_ufo_5 = function(parent,position){
    var retufo = {};


    retufo.deltaPos = cp.v.add(cp.v(80,-10),position);
    retufo.fireDuration = 100;

    var ufo = new cc.Sprite("res/car_a/scene1/feixingqi");
    retufo.ufo = ufo;
    ufo.setGlobalZOrder(constCar.globalZOrder.level_pos5);
    parent.addChild(ufo);
    ufo.setPosition(cp.v.add(cp.v(0,0),retufo.deltaPos));

    mylog("Car leftLine group = " + parent.spriteController.getCar().leftCollisionLineShape.group + " , leftLine layers = " + parent.spriteController.getCar().leftCollisionLineShape.layers);

    retufo.startFire = function(){
        var bothAnim = animationCreate2(1,7,"res/common/huoyan/huoyan-lan","",0.05,100,false);
        bothAnim.retain();

        var huoyan1 = new cc.Sprite("res/common/huoyan/huoyan-lan1");
        huoyan1.setPosition(cp.v(36-20,-27));
        huoyan1.setGlobalZOrder(constCar.globalZOrder.level_pos5);
        ufo.addChild(huoyan1, 10);
        var huoyan11 = new cc.Sprite("res/common/huoyan/huoyan-lan1");
        huoyan11.setPosition(cp.v(36+20,-27));
        huoyan11.setGlobalZOrder(constCar.globalZOrder.level_pos5);
        ufo.addChild(huoyan11, 10);

        var huoyan2 = new cc.Sprite("res/common/huoyan/huoyan-lan1");
        huoyan2.setPosition(cp.v(232-20,-27));
        huoyan2.setGlobalZOrder(constCar.globalZOrder.level_pos5);
        ufo.addChild(huoyan2, 10);
        var huoyan22 = new cc.Sprite("res/common/huoyan/huoyan-lan1");
        huoyan22.setPosition(cp.v(232+20,-27));
        huoyan22.setGlobalZOrder(constCar.globalZOrder.level_pos5);
        ufo.addChild(huoyan22, 10);


        huoyan1.runAction(bothAnim.clone());
        huoyan2.runAction(bothAnim.clone());
        huoyan11.runAction(bothAnim.clone());
        huoyan22.runAction(bothAnim.clone());


        huoyan1.setGlobalZOrder(constCar.globalZOrder.level_pos5 + 1);
        huoyan2.setGlobalZOrder(constCar.globalZOrder.level_pos5 + 1);
        huoyan11.setGlobalZOrder(constCar.globalZOrder.level_pos5 + 1);
        huoyan22.setGlobalZOrder(constCar.globalZOrder.level_pos5 + 1);
    };

    retufo.moveXY = cp.v(0,-1267);
    ufo.moveTime = 7;//7
    retufo.bothAction = cc.sequence(
        cc.delayTime(0.3),
        cc.callFunc(function(){

        }),
        cc.moveBy(ufo.moveTime,retufo.moveXY.x,retufo.moveXY.y),
        cc.callFunc(function(){

        })
    );
    retufo.bothAction.retain();


    retufo.groundLine = collisionline_new3(
        parent,
        cp.v.add(retufo.deltaPos,cp.v(-130,40)),
        cp.v.add(retufo.deltaPos,cp.v(130,40))
    );

    retufo._backFunc = function(backshape){
        parent.spriteController._shieldController.shieldTheLayer(true);
        parent._space.removeShape(backshape);
        var tempnode = new cc.Node();
        parent.addChild(tempnode);
        parent.spriteController.getCar().removeAllJointsShapeBody();
        tempnode.runAction(
            cc.sequence(
                cc.callFunc(function(){
                    parent.cameraController.changeStateToAutoMoveCamera(cp.v(0,-2));
                }),
                cc.delayTime(1),

                cc.callFunc(function(){
                    parent.cameraController.fromAutoMoveStateToNormal(cp.v(0,0));
                }),
                cc.callFunc(function(){
                    if(typeof(parent.spriteController) != "undefined") {
                        ufo.runAction(cc.sequence(retufo.bothAction,cc.delayTime(2.2),cc.callFunc(function(){ retufo.audioID1 = playUFOEffect(0.6);}),cc.moveBy(3,0,800),cc.callFunc(function(){ stopTheAudio(retufo.audioID1);}),cc.removeSelf(true)));
                        parent.spriteController.getCar().chassisSpr.runAction(cc.sequence(
                            cc.callFunc(function(){
                                parent.spriteController.getCar().isVisibleLeftRightSpr(true);
                                retufo.audioID = playUFOEffect();
                            }),
                            retufo.bothAction.clone(),
                            cc.callFunc(function(){
                                stopTheAudio(retufo.audioID);

                                var tmpnode = new cc.Node();
                                parent.addChild(tmpnode);
                                tmpnode.runAction(cc.sequence(
                                    cc.callFunc(function(){
                                        var prop = {
                                            group:0x0001,
                                            width:10,
                                            layers:3
                                        };
                                        parent.physicsController.addALineNew(cp.v.add(cp.v(-80,-100),cp.v.add(position,retufo.moveXY)),cp.v.add(cp.v.add(position,retufo.moveXY),cp.v(-80,300)),prop);

                                        var prop = {
                                            group:0x0001,
                                            width:9,
                                            layers:3
                                        };
                                        retufo.leftLine = parent.physicsController.addALineNew(cp.v.add(cp.v(180,-100),cp.v.add(position,retufo.moveXY)),cp.v.add(cp.v.add(position,retufo.moveXY),cp.v(180,300)),prop);
                                    }),
                                    cc.delayTime(1),
                                    cc.callFunc(function(){
                                        parent.cameraController.changeStateToAutoMoveCamera(cp.v(0,2));
                                    }),
                                    cc.delayTime(1),

                                    cc.callFunc(function(){
                                        mylog("state to normal");
                                        parent._space.removeShape(retufo.leftLine);
                                        parent.cameraController.fromAutoMoveStateToNormal(cp.v(0,0));
                                    }),
                                    cc.delayTime(0.2),
                                    cc.callFunc(function(){
                                        parent.spriteController._shieldController.shieldTheLayer(false);

                                        parent.spriteController.getCar().readdAllJointsShapeBody(retufo.moveXY);
                                        parent.spriteController.changeState(constState.stateNoNe);
                                        parent.spriteController.getCar().isVisibleLeftRightSpr(false);
                                    })
                                ));
                            })
                        ));
                    }
                })
            ));
    };
    retufo.leftCollisionLine = collisionline_new(
        parent._space,
        cp.v.add(retufo.deltaPos,cp.v(90,40)),
        cp.v.add(retufo.deltaPos,cp.v(90,70)),
        function(backshape){
            retufo.startFire();
            retufo._backFunc(backshape);
        },
        getNewCollType(),
        0.4);

    return retufo;
};


var c1_guanqia_ufo_a = function(parent,position){
    var retufo = {};//cp.v(10292,-1331)
    retufo.adjustY = -15;
    retufo.deltaPos = cp.v.add(cp.v(-200,-400 + retufo.adjustY),position);
    retufo.moveDistX = 740;
    retufo.moveX = 580;

    retufo.bothAction = cc.moveBy(3,retufo.moveX,0);
    // retufo.bothAction = cc.sequence(cc.callFunc(function(){
    //     retufo.audioID = playUFOEffect();
    // }),cc.moveBy(3,retufo.moveX,0),cc.callFunc(function(){
    //     stopTheAudio(retufo.audioID);
    // }));
    retufo.bothAction.retain();

    retufo.bothActionToLeft = cc.moveBy(3,-retufo.moveX,0);
    // retufo.bothActionToLeft = cc.sequence(cc.callFunc(function(){
    //     retufo.audioID = playUFOEffect();
    // }),cc.moveBy(3,-retufo.moveX,0),cc.callFunc(function(){
    //     stopTheAudio(retufo.audioID);
    // }));
    retufo.bothActionToLeft.retain();

    var ufopos = cp.v.add(cp.v(300,400),retufo.deltaPos);//ufopos = cp.v(10392,-1331);


    var spr = new cc.Sprite("res/common/add/quan");
    spr.setPosition(cp.v.add(cp.v(-131.5,17.5),ufopos));
    spr.setGlobalZOrder(constCar.globalZOrder.level_pos100);
    parent.addChild(spr);

    var spr1 = new cc.Sprite("res/common/add/quan");
    spr1.setPosition(cp.v.add(cp.v(-131.5+844,17.5),ufopos));
    spr1.setGlobalZOrder(constCar.globalZOrder.level_pos100);
    parent.addChild(spr1);

    // retufo.groundLineUp = parent.physicsController.addALine(cp.v(ufopos.x,100000),cp.v(ufopos.x,-100100));
    var point1 = cp.v(ufopos.x-110,ufopos.y+30 + retufo.adjustY + 13);
    var point2 = cp.v(ufopos.x+110,ufopos.y+30 + retufo.adjustY + 13);
    // retufo.groundLineUpLeft = parent.physicsController.addALine(point1,point2);
    // retufo.groundLine = parent.physicsController.addALine(cp.v(ufopos.x-110,ufopos.y+30 + 5 + retufo.adjustY),cp.v(ufopos.x+110 + retufo.moveDistX - 126,ufopos.y+30 + 5 + retufo.adjustY));
    // retufo.groundLineUpRight = parent.physicsController.addALine(cp.v(ufopos.x-110 + retufo.moveDistX - 126,ufopos.y+30 + retufo.adjustY + 13),cp.v(ufopos.x+110 + retufo.moveDistX - 126,ufopos.y+30 + retufo.adjustY + 13));

    retufo.groundLineUpLeft = collisionline_new3(
        parent,
        point1,
        point2);

    retufo.groundLine = collisionline_new3(
        parent,
        cp.v(ufopos.x-110,ufopos.y+30 + 5 + retufo.adjustY),
        cp.v(ufopos.x+110 + retufo.moveDistX - 126,ufopos.y+30 + 5 + retufo.adjustY)
    );

    retufo.groundLineUpRight = collisionline_new3(
        parent,
        cp.v(ufopos.x-110 + retufo.moveDistX - 126-30,ufopos.y+30 + retufo.adjustY + 13),
        cp.v(ufopos.x+110 + retufo.moveDistX - 126-30,ufopos.y+30 + retufo.adjustY + 13)
    );


    retufo._backFuncToLeft = function(backshape){
        parent._space.removeShape(backshape);
        var tempnode = new cc.Node();
        parent.addChild(tempnode);
        parent.spriteController.getCar().removeAllJointsShapeBody();
        tempnode.runAction(
            cc.sequence(
                cc.callFunc(function(){
                    if(typeof(parent.spriteController) != "undefined") {
                        parent.spriteController._shieldController.shieldTheLayer(true);
                        ufo.runAction(retufo.bothActionToLeft);
                        parent.spriteController.getCar().chassisSpr.runAction(cc.sequence(
                            cc.callFunc(function(){
                                retufo.audioID = playUFOEffect();
                            }),
                            retufo.bothActionToLeft.clone(),
                            cc.callFunc(function(){
                                stopTheAudio(retufo.audioID);
                            }),
                            cc.callFunc(function(){
                                parent.spriteController.getCar().readdAllJointsShapeBody(cp.v(-retufo.moveX,0));
                                parent.spriteController._shieldController.shieldTheLayer(false);


                                retufo.leftCollisionLine = collisionline_new(
                                    parent._space,
                                    cp.v.add(point2,cp.v(-10,0)),
                                    cp.v.add(point2,cp.v(-10,10)),
                                    function(backshape){
                                        retufo._backFunc(backshape);
                                    },
                                    getNewCollType(), 0.4);
                            })
                        ));
                    }
                })
            ));
    };

    retufo._backFunc = function(backshape){
        parent._space.removeShape(backshape);
        var tempnode = new cc.Node();
        parent.addChild(tempnode);
        parent.spriteController.getCar().removeAllJointsShapeBody();
        tempnode.runAction(
            cc.sequence(
                cc.callFunc(function(){
                    if(typeof(parent.spriteController) != "undefined") {
                        parent.spriteController._shieldController.shieldTheLayer(true);
                        ufo.runAction(retufo.bothAction);
                        parent.spriteController.getCar().chassisSpr.runAction(cc.sequence(
                            cc.callFunc(function(){
                                retufo.audioID = playUFOEffect();
                            }),
                            retufo.bothAction.clone(),
                            cc.callFunc(function(){
                                stopTheAudio(retufo.audioID);
                            }),
                            cc.callFunc(function(){
                                parent.spriteController.getCar().readdAllJointsShapeBody(cp.v(retufo.moveX,0));
                                parent.spriteController._shieldController.shieldTheLayer(false);


                                retufo.leftCollisionLine = collisionline_new(
                                    parent._space,
                                    cp.v.add(point2,cp.v(-10 + 390,0)),
                                    cp.v.add(point2,cp.v(-10 + 390,10)),
                                    function(backshape){
                                        retufo._backFuncToLeft(backshape);
                                    },
                                    getNewCollType(), 0.4);
                            })
                        ));
                    }
                })
            ));
    };
    retufo.leftCollisionLine = collisionline_new(
        parent._space,
        cp.v.add(point2,cp.v(-10,0)),
        cp.v.add(point2,cp.v(-10,10)),
        function(backshape){
            retufo._backFunc(backshape);
        },
        getNewCollType(), 0.4);

    var ufo = new cc.Sprite("res/car_c/scene1/yunshuji");
    parent.addChild(ufo);
    ufo.setPosition(ufopos);


    return retufo;
};




