var ParentCheckLayer = cc.Layer.extend({
    _closeCB:null,
    _rightCB:null,
    
    randA:null,
    randB:null,
    result:null,
    input:null,
    
    label_expression:null,
    label_result:null,
    
    arry_menu_item:null,
    
    success:null,
     
    ctor:function (closeCB, rightCB) {
        this._super();

        var size = cc.winSize;

        this.setAnchorPoint(cc.p(0.5, 0.5));
                                       
        this._closeCB = closeCB;
        this._rightCB = rightCB;
        
//        this.randA = Math.floor(Math.random() * 10);
//        this.randB = Math.floor(Math.random() * 10);              
        
        this.randA = Math.floor(this.getRand0ToN(4)+5);
        this.randB = Math.floor(this.getRand0ToN(4)+5);
        
        this.result = "" + (this.randA * this.randB);   
        this.resetDigitalState();
        this.resetResult();
        this.input = "";
        this.success = false;
        
        this.createComponents();


        return true;
    },
    getRand0ToN:function(n){
    	return Math.floor(Math.random()*(1+n));
    },
    resetDigitalState:function(){
    	this.checkUnits = false;
    	this.checkTens = true;
    },
    resetResult:function(){
    	if("" === this.result.substring(1,2)){
    		this.result = "0" + this.result;
    		this.checkUnits = true;
    		this.checkTens = false;
    	}
    },
    createComponents:function(){
        var size = cc.winSize;
        var background = new cc.LayerColor(cc.color(0, 0, 0, 150), size.width, size.height);
        this.addChild(background);
                                       
        var back_2 = new cc.Sprite("res/feedback/back2");
        back_2.x = size.width / 2 + 100;
        back_2.y = size.height / 2 + 55;
        this.addChild(back_2);
		
        this.label_expression = new cc.LabelTTF(this.randA + " x " + this.randB + " = ", "Arial", 40);
		this.label_expression.setColor(cc.color(135, 48, 3, 255));
		this.label_expression.textAlign = cc.TEXT_ALIGNMENT_RIGHT;
		this.label_expression.x = Config_check.back_size.width / 2 - 40;
		this.label_expression.y = Config_check.back_size.height - 70;
		
		back_2.addChild(this.label_expression, 2);
		
		var layer_result_back = new cc.LayerColor(cc.color(255, 255, 255, 255), 70, 42);
		layer_result_back.x = Config_check.back_size.width / 2 + 40;
		layer_result_back.y = Config_check.back_size.height - 88;
		back_2.addChild(layer_result_back, 3);
		
		this.label_result = new cc.LabelTTF(this.input, "Arial", 40);
		this.label_result.setColor(cc.color(135, 48, 3, 255));
		this.label_result.textAlign = cc.TEXT_ALIGNMENT_LEFT;
		this.label_result.x = Config_check.back_size.width / 2 + 70;
		this.label_result.y = Config_check.back_size.height - 70;

		back_2.addChild(this.label_result, 4);
		
		this.arry_menu_item = [];
		var self = this;
		
		var closeItem = new cc.MenuItemImage(
				"res/feedback/close",
				"res/feedback/close_high",
				function () {
					this._closeCB();
				}.bind(this), this);
		closeItem.attr({
			x: size.width - 240,
			y: size.height - 120,
			anchorX: 0.5,
			anchorY: 0.5,
			scale:1
		}); 
		this.arry_menu_item[0] = closeItem;
		
		var number_w_begin = size.width / 2 - 50;
		var number_h_begin = size.height / 2 + 50;
		
		var num_1 = new cc.MenuItemImage(             
				"res/feedback/1",
				"res/feedback/1",
				function () {
					this.checkInput("1");
				}.bind(this), this);
		num_1.attr({
			x: number_w_begin,
			y: number_h_begin,
			anchorX: 0.5,
			anchorY: 0.5,
			scale:1
		}); 
		this.arry_menu_item[1] = num_1;
		
		var num_2 = new cc.MenuItemImage(
				"res/feedback/2",
				"res/feedback/2",
				function () {
					this.checkInput("2");
				}.bind(this), this);
		num_2.attr({
			x: number_w_begin + Config_check.num_gap_w,
			y: number_h_begin,
			anchorX: 0.5,
			anchorY: 0.5,
			scale:1
		}); 
		this.arry_menu_item[2] = num_2;
		
		var num_3 = new cc.MenuItemImage(
				"res/feedback/3",
				"res/feedback/3",
				function () {
					this.checkInput("3");
				}.bind(this), this);
		num_3.attr({
			x: number_w_begin + Config_check.num_gap_w * 2,
			y: number_h_begin,
			anchorX: 0.5,
			anchorY: 0.5,
			scale:1
		}); 
		this.arry_menu_item[3] = num_3;
		
		var num_4 = new cc.MenuItemImage(
				"res/feedback/4",
				"res/feedback/4",
				function () {
					this.checkInput("4");
				}.bind(this), this);
		num_4.attr({
			x: number_w_begin + Config_check.num_gap_w * 3,
			y: number_h_begin,
			anchorX: 0.5,
			anchorY: 0.5,
			scale:1
		}); 
		this.arry_menu_item[4] = num_4;
		
		var num_5 = new cc.MenuItemImage(
				"res/feedback/5",
				"res/feedback/5",
				function () {
					this.checkInput("5");
				}.bind(this), this);
		num_5.attr({
			x: number_w_begin + Config_check.num_gap_w * 4,
			y: number_h_begin,
			anchorX: 0.5,
			anchorY: 0.5,
			scale:1
		}); 
		this.arry_menu_item[5] = num_5;
		
		var num_6 = new cc.MenuItemImage(
				"res/feedback/6",
				"res/feedback/6",
				function () {
					this.checkInput("6");
				}.bind(this), this);
		num_6.attr({
			x: number_w_begin + Config_check.num_gap_w * 0,
			y: number_h_begin - Config_check.num_gap_w,
			anchorX: 0.5,
			anchorY: 0.5,
			scale:1
		}); 
		this.arry_menu_item[6] = num_6;
		
		var num_7 = new cc.MenuItemImage(
				"res/feedback/7",
				"res/feedback/7",
				function () {
					this.checkInput("7");
				}.bind(this), this);
		num_7.attr({
			x: number_w_begin + Config_check.num_gap_w * 1,
			y: number_h_begin - Config_check.num_gap_w,
			anchorX: 0.5,
			anchorY: 0.5,
			scale:1
		}); 
		this.arry_menu_item[7] = num_7;
		
		var num_8 = new cc.MenuItemImage(
				"res/feedback/8",
				"res/feedback/8",
				function () {
					this.checkInput("8");
				}.bind(this), this);
		num_8.attr({
			x: number_w_begin + Config_check.num_gap_w * 2,
			y: number_h_begin - Config_check.num_gap_w,
			anchorX: 0.5,
			anchorY: 0.5,
			scale:1
		}); 
		this.arry_menu_item[8] = num_8;
		
		var num_9 = new cc.MenuItemImage(
				"res/feedback/9",
				"res/feedback/9",
				function () {
					this.checkInput("9");
				}.bind(this), this);
		num_9.attr({
			x: number_w_begin + Config_check.num_gap_w * 3,
			y: number_h_begin - Config_check.num_gap_w,
			anchorX: 0.5,
			anchorY: 0.5,
			scale:1
		}); 
		this.arry_menu_item[9] = num_9;
		
		var num_0 = new cc.MenuItemImage(
				"res/feedback/0",
				"res/feedback/0",
				function () {
					this.checkInput("0");
				}.bind(this), this);
		num_0.attr({
			x: number_w_begin + Config_check.num_gap_w * 4,
			y: number_h_begin - Config_check.num_gap_w,
			anchorX: 0.5,
			anchorY: 0.5,
			scale:1
		}); 
		this.arry_menu_item[10] = num_0;
		

		var menu = new cc.Menu(this.arry_menu_item);
		menu.x = 0;
		menu.y = 0;
		this.addChild(menu, 1);
    },
    checkOver:function(){
    	this.success = true;
    	this.scheduleOnce(function() {
    		mylog("current answer is right!");
    		this._rightCB();
    	}.bind(this), 1);
    },
    checkInput:function(input){
    	if (this.success) {
    		return;
    	} 
    	
    	if("0" != this.result.substring(0, 1)){
    		if(this.checkTens && !this.checkUnits){
    			if(this.result.substring(0,1) == input){
    				this.checkTens = false;
    				this.checkUnits = true;
    				this.label_result.setString(this.result.substring(0,1));
    			}
    		}else if(!this.checkTens && this.checkUnits){
    			if(this.result.substring(1,2) == input){
    				this.checkTens = true;
    				this.checkUnits = false;
    				this.label_result.setString(this.result.substring(0,2));
    				this.checkOver();
    			}
    		}
    	}else{
    		if(this.checkUnits && !this.checkTens){
    			if(this.result.substring(1,2) == input){
    				this.checkTens = false;
    				this.checkUnits = false;
    				this.label_result.setString(this.result.substring(1,2));
    				this.checkOver();
    			}
    		}
    	}
    }                             
});

var ParentCheckScene = cc.Scene.extend({
	ctor:function(){
		this._super();
		
		var layer = new ParentCheckLayer();                              
		this.addChild(layer);
	},
});
