function createRope(parent,space,standPointLeft,standPointRight,totalJoint,twoDist,twoLeftRight){
    var size=cc.winSize;
    var RADIUS = 0.01;
    var totalJoint = totalJoint ? totalJoint : 6;
    var twoDist = twoDist ? twoDist : 20;
    var twoLeftRight = twoLeftRight ? twoLeftRight : 20;
    var space = space;

    this.List=[];  //建立一个容器，用来储存咱们的10个刚体
    for(var i=0;i<totalJoint;i++){
        var body=new cp.Body(1,cp.momentForCircle(10,0,RADIUS,cp.v(0,0)));  //圆形刚体
        body.setPos(cc.p(size.width/2-i*10,size.height*0.9-i*50));    //为了能让绳子摆动，坐标稍微偏移一点
        space.addBody(body); //将刚体添加到空间里

        var shape=new cp.CircleShape(body,RADIUS,cp.v(0,0));  //圆型形状
        shape.setElasticity(0.0);
        shape.setFriction(1.5);
        space.addShape(shape);   //将形状添加到空间里

//        var sprite=new cc.PhysicsSprite("res/1");  //创建精灵
//        sprite.setBody(body);              //绑定刚体
//        sprite.setPosition(cc.p(size.width/2-i*10,size.height*0.9-i*50));
//        this.addChild(sprite);           //添加精灵到场景

        this.List.push(body);             //将刚体压入容器

    }

    for(var i=1;i<this.List.length;i++){     //注意我们从第二个刚体开始循环
        var body1=this.List[i-1];             //前一个刚体
        var body2=this.List[i];              //当前刚体
        var joint_j=new cp.SlideJoint(body1,body2,cc.p(0,0),cc.p(0,0),30,twoDist);   //将当前刚体和前一个刚体相连
        space.addConstraint(joint_j);   //将节点添加到空间
    }

    //静态刚体，作为绳子的顶端1
    var body_left=new cp.StaticBody(1,cp.momentForCircle(1,0,RADIUS,cp.v(0,0)));  //注意，这是一个静态刚体
    body_left.setPos(standPointLeft);

    var shape_left=new cp.CircleShape(body_left,RADIUS,cp.v(0,0));
    shape_left.setElasticity(0.0);
    shape_left.setFriction(1.5);
    space.addStaticShape(shape_left);

    var joint_up=new cp.SlideJoint(body_left,this.List[0],cc.p(0,0),cc.p(0,0),30,twoLeftRight);
    space.addConstraint(joint_up);

    //静态刚体，作为绳子的顶端2
    var body_right=new cp.StaticBody(1,cp.momentForCircle(1,0,RADIUS,cp.v(0,0)));  //注意，这是一个静态刚体
    body_right.setPos(standPointRight);

    var shape_right=new cp.CircleShape(body_right,RADIUS,cp.v(0,0));
    shape_right.setElasticity(0.0);
    shape_right.setFriction(1.5);
    space.addStaticShape(shape_right);

    var joint_up=new cp.SlideJoint(body_right,this.List[totalJoint - 1],cc.p(0,0),cc.p(0,0),30,twoLeftRight);
    space.addConstraint(joint_up);

    return [];
}
