var CarBControlLayer_b1 = cc.LayerColor.extend({
    ctor:function(color,width,height,parent){
        this._super(color,width,height);
        this.shouldUpdate = true;
        this.touchState = constState.stateNoNe;
        this.canUpdate = true;
        this.par = parent;
        this.volumeCount = 0;

        this.currentSpeed = 0;
        this.maxSpeed = 5;
        this.constMaxSpeed = 5;//only set once
        this.frameAccelerate = 0.1;
        this.touchBeginPos = cp.v(0,0);

        this.autoDriveSpeed = 0;
        this.autoDriveDist = 0;
        this.autoDriveCB = function(){};

        this.leftControl  = new cc.LayerColor(cc.color(255,255,0,0),width/2,height);
        this.addChild(this.leftControl);

        this.rightControl = new cc.LayerColor(cc.color(0,0,255,0),width/2,height);
        this.rightControl.setPosition(cp.v(width/2,0));
        this.addChild(this.rightControl);

        this.onTouchBegan=function (touch, event) {
            var target = event.getCurrentTarget();
            var locationInNode_ = touch.getLocationInView();
            var locationInNode  = cc.p(locationInNode_.x,cc.winSize.height-locationInNode_.y);
            var s = target.getContentSize();
            var rect = cc.rect(0, 0, s.width, s.height);
            if(this.touchState == constState.stateAutoDrive){
                return false;
            }
            if (cc.rectContainsPoint(rect, locationInNode)) {
                this.touchBeginPos = locationInNode;
                if(locationInNode.x <= cc.winSize.width/2){
                    this.touchState = constState.stateLeftBegin;
                    // mylog("begin --- left");
                }else{
                    this.touchState = constState.stateRightBegin;
                    // mylog("begin --- right");
                }
                return true;
            }
            return false;
        }.bind(this);
        this.onTouchMoved=function (touch, event) {
            if(this.touchState != constState.stateAutoDrive) {
                if(this.touchState == constState.stateNoNe){
                    return;
                }else if(this.touchState == constState.stateLeftBegin){
                    this.touchState = constState.stateLeftMoved;
                }else if(this.touchState == constState.stateRightBegin){
                    this.touchState = constState.stateRightMoved;
                }

                var locationInNode_ = touch.getLocationInView();
                var locationInNode = cc.p(locationInNode_.x, cc.winSize.height - locationInNode_.y);

                var deltaX = locationInNode.x - this.touchBeginPos.x;
                if(Math.abs(deltaX) < constCar.adjustmentControl){
                    return;
                }else{
                    var cstCtl = parseInt(constCar.adjustmentControl);

                    if(deltaX < (-1)*cstCtl){
                        this.touchState = constState.stateLeftMoved;
                    }else if(deltaX > (1)*cstCtl){
                        this.touchState = constState.stateRightMoved;
                    }else{
                        if(this.touchState == constState.stateLeftBegin){
                            this.touchState = constState.stateLeftMoved;
                        }else if(this.touchState == constState.stateLeftBegin){
                            this.touchState = constState.stateRightMoved;
                        }
                    }
                }
            }
        }.bind(this);
        this.onTouchEnded=function (touch, event) {
            if(this.touchState != constState.stateAutoDrive) {
                this.touchState = constState.stateNoNe;
            }
            this.touchBeginPos = cp.v(0,0);
            // mylog("end --- nottouch");
        }.bind(this);

        registerTouchEventOneByOne(this , true);

        this.scheduleUpdate();
    },
    changeState:function(state){
        this.touchState = state;
        mylog("constState.stateAutoDrive --- " + constState.stateAutoDrive);
        mylog("this.touchstate --- " + state);
    },
    changeStateToAutoDrive:function(){
        this.autoDriveStartPosX = this.getCar().chassisSpr.getPositionX();
        this.changeState(constState.stateAutoDrive);
    },
    regainStateFromAutoDrive:function(){
        this.changeState(constState.stateNoNe);
    },
    setAutoDriveCB:function(cb){
        this.autoDriveCB = cb;
    },
    setAutoDriveDist:function(dist){
        this.autoDriveDist = dist;
    },
    setAutoDriveSpeed:function(speed){
        this.autoDriveSpeed = speed;
    },
    getAutoDriveSpeed:function(){
        return this.autoDriveSpeed;
    },
    autoDrive:function(distX,cb,speed){
        mylog("autoDrive..b1");
        this.changeStateToAutoDrive();
        this.setAutoDriveCB(cb);
        this.setAutoDriveDist(distX);
        this.setMaxSpeed(speed);
        this.setAutoDriveSpeed(speed);
    },

    setConstMaxSpeed:function(constMaxSpeed){
        this.constMaxSpeed = constMaxSpeed;
    },
    resetMaxSpeed:function(){
        this.maxSpeed = this.constMaxSpeed;
    },
    setShouldUpdate:function(shouldUpdate){
        this.shouldUpdate = shouldUpdate;
    },

    getCurrentSpeed:function(){
        return this.currentSpeed;
    },
    getMaxSpeed:function(){
        return this.maxSpeed;
    },
    getFrameAccelerate:function(){
        return this.frameAccelerate;
    },
    setMaxSpeed:function(maxSpeed){
        this.maxSpeed = maxSpeed;
    },
    setFrameAccelerate:function(frameAccelerate){
        this.frameAccelerate = frameAccelerate;
    },
    update:function(dt){
        if(this.shouldUpdate){
            this.volumeCount ++;
            // mylog("updating --- " + this.touchState);
            if(this.touchState == constState.stateAutoDrive){
                mylog("autodrive current spped is " + this.autoDriveSpeed);
                // this.getCar().changeSpeed(this.currentSpeed);
                var dist = this.getCar().chassisSpr.getPositionX() - this.autoDriveStartPosX;
                mylog("autoDriveDist --- " + this.autoDriveDist);
                mylog("real autoDriveDist --- " + dist);
                if(this.autoDriveDist < dist){
                    mylog("auto drive is over");
                    this.touchState = constState.stateNoNe;
                    this.autoDriveCB();
                    this.resetMaxSpeed();
                    this.autoDriveSpeed = 0;
                    this.autoDriveStartPosX = 0;
                    this.autoDriveDist = 0;
                }

                if(Math.abs(this.autoDriveSpeed) < this.frameAccelerate){
                    this.autoDriveSpeed = 0;
                }
                if(this.autoDriveSpeed >= this.maxSpeed){
                    this.autoDriveSpeed = this.maxSpeed;
                }
                if(this.autoDriveSpeed <= -this.maxSpeed){
                    this.autoDriveSpeed = -this.maxSpeed;
                }
                this.getCar().changeSpeed(this.autoDriveSpeed);
                if(this.volumeCount == constCar.volumeCount) {
                    this.volumeCount = 0;
                    this.getCar().audioManager.carAudioRunningCtl.setVolume(mapval(Math.abs(this.autoDriveSpeed), 0, Math.abs(this.maxSpeed), constCar.volume.minVolume, constCar.volume.maxVolume));
                }
                // this.getCar().track.clockwiseRun(3);
                this.getCar().track.clockwiseRun(this.autoDriveSpeed * 0.6);
            }else{
                mylog("current spped is " + this.currentSpeed);
                if(this.canUpdate){
                    if(this.touchState == constState.stateLeftBegin || this.touchState == constState.stateLeftMoved){
                        this.currentSpeed -= this.frameAccelerate;
                    }else if(this.touchState == constState.stateRightBegin || this.touchState == constState.stateRightMoved){
                        this.currentSpeed += this.frameAccelerate;
                    }else if(this.touchState == constState.stateNoNe) {
                        this.currentSpeed *= (1.0 - this.frameAccelerate * 0.12);
                    }
                }
                if(Math.abs(this.currentSpeed) < this.frameAccelerate){
                    this.currentSpeed = 0;
                }
                if(this.currentSpeed >= this.maxSpeed){
                    this.currentSpeed = this.maxSpeed;
                }
                if(this.currentSpeed <= -this.maxSpeed){
                    this.currentSpeed = -this.maxSpeed;
                }
                this.getCar().changeSpeed(this.currentSpeed);
                if(this.volumeCount == constCar.volumeCount) {
                    this.volumeCount = 0;
                    this.getCar().audioManager.carAudioRunningCtl.setVolume(mapval(Math.abs(this.currentSpeed), 0, Math.abs(this.maxSpeed), constCar.volume.minVolume, constCar.volume.maxVolume));
                }
                if(!this.par.spriteController.getCar().premissionUpdateController)
                    this.getCar().track.clockwiseRun(this.currentSpeed * 0.6);
            }
        }
    },
    getCar:function(){
        return this.par.spriteController.getCar();
    },
});
