var CarAControlLayer_loop = cc.LayerColor.extend({
    ctor:function(color,width,height,parent){
        this._super(color,width,height);
        this.touchState = constState.stateNoNe;
        this.canUpdate = true;
        this.par = parent;
        this.volumeCount = 0;

        this.currentSpeed = 0;
        this.maxSpeed = 5.0;
        this.constMaxSpeed = 5.0;//only set once
        this.frameAccelerate = 0.1;

        this.autoDriveSpeed = 0;
        this.autoDriveDist = 0;
        this.autoDriveCB = function(){};

        this.leftControl  = new cc.LayerColor(cc.color(255,255,0,0),width/2,height);
        this.addChild(this.leftControl);

        this.rightControl = new cc.LayerColor(cc.color(0,0,255,0),width/2,height);
        this.rightControl.setPosition(cp.v(width/2,0));
        this.addChild(this.rightControl);

        this.onTouchBegan=function (touch, event) {
            return false;
        }.bind(this);
        this.onTouchMoved=function (touch, event) {
        }.bind(this);
        this.onTouchEnded=function (touch, event) {
        }.bind(this);

        registerTouchEventOneByOne(this , true);

        this.scheduleOnce(function(){
            this.touchState = constState.stateRightMoved;
            this.scheduleUpdate();
        }.bind(this),1);
    },
    changeState:function(state){
        this.touchState = state;
        mylog("constState.stateAutoDrive --- " + constState.stateAutoDrive);
        mylog("this.touchstate --- " + state);
    },
    changeStateToAutoDrive:function(){
        this.autoDriveStartPosX = this.getCar().chassisSpr.getPositionX();
        this.changeState(constState.stateAutoDrive);
    },
    regainStateFromAutoDrive:function(){
        this.changeState(constState.stateNoNe);
    },
    setAutoDriveCB:function(cb){
        this.autoDriveCB = cb;
    },
    setAutoDriveDist:function(dist){
        this.autoDriveDist = dist;
    },
    setAutoDriveSpeed:function(speed){
        this.autoDriveSpeed = speed;
    },
    getAutoDriveSpeed:function(){
        return this.autoDriveSpeed;
    },
    autoDrive:function(distX,cb,speed){
        mylog("autoDrive..");
        this.changeStateToAutoDrive();
        this.setAutoDriveCB(cb);
        this.setAutoDriveDist(distX);
        this.setMaxSpeed(speed);
        this.setAutoDriveSpeed(speed);
    },

    setConstMaxSpeed:function(constMaxSpeed){
        this.constMaxSpeed = constMaxSpeed;
    },
    resetMaxSpeed:function(){
        this.maxSpeed = this.constMaxSpeed;
    },

    getCurrentSpeed:function(){
        return this.currentSpeed;
    },
    getMaxSpeed:function(){
        return this.maxSpeed;
    },
    getFrameAccelerate:function(){
        return this.frameAccelerate;
    },
    setMaxSpeed:function(maxSpeed){
        this.maxSpeed = maxSpeed;
    },
    setFrameAccelerate:function(frameAccelerate){
        this.frameAccelerate = frameAccelerate;
    },
    update1:function(dt){
        this.getCar().changeSpeed(this.currentSpeed);
        // this.getCar().puff.resetCount(mapval(Math.abs(this.currentSpeed),0,Math.abs(this.maxSpeed),constCar.puff.minPuffCount,constCar.puff.maxPuffCount));
        if(this.volumeCount == constCar.volumeCount) {
            this.volumeCount = 0;
            this.getCar().audioManager.carAudioRunningCtl.setVolume(mapval(Math.abs(this.currentSpeed), 0, Math.abs(this.maxSpeed), constCar.volume.minVolume, constCar.volume.maxVolume));
        }
    },
    update:function(dt){
        // mylog("updating --- " + this.touchState);
        this.volumeCount ++;
        if(this.touchState == constState.stateAutoDrive){
            // mylog("current spped is " + this.autoDriveSpeed);
            // this.getCar().changeSpeed(this.currentSpeed);
            var dist = this.getCar().chassisSpr.getPositionX() - this.autoDriveStartPosX;
            mylog("autoDriveDist --- " + this.autoDriveDist);
            mylog("real autoDriveDist --- " + dist);
            if(this.autoDriveDist < dist){
                mylog("auto drive is over");
                this.touchState = constState.stateNoNe;
                this.autoDriveCB();
                this.resetMaxSpeed();
                this.autoDriveSpeed = 0;
                this.autoDriveStartPosX = 0;
                this.autoDriveDist = 0;
            }

            if(Math.abs(this.autoDriveSpeed) < this.frameAccelerate){
                this.autoDriveSpeed = 0;
            }
            if(this.autoDriveSpeed >= this.maxSpeed){
                this.autoDriveSpeed = this.maxSpeed;
            }
            if(this.autoDriveSpeed <= -this.maxSpeed){
                this.autoDriveSpeed = -this.maxSpeed;
            }
            this.getCar().changeSpeed(this.autoDriveSpeed);
            // this.getCar().puff.resetCount(mapval(Math.abs(this.autoDriveSpeed),0,Math.abs(this.maxSpeed),constCar.puff.minPuffCount,constCar.puff.maxPuffCount));//修改噴氣粒子多少//這種方法有問題
            if(this.volumeCount == constCar.volumeCount) {
                this.volumeCount = 0;
                this.getCar().audioManager.carAudioRunningCtl.setVolume(mapval(Math.abs(this.autoDriveSpeed), 0, Math.abs(this.maxSpeed), constCar.volume.minVolume, constCar.volume.maxVolume));
            }
        }else{
            if(this.canUpdate){
                if(this.touchState == constState.stateLeftBegin || this.touchState == constState.stateLeftMoved){
                    this.currentSpeed -= this.frameAccelerate;
                }else if(this.touchState == constState.stateRightBegin || this.touchState == constState.stateRightMoved){
                    this.currentSpeed += this.frameAccelerate;
                }else if(this.touchState == constState.stateNoNe) {
                    this.currentSpeed *= (1.0 - this.frameAccelerate * 0.12);
                }
            }
            if(Math.abs(this.currentSpeed) < this.frameAccelerate){
                this.currentSpeed = 0;
            }
            if(this.currentSpeed >= this.maxSpeed){
                this.currentSpeed = this.maxSpeed;
            }
            if(this.currentSpeed <= -this.maxSpeed){
                this.currentSpeed = -this.maxSpeed;
            }
            this.getCar().changeSpeed(this.currentSpeed);
            // this.getCar().puff.resetCount(mapval(Math.abs(this.currentSpeed),0,Math.abs(this.maxSpeed),constCar.puff.minPuffCount,constCar.puff.maxPuffCount));
            if(this.volumeCount == constCar.volumeCount) {
                this.volumeCount = 0;
                this.getCar().audioManager.carAudioRunningCtl.setVolume(mapval(Math.abs(this.currentSpeed), 0, Math.abs(this.maxSpeed), constCar.volume.minVolume, constCar.volume.maxVolume));
            }
        }
    },
    getCar:function(){
        return this.par.spriteController.getCar();
    },
});
