var PhysicsControllerB3 = Controller.extend({
    ctor:function(parent){
        this._super(parent);
        mylog("Physics controller ctor");
    },
    //override
    init:function(){
        mylog("Physics controller init");
        this.constGravity = cp.v(0, -300);
        this.metaData = this.par.metaData;
        this.initPhysics();
        this.isShowDebug(constCar.debug.physics);
        this.loadRoad();
    },
    initPhysics:function(){
        this._space = new cp.Space();
        //设置迭代次数
        this._space.setIterations(10);
        //设置重力
        this._space.gravity = this.constGravity;
        //设置睡眠时间阈
        this._space.sleepTimeThreshold = (0.5);

        this._canUpdatePhysics = true;
    },
    canUpdatePhysics:function(isUpdate){
        this._canUpdatePhysics = isUpdate;
    },
    changeGravity:function(newgravity){
        this._space.gravity = newgravity;
    },
    regainGravity:function(){
        this._space.gravity = this.constGravity;
    },
    getSpace:function(){
        return this._space;
    },
    isShowDebug:function(isShow) {
        this.par._debugNode = new cc.PhysicsDebugNode(this._space);
        this.par._debugNode.visible = isShow;
        this.par.addChild(this.par._debugNode,1000);
    },
    getStaticBody:function(){
        return this._space.staticBody;
    },
    loadRoad:function(){
        this._redressRoadData();

        var canPrintRoad = true;
        for(var i = 1;i <= this.roadData.length - 1;i += 2){
            if(this.roadData[i]){
                if(canPrintRoad) {
                    canPrintRoad = false;
                    mylog("first roaddate : " + this.roadData[i].x + "," + this.roadData[i].y);
                }
                if(Math.abs(this.roadData[i - 1].x - this.roadData[i].x) > 20 || Math.abs(this.roadData[i - 1].y - this.roadData[i].y) > 20){
                    i ++;
                }else{
                    // DrawController.getInstance().drawSegment(this.roadData[i - 1],this.roadData[i]);
                    this._drawRoadSegment(this.roadData[i - 1],this.roadData[i]);
                }
            }
        }

        this._resetRoadData();
    },
    _resetRoadData:function(){
        this.roadData = getRoadDataByName(GlobalCurrentLayerName);
        for(var i = 0;i <= this.roadData.length - 1;i += 1){
            this.roadData[i].x -= this.metaData.road.deltaX;
            this.roadData[i].y -= this.metaData.road.deltaY;
        }
    },
    _redressRoadData:function(){
        this.roadData = getRoadDataByName(GlobalCurrentLayerName);
        for(var i = 0;i <= this.roadData.length - 1;i += 1){
            this.roadData[i].x += this.metaData.road.deltaX;
            this.roadData[i].y += this.metaData.road.deltaY;
        }
    },
    _drawRoadSegment:function(point1,point2){
        var shape = this._space.addShape(new cp.SegmentShape(this._space.staticBody,point1,point2,0));
        shape.group = this.metaData.road.group;
        shape.setFriction(this.metaData.road.friction);
        shape.setElasticity(this.metaData.road.elastic);
    },
    addALine:function(point1,point2){
        var staticBody = this._space.staticBody;
        var shape = this._space.addShape(new cp.SegmentShape(staticBody, point1,point2, 1.0));
        shape.setElasticity(0.0);
        shape.setFriction(1.0);
        return shape;
    },
    addALineNew:function(point1,point2,prop){
        var group = prop.group;
        var layers = prop.layers;

        var staticBody = this._space.staticBody;
        var shape = this._space.addShape(new cp.SegmentShape(staticBody, point1,point2, prop.width));
        shape.setElasticity(0.0);
        shape.setFriction(1.0);

        shape.group = group;
        shape.layers = layers;

        return shape;
    },
    addTestGround:function(){
        this.addALine(cp.v(-100,50), cp.v(cc.winSize.width + 100,50));
    },
    startUpdatePhysics:function(){
        this.par.scheduleUpdate();
    },
});
