var GCarA1Layer = null;

var CarA1Layer = cc.Layer.extend({
	ctor:function () {
		this._super();
		this.initLayer();
		this.addBackground();
		this.addCheckpoints();
		this.startGame();
		return true;   
	},
	initLayer:function(){
		if(isPad()){
			this.adjustArgument = 106;
		}else{
			this.adjustArgument = 0;
		}
		this.initGlobal("A1");
		// this.initDrawController();
		this.initPhysicsController();
		this.addLeftGroundLine();
		this.initCameraController();
		// this.initCollisionController();
		// this.initEventController();
		this.initSpriteController();
		this.initUpdateController();
		// this.initLimit();
	},
	autoDrive:function(){
		this.spriteController.autoDrive(550,function(){
			this.spriteController._shieldController.shieldTheLayer(false);
			this.initLimit();

			var spr = ToolTipSpr(this);
			// this.cameraController.pushFollowCameraSprites([spr]);
		}.bind(this),4);
	},
	addLeftGroundLine:function(){
		// var posx = 400 + constCar.carLeftLine.c3;
		var posx = 30;
		var posy = 93+this.adjustArgument;
		var groundLine = collisionline_new3(
			this,
			cp.v.add(cp.v(posx,posy),cp.v(-1200,0)),
			cp.v.add(cp.v(posx,posy),cp.v(0,0))
		);
	},
	startGame:function(){
		this.physicsController.startUpdatePhysics();
		if(constCar.debug.debugStart) {
			this.spriteController._shieldController.shieldTheLayer(true);
			this.scheduleOnce(function () {
				this.nodeContainer1.destroyTheContainer();
				this.autoDrive();
			}, 1);
		}else{
			this.nodeContainer1.destroyTheContainer();
		}
	},
	initLimit:function(){
		var prop1 = {
			group:0x0001,
			width:10,
			layers:3
		};

		this.physicsController.addALineNew(cp.v.add(cp.v(-30,-100+this.adjustArgument),this.backDelta),cp.v.add(cp.v(-30,400+this.adjustArgument),this.backDelta),prop1);

		var prop2 = {
			group:0x0001,
			width:10,
			layers:3
		};

		this.physicsController.addALineNew(cp.v.add(cp.v(-30 + 16400,-100 - 1258+this.adjustArgument),this.backDelta),cp.v.add(cp.v(-30 + 16400,400 - 1258+this.adjustArgument),this.backDelta),prop1);
	},
	initGlobal:function(currentgame){
		GlobalCurrentLayerName = currentgame;
		GCarA1Layer = this;
		this.totalDelY = -80 + this.adjustArgument;
		this.backDelta = cp.v(0,0+this.totalDelY);
		this.foregroundData = [];
		this.metaData = {
			road:{
				deltaX:16,
				deltaY:-1694-194+this.totalDelY,
				group:0x1111,
				friction:0.8,
				elastic:0.0
			}
		};
	},
	initDrawController:function(){

		this.drawController = DrawController.getInstance();
		this.draw = this.drawController.getDraw();
	},
	initPhysicsController:function(){
		this.physicsController = PhysicsController.getInstance();
		this._space = this.physicsController.getSpace();
	},
	initCameraController:function(){
		this.cameraController = CameraController.getInstance();
		// mylog("camera start position = "+this.cameraController._camera.getPosition().x + "," + this.cameraController._camera.getPosition().y);
		this.initLabelAtlas();
	},
	initLabelAtlas:function(){
		this.label = LabelAtlas(this);
		this.cameraController.pushFollowCameraSprites([this.label]);
	},
	initCollisionController:function(){
		this.collisionController = CollisionController.getInstance();
	},
	initEventController:function(){
		this.eventController = EventController.getInstance();
	},
	initSpriteController:function(){
		this.spriteController = SpriteController.getInstance();
		this.spriteController.setMaxSpeed(5.6);//7
		this.spriteController.setConstMaxSpeed(5.6);//7
		this.cameraController.setCameraFollowSprite(this.spriteController.getCar().chassisSpr);
	},
	initUpdateController:function(){
		this.updateController = UpdateController.getInstance();
	},
	addCheckpoints:function(){
		this.addChickpoint_1();
		this.addChickpoint_2();
		this.addChickpoint_3();
		this.addChickpoint_4();
		this.addChickpoint_5();
		this.addChickpoint_6();
		this.addChickpoint_7();
		this.addChickpoint_8();
		this.addChickpoint_9();
		this.addChickpoint_a();
		this.addChickpoint_b();
		this.addChickpoint_c();
		this.addChickpoint_d();
		this.addChickpoint_over();
	},
	addChickpoint_over:function(){
		var overPos = cp.v.add(cp.v(15501,-995+20),this.backDelta);

		var self = this;
		var leftCollisionLine = collisionline_new(
			self._space,
			cp.v.add(overPos,cp.v(0,-150)),
			cp.v.add(overPos,cp.v(0,150)),
			function(backshape){
				self._space.removeShape(backshape);
				self.spriteController._shieldController.shieldTheLayer(true);

				var listProp = {
					pos:cp.v.add(overPos,cp.v(0,600)),
					parent:self,
					paths:["res/common/hong.plist","res/common/huang.plist","res/common/lv.plist","res/common/lan.plist"],
					globalzorder:constCar.globalZOrder.level_pos5,
					duration:8,
					zorder:1
				};
				// ddPlayEffect("effect","res/common/audio/ye.mp3",false);
				var particlelist = ParticleList(listProp);

				var node = new cc.Node();
				self.addChild(node);

				node.runAction(
					cc.sequence(
						cc.callFunc(
							function(){
								// self.spriteController._shieldController.shieldTheLayer(true);
							}
						),
						cc.delayTime(constCar.overTime),
						cc.callFunc(
							function(){
								// mylog("next scene!!!");
								self.cleanTheLayer();
								cc.director.runScene(new GLLoadingScene("a2"));
								// cc.director.runScene(new CarA2Scene());
							}
						)
					)
				);
			},
			getNewCollType(),
			0.4);
	},
	addChickpoint_1:function(){
		var dropstone = a1_guanqia_upstone_lan_1(this._space,this,cp.v.add(cp.v(2490,515),this.backDelta));
	},
	addChickpoint_2:function(){
		a1_guanqia_stone_2(this._space,this,cp.v.add(cp.v(3579,205),this.backDelta));
	},
	addChickpoint_3:function(){
		var deltaX = 4440+this.backDelta.x;
		var deltaY = -182+this.backDelta.y;

		this.shuteng = new cc.Sprite("res/car_a/scene1/dumuqiao/shutengshang");
		this.addChild(this.shuteng);
		this.shuteng.setPosition(212 + deltaX,924 + deltaY);

		this.mutouqiao = new Mutouqiao("res/car_a/scene1/dumuqiao/dumuqiao",this._space,90 + deltaX,360 + deltaY,this);
		this.mutouqiao.setGlobalZOrder(constCar.globalZOrder.level_pos100);
		this.mutouqiao.setAnchorPoint(cp.v(0.89,0));
		this.mutouqiao.setPosition(500 + deltaX,300 + deltaY);
		this.mutouqiao.setRotation(9);
		this.addChild(this.mutouqiao,2);
	},
	addChickpoint_4:function(){
		var tbPos = cp.v.add(cp.v(5680,290),this.backDelta);
		var carStopToTargetX = tbPos.x - 330;
		var tb = createTreasureBox(this,tbPos,carStopToTargetX);
	},
	addChickpoint_5:function(){
		a1_guanqia_ufo_5(this,cp.v.add(cp.v(6805,138),this.backDelta));
	},
	addChickpoint_6:function(){
		var tbPos = cp.v.add(cp.v(7632,-1040),this.backDelta);//
		var carStopToTargetX = tbPos.x - 300;
		var tb = createTreasureBox(this,tbPos,carStopToTargetX);
	},
	addChickpoint_7:function(){
		var machine = a1_guanqia_makeCrushMachine_7(this,cp.v.add(cp.v(8810,-1330),this.backDelta));
	},
	addChickpoint_8:function(){
		var tbPos = cp.v.add(cp.v(10226,-976),this.backDelta);
		var carStopToTargetX = tbPos.x - 300;
		var tb = createTreasureBox(this,tbPos,carStopToTargetX);
	},
	addChickpoint_9:function(){
		a1_guanqia_luzhang_9(this._space,this,cp.v.add(cp.v(10887,-1032-70),this.backDelta));
	},
	addChickpoint_a:function(){
		a1_guanqia_makeHangStone_a(this._space,this,cp.v.add(cp.v(12720,-647-70-20),this.backDelta));
	},
	addChickpoint_b:function(){
		this.stoneList = a1_guanqia_makeStoneList_b(this._space,this,cp.v.add(cp.v(13982,-1020),this.backDelta));
	},
	addChickpoint_c:function(){
		var balloon = a1_guanqia_qiqiu_8(this,cp.v.add(cp.v(14921,-995+20),this.backDelta));
	},
	addChickpoint_d:function(){
		var posx = 870+0+this.backDelta.x;
		var posy = 220-50+this.backDelta.y;

		var groundLine = collisionline_new3(
			this,
			cp.v.add(cp.v(posx,posy),cp.v(485,-1)),
			cp.v.add(cp.v(posx,posy),cp.v(465,-1))
		);
		a1_guanqia_chainBridge_d(this,this._space,cc.p(posx,posy), cc.p(posx+455,posy));
	},
	addBackground:function(){
		this.nodeContainer = createNodeContainer(this);
		this.nodeContainer.setPosition(0,0);
		this.nodeContainer.setGlobalZOrder(constCar.globalZOrder.level_neg5);
		this.nodeContainer.setAnchorPoint(cc.p(0,0));

		this.backDelta1 = cp.v(0,-250+this.totalDelY);

		for(var i = 0;i < constCar.backNum.a1;i ++){
			var back = createStaticNode_Only("res/car_a/scene1/background/map"+i+"_0",cc.p(0,0));
			this.nodeContainer.pushOneSprite(back);
			if(0 == i) {
				back.setPosition(cp.v.add(cp.v(0, back.getPosition().y - 1622), this.backDelta1));
			}else{
				back.setPositionY(back.getPositionY() - 1622 + this.backDelta1.y);
			}
		}

		this.nodeContainer1 = createNodeContainer(this);
		this.nodeContainer1.setPosition(0,0-2);
		this.nodeContainer1.setGlobalZOrder(constCar.globalZOrder.level_pos100);
		this.nodeContainer1.setAnchorPoint(cc.p(0,0));
		for(var i = 0;i < constCar.backNum.a1;i ++){
			var back = createStaticNode_Only("res/car_a/scene1/background/map"+i+"_01",cc.p(0,0));
			this.nodeContainer1.pushOneSprite(back);
			back.setPosition(cp.v.add(cp.v(0, back.getPosition().y - 1622), this.backDelta1));
			back.setGlobalZOrder(constCar.globalZOrder.level_pos100);
		}
	},
	update:function(dt){
		this.updateController.updateSelf(dt);//must put the updatecontroller before the physicscontroller
		if(this.physicsController._canUpdatePhysics && true) {
			this.physicsController.getSpace().step(0.02);
		}
		this.cameraController.updateCameraPos();
	},
	cleanTheLayer:function(){
		setAllControllerToNull();
	}
});

var CarA1Scene = cc.Scene.extend({
	onEnter:function () {
		this._super();

		cc.textureCache.removeAllTextures();
		cc.spriteFrameCache.removeSpriteFrames();
		ddStopAllAudios();

		var spr = addBackMenuFollowCamera(this,function(){
			ddStopAllAudios();
			this.cleanTheLayer();
			cc.director.runScene(new HomeSceneLoop());
		}.bind(this));

		backKeyListenerAdd(this,function(){
			ddStopAllAudios();
			this.cleanTheLayer();
			cc.director.runScene(new HomeSceneLoop());
		}.bind(this));

		this.layer = new CarA1Layer();
		this.layer.menuSprite = spr;
		this.layer.cameraController.pushFollowCameraSprites([spr]);
		cc.log("放进去。。。。。。。。。。。。。。");
		this.addChild(this.layer);
		// this.layer.startGame();
	},
	cleanTheLayer:function(){
		this.layer.cleanTheLayer();
	}
});
