var GCarA2Layer = null;
var CarA2Layer = cc.Layer.extend({
	ctor:function () {
		this._super();
		this.initLayer();
		this.addBackground();
		this.addCheckpoints();
		this.test();
		this.startGame();
		return true;   
	},
	initLayer:function(){
		if(isPad()){
			this.adjustArgument = 106;
		}else{
			this.adjustArgument = 0;
		}
		this.initGlobal("A2");
		// this.initDrawController();
		this.initPhysicsController();
		this.addLeftGroundLine();
		this.initCameraController();
		// this.initCollisionController();
		// this.initEventController();
		this.initSpriteController();
		this.initUpdateController();
		// this.initLimit();
	},
	autoDrive:function(){
		this.spriteController.autoDrive(550,function(){
			this.spriteController._shieldController.shieldTheLayer(false);
			this.initLimit();

			ToolTipSpr(this);
		}.bind(this),4);
	},
	addLeftGroundLine:function(){
		// var posx = 400 + constCar.carLeftLine.c3;
		var posx = 30;
		var posy = 133 + this.adjustArgument;
		var groundLine = collisionline_new3(
			this,
			cp.v.add(cp.v(posx,posy),cp.v(-1200,0)),
			cp.v.add(cp.v(posx,posy),cp.v(0,0))
		);
	},
	startGame:function(){
		this.physicsController.startUpdatePhysics();
		if(constCar.debug.debugStart) {
			this.spriteController._shieldController.shieldTheLayer(true);
			this.scheduleOnce(function () {
				this.nodeContainer1.destroyTheContainer();
				this.autoDrive();
			}, 1);
		}else{
			this.nodeContainer1.destroyTheContainer();
		}
	},
	initLimit:function(){
		var prop1 = {
			group:0x0001,
			width:10,
			layers:3
		};

		this.physicsController.addALineNew(cp.v.add(cp.v(-30,400),this.backDelta),cp.v.add(cp.v(-30,800),this.backDelta),prop1);

		var prop2 = {
			group:0x0001,
			width:10,
			layers:3
		};

		this.physicsController.addALineNew(cp.v.add(cp.v(30 + 11300,400 + 430),this.backDelta),cp.v.add(cp.v(30 + 11300,800 + 430),this.backDelta),prop2);
	},
	initGlobal:function(currentgame){
		GlobalCurrentLayerName = currentgame;
		GCarA2Layer = this;
		this.backDelta = cp.v(0,-300+this.adjustArgument);
		this.metaData = {
				road:{
					deltaX:5,
					deltaY:-306+this.adjustArgument,
					group:0x1111,
					friction:0.85,
					elastic:0.0
				}
		};
	},
	initDrawController:function(){

		this.drawController = DrawController.getInstance();
		this.draw = this.drawController.getDraw();
	},
	initPhysicsController:function(){
		this.physicsController = PhysicsController.getInstance();
		this._space = this.physicsController.getSpace();
	},
	initCameraController:function(){
		this.cameraController = CameraController.getInstance();
		this.initLabelAtlas();
	},
	initLabelAtlas:function(){
		this.label = LabelAtlas(this);
		this.cameraController.pushFollowCameraSprites([this.label]);
	},
	initCollisionController:function(){
		this.collisionController = CollisionController.getInstance();
	},
	initEventController:function(){
		this.eventController = EventController.getInstance();
	},
	initSpriteController:function(){
		this.spriteController = SpriteController.getInstance();
		this.spriteController.setMaxSpeed(5.6);//7
		this.spriteController.setConstMaxSpeed(5.6);//7
		this.cameraController.setCameraFollowSprite(this.spriteController.getCar().chassisSpr);
	},
	initUpdateController:function(){
		this.updateController = UpdateController.getInstance();
	},
	test:function(){

	},
	addCheckpoints:function(){
		this.addChickpoint_1();
		this.addChickpoint_2();
		this.addChickpoint_3();
		this.addChickpoint_4();
		this.addChickpoint_5();
		this.addChickpoint_6();
		this.addChickpoint_7();
		this.addChickpoint_over();
	},
	addChickpoint_over:function(){
		var overPos = cp.v.add(cp.v(8888+1600,956),this.backDelta);

		var self = this;
		var leftCollisionLine = collisionline_new(
			self._space,
			cp.v.add(overPos,cp.v(0,-150)),
			cp.v.add(overPos,cp.v(0,150)),
			function(backshape){
				self._space.removeShape(backshape);
				self.spriteController._shieldController.shieldTheLayer(true);

				var listProp = {
					pos:cp.v.add(overPos,cp.v(0,600)),
					parent:self,
					paths:["res/common/hong.plist","res/common/huang.plist","res/common/lv.plist","res/common/lan.plist"],
					globalzorder:constCar.globalZOrder.level_pos5,
					duration:8,
					zorder:1
				};
				var particlelist = ParticleList(listProp);

				var node = new cc.Node();
				self.addChild(node);

				node.runAction(
					cc.sequence(
						cc.callFunc(
							function(){
								// self.spriteController._shieldController.shieldTheLayer(true);
							}
						),
						cc.delayTime(constCar.overTime),
						cc.callFunc(
							function(){
								mylog("next scene!!!");
								self.cleanTheLayer();
								cc.director.runScene(new GLLoadingScene("a3"));
								// cc.director.runScene(new CarA3Scene());
							}
						)
					)
				);
			},
			getNewCollType(),
			0.4);
	},
	addChickpoint_1:function(){
		// this.cameraController.lookAtPoint(cp.v(1123,465));
		var deltaPos = cp.v.add(cp.v(954,421),this.backDelta);
		a2_guanqia_chainBridge_1(this,this._space,cp.v.add(cp.v(0,6),deltaPos), cp.v.add(cp.v(340,8),deltaPos));
	},
	addChickpoint_2:function(){
		// this.cameraController.lookAtPoint(cp.v.add(cp.v(2113,435),this.backDelta));
	},
	addChickpoint_3:function(){
		// this.cameraController.lookAtPoint(cp.v(2727,786));
		a2_guanqia_makeHangStone_3(this._space,this,cp.v.add(cp.v(2727,766),this.backDelta));
	},
	addChickpoint_4:function(){
		// this.cameraController.lookAtPoint(cp.v(3424,539));
		var deltaPos = cp.v.add(cp.v(3095,489),this.backDelta);
		makeRollerCoasterACar(this,deltaPos);
	},
	addChickpoint_5:function(){
		// this.cameraController.lookAtPoint(cp.v(7590,420));
		// this.stoneList = a2_guanqia_makeStoneList_5(this._space,this,cp.v.add(cp.v(7520,410),this.backDelta));
	},
	addChickpoint_6:function(){
		// this.cameraController.lookAtPoint(cp.v(8056,549));
		this._lifter = lifter2_a("res/car_a/scene2/shangsheng/1",this,450,cp.v.add(cp.v(7906,425),this.backDelta));
		// this.scheduleOnce(function(){
		// 	this._lifter.test();
		// },2);
	},
	addChickpoint_7:function(){
		// this.cameraController.lookAtPoint(cp.v(8888,956));
		var qiao = a2_guanqia_duanqiao_7(this,cp.v.add(cp.v(8888,956),this.backDelta));
		// qiao.startDrop();
	},
	addBackground:function(){
		this.nodeContainer = createNodeContainer(this);
		// this.nodeContainer.setPosition(-310,-264);
		this.nodeContainer.setPosition(0,0);
		this.nodeContainer.setGlobalZOrder(constCar.globalZOrder.level_neg5);
		this.nodeContainer.setAnchorPoint(cc.p(0,0));
		for(var i = 0;i < constCar.backNum.a2;i ++){
			var back = createStaticNode_Only("res/car_a/scene2/background/map"+i+"_0",cc.p(0,0));
			this.nodeContainer.pushOneSprite(back);
			if(0 == i) {
				back.setPosition(cp.v.add(this.backDelta,back.getPosition()));
			}else{
				back.setPositionY(back.getPositionY() + this.backDelta.y);
			}
		}

		this.nodeContainer1 = createNodeContainer(this);
		this.nodeContainer1.setPosition(0,0);
		this.nodeContainer1.setGlobalZOrder(constCar.globalZOrder.level_pos100);
		this.nodeContainer1.setAnchorPoint(cc.p(0,0));
		for(var i = 0;i < constCar.backNum.a2;i ++){
			var back = createStaticNode_Only("res/car_a/scene2/background/map"+i+"_01",cc.p(0,0));
			this.nodeContainer1.pushOneSprite(back);
			back.setGlobalZOrder(constCar.globalZOrder.level_pos100)
			back.setPosition(cp.v.add(this.backDelta,back.getPosition()));
		}
	},
	printCarChassisPos:function(){
		mylog("car chassis pos = " + this.spriteController.getCar().chassis.body.getPos().x + "," + this.spriteController.getCar().chassis.body.getPos().y);
	},
	update:function(dt){
		//		this.printCarChassisPos();
		this.updateController.updateSelf(dt);//must put the updatecontroller before the physicscontroller
		if(this.physicsController._canUpdatePhysics) {
		// if(false){
			this.physicsController.getSpace().step(0.02);
		}
		this.cameraController.updateCameraPos();
	},
	cleanTheLayer:function(){
		setAllControllerToNull();
	}
});

var CarA2Scene = cc.Scene.extend({
	onEnter:function () {
		this._super();

		cc.textureCache.removeAllTextures();
		cc.spriteFrameCache.removeSpriteFrames();
		ddStopAllAudios();
		// ddPlayEffect("music","res/game/audios/qitabg.mp3",true);
		var spr = addBackMenuFollowCamera(this,function(){
			ddStopAllAudios();
			this.cleanTheLayer();
			cc.director.runScene(new HomeSceneLoop());
		}.bind(this));
		backKeyListenerAdd(this,function(){
			ddStopAllAudios();
			this.cleanTheLayer();
			cc.director.runScene(new HomeSceneLoop());
		}.bind(this));

		this.layer = new CarA2Layer();
		this.layer.cameraController.pushFollowCameraSprites([spr]);
		this.addChild(this.layer);
		// this.layer.startGame();
	},
	cleanTheLayer:function(){
		this.layer.cleanTheLayer();
	}
});
