var GCarA3Layer = null;
var CarA3Layer = cc.Layer.extend({
    ctor:function () {
        this._super();
        this.initLayer();
        this.addBackground();
        this.addCheckpoints();
        this.startGame();
        return true;
    },
    initLayer:function(){
        if(isPad()){
            this.adjustArgument = 106;
        }else{
            this.adjustArgument = 0;
        }
        this.initGlobal("A3");
        // this.initDrawController();
        this.initPhysicsController();
        this.addLeftGroundLine();
        this.initCameraController();
        // this.initCollisionController();
        // this.initEventController();
        this.initSpriteController();
        this.initUpdateController();
        // this.initLimit();
    },
    autoDrive:function(){
        this.spriteController.autoDrive(550,function(){
            this.spriteController._shieldController.shieldTheLayer(false);
            this.initLimit();

            ToolTipSpr(this);
        }.bind(this),4);
    },
    addLeftGroundLine:function(){
        // var posx = 400 + constCar.carLeftLine.c3;
        var posx = 30;
        var posy = 85+this.adjustArgument;
        var groundLine = collisionline_new3(
            this,
            cp.v.add(cp.v(posx,posy),cp.v(-1200,0)),
            cp.v.add(cp.v(posx,posy),cp.v(0,0))
        );
    },
    startGame:function(){
        this.physicsController.startUpdatePhysics();
        if(constCar.debug.debugStart) {
            this.spriteController._shieldController.shieldTheLayer(true);
            this.scheduleOnce(function () {
                this.nodeContainer1.destroyTheContainer();
                this.autoDrive();
            }, 1);
        }else{
            this.nodeContainer1.destroyTheContainer();
        }
    },
    initLimit:function(){
        var prop1 = {
            group:0x0001,
            width:10,
            layers:3
        };

        this.physicsController.addALineNew(cp.v.add(cp.v(-30,-100),this.backDelta),cp.v.add(cp.v(-30,400),this.backDelta),prop1);

        var prop2 = {
            group:0x0001,
            width:10,
            layers:3
        };

        this.physicsController.addALineNew(cp.v.add(cp.v(-30 + 18400,-100 + 337),this.backDelta),cp.v.add(cp.v(-30 + 18400,400 + 337),this.backDelta),prop2);
    },
    initGlobal:function(currentgame){
        GlobalCurrentLayerName = currentgame;
        GCarA3Layer = this;
        this.backDelta = cp.v(0,0+this.adjustArgument);
        this.metaData = {
            road:{
                deltaX:-16,//-52
                deltaY:-98+this.adjustArgument,
                group:0x1111,
                friction:0.8,
                elastic:0.0
            }
        };
    },
    initDrawController:function(){
        this.drawController = DrawController.getInstance();
        this.draw = this.drawController.getDraw();
    },
    initPhysicsController:function(){
        this.physicsController = PhysicsController.getInstance();
        this._space = this.physicsController.getSpace();
    },
    initCameraController:function(){
        this.cameraController = CameraController.getInstance();
        this.initLabelAtlas();
    },
    initLabelAtlas:function(){
        this.label = LabelAtlas(this);
        this.cameraController.pushFollowCameraSprites([this.label]);
    },
    initCollisionController:function(){
        this.collisionController = CollisionController.getInstance();
    },
    initEventController:function(){
        this.eventController = EventController.getInstance();
    },
    initSpriteController:function(){
        this.spriteController = SpriteController.getInstance();
        this.spriteController.setMaxSpeed(5.6);//7
        this.spriteController.setConstMaxSpeed(5.6);//7
        this.cameraController.setCameraFollowSprite(this.spriteController.getCar().chassisSpr);
    },
    initUpdateController:function(){
        this.updateController = UpdateController.getInstance();
    },
    addCheckpoints:function(){
        this.addChickpoint_1();
        this.addChickpoint_2();
        this.addChickpoint_3();
        this.addChickpoint_4();
        this.addChickpoint_5();
        this.addChickpoint_6();
        this.addChickpoint_7();
        this.addChickpoint_8();
        this.addChickpoint_9();
        this.addChickpoint_a();
        this.addChickpoint_over();
    },
    addChickpoint_over:function(){
        var overPos = cc.p(17600,500+this.adjustArgument);

        var self = this;
        var leftCollisionLine = collisionline_new(
            self._space,
            cp.v.add(overPos,cp.v(0,-100)),
            cp.v.add(overPos,cp.v(0,-200)),
            function(backshape){
                self._space.removeShape(backshape);
                self.spriteController._shieldController.shieldTheLayer(true);

                var listProp = {
                    pos:cp.v.add(overPos,cp.v(0,600)),
                    parent:self,
                    paths:["res/common/hong.plist","res/common/huang.plist","res/common/lv.plist","res/common/lan.plist"],
                    globalzorder:constCar.globalZOrder.level_pos5,
                    duration:8,
                    zorder:1
                };
                var particlelist = ParticleList(listProp);

                var node = new cc.Node();
                self.addChild(node);

                node.runAction(
                    cc.sequence(
                        cc.callFunc(
                            function(){
                                // self.spriteController._shieldController.shieldTheLayer(true);
                            }
                        ),
                        cc.delayTime(constCar.overTime),
                        cc.callFunc(
                            function(){
                                mylog("next scene!!!");

                                self.cleanTheLayer();
                                cc.director.runScene(new HomeSceneLoop());
                            }
                        )
                    )
                );
            },
            getNewCollType(),
            0.4);
    },
    addChickpoint_1:function(){
        // var pos = cp.v(2665,140);
        var pos = cp.v.add(cp.v(4828,335),this.backDelta);
        var tb = createTreasureBox(this,pos,pos.x - 300);

        var yugu = new cc.Sprite("res/car_a/scene3/beike");
        yugu.setGlobalZOrder(constCar.globalZOrder.level_pos50);
        this.addChild(yugu);
        yugu.setPosition(cp.v.add(pos,cp.v(-2920,-270)));

        var qiao = new cc.Sprite("res/car_a/scene3/qiao");
        this.addChild(qiao);
        qiao.setPosition(cp.v.add(cp.v(4122,312),this.backDelta));
        qiao.setGlobalZOrder(constCar.globalZOrder.level_pos50);
    },
    addChickpoint_2:function(){
        // var pos = cp.v(5428,438);
        var pos = cp.v.add(cp.v(2605,360),this.backDelta);
        a3_guanqia_longzi_2(this,pos);
    },
    addChickpoint_3:function(){
        var pos = cp.v.add(cp.v(6566,-160),this.backDelta);
        a3_guanqia_skel_3(this,pos);
    },
    addChickpoint_4:function(){
        var tbPos = cp.v.add(cp.v(9998,337+7),this.backDelta);
        var carStopToTargetX = tbPos.x - 320;
        var tb = createTreasureBox(this,tbPos,carStopToTargetX);

        a3_guanqia_nangua_4(this,cp.v.add(tbPos,cp.v(-60,415)));
    },
    addChickpoint_5:function(){
        a3_guanqia_longzi_5(this,cp.v.add(cp.v(11084,784-50),this.backDelta));
    },
    addChickpoint_6:function(){
        var bridge = a3_guanqia_dropBridge_6(this,cp.v.add(cp.v(12120,300+167),this.backDelta));
    },
    addChickpoint_7:function(){
        a3_guanqia_longzi_7(this,cp.v.add(cp.v(13795,405),this.backDelta));
    },
    addChickpoint_8:function(){
        var tbPos = cp.v.add(cp.v(15000,100+212),this.backDelta);
        var carStopToTargetX = tbPos.x - 300;
        var tb = createTreasureBox(this,tbPos,carStopToTargetX);
    },
    addChickpoint_9:function(){
        a3_guanqia_longzi_9(this,cp.v.add(cp.v(15669,124+190+40),this.backDelta));
    },
    addChickpoint_a:function(){
        a3_guanqia_longzi_a(this,cp.v.add(cp.v(15990,124+245+0),this.backDelta));
    },
    addBackground:function(){
        this.nodeContainer = createNodeContainer(this);
        this.nodeContainer.setPosition(cp.v.add(cp.v(-5,-301),this.backDelta));//(0,-301)
        this.nodeContainer.setGlobalZOrder(-10);
        this.nodeContainer.setAnchorPoint(cc.p(0,0));

        for(var i = 0;i < constCar.backNum.a3;i ++){
            var back = createStaticNode_Only("res/car_a/scene3/background/map"+i+"_0",cc.p(0,0));
            this.nodeContainer.pushOneSprite(back);
            if(0 == i) {
                back.setPosition(cp.v.add(cp.v(0,212 - 200),back.getPosition()));
            }else{
                if(1 == i || 2 == i) {
                    back.setPositionY(back.getPositionY() + 212 - 200);
                }else{
                    back.setPositionY(back.getPositionY() + 212);
                }
            }
        }

        this.nodeContainer1 = createNodeContainer(this);
        this.nodeContainer1.setPosition(cp.v.add(cp.v(-5,-301),cp.v(0,0)));//(0,-301)
        this.nodeContainer1.setGlobalZOrder(constCar.globalZOrder.level_pos100);
        this.nodeContainer1.setAnchorPoint(cc.p(0,0));

        for(var i = 0;i < 1;i ++){
            var back = createStaticNode_Only("res/car_a/scene3/background/map"+i+"_01",cc.p(0,0));
            this.nodeContainer1.pushOneSprite(back);
            back.setGlobalZOrder(constCar.globalZOrder.level_pos100);
            back.setPosition(cp.v.add(cp.v(0,212+1.2),back.getPosition()));
        }



        var lu = new cc.Sprite("res/car_a/scene3/lu");
        lu.setPosition(cp.v.add(cp.v(5833+15, 76-78),this.backDelta));
        lu.setGlobalZOrder(constCar.globalZOrder.level_pos5+1);
        this.addChild(lu);
    },
    printCarChassisPos:function(){
        mylog("car chassis pos = " + this.spriteController.getCar().chassis.body.getPos().x + "," + this.spriteController.getCar().chassis.body.getPos().y);
    },
    update:function(dt) {
        this.updateController.updateSelf(dt);//must put the updatecontroller before the physicscontroller
        if(this.physicsController._canUpdatePhysics && true) {
            this.physicsController.getSpace().step(0.02);
        }
        this.cameraController.updateCameraPos();
    },
    cleanTheLayer:function(){
        setAllControllerToNull();
    }
});

var CarA3Scene = cc.Scene.extend({
    onEnter:function () {
        this._super();

        cc.textureCache.removeAllTextures();
        cc.spriteFrameCache.removeSpriteFrames();
        ddStopAllAudios();
        // ddPlayEffect("music","res/game/audios/qitabg.mp3",true);
        var spr = addBackMenuFollowCamera(this,function(){
            ddStopAllAudios();
            this.cleanTheLayer();
            cc.director.runScene(new HomeSceneLoop());
        }.bind(this));
        backKeyListenerAdd(this,function(){
            ddStopAllAudios();
            this.cleanTheLayer();
            cc.director.runScene(new HomeSceneLoop());
        }.bind(this));

        this.layer = new CarA3Layer();
        this.layer.cameraController.pushFollowCameraSprites([spr]);
        this.addChild(this.layer);
        // this.layer.startGame();
    },
    cleanTheLayer:function(){
        this.layer.cleanTheLayer();
    }
});
