var GCarB1Layer = null;

var CarB1Layer = cc.Layer.extend({
	ctor:function () {
		this._super();
		this.initLayer();
		this.addBackground();
		this.addCheckpoints();
		this.startGame();
		return true;
	},
	initLayer:function(){
		if(isPad()){
			this.adjustArgument = 106;
		}else{
			this.adjustArgument = 0;
		}
		this.initGlobal("B1");
		// this.initDrawController();
		this.initPhysicsController();
		this.addLeftGroundLine();
		this.initCameraController();
		// this.initCollisionController();
		// this.initEventController();
		this.initSpriteController();
		this.initUpdateController();
		// this.initLimit();
	},
	autoDrive:function(){
		this.spriteController.autoDrive(600,function(){
			this.spriteController._shieldController.shieldTheLayer(false);
			this.initLimit();

			ToolTipSpr(this);
		}.bind(this),4);
	},
	addLeftGroundLine:function(){
		// var posx = 400 + constCar.carLeftLine.c3;
		var posx = 30;
		var posy = 45;
		var groundLine = collisionline_new3(
			this,
			cp.v.add(cp.v(posx,posy),cp.v(-1200,0+this.changeY)),
			cp.v.add(cp.v(posx,posy),cp.v(0,0+this.changeY))
		);
	},
	startGame:function(){
		this.physicsController.startUpdatePhysics();
		if(constCar.debug.debugStart) {
			this.spriteController._shieldController.shieldTheLayer(true);
			this.scheduleOnce(function () {
				this.nodeContainer1.destroyTheContainer();
				this.autoDrive();
			}, 1);
		}else{
			this.nodeContainer1.destroyTheContainer();
		}
	},
	initLimit:function(){
		var prop1 = {
			group:0x0001,
			width:10,
			layers:3
		};

		this.physicsController.addALineNew(cp.v.add(cp.v(-30,-100),this.backDelta),cp.v.add(cp.v(-30,400),this.backDelta),prop1);

		var prop2 = {
			group:0x0001,
			width:10,
			layers:3
		};

		this.physicsController.addALineNew(cp.v.add(cp.v(-30 + 16325,-100 + 337),this.backDelta),cp.v.add(cp.v(-30 + 16325,400 + 337),this.backDelta),prop2);
	},
	initUpdateController:function(){
		this.updateController = UpdateController.getInstance();
	},
	initGlobal:function(currentgame){
		GlobalCurrentLayerName = currentgame;
		GCarB1Layer = this;
		this.changeY = 50+this.adjustArgument;
		this.deltaXY = cp.v(-5,-99 + this.changeY);
		this.backDelta = cp.v(0,0+this.changeY);
		this.foregroundData = [];
		this.metaData = {
			road:{
				deltaX:-5+this.deltaXY.x,
				deltaY:-250-160+this.deltaXY.y,
				group:0x1111,
				friction:0.9,
				elastic:0.0
			}
		};
	},
	initDrawController:function(){

		this.drawController = DrawController.getInstance();
		this.draw = this.drawController.getDraw();
	},
	initPhysicsController:function(){
		this.physicsController = PhysicsController.getInstance();
		this._space = this.physicsController.getSpace();
	},
	initCameraController:function(){
		this.cameraController = CameraController.getInstance();
		mylog("camera start position = "+this.cameraController._camera.getPosition().x + "," + this.cameraController._camera.getPosition().y);
		this.initLabelAtlas();
	},
	initLabelAtlas:function(){
		this.label = LabelAtlas(this);
		this.cameraController.pushFollowCameraSprites([this.label]);
	},
	initCollisionController:function(){
		this.collisionController = CollisionController.getInstance();
	},
	initEventController:function(){
		this.eventController = EventController.getInstance();
	},
	initSpriteController:function(){
		this.spriteController = SpriteController.getInstance();
		this.spriteController.setMaxSpeed(6.5);//7
		this.spriteController.setConstMaxSpeed(6.5);//7
		this.cameraController.setCameraFollowSprite(this.spriteController.getCar().chassisSpr);
	},
	addCheckpoints:function(){
		this.addChickpoint_1();
		this.addChickpoint_2();
		this.addChickpoint_3();
		this.addChickpoint_4();
		this.addChickpoint_5();
		this.addChickpoint_6();
		this.addChickpoint_7();
		this.addChickpoint_8();
		this.addChickpoint_9();
		this.addChickpoint_a();
		this.addChickpoint_b();
		this.addChickpoint_c();
		this.addChickpoint_over();
	},
	addChickpoint_over:function(){
		var overPos = cp.v(15820,211+this.adjustArgument);

		var self = this;
		var leftCollisionLine = collisionline_new(
			self._space,
			cp.v.add(overPos,cp.v(0,-150)),
			cp.v.add(overPos,cp.v(0,150)),
			function(backshape){
				self._space.removeShape(backshape);
				self.spriteController._shieldController.shieldTheLayer(true);

				var listProp = {
					pos:cp.v.add(overPos,cp.v(0,600)),
					parent:self,
					paths:["res/common/hong.plist","res/common/huang.plist","res/common/lv.plist","res/common/lan.plist"],
					globalzorder:constCar.globalZOrder.level_pos5,
					duration:8,
					zorder:1
				};
				var particlelist = ParticleList(listProp);

				var node = new cc.Node();
				self.addChild(node);

				node.runAction(
					cc.sequence(
						cc.callFunc(
							function(){
								// self.spriteController._shieldController.shieldTheLayer(true);
							}
						),
						cc.delayTime(constCar.overTime),
						cc.callFunc(
							function(){
								mylog("next scene!!!");
								self.cleanTheLayer();
								cc.director.runScene(new GLLoadingScene("b2"));
								// cc.director.runScene(new CarB2Scene());
							}
						)
					)
				);
			},
			getNewCollType(),
			0.4);
	},
	addChickpoint_1:function(){

	},
	addChickpoint_2:function(){
		this._lifter = lifter2_b("res/car_b/scene1/lifter_head",this,210,cp.v(2050,105+this.changeY));
		var lifterChild = new cc.Sprite("res/car_b/scene1/lifter");
		lifterChild.setAnchorPoint(0,1);
		lifterChild.setPosition(cp.v(0,30+this.changeY-48));
		this._lifter.spr.addChild(lifterChild,2);
	},
	addChickpoint_3:function(){
		var dropstone = b1_guanqia_upstone_lan_1(this._space,this,cp.v(3097,608+this.changeY));
	},
	addChickpoint_4:function(){
		var posx = 5463;
		var posy = 185+6+this.changeY;
		b1_guanqia_chainBridge_4(this,cp.v(posx,posy));
	},
	addChickpoint_5:function(){
		b1_guanqia_upstone_5(this,this._space,cp.v(6680,573+this.changeY));
	},
	addChickpoint_6:function(){

	},
	addChickpoint_7:function(){
		var skel = b1_guanqia_skel_7(this,cp.v(8616,277+this.changeY));
	},
	addChickpoint_8:function(){
		var dropstone = b1_guanqia_upstone_lan_8(this._space,this,cp.v(10560,78+this.changeY));
		// var dropstone = b1_guanqia_upstone_lan_8(this._space,this,cp.v(10940,158));
	},
	addChickpoint_9:function(){
		var deltaPos = cp.v(11368,-350+this.changeY);
		var stonelist = b1_guanqia_makeStoneList_9(this,deltaPos);
	},
	addChickpoint_a:function(){
		b1_guanqia_luzhang_a(this._space,this,cp.v(12670+30,-195+this.changeY));
	},
	addChickpoint_b:function(){
		var qiao = b1_guanqia_duanqiao_b(this,cp.v(14920,211+this.changeY));
	},
	addChickpoint_c:function(){
		this.stoneList = b1_guanqia_makeStoneList_c(this._space,this,cp.v(3630,240+this.changeY));
	},
	addBackground:function(){
		this.nodeContainer = createNodeContainer(this);
		// this.nodeContainer.setPosition(-310,-264);
		this.nodeContainer.setPosition(0,0);
		this.nodeContainer.setGlobalZOrder(-10);
		this.nodeContainer.setAnchorPoint(cc.p(0,0));

		for(var i = 0;i < constCar.backNum.b1;i ++){
			var back = createStaticNode_Only("res/car_b/scene1/background/map"+i+"_0",cc.p(0,0));
			this.nodeContainer.pushOneSprite(back);
			if(0 == i) {
				back.setPosition(cp.v.add(cp.v.add(cp.v(0+5,-510),this.deltaXY),back.getPosition()));//+5  to fix the black line
			}else{
				back.setPositionY(back.getPositionY() + -510 + this.deltaXY.y);
			}
		}

		this.nodeContainer1 = createNodeContainer(this);
		this.nodeContainer1.setPosition(0,0);
		this.nodeContainer1.setGlobalZOrder(constCar.globalZOrder.level_pos100);
		this.nodeContainer1.setAnchorPoint(cc.p(0,0));

		for(var i = 0;i < 1;i ++){
			var back = createStaticNode_Only("res/car_b/scene1/background/map"+i+"_01",cc.p(0,0));
			this.nodeContainer1.pushOneSprite(back);
			back.setGlobalZOrder(constCar.globalZOrder.level_pos100);
			back.setPosition(cp.v.add(cp.v.add(cp.v(0+5,-510),this.deltaXY),back.getPosition()));
		}
	},
	printCarChassisPos:function(){
		mylog("car chassis pos = " + this.spriteController.getCar().chassis.body.getPos().x + "," + this.spriteController.getCar().chassis.body.getPos().y);
	},
	update:function(dt){
		this.updateController.updateSelf(dt);//must put the updatecontroller before the physicscontroller
		if(this.physicsController._canUpdatePhysics && true) {
			this.physicsController.getSpace().step(0.02);
		}
		this.cameraController.updateCameraPos();
	},
	cleanTheLayer:function(){
		setAllControllerToNull();
	}
});

var CarB1Scene = cc.Scene.extend({
	onEnter:function () {
		this._super();

		cc.textureCache.removeAllTextures();
		cc.spriteFrameCache.removeSpriteFrames();
		ddStopAllAudios();
		// ddPlayEffect("music","res/game/audios/qitabg.mp3",true);
		var spr = addBackMenuFollowCamera(this,function(){
			ddStopAllAudios();
			this.cleanTheLayer();
			cc.director.runScene(new HomeSceneLoop());
		}.bind(this));
		backKeyListenerAdd(this,function(){
			ddStopAllAudios();
			this.cleanTheLayer();
			cc.director.runScene(new HomeSceneLoop());
		}.bind(this));

		this.layer = new CarB1Layer();
		this.layer.cameraController.pushFollowCameraSprites([spr]);
		this.addChild(this.layer);
		// this.layer.startGame();
	},
	cleanTheLayer:function(){
		this.layer.cleanTheLayer();
	}
});
