var GCarB2Layer = null;

var CarB2Layer = cc.Layer.extend({
    ctor:function () {
        this._super();
        this.initLayer();
        this.addBackground();
        this.addCheckpoints();
        this.startGame();
        return true;
    },
    initLayer:function(){
        if(isPad()){
            this.adjustArgument = 106;
        }else{
            this.adjustArgument = 0;
        }
        this.initGlobal("B2");
        // this.initDrawController();
        this.initPhysicsController();
        this.addLeftGroundLine();
        this.initCameraController();
        // this.initCollisionController();
        // this.initEventController();
        this.initSpriteController();
        this.initUpdateController();
        // this.initLimit();
    },
    autoDrive:function(){
        this.spriteController.autoDrive(600,function(){
            this.spriteController._shieldController.shieldTheLayer(false);
            this.initLimit();

            ToolTipSpr(this);
        }.bind(this),4);
    },
    addLeftGroundLine:function(){
        // var posx = 400 + constCar.carLeftLine.c3;
        var posx = 30;
        var posy = 80+this.adjustArgument;
        var groundLine = collisionline_new3(
            this,
            cp.v.add(cp.v(posx,posy),cp.v(-1200,0)),
            cp.v.add(cp.v(posx,posy),cp.v(0,0))
        );
    },
    startGame:function(){
        this.physicsController.startUpdatePhysics();
        if(constCar.debug.debugStart) {
            this.spriteController._shieldController.shieldTheLayer(true);
            this.scheduleOnce(function () {
                this.nodeContainer1.destroyTheContainer();//to fix the black line bug
                this.autoDrive();
            }, 1);
        }else{
            this.nodeContainer1.destroyTheContainer();//to fix the black line bug
        }
    },
    initLimit:function(){
        var prop1 = {
            group:0x0001,
            width:10,
            layers:3
        };

        this.physicsController.addALineNew(cp.v.add(cp.v(-30,600),this.backDelta),cp.v.add(cp.v(-30,1100),this.backDelta),prop1);

        var prop2 = {
            group:0x0001,
            width:10,
            layers:3
        };

        this.physicsController.addALineNew(cp.v.add(cp.v(-30 + 11336,600 + 0),this.backDelta),cp.v.add(cp.v(-30 + 11336,1100 + 0),this.backDelta),prop2);
    },
    initGlobal:function(currentgame){
        GlobalCurrentLayerName = currentgame;
        GCarB2Layer = this;
        this.totalDeltaY = -80+this.adjustArgument;
        this.totalDeltaX = 0;
        this.backDelta = cp.v(-3+this.totalDeltaX,-730+this.totalDeltaY);
        this.foregroundData = [];
        this.metaData = {
            road:{
                deltaX:0+this.totalDeltaX,
                deltaY:-737+this.totalDeltaY,
                group:0x1111,
                friction:1.0,
                elastic:0.0
            }
        };
    },
    initDrawController:function(){

        this.drawController = DrawController.getInstance();
        this.draw = this.drawController.getDraw();
    },
    initPhysicsController:function(){
        this.physicsController = PhysicsController.getInstance();
        this._space = this.physicsController.getSpace();
    },
    initCameraController:function(){
        this.cameraController = CameraController.getInstance();
        // mylog("camera start position = "+this.cameraController._camera.getPosition().x + "," + this.cameraController._camera.getPosition().y);
        this.initLabelAtlas();
    },
    initLabelAtlas:function(){
        this.label = LabelAtlas(this);
        this.cameraController.pushFollowCameraSprites([this.label]);
    },
    initCollisionController:function(){
        this.collisionController = CollisionController.getInstance();
    },
    initEventController:function(){
        this.eventController = EventController.getInstance();
    },
    initSpriteController:function(){
        this.spriteController = SpriteController.getInstance();
        this.spriteController.setMaxSpeed(6.5);//7
        this.spriteController.setConstMaxSpeed(6.5);//7
        this.cameraController.setCameraFollowSprite(this.spriteController.getCar().chassisSpr);
    },
    initUpdateController:function(){
        this.updateController = UpdateController.getInstance();
    },
    addCheckpoints:function(){
        this.addChickpoint_1();
        this.addChickpoint_2();
        this.addChickpoint_3();
        this.addChickpoint_4();
        this.addChickpoint_5();
        this.addChickpoint_6();
        this.addChickpoint_7();
        this.addChickpoint_over();
    },
    addChickpoint_over:function(){
        var overPos = cp.v.add(cp.v(10654,912),this.backDelta);

        var self = this;
        var leftCollisionLine = collisionline_new(
            self._space,
            cp.v.add(overPos,cp.v(0,-150)),
            cp.v.add(overPos,cp.v(0,150)),
            function(backshape){
                self._space.removeShape(backshape);
                self.spriteController._shieldController.shieldTheLayer(true);

                var listProp = {
                    pos:cp.v.add(overPos,cp.v(0,600)),
                    parent:self,
                    paths:["res/common/hong.plist","res/common/huang.plist","res/common/lv.plist","res/common/lan.plist"],
                    globalzorder:constCar.globalZOrder.level_pos5,
                    duration:8,
                    zorder:1
                };
                var particlelist = ParticleList(listProp);

                var node = new cc.Node();
                self.addChild(node);

                node.runAction(
                    cc.sequence(
                        cc.callFunc(
                            function(){
                                // self.spriteController._shieldController.shieldTheLayer(true);
                            }
                        ),
                        cc.delayTime(constCar.overTime),
                        cc.callFunc(
                            function(){
                                mylog("next scene!!!");
                                self.cleanTheLayer();
                                cc.director.runScene(new GLLoadingScene("b3"));
                                // cc.director.runScene(new CarB3Scene());
                            }
                        )
                    )
                );
            },
            getNewCollType(),
            0.4);
    },
    addChickpoint_1:function(){
        var skel = b2_guanqia_skel_1(this,cp.v.add(cp.v(825,460),this.backDelta));
    },
    addChickpoint_2:function(){
        this.stoneList = b2_guanqia_makeStoneList_2(this._space,this,cp.v.add(this.backDelta,cp.v(1560,450)));
    },
    addChickpoint_3:function(){
        var posx = 1960;
        var posy = 503;
        b2_guanqia_chainBridge_3(this,this._space,cp.v.add(cc.p(posx,posy),this.backDelta), cp.v.add(cc.p(posx+560,posy + 17),this.backDelta));
    },
    addChickpoint_4:function(){
        var dropstone = b2_guanqia_upstone_hong_4(this._space,this,cp.v.add(cp.v(3439,898),this.backDelta));
    },
    addChickpoint_5:function(){
        b2_guanqia_ufo_5(this,cp.v.add(cp.v(3696,851),this.backDelta));
    },
    addChickpoint_6:function(){
        makeRollerCoasterBCar(this,cp.v.add(cp.v(5245,600),this.backDelta));
    },
    addChickpoint_7:function(){
        b2_guanqia_makeHangStone_7(this._space,this,cp.v.add(cp.v(9314+35,1012+30),this.backDelta));
    },
    addBackground:function(){
        this.nodeContainer = createNodeContainer(this);
        // this.nodeContainer.setPosition(-310,-264);
        this.nodeContainer.setPosition(0,0);
        this.nodeContainer.setGlobalZOrder(constCar.globalZOrder.level_neg10);
        this.nodeContainer.setAnchorPoint(cc.p(0,0));

        for(var i = 0;i < constCar.backNum.b2;i ++){
            var back = createStaticNode_Only("res/car_b/scene2/background/map"+i+"_0",cc.p(0,0));
            this.nodeContainer.pushOneSprite(back);
            if(0 == i) {
                back.setPosition(cp.v.add(cp.v.add(this.backDelta,cp.v(0,0)),back.getPosition()));
                back.setGlobalZOrder(constCar.globalZOrder.level_neg10);
            }else{
                back.setPositionX(back.getPositionX() - 4);//-4 to fix the black line bug
                back.setPositionY(back.getPositionY() + this.backDelta.y);
            }
        }

        this.nodeContainer1 = createNodeContainer(this);
        this.nodeContainer1.setPosition(0,0);
        this.nodeContainer1.setGlobalZOrder(constCar.globalZOrder.level_pos100);
        this.nodeContainer1.setAnchorPoint(cc.p(0,0));

        for(var i = 0;i < 1;i ++){
            var back = createStaticNode_Only("res/car_b/scene2/background/map"+i+"_01",cc.p(0,0));
            this.nodeContainer1.pushOneSprite(back);
            back.setGlobalZOrder(constCar.globalZOrder.level_pos100);
            back.setPosition(cp.v.add(this.backDelta,back.getPosition()));
        }
    },
    update:function(dt){
        this.updateController.updateSelf(dt);//must put the updatecontroller before the physicscontroller
        if(this.physicsController._canUpdatePhysics && true) {
            this.physicsController.getSpace().step(0.02);
        }
        if(this.spriteController && this.spriteController.getCar().chassis.body.getPos().x > cc.winSize.width/2 && this.spriteController.getCar().chassis.body.getPos().x < 11300) {
            this.cameraController.updateCameraPos();
        }
    },
    cleanTheLayer:function(){
        setAllControllerToNull();
    }
});

var CarB2Scene = cc.Scene.extend({
    onEnter:function () {
        this._super();

        cc.textureCache.removeAllTextures();
        cc.spriteFrameCache.removeSpriteFrames();
        ddStopAllAudios();
        // ddPlayEffect("music","res/game/audios/qitabg.mp3",true);
        var spr = addBackMenuFollowCamera(this,function(){
            ddStopAllAudios();
            this.cleanTheLayer();
            cc.director.runScene(new HomeSceneLoop());
        }.bind(this));
        backKeyListenerAdd(this,function(){
            ddStopAllAudios();
            this.cleanTheLayer();
            cc.director.runScene(new HomeSceneLoop());
        }.bind(this));

        this.layer = new CarB2Layer();
        this.layer.cameraController.pushFollowCameraSprites([spr]);
        this.addChild(this.layer);
        // this.layer.startGame();
    },
    cleanTheLayer:function(){
        this.layer.cleanTheLayer();
    }
});
