var GCarB3Layer = null;

var CarB3Layer = cc.Layer.extend({
    ctor:function () {
        this._super();
        this.initLayer();
        this.addBackground();
        this.addCheckpoints();
        this.startGame();
        return true;
    },
    initLayer:function(){
        if(isPad()){
            this.adjustArgument = 106;
        }else{
            this.adjustArgument = 0;
        }
        this.initGlobal("B3");
        // this.initDrawController();
        this.initPhysicsController();
        this.addLeftGroundLine();
        this.initCameraController();
        // this.initCollisionController();
        // this.initEventController();
        this.initSpriteController();
        this.initUpdateController();
        // this.initLimit();
    },
    autoDrive:function(){
        this.spriteController.autoDrive(600,function(){
            this.spriteController._shieldController.shieldTheLayer(false);
            this.initLimit();

            ToolTipSpr(this);
        }.bind(this),4);
    },
    addLeftGroundLine:function(){
        // var posx = 400 + constCar.carLeftLine.c3;
        var posx = 30;
        var posy = 128+this.adjustArgument;
        var groundLine = collisionline_new3(
            this,
            cp.v.add(cp.v(posx,posy),cp.v(-1200,0)),
            cp.v.add(cp.v(posx,posy),cp.v(0,0))
        );
    },
    startGame:function(){
        this.physicsController.startUpdatePhysics();
        if(constCar.debug.debugStart) {
            this.spriteController._shieldController.shieldTheLayer(true);
            this.scheduleOnce(function () {
                this.nodeContainer1.destroyTheContainer();
                this.autoDrive();
            }, 1);
        }else{
            this.nodeContainer1.destroyTheContainer();
        }
    },
    initLimit:function(){
        var prop1 = {
            group:0x0001,
            width:10,
            layers:3
        };

        this.physicsController.addALineNew(cp.v.add(cp.v(-30,-200),this.backDelta),cp.v.add(cp.v(-30,600),this.backDelta),prop1);

        var prop2 = {
            group:0x0001,
            width:10,
            layers:3
        };

        this.physicsController.addALineNew(cp.v.add(cp.v(-30 + 19840,-200 + 1690),this.backDelta),cp.v.add(cp.v(-30 + 19840,600 + 1690),this.backDelta),prop2);
    },
    initGlobal:function(currentgame){
        GlobalCurrentLayerName = currentgame;
        GCarB3Layer = this;
        this.back2DeltaY = -80+this.adjustArgument;

        this.backDelta = cp.v(0,0+this.adjustArgument);
        this.foregroundData = [];
        this.metaData = {
            road:{
                deltaX:6,
                deltaY:this.back2DeltaY-4,
                group:0x1111,
                // group:1,
                friction:0.8,
                elastic:0.0
            }
        };
    },
    initDrawController:function(){

        this.drawController = DrawController.getInstance();
        this.draw = this.drawController.getDraw();
    },
    initPhysicsController:function(){
        mylog("load physics controller b");
        this.physicsController = PhysicsController.getInstance();
        this._space = this.physicsController.getSpace();
    },
    initCameraController:function(){
        this.cameraController = CameraController.getInstance();
        mylog("camera start position = "+this.cameraController._camera.getPosition().x + "," + this.cameraController._camera.getPosition().y);
        this.initLabelAtlas();
    },
    initLabelAtlas:function(){
        this.label = LabelAtlas(this);
        this.cameraController.pushFollowCameraSprites([this.label]);
    },
    initCollisionController:function(){
        this.collisionController = CollisionController.getInstance();
    },
    initEventController:function(){
        this.eventController = EventController.getInstance();
    },
    initSpriteController:function(){
        this.spriteController = SpriteController.getInstance();
        this.spriteController.setMaxSpeed(6.5);//7
        this.spriteController.setConstMaxSpeed(6.5);//7
        this.cameraController.setCameraFollowSprite(this.spriteController.getCar().chassisSpr);
    },
    initUpdateController:function(){
        this.updateController = UpdateController.getInstance();
    },
    addCheckpoints:function(){
        this.addChickpoint_1();
        this.addChickpoint_2();
        this.addChickpoint_3();
        this.addChickpoint_4();
        this.addChickpoint_5();
        this.addChickpoint_6();
        this.addChickpoint_7();
        this.addChickpoint_8();
        this.addChickpoint_9();// maybe updatecontroller(stopToTargetX) and controllayer(update) is conflict, in fact the problem is stopToTargetX!!!,the most simple method is to exchange pos 8 and 9,so this i soved the bug!
        this.addChickpoint_a();
        this.addChickpoint_b();
        this.addChickpoint_c();
        this.addChickpoint_over();
    },
    addChickpoint_over:function(){
        var overPos = cp.v(16280+2700,1740+this.back2DeltaY);

        var self = this;
        var leftCollisionLine = collisionline_new(
            self._space,
            cp.v.add(overPos,cp.v(0,-150)),
            cp.v.add(overPos,cp.v(0,150)),
            function(backshape){
                self._space.removeShape(backshape);
                self.spriteController._shieldController.shieldTheLayer(true);

                var listProp = {
                    pos:cp.v.add(overPos,cp.v(0,600)),
                    parent:self,
                    paths:["res/common/hong.plist","res/common/huang.plist","res/common/lv.plist","res/common/lan.plist"],
                    globalzorder:constCar.globalZOrder.level_pos5,
                    duration:8,
                    zorder:1
                };
                var particlelist = ParticleList(listProp);

                var node = new cc.Node();
                self.addChild(node);

                node.runAction(
                    cc.sequence(
                        cc.callFunc(
                            function(){
                                // self.spriteController._shieldController.shieldTheLayer(true);
                            }
                        ),
                        cc.delayTime(constCar.overTime),
                        cc.callFunc(
                            function(){
                                mylog("next scene!!!");

                                self.cleanTheLayer();
                                cc.director.runScene(new HomeSceneLoop());
                            }
                        )
                    )
                );
            },
            getNewCollType(),
            0.4);
    },
    addChickpoint_1:function(){
        b3_guanqia_longzi_1(this,cp.v(1730,605+this.back2DeltaY));
    },
    addChickpoint_2:function(){
        b3_guanqia_qiao_2(this,cp.v(2885,10+this.back2DeltaY));
    },
    addChickpoint_3:function(){
        var tbPos = cp.v(3922,469+this.back2DeltaY);
        var carStopToTargetX = tbPos.x - 200;
        var tb = createTreasureBox(this,tbPos,carStopToTargetX);
    },
    addChickpoint_4:function(){
        this.stoneList = b3_guanqia_makeStoneList_4(this._space,this,cp.v(5057,130+this.back2DeltaY));
    },
    addChickpoint_5:function(){
        b3_guanqia_skel_5(this);
    },
    addChickpoint_6:function(){
        var tbPos = cp.v(10314+this.back2DeltaX,2281+this.back2DeltaY);
        var carStopToTargetX = tbPos.x - 200;
        var tb = createTreasureBox(this,tbPos,carStopToTargetX);
    },
    addChickpoint_7:function(){
        b3_guanqia_skel_7(this,cp.v(11309+30+this.back2DeltaX,1913+this.back2DeltaY));
    },
    addChickpoint_8:function(){
        var tbPos = cp.v(12636 + 2000-300,2015+this.back2DeltaY+30);
        var carStopToTargetX = tbPos.x - 200;
        var tb = createTreasureBox(this,tbPos,carStopToTargetX);

        var yugu = new cc.Sprite("res/car_b/scene3/yugu");
        yugu.setGlobalZOrder(constCar.globalZOrder.level_pos50);
        this.addChild(yugu);
        yugu.setPosition(cp.v.add(tbPos,cp.v(-870,-173)));
    },
    addChickpoint_9:function(){
        b3_guanqia_longzi_9(this,cp.v(14936 - 2200,2191+this.back2DeltaY));
    },
    addChickpoint_a:function(){
        this.stoneList = b3_guanqia_makeStoneList_a(this._space,this,cp.v(15670,1895+this.back2DeltaY));
    },
    addChickpoint_b:function(){
        b3_guanqia_longzi_b(this);
    },
    addChickpoint_c:function(){
        b3_guanqia_longzi_c(this);
    },
    addBackground:function(){
        this.nodeContainer = createNodeContainer(this);
        this.nodeContainer.setPosition(0,-200);
        this.nodeContainer.setGlobalZOrder(constCar.globalZOrder.level_neg5);
        this.nodeContainer.setAnchorPoint(cc.p(0,0));

        this.back2DeltaX = -165;
        for(var i = 0;i < constCar.backNum.b3;i ++){
            var back = createStaticNode_Only("res/car_b/scene3/background/map"+i+"_0",cc.p(0,0));
            this.nodeContainer.pushOneSprite(back);
            if(0 == i) {
                back.setPosition(cp.v.add(cp.v(0,0 + this.back2DeltaY),back.getPosition()));
            }else{
                back.setPositionY(back.getPositionY() + this.back2DeltaY);
            }
        }

        this.nodeContainer1 = createNodeContainer(this);
        this.nodeContainer1.setPosition(0,0+4.5);
        this.nodeContainer1.setGlobalZOrder(constCar.globalZOrder.level_pos100);
        this.nodeContainer1.setAnchorPoint(cc.p(0,0));

        for(var i = 0;i < 1;i ++){
            var back = createStaticNode_Only("res/car_b/scene3/background/map"+i+"_01",cc.p(0,0));
            this.nodeContainer1.pushOneSprite(back);
            back.setGlobalZOrder(constCar.globalZOrder.level_pos100);
            back.setPosition(cp.v.add(cp.v(0,0 + this.back2DeltaY),back.getPosition()));
        }
    },
    printCarChassisPos:function(){
        mylog("car chassis pos = " + this.spriteController.getCar().chassis.body.getPos().x + "," + this.spriteController.getCar().chassis.body.getPos().y);
    },
    update:function(dt){
        this.updateController.updateSelf(dt);//must put the updatecontroller before the physicscontroller
        if(this.physicsController._canUpdatePhysics && true) {
            this.physicsController.getSpace().step(0.02);
        }
        this.cameraController.updateCameraPos();
    },
    cleanTheLayer:function(){
        setAllControllerToNull();
    }
});

var CarB3Scene = cc.Scene.extend({
    onEnter:function () {
        this._super();

        cc.textureCache.removeAllTextures();
        cc.spriteFrameCache.removeSpriteFrames();
        ddStopAllAudios();
        // ddPlayEffect("music","res/game/audios/qitabg.mp3",true);
        var spr = addBackMenuFollowCamera(this,function(){
            ddStopAllAudios();
            this.cleanTheLayer();
            cc.director.runScene(new HomeSceneLoop());
        }.bind(this));
        backKeyListenerAdd(this,function(){
            ddStopAllAudios();
            this.cleanTheLayer();
            cc.director.runScene(new HomeSceneLoop());
        }.bind(this));

        this.layer = new CarB3Layer();
        this.layer.cameraController.pushFollowCameraSprites([spr]);
        this.addChild(this.layer);
        // this.layer.startGame();
    },
    cleanTheLayer:function(){
        this.layer.cleanTheLayer();
    }
});
