var GCarC1Layer = null;

var CarC1Layer = cc.Layer.extend({
    ctor:function () {
        this._super();
        this.initLayer();
        this.addBackground();
        this.addCheckpoints();
        this.startGame();
        return true;
    },
    initLayer:function(){
        if(isPad()){
            this.adjustArgument = 106;
        }else{
            this.adjustArgument = 0;
        }
        this.initGlobal("C1");
        // this.initDrawController();
        this.initPhysicsController();
        this.addLeftGroundLine();
        this.initCameraController();
        // this.initCollisionController();
        // this.initEventController();
        this.initSpriteController();
        this.initUpdateController();
        // this.initLimit();
    },
    autoDrive:function(){
        mylog("autodrive .... ");
        this.spriteController.autoDrive(600,function(){
            this.spriteController._shieldController.shieldTheLayer(false);
            this.initLimit();

            ToolTipSpr(this);
        }.bind(this),4);
    },
    addLeftGroundLine:function(){
        // var posx = 400 + constCar.carLeftLine.c3;
        var posx = 10;
        var posy = 128+this.adjustArgument;
        var groundLine = collisionline_new3(
            this,
            cp.v.add(cp.v(posx,posy),cp.v(-1200,0)),
            cp.v.add(cp.v(posx,posy),cp.v(0,0))
        );
    },
    startGame:function(){
        this.physicsController.startUpdatePhysics();
        mylog("startGame...");
        if(constCar.debug.debugStart) {
            this.spriteController._shieldController.shieldTheLayer(true);
            this.scheduleOnce(function () {
                this.nodeContainer1.destroyTheContainer();
                this.autoDrive();
            }, 1);
        }else{
            this.nodeContainer1.destroyTheContainer();
        }
    },
    initLimit:function(){
        var prop1 = {
            group:0x0001,
            width:10,
            layers:3
        };

        this.physicsController.addALineNew(cp.v.add(cp.v(30,-692),this.backDelta),cp.v.add(cp.v(30,692),this.backDelta),prop1);

        var prop2 = {
            group:0x0001,
            width:10,
            layers:3
        };
        this.physicsController.addALineNew(cp.v.add(cp.v(30 + 16270,-692 - 1120),this.backDelta),cp.v.add(cp.v(30 + 16270,692-1120),this.backDelta),prop1);
    },
    initGlobal:function(currentgame){
        GlobalCurrentLayerName = currentgame;
        GCarC1Layer = this;
        this.foregroundData = [];
        this.metaData = {
            road:{
                deltaX:0,
                deltaY:-1735-860+1176-220+this.adjustArgument,
                group:0x1111,
                // group:1,
                friction:0.9,
                elastic:0.0
            }
        };
        this.backDelta = cp.v(0,0+this.adjustArgument);
    },
    initUpdateController:function(){
        this.updateController = UpdateController.getInstance();
    },
    initDrawController:function(){

        this.drawController = DrawController.getInstance();
        this.draw = this.drawController.getDraw();
    },
    initPhysicsController:function(){
        this.physicsController = PhysicsController.getInstance();
        this._space = this.physicsController.getSpace();
    },
    initCameraController:function(){
        this.cameraController = CameraController.getInstance();
        mylog("camera start position = "+this.cameraController._camera.getPosition().x + "," + this.cameraController._camera.getPosition().y);
        this.initLabelAtlas();
    },
    initLabelAtlas:function(){
        this.label = LabelAtlas(this);
        this.cameraController.pushFollowCameraSprites([this.label]);
    },
    initCollisionController:function(){
        this.collisionController = CollisionController.getInstance();
    },
    initEventController:function(){
        this.eventController = EventController.getInstance();
    },
    initSpriteController:function(){
        this.spriteController = SpriteController.getInstance();
        this.spriteController.setMaxSpeed(6);//7
        this.spriteController.setConstMaxSpeed(6);//7
        this.cameraController.setCameraFollowSprite(this.spriteController.getCar().chassisSpr);
    },
    addCheckpoints:function(){
        this.addChickpoint_1();
        this.addChickpoint_2();
        this.addChickpoint_3();
        this.addChickpoint_4();
        this.addChickpoint_5();
        this.addChickpoint_6();
        this.addChickpoint_7();
        this.addChickpoint_8();
        this.addChickpoint_9();
        this.addChickpoint_a();
        this.addChickpoint_b();
        this.addChickpoint_c();
        this.addChickpoint_d();//hava nothing
        this.addChickpoint_e();
        this.addChickpoint_over();
    },
    addChickpoint_over:function(){
        var overPos = cp.v.add(cp.v(16100,-800),this.backDelta);

        var self = this;
        var leftCollisionLine = collisionline_new(
            self._space,
            cp.v.add(overPos,cp.v(0,-150)),
            cp.v.add(overPos,cp.v(0,150)),
            function(backshape){
                self._space.removeShape(backshape);
                self.spriteController._shieldController.shieldTheLayer(true);

                var listProp = {
                    pos:cp.v.add(overPos,cp.v(0,600)),
                    parent:self,
                    paths:["res/common/hong.plist","res/common/huang.plist","res/common/lv.plist","res/common/lan.plist"],
                    globalzorder:constCar.globalZOrder.level_pos5,
                    duration:8,
                    zorder:1
                };
                var particlelist = ParticleList(listProp);

                var node = new cc.Node();
                self.addChild(node);

                node.runAction(
                    cc.sequence(
                        cc.callFunc(
                            function(){
                                // self.spriteController._shieldController.shieldTheLayer(true);
                            }
                        ),
                        cc.delayTime(constCar.overTime),
                        cc.callFunc(
                            function(){
                                mylog("next scene!!!");

                                self.cleanTheLayer();
                                cc.director.runScene(new GLLoadingScene("c2"));
                                // cc.director.runScene(new CarC2Scene());
                            }
                        )
                    )
                );
            },
            getNewCollType(),
            0.4);
    },
    addChickpoint_1:function(){
        var sprite = new cc.Sprite("res/car_c/scene1/qiao");
        sprite.setGlobalZOrder(constCar.globalZOrder.level_pos100);
        this.addChild(sprite);
        sprite.setPosition(1367,186-15+this.adjustArgument);
    },
    addChickpoint_2:function(){
        var precious = c1_guanqia_upprecious_2(this,cp.v(2470,500+this.adjustArgument));
    },
    addChickpoint_3:function(){
        c1_guanqia_ufo_3(this,cp.v(3575,52+this.adjustArgument));//cp.v(3575+6800,52-1450)
    },
    addChickpoint_4:function(){
        var yasuiji = c1_guanqia_yasuiji_4(this,cp.v(4700,-500+this.adjustArgument));

        var prop = {
            group:0x1111,
            width:2,
            layers:2
        };
        this.physicsController.addALineNew(cp.v.add(cp.v(-180,-500+6),cp.v(3500,-500+this.adjustArgument)),cp.v.add(cp.v(3500,-500+this.adjustArgument),cp.v(-180+300,-500+6)),prop);
    },
    addChickpoint_5:function(){
        c1_guanqia_luzhang_5(this._space,this,cp.v(5826,-1080+this.adjustArgument));
    },
    addChickpoint_6:function(){
        var posx = 6410;
        var posy = -1085+this.adjustArgument;
        c1_guanqia_chainBridge_6(this,this._space,cc.p(posx,posy), cc.p(posx+628,posy+232));
    },
    addChickpoint_7:function(){
        this.stoneList = c1_guanqia_makeStoneList_7(this._space,this,cp.v(7842,-731-130+this.adjustArgument));
    },
    addChickpoint_8:function(){
        c1_guanqia_upprecious_8(this,cp.v(8412,-340+this.adjustArgument));
    },
    addChickpoint_9:function(){
        var sprite = new cc.Sprite("res/car_c/scene1/gutou");
        sprite.setPosition(9569,-1030+this.adjustArgument);
        sprite.setGlobalZOrder(constCar.globalZOrder.level_pos15);
        this.addChild(sprite);
    },
    addChickpoint_a:function(){
        c1_guanqia_ufo_a(this,cp.v(10292,-1331+this.adjustArgument));
    },
    addChickpoint_b:function(){
        var spr = new cc.Sprite("res/common/add/car3-1");
        spr.setGlobalZOrder(1);
        this.addChild(spr);
        if(isPad()){
            spr.setPosition(12340+0.5,-1225+6.2);
        }else{
            spr.setPosition(12340,-1325);
        }
        //nothing
    },
    addChickpoint_c:function(){
        var machine = c1_guanqia_makeCrushMachine_c(this,cp.v.add(cp.v(-300,-200+this.adjustArgument),cp.v(13968,-680)));
    },
    addChickpoint_d:function(){
        //nothing
    },
    addChickpoint_e:function(){
        var balloon = c1_guanqia_qiqiu_e(this,cp.v(15400,-800+this.adjustArgument));
    },
    addBackground:function(){
        this.nodeContainer = createNodeContainer(this);
        // this.nodeContainer.setPosition(-310,-264);
        this.nodeContainer.setPosition(0,0+this.adjustArgument);
        this.nodeContainer.setGlobalZOrder(-10);
        this.nodeContainer.setAnchorPoint(cc.p(0,0));

        for(var i = 0;i < constCar.backNum.c1;i ++){
            var back = createStaticNode_Only("res/car_c/scene1/background/map"+i+"_0",cc.p(0,0));
            this.nodeContainer.pushOneSprite(back);
            if(0 == i) {
                back.setPosition(cp.v.add(cp.v(0,-1622),back.getPosition()));
            }else{
                back.setPositionY(back.getPositionY() - 1622);
            }
        }

        this.nodeContainer1 = createNodeContainer(this);
        this.nodeContainer1.setPosition(0,0+this.adjustArgument);
        this.nodeContainer1.setGlobalZOrder(constCar.globalZOrder.level_pos100);
        this.nodeContainer1.setAnchorPoint(cc.p(0,0));

        for(var i = 0;i < 1;i ++){
            var back = createStaticNode_Only("res/car_c/scene1/background/map"+i+"_01",cc.p(0,0));
            this.nodeContainer1.pushOneSprite(back);
            back.setGlobalZOrder(constCar.globalZOrder.level_pos100);
            back.setPosition(cp.v.add(cp.v(0,-1622),back.getPosition()));
        }
    },
    printCarChassisPos:function(){
        mylog("car chassis pos = " + this.spriteController.getCar().chassis.body.getPos().x + "," + this.spriteController.getCar().chassis.body.getPos().y);
    },
    update:function(dt){
        this.updateController.updateSelf(dt);//must put the updatecontroller before the physicscontroller
        if(this.physicsController._canUpdatePhysics && true) {
            this.physicsController.getSpace().step(0.02);
        }
        this.cameraController.updateCameraPos();
    },
    cleanTheLayer:function(){
        setAllControllerToNull();
    }
});

var CarC1Scene = cc.Scene.extend({
    onEnter:function () {
        this._super();

        cc.textureCache.removeAllTextures();
        cc.spriteFrameCache.removeSpriteFrames();
        ddStopAllAudios();
        // ddPlayEffect("music","res/game/audios/qitabg.mp3",true);
        var spr = addBackMenuFollowCamera(this,function(){
            mylog("back is clicked");
            ddStopAllAudios();
            this.cleanTheLayer();
            cc.director.runScene(new HomeSceneLoop());
        }.bind(this));
        backKeyListenerAdd(this,function(){
            ddStopAllAudios();
            this.cleanTheLayer();
            cc.director.runScene(new HomeSceneLoop());
        }.bind(this));

        this.layer = new CarC1Layer();
        this.layer.cameraController.pushFollowCameraSprites([spr]);
        this.addChild(this.layer);
        // this.layer.startGame();
    },
    cleanTheLayer:function(){
        this.layer.cleanTheLayer();
    }
});
