var GCarC2Layer = null;

var CarC2Layer = cc.Layer.extend({
    ctor:function () {
        this._super();
        this.initLayer();
        this.addBackground();
        this.addCheckpoints();
        // this.test();
        this.startGame();
        return true;
    },
    initLayer:function(){
        if(isPad()){
            this.adjustArgument = 106;
        }else{
            this.adjustArgument = 0;
        }
        this.initGlobal("C2");
        // this.initDrawController();
        this.initPhysicsController();
        this.addLeftGroundLine();
        this.initCameraController();
        // this.initCollisionController();
        // this.initEventController();
        this.initSpriteController();
        this.initUpdateController();
        // this.initLimit();
    },
    startGame:function(){
        this.physicsController.startUpdatePhysics();
        if(constCar.debug.debugStart) {
            this.spriteController._shieldController.shieldTheLayer(true);
            this.scheduleOnce(function () {
                this.nodeContainer1.destroyTheContainer();
                this.autoDrive();
            }, 1);
        }else{
            this.nodeContainer1.destroyTheContainer();
        }
    },
    initGlobal:function(currentgame){
        GlobalCurrentLayerName = currentgame;
        GCarC2Layer = this;
        this.backDelta = cp.v(0,-140+this.adjustArgument);
        this.foregroundData = [];
        this.metaData = {
            road:{
                deltaX:0+this.backDelta.x,
                deltaY:-759+this.backDelta.y,//-759
                group:0x1111,
                friction:0.8,
                elastic:0.1
            }
        };
    },
    autoDrive:function(){
        this.spriteController.autoDrive(600,function(){
            this.spriteController._shieldController.shieldTheLayer(false);
            this.initLimit();

            ToolTipSpr(this);
        }.bind(this),4);
    },
    addLeftGroundLine:function(){
        // var posx = 400 + constCar.carLeftLine.c3;
        var posx = 0;
        var posy = 55+this.adjustArgument;
        var groundLine = collisionline_new3(
            this,
            cp.v.add(cp.v(posx,posy),cp.v(-1200,0)),
            cp.v.add(cp.v(posx,posy),cp.v(0,0))
        );
    },
    initLimit:function(){
        var prop1 = {
            group:0x0001,
            width:10,
            layers:3
        };

        this.physicsController.addALineNew(cp.v.add(cp.v(30,-692),this.backDelta),cp.v.add(cp.v(30,692),this.backDelta),prop1);

        var prop2 = {
            group:0x0001,
            width:10,
            layers:3
        };

        this.physicsController.addALineNew(cp.v.add(cp.v(30 + 14624 - 24,-692 + 1008),this.backDelta),cp.v.add(cp.v(30 + 14624 - 24,692 + 1008),this.backDelta),prop2);
    },
    initDrawController:function(){
        this.drawController = DrawController.getInstance();
        this.draw = this.drawController.getDraw();
    },
    initPhysicsController:function(){
        this.physicsController = PhysicsController.getInstance();
        this._space = this.physicsController.getSpace();
    },
    initCameraController:function(){
        this.cameraController = CameraController.getInstance();
        mylog("camera start position = "+this.cameraController._camera.getPosition().x + "," + this.cameraController._camera.getPosition().y);
        this.initLabelAtlas();
    },
    initLabelAtlas:function(){
        this.label = LabelAtlas(this);
        this.cameraController.pushFollowCameraSprites([this.label]);
    },
    initCollisionController:function(){
        this.collisionController = CollisionController.getInstance();
    },
    initEventController:function(){
        this.eventController = EventController.getInstance();
    },
    initSpriteController:function(){
        this.spriteController = SpriteController.getInstance();
        this.spriteController.setMaxSpeed(6);
        this.spriteController.setConstMaxSpeed(6);
        this.cameraController.setCameraFollowSprite(this.spriteController.getCar().chassisSpr);
    },
    initUpdateController:function(){
        this.updateController = UpdateController.getInstance();
    },
    test:function() {
        addKeyboardListener(this);
    },
    addCheckpoints:function(){
        this.addChickpoint_1();
        this.addChickpoint_2();//not anything
        this.addChickpoint_3();//all over
        this.addChickpoint_4();//all over
        this.addChickpoint_5();//all over // 5完成后6不能到达,the bug is already fixed!
        this.addChickpoint_6();//all over // 6单独可以到达
        this.addChickpoint_7();//all over
        this.addChickpoint_over();
    },
    addChickpoint_over:function(){
        var overPos = cp.v(13845,1150+this.adjustArgument);

        var self = this;
        var leftCollisionLine = collisionline_new(
            self._space,
            cp.v.add(overPos,cp.v(0,-150)),
            cp.v.add(overPos,cp.v(0,150)),
            function(backshape){
                self._space.removeShape(backshape);
                self.spriteController._shieldController.shieldTheLayer(true);

                var listProp = {
                    pos:cp.v.add(overPos,cp.v(0,600)),
                    parent:self,
                    paths:["res/common/hong.plist","res/common/huang.plist","res/common/lv.plist","res/common/lan.plist"],
                    globalzorder:constCar.globalZOrder.level_pos5,
                    duration:8,
                    zorder:1
                };
                var particlelist = ParticleList(listProp);

                var node = new cc.Node();
                self.addChild(node);

                node.runAction(
                    cc.sequence(
                        cc.callFunc(
                            function(){
                                // self.spriteController._shieldController.shieldTheLayer(true);
                            }
                        ),
                        cc.delayTime(constCar.overTime),
                        cc.callFunc(
                            function(){
                                mylog("next scene!!!");

                                self.cleanTheLayer();
                                cc.director.runScene(new GLLoadingScene("c3"));
                                // cc.director.runScene(new CarC3Scene());
                            }
                        )
                    )
                );
            },
            getNewCollType(),
            0.4);
    },
    getCarStartPosition:function(){
        mylog("car pos " + this.spriteController.getCar().chassisSpr.getPosition().x + "," +  this.spriteController.getCar().chassisSpr.getPosition().y);
    },
    addChickpoint_1:function(){
        c2_guanqia_icePrecious_1(this,cp.v.add(this.backDelta,cp.v(2400,700)));
    },
    addChickpoint_2:function(){},
    addChickpoint_3:function(){//over
        var self = this;

        var qiao = c2_guanqia_duanqiao_3(this,cp.v.add(cp.v(3925,692),this.backDelta));
        var colline = collisionline_new(
            self._space,
            cp.v.add(cp.v(3402,540),this.backDelta),
            cp.v.add(cp.v(3402,640),this.backDelta),
            function(backshape){
                self.spriteController.autoDrive(1100,function(){
                    mylog("auto drive over");
                    var prop = {
                        group:0x0001,
                        width:10,
                        layers:3
                    };
                    self.physicsController.addALineNew(cp.v.add(cp.v(3925+180,-692+200),self.backDelta),cp.v.add(cp.v(3925+180,692+200),self.backDelta),prop);
                },6);

                self._space.removeShape(backshape);
                qiao.startDrop();
                mylog("addChickpoint_3");
            },
            getNewCollType(),
            0.4);
    },
    addChickpoint_4:function(){//over
        var self = this;
        var dropBridge = c2_guanqia_dropBridge_4(this,cp.v.add(cp.v(5694,687),this.backDelta));
    },
    addChickpoint_5:function(){//over
        c2_guanqia_upprecious_5(this,cp.v.add(cp.v(7094-10,1135-20),this.backDelta));
    },
    addChickpoint_6:function(){
        makeRollerCoasterCCar(this,cp.v.add(cp.v(7856,665),this.backDelta));
    },
    addChickpoint_7:function(){
        var tstpos = 0;
        this._lifter = lifter2_c2("res/car_c/scene2/shangshengji/shangshengji1",this,450,cp.v.add(cp.v(12945+tstpos,770),this.backDelta));
    },
    addBackground:function(){
        this.nodeContainer = createNodeContainer(this);
        // this.nodeContainer.setPosition(-310,-264);
        this.nodeContainer.setPosition(0,0);
        this.nodeContainer.setGlobalZOrder(constCar.globalZOrder.level_neg5);
        this.nodeContainer.setAnchorPoint(cc.p(0,0));

        for(var i = 0;i < constCar.backNum.c2;i ++){
            var back = createStaticNode_Only("res/car_c/scene2/background/map"+i+"_0",cc.p(0,0));
            this.nodeContainer.pushOneSprite(back);
            if(0 == i) {
                back.setPosition(cp.v.add(cp.v(-6+this.backDelta.x,-750+this.backDelta.y),back.getPosition()));
            }else{
                back.setPositionX(back.getPositionX() - 10);//-4 to fix the black line bug
                back.setPositionY(back.getPositionY() - 750+this.backDelta.y);
            }
        }


        this.nodeContainer1 = createNodeContainer(this);
        // this.nodeContainer.setPosition(-310,-264);
        this.nodeContainer1.setPosition(0,0);
        this.nodeContainer1.setGlobalZOrder(constCar.globalZOrder.level_pos100);
        this.nodeContainer1.setAnchorPoint(cc.p(0,0));

        for(var i = 0;i < 1;i ++){
            var back = createStaticNode_Only("res/car_c/scene2/background/map"+i+"_01",cc.p(0,0));
            back.setGlobalZOrder(constCar.globalZOrder.level_pos100);
            this.nodeContainer1.pushOneSprite(back);
            back.setPosition(cp.v.add(cp.v(-6+this.backDelta.x,-750+this.backDelta.y),back.getPosition()));
        }
    },
    printCarChassisPos:function(){
        mylog("car chassis pos = " + this.spriteController.getCar().chassis.body.getPos().x + "," + this.spriteController.getCar().chassis.body.getPos().y);
    },
    update:function(dt){
        this.updateController.updateSelf(dt);//must put the updatecontroller before the physicscontroller
        if(this.physicsController._canUpdatePhysics && true) {
            this.physicsController.getSpace().step(0.02);
        }
        this.cameraController.updateCameraPos();
    },
    cleanTheLayer:function(){
        setAllControllerToNull();
    }
});

var CarC2Scene = cc.Scene.extend({
    onEnter:function () {
        this._super();

        cc.textureCache.removeAllTextures();
        cc.spriteFrameCache.removeSpriteFrames();
        ddStopAllAudios();
        // ddPlayEffect("music","res/game/audios/qitabg.mp3",true);
        var spr = addBackMenuFollowCamera(this,function(){
            ddStopAllAudios();
            this.cleanTheLayer();
            cc.director.runScene(new HomeSceneLoop());
        }.bind(this));
        backKeyListenerAdd(this,function(){
            ddStopAllAudios();
            this.cleanTheLayer();
            cc.director.runScene(new HomeSceneLoop());
        }.bind(this));

        this.layer = new CarC2Layer();
        this.layer.cameraController.pushFollowCameraSprites([spr]);
        this.addChild(this.layer);
        // this.layer.startGame();
    },
    cleanTheLayer:function(){
        this.layer.cleanTheLayer();
    }
});
