var GCarC3Layer = null;

var CarC3Layer = cc.Layer.extend({
    ctor:function () {
        this._super();
        this.initLayer();
        this.addBackground();
        this.addCheckpoints();
        this.startGame();
        return true;
    },
    initLayer:function(){
        if(isPad()){
            this.adjustArgument = 106;
        }else{
            this.adjustArgument = 0;
        }
        this.initGlobal("C3");
        // this.initDrawController();
        this.initPhysicsController();
        this.addLeftGroundLine();
        this.initCameraController();
        // this.initCollisionController();
        // this.initEventController();
        this.initSpriteController();
        this.initUpdateController();
    },
    autoDrive:function(){
        this.spriteController.autoDrive(600,function(){
            this.spriteController._shieldController.shieldTheLayer(false);
            this.initLimit();

            ToolTipSpr(this);
        }.bind(this),4);
    },
    addLeftGroundLine:function(){
        // var posx = 400 + constCar.carLeftLine.c3;
        var posx = 0;
        var posy = 62+this.adjustArgument;
        var groundLine = collisionline_new3(
        this,
            cp.v.add(cp.v(posx,posy),cp.v(-1200,0)),
            cp.v.add(cp.v(posx,posy),cp.v(0,0))
        );
    },
    initLimit:function(){
        var prop1 = {
            group:0x0001,
            width:10,
            layers:3
        };

        this.physicsController.addALineNew(cp.v.add(cp.v(0,162-300),this.deltaXY),cp.v.add(cp.v(0,162+300),this.deltaXY),prop1);

        var prop2 = {
            group:0x0001,
            width:10,
            layers:3
        };

        this.physicsController.addALineNew(cp.v.add(cp.v(0 + 20300,162-300 + 184),this.deltaXY),cp.v.add(cp.v(0 + 20300,162+300 + 184),this.deltaXY),prop2);
    },
    startGame:function(){
        this.physicsController.startUpdatePhysics();
        if(constCar.debug.debugStart) {
            this.spriteController._shieldController.shieldTheLayer(true);
            this.scheduleOnce(function () {
                this.nodeContainer1.destroyTheContainer();
                this.autoDrive();
            }, 1);
        }else{
            this.nodeContainer1.destroyTheContainer();
        }
    },
    initGlobal:function(currentgame){
        GlobalCurrentLayerName = currentgame;
        GCarC3Layer = this;
        this.deltaXY = cp.v(0,-100+this.adjustArgument);
        this.foregroundData = [];
        this.metaData = {
            road:{
                deltaX:-13,
                deltaY:this.deltaXY.y-4-3,
                group:0x1111,
                friction:0.9,
                elastic:0.0
            }
        };
    },
    initDrawController:function(){

        this.drawController = DrawController.getInstance();
        this.draw = this.drawController.getDraw();
    },
    initPhysicsController:function(){
        this.physicsController = PhysicsController.getInstance();
        this._space = this.physicsController.getSpace();
    },
    initCameraController:function(){
        this.cameraController = CameraController.getInstance();
        mylog("camera start position = "+this.cameraController._camera.getPosition().x + "," + this.cameraController._camera.getPosition().y);
        this.initLabelAtlas();
    },
    initLabelAtlas:function(){
        this.label = LabelAtlas(this);
        this.cameraController.pushFollowCameraSprites([this.label]);
    },
    initCollisionController:function(){
        this.collisionController = CollisionController.getInstance();
    },
    initEventController:function(){
        this.eventController = EventController.getInstance();
    },
    initSpriteController:function(){
        this.spriteController = SpriteController.getInstance();
        this.spriteController.setMaxSpeed(6);
        this.spriteController.setConstMaxSpeed(6);
        this.cameraController.setCameraFollowSprite(this.spriteController.getCar().chassisSpr);
    },
    initUpdateController:function(){
        this.updateController = UpdateController.getInstance();
    },
    addCheckpoints:function(){
        this.addChickpoint_1();//over
        this.addChickpoint_2();//over
        this.addChickpoint_3();//over
        this.addChickpoint_4();//over
        this.addChickpoint_5();//over
        this.addChickpoint_6();//over
        this.addChickpoint_7();//over
        this.addChickpoint_8();//over
        this.addChickpoint_9();//over
        this.addChickpoint_a();//not over
        this.addChickpoint_b();//over
        this.addChickpoint_c();//over
        this.addChickpoint_d();//over
        this.addChickpoint_over();//over
    },
    addChickpoint_over:function(){
        var overPos = cp.v.add(this.deltaXY,cp.v(19600,292));

        var self = this;
        var leftCollisionLine = collisionline_new(
            self._space,
            cp.v.add(overPos,cp.v(0,-150)),
            cp.v.add(overPos,cp.v(0,150)),
            function(backshape){
                self._space.removeShape(backshape);
                self.spriteController._shieldController.shieldTheLayer(true);

                var listProp = {
                    pos:cp.v.add(overPos,cp.v(0,600)),
                    parent:self,
                    paths:["res/common/hong.plist","res/common/huang.plist","res/common/lv.plist","res/common/lan.plist"],
                    globalzorder:constCar.globalZOrder.level_pos5,
                    duration:8,
                    zorder:1
                };
                var particlelist = ParticleList(listProp);

                var node = new cc.Node();
                self.addChild(node);

                node.runAction(
                    cc.sequence(
                        cc.callFunc(
                            function(){
                                // self.spriteController._shieldController.shieldTheLayer(true);
                            }
                        ),
                        cc.delayTime(constCar.overTime),
                        cc.callFunc(
                            function(){
                                mylog("next scene!!!");

                                self.cleanTheLayer();
                                cc.director.runScene(new HomeSceneLoop());
                            }
                        )
                    )
                );
            },
            getNewCollType(),
            0.4);
    },
    addChickpoint_1:function(){
        this._lifter = lifter2_c3("res/car_c/scene3/qiao1",this,365,cp.v.add(cp.v(1675,162),this.deltaXY));
    },
    addChickpoint_2:function(){
        c3_guanqia_longzi_2(this,cp.v.add(this.deltaXY,cp.v(4027,690)));
    },
    addChickpoint_3:function(){// 4885,407 //exchange position with 6
        var tbPos = cp.v.add(cp.v(9220,330),this.deltaXY);
        var carStopToTargetX = tbPos.x - 200;
        var tb = createTreasureBox(this,tbPos,carStopToTargetX);
        tb.setRotation(3);


        //source
        var tbPos = cp.v.add(cp.v(4885,407),this.deltaXY);
        var carStopToTargetX = tbPos.x - 200;
        var tb = createTreasureBox(this,tbPos,carStopToTargetX);
    },
    addChickpoint_4:function(){
        c3_guanqia_duanqiao_4(this,cp.v.add(this.deltaXY,cp.v(5815,699)));
    },
    addChickpoint_5:function(){
        var dropBridge = c3_guanqia_dropBridge_5(this,cp.v.add(this.deltaXY,cp.v(6784,320)));
    },
    addChickpoint_6:function(){
        c3_guanqia_longzi_6(this,cp.v.add(this.deltaXY,cp.v(2527,760)));// 9560,513 // move to 1-2
    },
    addChickpoint_7:function(){
        c3_guanqia_skel_7(this,cp.v.add(cp.v(10580,270),this.deltaXY));
    },
    addChickpoint_8:function(){
        c3_guanqia_particle_8(this,cp.v.add(cp.v(13600,260),this.deltaXY));
    },
    addChickpoint_9:function(){
        var tbPos = cp.v.add(cp.v(14600,420),this.deltaXY);
        var carStopToTargetX = tbPos.x - 200;
        var tb = createTreasureBox(this,tbPos,carStopToTargetX);
        tb.setRotation(-5);
    },
    addChickpoint_a:function(){
        seesaw(this,cp.v.add(cp.v(14973,233),this.deltaXY));
    },
    addChickpoint_b:function(){
        var tbPos = cp.v.add(cp.v(16880,507),this.deltaXY);
        var carStopToTargetX = tbPos.x - 200;
        var tb = createTreasureBox(this,tbPos,carStopToTargetX);
        tb.setRotation(5);
    },
    addChickpoint_c:function(){
        c3_guanqia_longzi_c(this,cp.v.add(this.deltaXY,cp.v(17384,312 + 16)));
    },
    addChickpoint_d:function(){
        c3_guanqia_longzi_d(this,cp.v.add(this.deltaXY,cp.v(17784 + 50,292 + 30)));
    },
    addBackground:function(){
        this.nodeContainer = createNodeContainer(this);
        // this.nodeContainer.setPosition(-310,-264);
        this.nodeContainer.setPosition(0,0);
        this.nodeContainer.setGlobalZOrder(constCar.globalZOrder.level_neg5);
        this.nodeContainer.setAnchorPoint(cc.p(0,0));
        this.backDeltaXY = cp.v(0,-115);

        for(var i = 0;i < constCar.backNum.c3;i ++){
            var back = createStaticNode_Only("res/car_c/scene3/background/map"+i+"_0",cc.p(0,0));
            this.nodeContainer.pushOneSprite(back);
            if(0 == i) {
                back.setPosition(cp.v.add(cp.v.add(this.deltaXY,this.backDeltaXY),back.getPosition()));
            }else{
                if(i != 3) {
                    back.setPositionY(back.getPositionY() + this.deltaXY.y + this.backDeltaXY.y);
                }else{
                    back.setPositionY(back.getPositionY() + this.deltaXY.y + this.backDeltaXY.y-200);
                }
            }
        }


        this.nodeContainer1 = createNodeContainer(this);
        this.nodeContainer1.setPosition(0,0);
        this.nodeContainer1.setGlobalZOrder(constCar.globalZOrder.level_pos100);
        this.nodeContainer1.setAnchorPoint(cc.p(0,0));
        this.backDeltaXY = cp.v(0,-115);

        for(var i = 0;i < 1;i ++){
            var back = createStaticNode_Only("res/car_c/scene3/background/map"+i+"_01",cc.p(0,0));
            back.setGlobalZOrder(constCar.globalZOrder.level_pos100);
            this.nodeContainer1.pushOneSprite(back);
            back.setPosition(cp.v.add(cp.v.add(this.deltaXY,this.backDeltaXY),back.getPosition()));
        }
    },
    printCarChassisPos:function(){
        mylog("car chassis pos = " + this.spriteController.getCar().chassis.body.getPos().x + "," + this.spriteController.getCar().chassis.body.getPos().y);
    },
    update:function(dt){
        // mylog("jiaodu :  " + (this.spriteController.getCar().rightWheel.body.getAngle() * 180 / 3.1415)%360) ;
        this.printCarChassisPos();
        this.updateController.updateSelf(dt);//must put the updatecontroller before the physicscontroller
        if(this.physicsController._canUpdatePhysics && true) {
            this.physicsController.getSpace().step(0.02);
        }
        this.cameraController.updateCameraPos();
    },
    cleanTheLayer:function(){
        setAllControllerToNull();
    }
});

var CarC3Scene = cc.Scene.extend({
    onEnter:function () {
        this._super();

        cc.textureCache.removeAllTextures();
        cc.spriteFrameCache.removeSpriteFrames();
        ddStopAllAudios();
        // ddPlayEffect("music","res/game/audios/qitabg.mp3",true);
        var spr = addBackMenuFollowCamera(this,function(){
            ddStopAllAudios();
            this.cleanTheLayer();
            cc.director.runScene(new HomeSceneLoop());
        }.bind(this));
        backKeyListenerAdd(this,function(){
            ddStopAllAudios();
            this.cleanTheLayer();
            cc.director.runScene(new HomeSceneLoop());
        }.bind(this));

        this.layer = new CarC3Layer();
        this.layer.cameraController.pushFollowCameraSprites([spr]);
        this.addChild(this.layer);
        // this.layer.startGame();
    },
    cleanTheLayer:function(){
        this.layer.cleanTheLayer();
    }
});
