var GCarLoopLayer = null;

var CarLoopLayer = cc.Layer.extend({
    sprite_play:null,
    sprite_video:null,
    sprite_title:null,
    listener_book:null,
    listener_play:null,
    listener_video:null,
    ad_view:null,
    layer_quit:null,
    parent_check:null,
    is_update:true,


    ctor:function () {
        this._super();
        this.initLayer();
        this.addBackground();


        cc.textureCache.removeAllTextures();
        cc.spriteFrameCache.removeSpriteFrames();

        
        this.createComponents();
        this.showBeginAnimation();
        // this.testADView();

		// if(!isPad()){
			//this.getAdConfig();
		// }

        this.addBackKeyListener();
        this.startGame();
        return true;
    },
    testADView:function(){
        var self  = this;
        var item = new AdItem();
        self.layer_quit = new QuitAdViewLayerLoop(function(action) {
            cc.log("ad action = " + action);
            switch (action) {
                case "quit":
                {
                    ddStopAllAudios();
                    self.cleanTheLayer();
                    quiteGame();
                    break;
                }
                case "continue":
                {
                    self.layer_quit.showAndEnable(false);
                    break;
                }
                default:
                    break;
            }
        },item);

        this.layer_quit.setGlobalZOrder(100);
        // this.layer_quit.showAndEnable(true);
        this.addChild(this.layer_quit, 50);
        this.cameraController.pushFollowCameraSprites([this.layer_quit]);
    },
    cleanTheLayer:function(){
        ddStopAllAudios();

        this.sprite_title.stopAllActions();
        this.sprite_play.stopAllActions();
        this.sprite_video.stopAllActions();

        this.sprite_video.removeFromParent(true);
        this.sprite_play.removeFromParent(true);
        this.sprite_title.removeFromParent(true);

        this.is_update = false;
        this.spriteController.getCar().destroySelf();

        this.nodeContainer.destroyTheContainer();

        resetLoopSceneRoadData();
        setAllControllerToNull();
    },
    addBackKeyListener:function(){
        this.glQuitNum = 1;
        var self = this;

        var ad_item = getQuitAd();
        if(ad_item){
            cc.log("get ad_item");
            self.layer_quit = new QuitAdViewLayerLoop(function(action) {
                cc.log("noad action = " + action);
                switch (action) {
                    case "quit":
                    {
                        ddStopAllAudios();
                        self.cleanTheLayer();
                        quiteGame();
                        break;
                    }
                    case "continue":
                    {
                        self.layer_quit.showAndEnable(false);
                        break;
                    }
                    default:
                        break;
                }
            },ad_item);
        }else{
            self.layer_quit = new QuitViewLayerLoop(function(action) {
                cc.log("ad action = " + action);
                switch (action) {
                    case "quit":
                    {
                        ddStopAllAudios();
                        self.cleanTheLayer();
                        quiteGame();
                        break;
                    }
                    case "continue":
                    {
                        self.layer_quit.showAndEnable(false);
                        break;
                    }
                    default:
                        break;
                }
            });
        }
        this.layer_quit.setGlobalZOrder(100);
        this.layer_quit.showAndEnable(false);
        this.addChild(this.layer_quit, 50);
        this.cameraController.pushFollowCameraSprites([this.layer_quit]);


        var self = this;
        cc.eventManager.addListener({
            event: cc.EventListener.KEYBOARD,
            onKeyReleased: function(keyCode, event) {
                if (keyCode == cc.KEY.back) {
                    if(0 == self.glQuitNum % 2) {
                        if(self.layer_quit._showAndEnable){
                            self.layer_quit.showAndEnable(false);
                        }else {
                            self.layer_quit.showAndEnable(!self.layer_quit._showAndEnable);
                            self.layer_quit._showAndEnable = !self.layer_quit._showAndEnable;
                        }
                    }else{
                        self.layer_quit.showAndEnable(!self.layer_quit._showAndEnable);
                    }
                    self.glQuitNum ++;
                }
                else if (keyCode == cc.KEY.menu) {

                }
            }}, this);
    },
    createComponents:function(){
        this.sprite_title = new cc.Sprite("res/home/main_title");
        this.sprite_title.setGlobalZOrder(constCar.globalZOrder.level_pos50);
        this.sprite_title.x = Config_Home.title_begin.x;
        this.sprite_title.y = Config_Home.title_begin.y;
        this.sprite_title._setAnchorX(0.5);
        this.sprite_title._setAnchorY(0.1);
        this.sprite_title.setScale(0.8, 0.8);
        this.addChild(this.sprite_title,5);

        this.sprite_play = new MenuSingleSprite("res/home/main_play");
        this.sprite_play.setGlobalZOrder(constCar.globalZOrder.level_pos50);
        this.sprite_play.x = Config_Home.menu01_begin.x;
        this.sprite_play.y = Config_Home.menu01_begin.y;
        this.sprite_play.setScale(1.2);
        this.addChild(this.sprite_play,20);


        this.sprite_video = new MenuSingleSprite("res/home/main_video");
        this.sprite_video.setGlobalZOrder(constCar.globalZOrder.level_pos50);
        this.sprite_video.x = Config_Home.menu03_begin.x;
        this.sprite_video.y = Config_Home.menu03_begin.y;
        this.sprite_video.setScale(1.2);
        this.sprite_video.setVisible(false);
        this.addChild(this.sprite_video,20);
    },
    showBeginAnimation:function(){
        var move_duration = 0.21;
        this.sprite_title.runAction(cc.sequence(
            cc.delayTime(0.3),
            cc.moveBy(0.1, Config_Home.title_moved).easing(cc.easeOut(3)),
            cc.scaleBy(move_duration / 4, 0.95, 0.95),
            cc.scaleTo(move_duration / 4, 0.9, 0.9),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 15)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -15)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 10)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -10)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 5)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -5)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -3))
        ));

        this.sprite_play.runAction(cc.sequence(
            cc.delayTime(0.4),
            cc.moveBy(0.2, Config_Home.menu01_moved).easing(cc.easeIn(2)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 9)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -9)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 6)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -6)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -3)),
            cc.callFunc(function() {
                this.sprite_play.runAction(cc.repeatForever(cc.sequence(cc.scaleTo(0.8, 1.05, 1.05), cc.scaleTo(0.8, 0.95, 0.95))));
            }.bind(this))
        ));


        this.sprite_video.runAction(cc.sequence(
            cc.delayTime(1.2),
            cc.moveBy(0.2, Config_Home.menu03_moved).easing(cc.easeIn(2)),
            cc.callFunc(function() {
                this.addListener();
            }.bind(this)),
            cc.moveBy(move_duration, cc.p(0, 9)),
            cc.moveBy(move_duration, cc.p(0, -9)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 6)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -6)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -3)),
            cc.callFunc(function() {
                this.sprite_video.runAction(cc.repeatForever(cc.sequence(cc.scaleTo(0.8, 1.05, 1.05), cc.scaleTo(0.8, 0.95, 0.95))));
            }.bind(this))
        ));
    },
    addListener:function(){
        var self = this;
        var sprite_listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                var target = event.getCurrentTarget();
                var cameraPos = cc.Camera.getDefaultCamera().getPosition();
                var cameraDeltaPos = cp.v(cameraPos.x - cc.winSize.width/2,cameraPos.y-cc.winSize.height/2);
                var locationInNode = target.convertToNodeSpace(cp.v(cameraDeltaPos.x + touch.getLocation().x ,cameraDeltaPos.y + touch.getLocation().y));

                var s = target.getContentSize();
                var rect = cc.rect(0, 0, s.width, s.height);

                if (cc.rectContainsPoint(rect, locationInNode)) {
                    if(target == self.sprite_play){
                        mylog("play is selected!!!");
                        if (!self.sprite_play.isEnable()) {
                            return false;
                        }
                        self.sprite_play.setEnable(false);
                        self.scheduleOnce(function() {
                            ddStopAllAudios();
                            self.cleanTheLayer();
                            cc.director.runScene(new SelectScene());
                        }, 0.1);

                    } else if(target == self.sprite_video){
                        mylog("video is selected!!!");
                        if (!self.sprite_video.isEnable()) {
                            return false;
                        }
                        self.sprite_video.setEnable(false);
                        ddStopAllAudios();
                        playVideo();
                        self.sprite_video.setEnable(true);
                    }
                    return false;
                }
                return false;
            },
            onTouchMoved: function (touch, event) {

            },
            onTouchEnded: function (touch, event) {

            }
        });

        this.listener_play = sprite_listener.clone();
        this.listener_play.retain();
        this.listener_book = sprite_listener.clone();
        this.listener_book.retain();
        this.listener_video = sprite_listener.clone();
        this.listener_video.retain();

        cc.eventManager.addListener(this.listener_play, this.sprite_play);
        cc.eventManager.addListener(this.listener_video, this.sprite_video);
    },
    onEnterTransitionDidFinish:function(){
        this.sprite_play.setEnable(true);
        this.sprite_video.setEnable(true);
		ddStopAllAudios();
		ddPlayEffect("music","res/common/audio/background.mp3",true);
    },
    onExitTransitionDidStart:function(){

    },
    getAdConfig:function(){
        this.getAdList(function(){
            if(AD_ENABLE && ARRY_AD_HOME.length != 0){
                this.ad_view = new AdViewLayer(ARRY_AD_HOME, cc.size(200, cc.winSize.height));
                this.ad_view.setGlobalZOrder(100);
                this.addChild(this.ad_view, 350);
                this.cameraController.pushFollowCameraSprites([this.ad_view]);
            }
        }.bind(this));
    },
    getAdList:function(showAd){
        if(!recommandEnable()){
            AD_ENABLE = false;
            return;
        }

        getAdConfig("http://bb.ergeduoduo.com/baby/game.php?act=sharelist&rid=10014&ver=1026" + "&isar=" + (cc.sys.os == cc.sys.OS_ANDROID ? 1 : 0), function(){
            var ad_value = cc.sys.localStorage.getItem("KEY_AD_LIST");
            if(ad_value){
                cc.log("ad_value is not null");
                var parse_result = JSON.parse(ad_value);
                AD_ENABLE = parse_result.enable;
                var ad_list = parse_result.list;
                var ad_in_list = parse_result.inads;
                var ad_quit_list = parse_result.quitads;
                var ad_lock_list = parse_result.lockads;
                if(null != ad_list){
                    var AD_HOME_LIST = new Array(ad_list.length);
                    parseAdList(AD_HOME_LIST, ad_list);
                    ARRY_AD_HOME = filterAdInstall(AD_HOME_LIST, 4);
                }

                if(null != ad_in_list){
                    var AD_IN_LIST = new Array(ad_in_list.length);
                    parseAdList(AD_IN_LIST, ad_in_list);
                    ARRY_AD_IN = filterAdInstall(AD_IN_LIST, 4);
                }

                if(null != ad_quit_list){
                    cc.log("ad_quit_list is not null,and length is " + ad_quit_list.length);
                    var AD_QUIT_LIST = new Array(ad_quit_list.length);
                    parseAdList(AD_QUIT_LIST, ad_quit_list);
                    ARRY_AD_QUIT = filterAdInstall(AD_QUIT_LIST, 4);
                }else{
                    cc.log("ad_quit_list is null");
                }

                if(null != ad_lock_list){
                    var AD_LOCK_LIST = new Array();
                	parseAdList(AD_LOCK_LIST, ad_lock_list);
                	ARRY_AD_LOCK = lockAdNotInstall(AD_LOCK_LIST, 4);
                }


                showAd();
            }else{
                cc.log("ad_value is null");
            }
        });
    },
    initLayer:function(){
        this.initGlobal("Loop");
        this.initPhysicsController();
        this.initCameraController();
        this.initSpriteController();
        this.initUpdateController();
    },
    startGame:function(){
        this.cameraController.pushFollowCameraSprites([this.sprite_video,this.sprite_title,this.sprite_play]);
        this.spriteGoX = 0;
        this.spriteGoXCst = 0;
        this.picX = 0;
        this.spriteStartXCst = this.spriteController.getCar().chassis.body.getPos().x;
        this.spriteStartFirst = this.spriteController.getCar().chassis.body.getPos().x;
        this.spriteStartX = this.spriteController.getCar().chassis.body.getPos().x;
        this.physicsController.startUpdatePhysics();
        this.firstAddRoad = true;
        this.firstAddPic = true;

        // this.scheduleOnce(function () {
        //     this.nodeContainer1.destroyTheContainer();
        // }, 1);
    },
    initGlobal:function(currentgame){
        GlobalCurrentLayerName = currentgame;
        GCarLoopLayer = this;
        this.backDelta = cp.v(0,0);
        this.foregroundData = [];
        this.metaData = {
            road:{
                deltaX:16,
                dx:2,
                deltaY:-1888,
                group:0x1111,
                friction:0.8,
                elastic:0.0
            }
        };
    },
    initPhysicsController:function(){
        resetLoopSceneRoadData();
        this.physicsController = PhysicsController.getInstance();
        this.roadLen = constScene.carLoop.roadData.length;
        this._space = this.physicsController.getSpace();
    },
    initCameraController:function(){
        this.cameraController = CameraController.getInstance();
    },
    initSpriteController:function(){
        this.spriteController = SpriteController.getInstance();
        mylog("this.spriteController = " + this.spriteController);
        mylog("car.chassisSpr = " + this.spriteController.getCar().chassisSpr);
        mylog("car.chassisSpr.posx = " + this.spriteController.getCar().chassisSpr.getPosition().x);
        this.cameraController.setCameraFollowSprite(this.spriteController.getCar().chassisSpr);
    },
    initUpdateController:function(){
        this.updateController = UpdateController.getInstance();
    },
    addBackground:function(){
        this.backDelta1 = cp.v(0,-250);
        this.spriteDeltaXY = cp.v.add(cp.v(0,-1622),this.backDelta1);
        this.nodeContainer = createNodeContainer(this);
        this.nodeContainer.setPosition(this.spriteDeltaXY);
        this.nodeContainer.setGlobalZOrder(constCar.globalZOrder.level_neg5);
        this.nodeContainer.setAnchorPoint(cc.p(0,0));

        this.backDelta1 = cp.v(0,-250);
        this.onePicLen = 2390;
        this.picIdx = 1;
        this.onePicDeltaLen = this.onePicLen - 0;
        this.roadLenDel = 9570;
        this.picTotalLen = this.onePicLen * 4;//2390*4
        this.changeLengthRoad = this.onePicLen * 3;
        this.changeLengthPic = this.onePicLen * 3;

        // this.nodeContainer2 = createNodeContainer(this);
        // this.nodeContainer2.setPosition(this.spriteDeltaXY);
        // this.nodeContainer2.setGlobalZOrder(constCar.globalZOrder.level_neg5);
        // this.nodeContainer.setAnchorPoint(cc.p(0,0));
        // this.tmpBack = createStaticNode_Only("res/home/map0_1",cc.p(0,0));
        // this.nodeContainer.pushOneSprite(this.tmpBack);


        for(var i = 0;i < 4;i ++){
            var back = createStaticNode_Only("res/home/map"+i+"_0",cc.p(0,0));
            this.nodeContainer.pushOneSprite(back);
        }
    },
    readdPicFirst:function(){
        for(var i = 0;i < 1;i ++) {
            var pic = this.nodeContainer.shift();
            pic.setPositionX(pic.getPositionX()+this.picTotalLen*1);
            this.nodeContainer.push(pic);
        }
    },
    readdPic:function(){
        for(var i = 0;i < 1;i ++) {
            var pic = this.nodeContainer.shift();
            pic.setPositionX(pic.getPositionX()+this.picTotalLen*1);
            this.nodeContainer.push(pic);
        }
    },
    readdRoadFirst:function(){
        var deltax = 1 * this.roadLenDel - this.metaData.road.deltaX;
        for(var i = 0;i < this.roadLen; i ++){
            mylog("readdRoadFirst");
            constScene.carLoop.roadData[i].x += deltax;
            if(i == 0 || i == this.roadLen-1)
                mylog(constScene.carLoop.roadData[i].x + "," + constScene.carLoop.roadData[i].y);
        }
        this.physicsController.reLoadRoad();
    },
    readdRoad:function(idx){
        var deltax = 1 * this.roadLenDel + this.metaData.road.dx * idx;
        for(var i = 0;i < this.roadLen; i ++){
            mylog("readdRoad....");
            constScene.carLoop.roadData[i].x += deltax;
            if(i == 0 || i == this.roadLen-1)
                mylog(constScene.carLoop.roadData[i].x + "," + constScene.carLoop.roadData[i].y);
        }
        this.physicsController.reLoadRoad();
        this.physicsController._removeFromArray();
    },
    printCarChassisPos:function(){
        mylog("car chassis pos = " + this.spriteController.getCar().chassis.body.getPos().x + "," + this.spriteController.getCar().chassis.body.getPos().y);
    },
    update:function(dt){
        if(this.is_update){
            var carX = this.spriteController.getCar().chassis.body.getPos().x;
            this.spriteGoX =  carX - this.spriteStartX;
            if(this.firstAddPic) {
                this.spriteGoXCst = carX - this.spriteStartXCst;
                this.picX = this.spriteGoXCst;
            }
            if(this.spriteGoX >= this.changeLengthRoad){
                if(this.firstAddRoad) {
                    this.firstAddRoad = false;
                    this.readdRoadFirst();
                    mylog("first road");
                }else{
                    mylog("other road");
                    this.readdRoad(this.picIdx ++);
                }
                this.spriteGoX = 0;
                this.spriteStartX += this.picTotalLen;
            }

            if(this.picX >= this.changeLengthPic){
                if(this.firstAddPic) {
                    this.firstAddPic = false;
                    this.readdPicFirst();
                    mylog("first pic");
                }else{
                    mylog("other pic");
                    this.readdPic();
                }
                this.changeLengthPic = this.onePicLen;
                this.spriteStartXCst = this.spriteController.getCar().chassis.body.getPos().x - this.spriteStartFirst;
            }

            this.picX = this.spriteController.getCar().chassis.body.getPos().x - this.spriteStartFirst - this.spriteStartXCst;

            this.updateController.updateSelf(dt);//must put the updatecontroller before the physicscontroller
            if(this.physicsController._canUpdatePhysics && true) {
                this.physicsController.getSpace().step(0.02);
            }
            this.cameraController.updateCameraPos();
        }
    },
});

var HomeSceneLoop = cc.Scene.extend({
    onEnter:function () {
        this._super();
        GlobalCurrentLayerName = "Loop";
        resetLoopSceneRoadData();
        var layer = new CarLoopLayer();
        this.addChild(layer);
    }
});
