var Changjing = cc.Sprite.extend({
	ctor:function(path,parent,idx,scenename){
		this._super(path);
		this.idx = idx;
		this.scenename = scenename;
		this.touch0 = true;
		this.touch1 = false;
		this.touch2 = false;
		this.parent_ = parent;

		this.lis = registerTouchEventOneByOne(this, true);
	},
	cleanListener:function(){
		cc.eventManager.removeListener(this.lis);
	},
	setNotTouch:function(){
		this.touch0 = false;
	},
	setCanTouch:function(){
		this.touch0 = true;
	},
	onTouchBegan: function (touch, event) {
		var target = event.getCurrentTarget();
		var locationInNode = target.convertToNodeSpace(touch.getLocation());
		var s = target.getContentSize();
		var rect = cc.rect(0, 0, s.width, s.height);
		if (cc.rectContainsPoint(rect, locationInNode) && this.touch0) {
			ddPlayEffect("effect","res/touch.mp3",false);
			return true;
		}
		return false;
	},
	onTouchMoved:function(touch,event){

	},
	onTouchEnded:function(touch,event){
	    if(shouldShowLock() && (this.scenename == "car1")){
	        this.parent_.showLockAdView();
	    }else {
	        this.parent_.setChooseIdx(this.idx);
            this.parent_.allnottouch();
            this.parent_.allstopaction();
            this.parent_.chooseOver();
	    }
	}
});


var SelectLayer = cc.Layer.extend({
	chooseIdx:null,
	lockAd:null,
	ctor:function(){
		this._super();
		this.changjing = ["car1","car2","car3"];
		this.changjing.reshuffle();
		this.chooseIdx = -1;
		this.shakeAble = true;

		cc.textureCache.removeAllTextures();
		cc.spriteFrameCache.removeSpriteFrames();
		ddStopAllAudios();
		ddPlayEffect("music","res/game/audios/qitabg.mp3",true);
		addJigsawMenu(this,function(){
			ddStopAllAudios();
			this.cleanTheLayer();
			cc.director.runScene(new JigsawScene());
		}.bind(this));
		addBackMenu(this,function(){
			ddStopAllAudios();
			this.cleanTheLayer();
			cc.director.runScene(new HomeSceneLoop());
		}.bind(this));
		backKeyListenerAdd(this,function(){
			if(this.lockAd){
			    this.lockAd.removeFromParent(true);
			    this.lockAd = null;
			}else {
			    ddStopAllAudios();
                this.cleanTheLayer();
                cc.director.runScene(new HomeSceneLoop());
			}
		}.bind(this));

		this.createComponents();
		this.handleEvents();
	},
	showLockAdView:function(){
	    showLockAd(this, this.lockAd);
	},
	setChooseIdx:function(idx){
		this.chooseIdx = idx;
	},
	chooseOver:function(){
		this.scheduleOnce(function(){
			constCar.choosedScene = this.changjing[this.chooseIdx];
			this.cleanTheLayer();
			switch (constCar.choosedScene){
				case "car1" :
					cc.director.runScene(new GLLoadingScene("a1"));
					break;
				case "car2" :
					cc.director.runScene(new GLLoadingScene("b1"));
					break;
				case "car3" :
					cc.director.runScene(new GLLoadingScene("c1"));
					break;
				default :
					break;
			}
		},1);
	},
	createComponents:function(){
		this.background = createStaticNode_AP("res/home/chooseback",this,cc.p(0,0),1,cc.p(0,0));
		this.background.scaleX = winWidth() / 1136;
		this.beiziS = [];

        var size = cc.winSize;

		for(var i = 0;i < 3;i ++){
			this.beiziS[i] = new Changjing("res/home/"+this.changjing[i]+"",this,i,this.changjing[i]);
			this.beiziS[i].setAnchorPoint(0.5,0);
			this.beiziS[i].setScale(0.8);                              
			this.beiziS[i].setPosition(size.width * (1 + i) / 4 + (i - 1) * 70,180);
			this.beiziS[i].setNotTouch();
			this.addChild(this.beiziS[i],10);

//			if(recommandEnable()&& (!isInstall("com.duoduo.child.story")) && (this.changjing[i] == "car3")){
            if(shouldShowLock() && (this.changjing[i] == "car1")){
                var lock = new cc.Sprite("res/adView/lock/lock");
                lock.setPosition(150,120);
                lock.setAnchorPoint(0.5,0.5);
                this.beiziS[i].addChild(lock);
            }
		}

		this.scheduleOnce(function(){
			for(var i = 0;i < 3;i ++){
				this.beiziS[i].setCanTouch();
			}
		}.bind(this),1);

		this.currentShake = 0;
		this.schedule(function(){
			if(this.shakeAble){
				this.beiziS[this.currentShake % 3].runAction(cc.sequence(cc.sequence(cc.scaleTo(0.1, 0.86, 0.86), cc.scaleTo(0.1, 0.76, 0.76),cc.scaleTo(0.1,0.82,0.82),cc.scaleTo(0.05,0.8,0.8))));

				this.currentShake ++;
			}
		}.bind(this),2,cc.REPEAT_FOREVER,0.3);
	},
	touchbeizicallback:function(){
		for(var i = 0;i < 3;i ++){
			this.beiziS[i].setSmall();
		}
	},
	allnottouch:function(){
		this.shakeAble = false;
		for(var i = 0;i < 3;i ++){
			this.beiziS[i].setNotTouch();
		}
	},
	allstopaction:function(){
		for(var i = 0;i < 3;i ++){
			this.beiziS[i].stopAllActions();
		}
	},
	allcantouch:function(){
		for(var i = 0;i < 3;i ++){
			this.beiziS[i].setCanTouch();
		}
	},
	handleEvents:function(){
		recvCustomEvent("game1_diantianniu_touched", function(){
			var self = this;
		}.bind(this));
	},
	cleanTheLayer:function(){
		this.unRegistListner();
		this.cleanSprites();
	},
	unRegistListner:function(){

	},
	cleanSprites:function(){
		this.background.setVisible(false);
		for(var i = 0;i < 3;i ++){
			this.beiziS[i].cleanListener();
			this.beiziS[i].setVisible(false);
		}
	}
});

var SelectScene = cc.Scene.extend({
	ctor:function(){
		this._super();

		cc.textureCache.removeAllTextures();
		cc.spriteFrameCache.removeSpriteFrames();

		var layer = new SelectLayer();
		this.addChild(layer);
	},
});
