function registerTouchEventOneByOne(target, isSwallow) {
    var obj = {
        event: cc.EventListener.TOUCH_ONE_BY_ONE,
        swallowTouches: isSwallow == null ? true : isSwallow,
        onTouchBegan: target.onTouchBegan.bind(target)
    };
    mylog("registerTouchEventonebyone");
    if (target.onTouchMoved) {
        obj.onTouchMoved = target.onTouchMoved.bind(target)
    }

    if (target.onTouchEnded) {
        obj.onTouchEnded = target.onTouchEnded.bind(target)
    }

    if (target.onTouchCanceled) {
        obj.onTouchCanceled = target.onTouchCanceled.bind(target)
    }
    var eventListener = cc.EventListener.create(obj);
    cc.eventManager.addListener(eventListener, target);
    return eventListener;
}
// onTouchBegan: function (touch, event) {
//     var target = event.getCurrentTarget();
//     var locationInNode = target.convertToNodeSpace(touch.getLocation());
//     var s = target.getContentSize();
//     var rect = cc.rect(0, 0, s.width, s.height);
//     if (cc.rectContainsPoint(rect, locationInNode)) {
//         return true;
//     }
//     return false;
// }

function sendCustomEvent(eventname) {
    var event = new cc.EventCustom(eventname);
    cc.eventManager.dispatchEvent(event);
}

function recvCustomEvent(eventname,callback){
    cc.eventManager.addCustomListener(eventname,callback);
}

function sendCustomEventAddUserData(eventname,userdata) {
    var event = new cc.EventCustom(eventname);
    event.setUserData(userdata);
    cc.eventManager.dispatchEvent(event);
}

function unRegistCustomEvent(eventname){
    cc.eventManager.removeCustomListeners(eventname);
}

function sendOnceCustomEvent(eventname) {
    var event = new cc.EventCustom(eventname);
    cc.eventManager.dispatchEvent(event);
    unRegistCustomEvent(eventname);
}
function sendOnceCustomEventAddUserData(eventname,userdata) {
    var event = new cc.EventCustom(eventname);
    event.setUserData(userdata);
    cc.eventManager.dispatchEvent(event);
    unRegistCustomEvent(eventname);
}



function addBackKeyListener(isroot, obj, handle) {
    cc.eventManager.addListener({
        event: cc.EventListener.KEYBOARD,
        onKeyReleased: function(keyCode, event) {
            if (keyCode == cc.KEY.back) {
                ddStopAllAudios();
                handle();
                if (isroot) {
                    cc.director.end();
                } else {
                    cc.director.popScene();
                }
            }
        }}, obj);
}


function setStartListener(spineSprite){
    spineSprite.setStartListener(function(trackEntry){
        if(trackEntry){
            var animationName = trackEntry.animation ? trackEntry.animation.name : "nullname";
            mylog("start ! current trackEntry index is "+trackEntry.trackIndex+" and trackEntry name is " + animationName);
            switch(animationName){
                case "animationName_a":
                    break;
                case "animationName_b":
                    break;
                case "animationName_c":
                    break;
                default :
                    break;
            }
        }else{
            mylog("start ! tackEntry is null");
        }
    });
}
function setEndListener(spineSprite){
    spineSprite.setEndListener(function(trackEntry){
        if(trackEntry){
            var animationName = trackEntry.animation ? trackEntry.animation.name : "nullname";
            mylog("end ! current trackEntry index is "+trackEntry.trackIndex+" and trackEntry name is " + animationName);
        }else{
            mylog("end ! tackEntry is null");
        }
    });
}
function setCompleteListener(spineSprite) {
    spineSprite.setCompleteListener(function(trackEntry){
        if(trackEntry){
            var animationName = trackEntry.animation ? trackEntry.animation.name : "nullname";
            var loopCount = Math.floor(trackEntry.trackTime / trackEntry.animationEnd);
            mylog("completed ! current trackEntry index is "+trackEntry.trackIndex+" and trackEntry name is " + animationName +" and completed time is "+ loopCount);

            switch(animationName){
                case "animationName_a":
                    break;
                case "animationName_b":
                    break;
                case "animationName_c":
                    break;
                // case "animationName_d":
                //     this.setAnimation(1,"animationname",true);
                //     break;
                default :
                    break;
            }
        }else{
            mylog("completed ! tackEntry is null");
        }
    });

}
function setEventListener(spineSprite) {
    spineSprite.setEventListener(function(trackEntry,event){
        if(trackEntry){
            var animationName = trackEntry.animation ? trackEntry.animation.name : "nullname";
            var loopCount = Math.floor(trackEntry.trackTime / trackEntry.animationEnd);
            // mylog("event ! current trackEntry index is "+trackEntry.trackIndex+" and trackEntry name is " + animationName +" and event.data.name = "+event.data.name+"event.intvalue:%d,event.floatvalue:%d,event.stringvalue",event.intValue,event.floatValue,event.stringValue);
        }else{
            mylog("event ! tackEntry is null");
        }
    });
}


function spineSpriteAddClick(path,rect,position,visible,spinesprite){
    var click = new cc.Sprite(path,rect);
    click.setPosition(position);
    click.setVisible(visible);
    spinesprite.addChild(click);

    return click;
}



function addKeyboardListener(obj){
    cc.eventManager.addListener({
        event: cc.EventListener.KEYBOARD,
        onKeyPressed:  function(keyCode, event){
            mylog(keyCode);
            switch(keyCode){
                case 68 :
                    mylog("向左");
                    // GlobalToolLayer.curSelectSprite.x -= GlobalToolLayer.moveStep;
                    cc.Camera.getDefaultCamera().setPositionX(cc.Camera.getDefaultCamera().getPositionX() + 500);
                    break;
                case 83 :
                    mylog("向下");
                    // GlobalToolLayer.curSelectSprite.y -= GlobalToolLayer.moveStep;
                    cc.Camera.getDefaultCamera().setPositionY(cc.Camera.getDefaultCamera().getPositionY() - 500);
                    break;
                case 86 :
                    mylog("向右");
                    // GlobalToolLayer.curSelectSprite.x += GlobalToolLayer.moveStep;
                    cc.Camera.getDefaultCamera().setPositionX(cc.Camera.getDefaultCamera().getPositionX() - 500);
                    break;
                case 87 :
                    mylog("向上");
                    // GlobalToolLayer.curSelectSprite.y += GlobalToolLayer.moveStep;
                    cc.Camera.getDefaultCamera().setPositionY(cc.Camera.getDefaultCamera().getPositionY() + 500);
                    break;
                default:
                    break;
            }

        }
    }, obj);
}
