var custom_pre_index = 0;
var custom_cur_index = 0;
var custom_resource_length = 0;
var custom_timeout = 100;
var custom_cur_time = 0;
var texture_name = null;

function textureOrPlistPath(name,idx,ext){
    return "res/K/picture/home/"+name+idx+"."+ext;
}

CustomLoadingLayer = cc.Layer.extend({
    listener_back:null,
//	_progress:null,
    layer_back:null,
    layer_listener:null,
    _cb:null,
    ctor:function (name ,length, cb){
        this._super();

        this._cb = cb;
        texture_name = name;
        custom_cur_index = 0;
        custom_resource_length = length;

        this.createComponents();

        this.loadResource();

        this.scheduleUpdate();
    },

    createComponents:function(){
        var size = cc.winSize;

        this.layer_back = new cc.LayerColor(cc.color("#000000"), size.width, size.height);
        this.layer_back.opacity = 0;
        this.layer_back.x = 0;
        this.layer_back.y = 0;
        this.addChild(this.layer_back, 0);

        var self = this;
        var layer_listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                mylog("touch begin");
                var target = event.getCurrentTarget();
                var locationInNode = target.convertToNodeSpace(touch.getLocation());

                var s = target.getContentSize();
                var rect = cc.rect(0, 0, s.width, s.height);

                if (cc.rectContainsPoint(rect, locationInNode)) {
                    return false;
                }

                return false;
            },
            onTouchMoved: function (touch, event) {

            },
            onTouchEnded: function (touch, event) {
            }
        });
        this.layer_listener = layer_listener.clone();
        this.layer_listener.retain();

        cc.eventManager.addListener(this.layer_listener, this.layer_back);

//		this._progress = new cc.Sprite("res/play/snake/bubble.png");
//		this._progress.x = size.width / 2;
//		this._progress.y = size.height / 2;
//		this._progress.scale = 1.5;
//		this.addChild(this._progress);
    },
    loadResource:function(){

//		this._progress.runAction(cc.repeatForever(cc.rotateBy(1, 360, 360)));

        var self = this;

        for (var index = 0; index < custom_resource_length; ++index) {
            console.log("kg:"+textureOrPlistPath(texture_name, 1 + index, "pvr.ccz"));
            cc.textureCache.addImageAsync(textureOrPlistPath(texture_name, 1 + index, "pvr.ccz"), function() {
                console.log("kg:"+textureOrPlistPath(texture_name, 1 + custom_cur_index, "plist"));
                cc.spriteFrameCache.addSpriteFrames(textureOrPlistPath(texture_name, 1 + custom_cur_index, "plist"));
                custom_cur_index++;
                self.checkCurTime();
            });
        }
    },
    checkCurTime:function(){
        if(custom_cur_index >= custom_resource_length){
            if (this._cb) {
                this._cb();
            }

            this.removeFromParent(true);
        }
    }
});

















var gl_cur_step = 0;
var gl_timmer = 1;
var gl_gap = 60;
var GLLoadingLayer = cc.Layer.extend({
    monkey:null,
    lab_percent:null,
    percent:null,
    scenename:null,
    backpicnum:null,
    backpicprefix:null,
    canUpdate:null,
    ctor:function (scenename,backpicnum,backpicprefix) {
        //////////////////////////////
        // 1. super init first
        this._super();
        this.initLayer(scenename,backpicnum,backpicprefix);
        var size = cc.winSize;
        this.canUpdate = true;

        this.setAnchorPoint(cc.p(0.5, 0.5));

        this.createComponents();

        this.scheduleUpdate();

        return true;
    },
    initLayer:function(scenename,backpicnum,backpicprefix){
        this.scenename = scenename;
        this.backpicnum = backpicnum;
        this.backpicprefix = backpicprefix;

        this.tmparr = {
            "4":[[0],[1],[2,3]],
            "5":[[0,1],[2,3],[4]],
            "6":[[0,1],[2,3],[4,5]],
            "7":[[0,1],[2,3],[4,5,6]],
            "8":[[0,1,2],[3,4,5],[6,7]],
            "9":[[0,1,2],[3,4,5],[6,7,8]]
        };
        this.picArray = this.tmparr[""+this.backpicnum];
    },
    createComponents:function(){
        var name = "";
        switch (this.scenename){
            case "CarA1Scene":
            case "CarA2Scene":
            case "CarA3Scene":
                name = "back_a";
                break;
            case "CarB1Scene":
            case "CarB2Scene":
            case "CarB3Scene":
                name = "back_b";
                break;
            case "CarC1Scene":
            case "CarC2Scene":
            case "CarC3Scene":
                name = "back_c";
                break;
        }

        var background = new cc.Sprite("res/loading/"+name);
        background.setAnchorPoint(cc.p(0, 0));
        background.x = 0;
        background.y = 0;
        background.scaleX = winWidth() / 1136;
        this.addChild(background);

//        this.lab_percent = new cc.LabelTTF("0%", "Arial", 45);
        this.lab_percent = new cc.LabelAtlas("0%","res/loading/number2", 90, 110, "%");
        this.lab_percent.scale = 0.9;
        this.lab_percent.x = cc.winSize.width / 2 - 80;
        this.lab_percent.y = 70;
        this.addChild(this.lab_percent, 5);
    },
    runNetScene:function(){
        cc.director.runScene(eval("new " + this.scenename + "()"));
    },
    loadImg:function(idx){
        cc.log("load image ... idx = " + idx);
        if(3 == idx)
            return;
        // mylog("loadImg = " + idx);
        var tmparr = this.picArray[idx];
        for(var i = 0;i < tmparr.length;i ++){
            cc.textureCache.addImageAsync(this.backpicprefix + tmparr[i]+"_0",function(){
                cc.log("kkk");
                this.canUpdate = true;
            }.bind(this));
        }
    },
    update:function(dt){
        if(gl_timmer <= 3 * 60){
            // mylog("timmer is " + gl_timmer);
            this.lab_percent.setString(Math.floor(gl_timmer * 99 / 180) + "%");
        }
        if(0 == (gl_timmer % gl_gap) && 4 > gl_cur_step){
            this.canUpdate = false;
            this.loadImg(gl_cur_step);
            gl_cur_step++;
            // mylog("cur step is " + gl_cur_step);
            if(4 == gl_cur_step){
                gl_timmer = 1;
                gl_cur_step = 0;
                this.runNetScene();
            }
        }
        // if(this.canUpdate)
            gl_timmer++;
    }
});

var GLLoadingScene = cc.Scene.extend({
    ctor:function (name) {
        this._super();
        ddStopAllAudios();
        var layer = null;
        switch (name){
            case "a1":
                layer = new GLLoadingLayer("CarA1Scene",6,"res/car_a/scene1/background/map");
                break;
            case "a2":
                layer = new GLLoadingLayer("CarA2Scene",4,"res/car_a/scene2/background/map");
                break;
            case "a3":
                layer = new GLLoadingLayer("CarA3Scene",7,"res/car_a/scene3/background/map");
                break;

            case "b1":
                layer = new GLLoadingLayer("CarB1Scene",6,"res/car_b/scene1/background/map");
                break;
            case "b2":
                layer = new GLLoadingLayer("CarB2Scene",4,"res/car_b/scene2/background/map");
                break;
            case "b3":
                layer = new GLLoadingLayer("CarB3Scene",7,"res/car_b/scene3/background/map");
                break;

            case "c1":
                layer = new GLLoadingLayer("CarC1Scene",6,"res/car_c/scene1/background/map");
                break;
            case "c2":
                layer = new GLLoadingLayer("CarC2Scene",5,"res/car_c/scene2/background/map");
                break;
            case "c3":
                layer = new GLLoadingLayer("CarC3Scene",7,"res/car_c/scene3/background/map");
                break;
            case "loop":
                layer = new GLLoadingLayer("HomeSceneLoop",5,"res/home/map");
                break;
            default:
                layer = new GLLoadingLayer("CarC3Scene",7,"res/car_c/scene3/background/map");
                break;
        }
        this.addChild(layer);
    }
});

