function _initPhysics(parent){
	mylog("创建物理环境");
	
	parent.space = new cp.Space();
	parent.space.gravity = cp.v(0,-480);//设置重力，-450
	
	var staticBody = parent.space.staticBody;
	var deltaX = 340;//为正,远离屏幕中心点，为负，靠近屏幕中心点640
	var deltaY = 340;
	var walls = [
	    new cp.SegmentShape(staticBody, cp.v(-deltaX, -deltaY), cp.v(GW + deltaX, -deltaY), 15),  //下   //body,startpoint,endpoint,width
	    new cp.SegmentShape(staticBody, cp.v(-deltaX, GH + deltaY), cp.v(GW + deltaX, GH + deltaY), 15),//上
	    new cp.SegmentShape(staticBody, cp.v(-deltaX, -deltaY), cp.v(-deltaX,GH + deltaY), 15),  //左
	    new cp.SegmentShape(staticBody, cp.v(GW + deltaX,-deltaY), cp.v(GW + deltaX, GH + deltaY), 15) //右
	];

	for (var i = 0; i < walls.length; i++){
		var shape = walls[i];
		shape.setElasticity(0);     //设置弹性系数
		shape.setFriction(0);       //设置摩擦力
		shape.group = Config_Physics.collisionGroup.bigwall;					//设置分组，同组之间不会碰撞
		shape.layers = Config_Physics.collisionLayer.bigwall;
		shape.setCollisionType(1000);
		mylog("bigwall.group %d ,bigwall.layers %d",shape.group,shape.layers);
		parent.space.addStaticShape(shape);
	}

	parent.space.addCollisionHandler(1000,1001,parent.collisionBegin.bind(parent),null,null,null);
	return parent.space;
}

function _updatePhysics(space,dt){
	var timeStep = 0.06;
	space.step(timeStep);    //timeStep 控制物理世界的时间流速
}
function _showDebug(parent) {
	parent._debugNode = new cc.PhysicsDebugNode(parent.space);
	parent._debugNode.visible = true;     // 为true 时, 显示物理框体
	parent.addChild(parent._debugNode);
}
function _addPhysicsBody(parent,path){
	var body = new cp.Body(1, cp.momentForBox(1, 250, 250));    //质量，宽，高
	body.setPos(125,125);
	parent.space.addBody(body);

	var shape = new cp.BoxShape(body, 250,250);
	shape.setElasticity(0);             //设置弹性系数
	shape.setFriction(0);               //设置摩擦力
	// shape.group = 10;					//设置分组，同组之间不会碰撞
	parent.space.addShape(shape);

	//创建物理精灵
	var sprite = new cc.PhysicsSprite(path);
	sprite.setBody(body);
	sprite.setPosition(GW2,50);
	parent.addChild(sprite);

	return body;
}
function _addStaticShape(parent,start,end,width,group,layers){
	var staticBody = parent.space.staticBody;
	var wall = new cp.SegmentShape(staticBody,start,end,width);
	// wall.mass = cc.ParticleSystem.DURATION_INFINITY;//设置了质量无限大，目的是想要不让该shape和其他shape发生碰撞，但是还是没有效果
	wall.setElasticity(0);
	wall.setFriction(0);
	wall.group = group;
	wall.layers = layers;
	parent.space.addStaticShape(wall);

	return wall;
}

function removeShapeAndBody(space,shape){
	var body = shape.getBody();
	space.removeShape(shape);
//	space.removeBody(body);
}
