//传统帧
//一个动画：number图片的张数,prefix图片前缀,start--0从0开始或者1从1开始,ispng--0png1jpg,delayPerUnit每帧持续时间,obj运行动画的对象，times运行的次数,-1无限循环,resumeOriginFrame是否恢复到原始帧
function animationCreate(start,number,prefix,ispng,delayPerUnit,times,resumeOriginFrame){
    var animation = cc.Animation();
    animation.setDelayPerUnit(delayPerUnit);
    animation.setRestoreOriginalFrame(resumeOriginFrame);
    var suffix = null;
    (ispng) ? (suffix = ".png") : ( suffix = ".jpg");
    for(var i = start;i <= number;i ++ ){
        var fileName = prefix + i + suffix;
        animation.addSpriteFrameWithFile(fileName);
    }
    var animate = cc.animate(animation);
    if(-1 != times)
        var action = cc.repeat(animate, times);
    else
        var action = cc.repeatForever(animate);

    return animate;
}
function animationCreate2(start,number,prefix,suffix,delayPerUnit,times,resumeOriginFrame){
	var animation = cc.Animation();
	animation.setDelayPerUnit(delayPerUnit);
	animation.setRestoreOriginalFrame(resumeOriginFrame);
	for(var i = start;i <= number;i ++ ){
		var fileName = prefix + i + suffix;
		animation.addSpriteFrameWithFile(fileName);
	}
	var animate = cc.animate(animation);
	if(-1 != times)
		var action = cc.repeat(animate, times);
	else
		var action = cc.repeatForever(animate);

	return action;
}
function animationCreate2_rev(start,number,prefix,suffix,delayPerUnit,times,resumeOriginFrame){
    var animation = cc.Animation();
    animation.setDelayPerUnit(delayPerUnit);
    animation.setRestoreOriginalFrame(resumeOriginFrame);
    for(var i = number;i >= start;i -- ){
        var fileName = prefix + i + suffix;
        animation.addSpriteFrameWithFile(fileName);
    }
    var animate = cc.animate(animation);
    if(-1 != times)
        var action = cc.repeat(animate, times);
    else
        var action = cc.repeatForever(animate);

    return action;
}
//精灵帧
function newAnimationCreate(number,prefix,delayPerUnit,times,resumeOriginFrame) {
    var animation = cc.Animation();
    animation.setDelayPerUnit(delayPerUnit);
    if (typeof(resumeOriginFrame) == "undefined")
        resumeOriginFrame = true;
    animation.setRestoreOriginalFrame(resumeOriginFrame);
    var suffix = ".png";
    for (var i = 1; i <= number; i++) {
        var fileName = prefix + i + ".png";
        animation.addSpriteFrame(cc.spriteFrameCache.getSpriteFrame(fileName));
    }
    var animate = cc.animate(animation);
    if (-1 != times)
        var action = cc.repeat(animate, times);
    else
        var action = cc.repeatForever(animate);

    return action;
}

function createSkeletonSprite(json,atlas,scale,parent,position,zorder){
    var skeletonsprite = sp.SkeletonAnimation.createWithJsonFile(json,atlas,scale);
    skeletonsprite.setPosition(position);
    parent.addChild(skeletonsprite,zorder);

    return skeletonsprite;
}
function createSkeletonAnimation(json,atlas,scale,parent,position,zorder,priority,defaultanimation,iscircle){
    var skeletonsprite = createSkeletonSprite(json,atlas,scale,parent,position,zorder);
    skeletonsprite.setAnimation(priority,defaultanimation,iscircle);
    return skeletonsprite;
}


/**
 * var shakeAction = new Shake2(0.5,20,20,node);
 * shakeAction.shake();
 */
var Shake = cc.Class.extend({
    duration:0,
    dtCost:0,
    shakeStrengthX:0,
    shakeStrengthY:0,
    shakeNode:null,
    nodeInitialPos:null,
    bindCallback:null,
    ctor:function(duration,shakeStrengthX,shakeStrengthY,shakeNode){
        this.duration = duration;
        this.shakeStrengthX = shakeStrengthX;
        this.shakeStrengthY = shakeStrengthY;
        this.shakeNode = shakeNode;
        this.nodeInitialPos = shakeNode.getPosition();
    },
    shake:function(){
        this.bindCallback = this.doSchedule.bind(this);
        this.shakeNode.unschedule(this.bindCallback);
        this.shakeNode.schedule(this.bindCallback,0,cc.REPEAT_FOREVER,0);

    },
    doSchedule:function(dt){
        var dt2=dt*50;
        var randX=this.getRandomStrength(-this.shakeStrengthX,this.shakeStrengthX)*dt2;
        var randY=this.getRandomStrength(-this.shakeStrengthY,this.shakeStrengthY)*dt2;

        this.shakeNode.setPosition(cc.pAdd(this.nodeInitialPos,cc.p(randX,randY)));
        this.dtCost+=dt;
        if(this.dtCost>=this.duration){
            this.shakeNode.unschedule(this.bindCallback);
            this.shakeNode.setPosition(this.nodeInitialPos);
        }
    },
    getRandomStrength:function(min,max){
        return Math.random()*(max-min+1)+min;
    },
});